;
; 3D Core
; by NightWare
;

;
; ASM DIRECTIVES
;
.686P												;; minimum = pentium pro (ou 2) avec le mode privilegi
.MMX													;; pour activer les instructions mmx
.XMM													;; pour activer les instructions sse (donc l pentium 3 minimum)
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED											;; les labels locaux sont autoriss, et les labels globaux  l'intrieur des procdures doivent tre dfinis avec 2 fois 2 points (LABEL::)
OPTION LJMP											;; lors de la compilation, le compileur prviendra si un jmp pourra tre court (SHORT)
OPTION CASEMAP:NONE										;; optionel: rends les identifiants sensibles  la casse de caractres


;
; INC FILES
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
INCLUDE \Masm32\FPULIB\Fpu.inc


;
; LIB FILES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
INCLUDELIB \Masm32\FPULIB\Fpu.lib


;
; Equivalences
;
cmpgeps					EQU cmpnltps					;; ) correspondances pour viter de se triturer les mninges
cmpgess					EQU cmpnltss					;; )
cmpgtps					EQU cmpnleps					;; )
cmpgtss					EQU cmpnless					;; )
cmpngeps					EQU cmpltps					;; )
cmpngess					EQU cmpltss					;; )
cmpngtps					EQU cmpleps					;; )
cmpngtss					EQU cmpless					;; )

Colour_Red_Bright			EQU 0FFFF1F1Fh					;; 255,031,031 ) Colours
Colour_Red				EQU 0FFDF3F3Fh					;; 223,063,063 )
Colour_Orange				EQU 0FFDF7F3Fh					;; 223,127,063 )
Colour_Yellow				EQU 0FFDFDF3Fh					;; 223,223,063 )
Colour_Blue				EQU 0FF3F3FDFh					;; 063,063,223 )
Colour_Magenta_Bright		EQU 0FFFF3FFFh					;; 255,063,255 )

Main_Process_Stack_Size		EQU 16

;
; resources ids
;
Rsrc_IDI_Icon_32			EQU 532

Rsrc_IDD_Obsolet			EQU 2100
Rsrc_IDC_Obsolet_C			EQU 2101
Rsrc_IDC_Sorry				EQU 2102
Rsrc_IDC_Change			EQU 2103

Rsrc_IDD_Quit				EQU 2200
Rsrc_IDC_Quit_C			EQU 2201
Rsrc_IDC_Really			EQU 2202
Rsrc_IDC_Hmm_Yes			EQU 2203
Rsrc_IDC_Oh_No				EQU 2204


;
; PROTO
;
;MainWinMessages	PROTO :DWORD,:DWORD,:DWORD,:DWORD
;DlgBoxWinMessage	PROTO :DWORD,:DWORD,:DWORD,:DWORD
;DebugInfo			PROTO


.DATA
;
; STRUCTURES
;

; structure used to get/free the memory instance
Mem_Info	STRUCT										;; pour un total de 16 octets
	Instance			DWORD ?							;; (align 16) pointeur de l'instance
	Init_Size			DWORD ?							;; taille initiale (dfinie par HeapCreate)
	Maxi_Size			DWORD ?							;; taille maximale (dfinie par HeapCreate)
	Unused_01			DWORD ?							;; inutilis, pour le moment... (mais ncessaire pour que la structure aligne ce qui suivra)
Mem_Info	ENDS

; structure used to alloc/free memory block
Mem_Block	STRUCT										;; pour un total de 16 octets
	Block_Size		DWORD ?							;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	Pointer_To_Free	DWORD ?							;; adresse qui sert pour librer/supprimer le bloc
	Pointer			DWORD ?							;; (align 8) pointeur de la zone utilisable (align sur 16 octets)
	Unused_01			DWORD ?							;; inutilis...
Mem_Block	ENDS

; structure used to alloc/free memory block concerning screens
Screen_Block	STRUCT									;; pour un total de 64 octets
	Screen_Width_x4	DWORD ?							;; (align 16) width de l'cran relle multiplie par 4 (*DWORD) (ajout, parceque souvent utilis, evite donc des shl,2)
	Screen_Width		DWORD ?							;; width de l'cran (en pixels)
	Screen_Height		DWORD ?							;; (align 8) height de l'cran (en pixels)
	Unused_01			DWORD ?							;; inutilis...
	Block_Size		DWORD ?							;; (align 16) taille du bloc (moins les 16 octets ncessaires  l'alignement)
	Unused_02			DWORD ?							;; inutilis...
	Pointer			DWORD ?							;; (align 8) pointeur de la zone utilisable (adresse aligne sur 16 octets)
	Pointer_To_Free	DWORD ?							;; adresse qui sert pour librer/supprimer le bloc
	Face_Limits_Pointer	DWORD ?							;; (align 16) pointeur de la zone limites face (zro quand ce n'est pas un cran double)
	DBuffer_Pointer	DWORD ?							;; pointeur de la zone Dbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	ZBuffer_Pointer	DWORD ?							;; (align 8) pointeur de la zone Zbuffer (quand c'est un cran double, sinon, c'est une copie du pointeur)
	Flags			DWORD ?							;; tmoins de l'cran... bit 0=cran double buffet utilis
Screen_Block	ENDS

; structure used to get pointers of a bmp file loaded in memory
Bitmap_Pointers	STRUCT								;; pour un totals de 16 octets
	Header_Pointer		DWORD ?							;; position de dbut du fichier bitmap en mmoire (BITMAPFILEHEADER)
	Info_Pointer		DWORD ?							;; position o se situent les informations relatives au bitmap (BITMAPINFOHEADER ou BITMAPCOREHEADER)
	Colours_Pointer	DWORD ?							;; position o se situe la palette du bitmap
	Pixels_Pointer		DWORD ?							;; position o se situe les pixels du bitmap
Bitmap_Pointers	ENDS

; tampon contenant les infos spcifiques  un seul sprite
Sprite_Info STRUCT
	Background_Color	DWORD ?							;; (align 16) la couleur qui sert de transparence au sprite
	Sprite_Pointer		DWORD ?							;; adresse du bloc mmoire qui contient le sprite
	Position_X		DWORD ?							;; )
	Position_Y		DWORD ?							;; ) positions relles dans l'cran
	Sprite_Width_x4	DWORD ?							;; (align 16) width de sprite * 4 (width en dwords) souvent utilis
	Sprite_Width		DWORD ?							;; width du sprite (en pixels)
	Sprite_Height		DWORD ?							;; height du sprite (en pixels)
	Sprite_Size		DWORD ?							;; taille en pixels (taille thorique) du sprite
	Sprite_Size_x4		DWORD ?							;; (align 16) width * height * 4 (la taille relle du sprite)
	Unused_01			DWORD ?							;; inutilis, pour le moment...
	Transparency_Level	DWORD ?							;; niveau de transparence du sprite (les alphas dfinis 0,A,A,A)
	Unused_02			DWORD ?							;; inutilis, pour le moment...
	X_Base			DWORD ?							;; (align 16) base X du sprite (le x de rfrence)
	Virtual_Height		DWORD ?							;; height du sprite en lignes cran
	Y_Base			DWORD ?							;; base Y du sprite (le y de rfrence)
	Unused_03			DWORD ?							;; inutilis, pour le moment...
Sprite_Info ENDS


;
Rotation_Matrix_4x4	STRUCT
; X axis rotation matrix
	X_Axis_00		DWORD ?								;; ) 1,0,0,0
	X_Axis_01		DWORD ?								;; )
	X_Axis_02		DWORD ?								;; )
	X_Axis_03		DWORD ?								;; )
	X_Axis_04		DWORD ?								;; ) 0,Cos(Angle_X),-Sin(Angle_X),0
	X_Axis_05		DWORD ?								;; )
	X_Axis_06		DWORD ?								;; )
	X_Axis_07		DWORD ?								;; )
	X_Axis_08		DWORD ?								;; ) 0,Sin(Angle_X),Cos(Angle_X),0
	X_Axis_09		DWORD ?								;; )
	X_Axis_10		DWORD ?								;; )
	X_Axis_11		DWORD ?								;; )
	X_Axis_12		DWORD ?								;; ) 0,0,0,1
	X_Axis_13		DWORD ?								;; )
	X_Axis_14		DWORD ?								;; )
	X_Axis_15		DWORD ?								;; )
; Y axis rotation matrix
	Y_Axis_00		DWORD ?								;; ) Cos(Angle_Y),0,-Sin(Angle_Y),0
	Y_Axis_01		DWORD ?								;; )
	Y_Axis_02		DWORD ?								;; )
	Y_Axis_03		DWORD ?								;; )
	Y_Axis_04		DWORD ?								;; ) 0,1,0,0
	Y_Axis_05		DWORD ?								;; )
	Y_Axis_06		DWORD ?								;; )
	Y_Axis_07		DWORD ?								;; )
	Y_Axis_08		DWORD ?								;; ) Sin(Angle_Y),0,Cos(Angle_Y),0
	Y_Axis_09		DWORD ?								;; )
	Y_Axis_10		DWORD ?								;; )
	Y_Axis_11		DWORD ?								;; )
	Y_Axis_12		DWORD ?								;; ) 0,0,0,1
	Y_Axis_13		DWORD ?								;; )
	Y_Axis_14		DWORD ?								;; )
	Y_Axis_15		DWORD ?								;; )
; Z axis rotation matrix
	Z_Axis_00		DWORD ?								;; ) Cos(Angle_Z),-Sin(Angle_Z),0,0
	Z_Axis_01		DWORD ?								;; )
	Z_Axis_02		DWORD ?								;; )
	Z_Axis_03		DWORD ?								;; )
	Z_Axis_04		DWORD ?								;; ) Sin(Angle_Z),Cos(Angle_Z),0,0
	Z_Axis_05		DWORD ?								;; )
	Z_Axis_06		DWORD ?								;; )
	Z_Axis_07		DWORD ?								;; )
	Z_Axis_08		DWORD ?								;; ) 0,0,1,0
	Z_Axis_09		DWORD ?								;; )
	Z_Axis_10		DWORD ?								;; )
	Z_Axis_11		DWORD ?								;; )
	Z_Axis_12		DWORD ?								;; ) 0,0,0,1
	Z_Axis_13		DWORD ?								;; )
	Z_Axis_14		DWORD ?								;; )
	Z_Axis_15		DWORD ?								;; )
; XYZ axis rotation matrix (it's the global rotation matrix)
	XYZ_Axis_00	DWORD ?								;; ) 1,0,0,0 (matriceXYZ = matriceX * matriceY * matriceZ)
	XYZ_Axis_01	DWORD ?								;; )
	XYZ_Axis_02	DWORD ?								;; )
	XYZ_Axis_03	DWORD ?								;; )
	XYZ_Axis_04	DWORD ?								;; ) 0,1,0,0
	XYZ_Axis_05	DWORD ?								;; )
	XYZ_Axis_06	DWORD ?								;; )
	XYZ_Axis_07	DWORD ?								;; )
	XYZ_Axis_08	DWORD ?								;; ) 0,0,1,0
	XYZ_Axis_09	DWORD ?								;; )
	XYZ_Axis_10	DWORD ?								;; )
	XYZ_Axis_11	DWORD ?								;; )
	XYZ_Axis_12	DWORD ?								;; ) 0,0,0,1
	XYZ_Axis_13	DWORD ?								;; )
	XYZ_Axis_14	DWORD ?								;; )
	XYZ_Axis_15	DWORD ?								;; )
Rotation_Matrix_4x4	ENDS


;
A_3D_World	STRUCT
; point of view angles
	View_Angle_X			DWORD ?						;; ) angles de dpart (par dfaut) de la camra
	View_Angle_Y			DWORD ?						;; )
	View_Angle_Z			DWORD ?						;; )
	View_Angle			DWORD ?						;; (ncessaire pour une question d'alignement)
;; old angles of the point of view
;	View_Angle_X_Old		DWORD ?						;; ) angles de dpart (par dfaut) de la camra
;	View_Angle_Y_Old		DWORD ?						;; )
;	View_Angle_Z_Old		DWORD ?						;; )
;	View_Angle_Old			DWORD ?						;; (ncessaire pour une question d'alignement)
; angles de la vue
	View_Angle_X_Real		DWORD ?						;; ) angles rels de la camra
	View_Angle_Y_Real		DWORD ?						;; )
	View_Angle_Z_Real		DWORD ?						;; )
	View_Angle_Real		DWORD ?						;; (ncessaire pour une question d'alignement)
; min limits of the point of view
	View_Angle_X_Mini		DWORD ?						;; angle mini pour regarder en l'air (en degrs)
	View_Angle_Y_Mini		DWORD ?						;; angle mini pour regarder  droite/gauche (en degrs)
	View_Angle_Z_Mini		DWORD ?						;; angle maxi pour se pencher  gauche (en degrs)
	View_Angle_Mini		DWORD ?						;; (ncessaire pour une question d'alignement)
; max limits of the point of view
	View_Angle_X_Maxi		DWORD ?						;; angle maxi pour regarder par terre (en degrs)
	View_Angle_Y_Maxi		DWORD ?						;; angle maxi pour regarder  droite/gauche (en degrs)
	View_Angle_Z_Maxi		DWORD ?						;; angle maxi pour se pencher  droite (en degrs)
	View_Angle_Maxi		DWORD ?						;; (ncessaire pour une question d'alignement)
; sine of the point of view
	View_Sine_X_Axis		DWORD ?						;; ) Sinus de l'angle de la camra
	View_Sine_Y_Axis		DWORD ?						;; )
	View_Sine_Z_Axis		DWORD ?						;; )
	View_Sine				DWORD ?						;; (ncessaire pour une question d'alignement)
; cosine of the point of view
	View_Cosine_X_Axis		DWORD ?						;; ) Cosinus de l'angle de la camra
	View_Cosine_Y_Axis		DWORD ?						;; )
	View_Cosine_Z_Axis		DWORD ?						;; )
	View_Cosine			DWORD ?						;; (ncessaire pour une question d'alignement)
; position of the point of view
	View_Position_X		DWORD ?						;; ) Position de la camra (c'est galement le point de dpart)
	View_Position_Y		DWORD ?						;; )
	View_Position_Z		DWORD ?						;; )
	View_Position			DWORD ?						;; (ncessaire pour une question d'alignement)
; extra position of the point of view, moved to allow a speed up
	View_Position_Plus_01	DWORD ?						;; ) ici c'est particulier, c'est pour le traitement des
	View_Position_Plus_02	DWORD ?						;; ) points par 3 dwords
	View_Position_Plus_03	DWORD ?						;; )
	View_Position_Plus_04	DWORD ?						;; )
	View_Position_Plus_05	DWORD ?						;; )
	View_Position_Plus_06	DWORD ?						;; )
	View_Position_Plus_07	DWORD ?						;; )
	View_Position_Plus_08	DWORD ?						;; )
	View_Position_Plus_09	DWORD ?						;; )
	View_Position_Plus_10	DWORD ?						;; )
	View_Position_Plus_11	DWORD ?						;; )
	View_Position_Plus_12	DWORD ?						;; )
; point of view movments
	View_Movment_X			DWORD ?						;; dplacement latral (gauche/droite) de la camra
	View_Movment_Y			DWORD ?						;; dplacement de l'altitude de la camra
	View_Movment_Z			DWORD ?						;; dplacement frontal (avant/arrire) de la camra
	View_Movment			DWORD ?						;; (ncessaire pour une question d'alignement)
; zoom of the view
	View_Zoom_X			DWORD ?						;; ) distance de vue (ici, Z peut aller de 0+  depth(trs gros zoom))
	View_Zoom_Y			DWORD ?						;; ) (mais plus communment, de 1  10 maxi...)
	View_Zoom_Z			DWORD ?						;; )
	View_Zoom				DWORD ?						;; (ncessaire pour une question d'alignement)
; here, to compare
	Screen_Width			DWORD ?						;; ) conversion de valeurs au format real4
	Screen_Height			DWORD ?						;; )
	Screen_Width_2			DWORD ?						;;	) valeurs dupliques
	Screen_Height_2		DWORD ?						;;	)
;; here, for our "projections"
;	Screen_Width_x2		DWORD ?						;; ) conversion de valeurs au format real4
;	Screen_Height_x2		DWORD ?						;; )
;	Unused_01				DWORD ?						;;	) 0
;	Unused_02				DWORD ?						;;	)
; here, to compare
	Screen_Width_m1		DWORD ?						;; ) conversion de valeurs au format real4
	Screen_Height_m1		DWORD ?						;; )
	Screen_Width_m1_2		DWORD ?						;;	) valeurs dupliques
	Screen_Height_m1_2		DWORD ?						;;	)
; here, it's the multiplier to obtain the visible part (width or height maxi * 1,5, to obtain a vision of 120 instead of 180 and a 1:1 screen ratio)
	View_Screen_Width		DWORD ?						;; ) conversion de valeurs au format real4
	View_Screen_Height		DWORD ?						;; )
	View_Screen_Depth		DWORD ?						;; )
	Unused_03				DWORD ?						;; (ncessaire pour une question d'alignement)
; here, for an addition (following the previous multiplier) to obtain positive usable values
	Half_Screen_Width		DWORD ?						;; ) conversion de valeurs au format real4
	Half_Screen_Height		DWORD ?						;; )
	Unused_04				DWORD ?						;;	) pour l'alignement
	Unused_05				DWORD ?						;;	)
; here, to compare
	Visual_Limit_X_Mini		DWORD ?						;; ) conversion de valeurs au format real4
	Visual_Limit_Y_Mini		DWORD ?						;; )
	Visual_Limit_Z_Mini		DWORD ?						;; )
	Unused_06				DWORD ?						;; (ncessaire pour une question d'alignement)
; here, to compare
	Visual_Limit_X_Maxi		DWORD ?						;; ) conversion de valeurs au format real4
	Visual_Limit_Y_Maxi		DWORD ?						;; )
	Visual_Limit_Z_Maxi		DWORD ?						;; ) conversion de valeurs au format real4
	Unused_07				DWORD ?						;; (ncessaire pour une question d'alignement)
; here, to compare and to be used
	Visual_Limit_Z_Maxi_1	DWORD ?						;; ) conversion de valeurs au format real4
	Visual_Limit_Z_Maxi_2	DWORD ?						;; )
	Visual_Limit_Z_Maxi_3	DWORD ?						;; )
	Visual_Limit_Z_Maxi_4	DWORD ?						;; )
; here, thoses values will make the difference between virtual and real angles
	Value_180_1			DWORD ?						;; 180
	Value_180_2			DWORD ?						;; 180
	Value_180_3			DWORD ?						;; 180
	Unused_08				DWORD ?						;; 0
; here, the alignment isn't essential (but warning, the structure must be multiple of 16 bytes (4*DWORD))
	View_Movment_SpeedUp	DWORD ?						;; (align 16) vitesse d'acceleration des dplacements
	View_Movment_SlowDown	DWORD ?						;; vitesse de dcleration des dplacements
	View_Speed_Movment_Mini	DWORD ?						;; aucun mouvement...
	View_Speed_Movment_Maxi	DWORD ?						;; doit imprativement tre un multiple de Vitesse_Acceleration_Camera et de Vitesse_Deceleration_Camera
;
	View_Rotation_Speed		DWORD ?						;; vitesse d'orientation de la camra/vue
	Unused_09				DWORD ?						;; vide
	Unused_10				DWORD ?						;; vide
	Unused_11				DWORD ?						;; vide
; rotation matrix (alignment essential here)
	View_Matrix			Rotation_Matrix_4x4 <?>			;; matrices de rotations
A_3D_World	ENDS


;
A_3D_Object	STRUCT
; position of the object
	Position_X			DWORD ?						;; ) positions X,Y,Z de l'objet 3D
	Position_Y			DWORD ?						;; )
	Position_Z			DWORD ?						;; )
	Position				DWORD ?						;; (ncessaire pour une question d'alignement)
; virtual center of the object (usefull for object resizing)
	Center_X				DWORD ?						;; ) center X,Y,Z de l'objet 3D
	Center_Y				DWORD ?						;; )
	Center_Z				DWORD ?						;; )
	Center				DWORD ?						;; (ncessaire pour une question d'alignement)
; size of the object
	Size_X				DWORD ?						;; ) tailles X,Y,Z de l'objet 3D
	Size_Y				DWORD ?						;; )
	Size_Z				DWORD ?						;; )
	Size_				DWORD ?						;; (ncessaire pour une question d'alignement)
; le rayon maximal de l'objet (ca correspond  la zone comprenant les possibles rotations)
	Maxi_Ray_Area_1		DWORD ?						;; ) rayon maximal de l'objet
	Maxi_Ray_Area_2		DWORD ?						;; )
	Maxi_Ray_Area_3		DWORD ?						;; )
	Maxi_Ray_Area_4		DWORD ?						;; (ncessaire pour une question d'alignement)
; angles de direction de l'objet
	Angle_X				DWORD ?						;; ) angles d'orientation X,Y,Z de l'objet 3D
	Angle_Y				DWORD ?						;; )
	Angle_Z				DWORD ?						;; )
	Angle				DWORD ?						;; (ncessaire pour une question d'alignement)
; the points used to determine X,Y,Z axis of the object
	X_Axis_1				DWORD ?						;; ) l'axe X
	X_Axis_2				DWORD ?						;; )
	X_Axis_3				DWORD ?						;; )
	X_Axis_4				DWORD ?						;; (ncessaire pour une question d'alignement)
	Y_Axis_1				DWORD ?						;; ) l'axe Y
	Y_Axis_2				DWORD ?						;; )
	Y_Axis_3				DWORD ?						;; )
	Y_Axis_4				DWORD ?						;; (ncessaire pour une question d'alignement)
	Z_Axis_1				DWORD ?						;; ) l'axe Z
	Z_Axis_2				DWORD ?						;; )
	Z_Axis_3				DWORD ?						;; )
	Z_Axis_4				DWORD ?						;; (ncessaire pour une question d'alignement)
; limits of the object area (usefull to test if the object is on screen or not...)
	Mini_Area_Limit_X		DWORD ?						;; ) zone de l'objet 3D
	Mini_Area_Limit_Y		DWORD ?						;; )
	Mini_Area_Limit_Z		DWORD ?						;; )
	Mini_Area_Limit		DWORD ?						;; (ncessaire pour une question d'alignement)
	Maxi_Area_Limit_X		DWORD ?						;; )
	Maxi_Area_Limit_Y		DWORD ?						;; )
	Maxi_Area_Limit_Z		DWORD ?						;; )
	Maxi_Area_Limit		DWORD ?						;; (ncessaire pour une question d'alignement)
; the 6 others coords of the area
	Area_Limit_1_1			DWORD ?						;; ) point 1
	Area_Limit_1_2			DWORD ?						;; )
	Area_Limit_1_3			DWORD ?						;; )
	Area_Limit_1_4			DWORD ?						;; (ncessaire pour une question d'alignement)
	Area_Limit_2_1			DWORD ?						;; ) point 2
	Area_Limit_2_2			DWORD ?						;; )
	Area_Limit_2_3			DWORD ?						;; )
	Area_Limit_2_4			DWORD ?						;; (ncessaire pour une question d'alignement)
	Area_Limit_3_1			DWORD ?						;; ) point 3
	Area_Limit_3_2			DWORD ?						;; )
	Area_Limit_3_3			DWORD ?						;; )
	Area_Limit_3_4			DWORD ?						;; (ncessaire pour une question d'alignement)
	Area_Limit_4_1			DWORD ?						;; ) point 4
	Area_Limit_4_2			DWORD ?						;; )
	Area_Limit_4_3			DWORD ?						;; )
	Area_Limit_4_4			DWORD ?						;; (ncessaire pour une question d'alignement)
	Area_Limit_5_1			DWORD ?						;; ) point 5
	Area_Limit_5_2			DWORD ?						;; )
	Area_Limit_5_3			DWORD ?						;; )
	Area_Limit_5_4			DWORD ?						;; (ncessaire pour une question d'alignement)
	Area_Limit_6_1			DWORD ?						;; ) point 6
	Area_Limit_6_2			DWORD ?						;; )
	Area_Limit_6_3			DWORD ?						;; )
	Area_Limit_6_4			DWORD ?						;; (ncessaire pour une question d'alignement)
; here, the alignment isn't essential (but warning, the structure must be multiple of 16 bytes (4*DWORD))
	Number_Of_Points		DWORD ?						;; (align 16) nombre de points de l'objet
	Colour_Aplha			DWORD ?						;; l'alpha positionn aux emplacements couleur (pour une question de rapidit du traitement alpha)
	Points_Pointer			DWORD ?						;; adresse de dbut des points de l'objet
	Objetc_Name_Pointer		DWORD ?						;; adresse du nom de l'objet
	Number_Of_Points_treated	DWORD ?						;; (align 16) nombre de points "traits" de l'objet (nombre de points+valeurs vides)
	Default_Colour			DWORD ?						;; couleur de l'objet par dfaut
	Faces_Pointer			DWORD ?						;; adresse de dbut des faces triangulaires
	Object_Flags			DWORD ?						;; statut de l'objet bit 31=affichage ou pas
	Number_Of_Faces		DWORD ?						;; (align 16) nombre de faces triangulaires
	Unused_01				DWORD ?						;; )
	Unused_02				DWORD ?						;; )
	Unused_03				DWORD ?						;; ) ncessaire pour une question d'alignement
; rotation matrix (alignment essential here)
	Direction_Matrix		Rotation_Matrix_4x4 <?>			;; matrices de rotations
; mem block
	Coords_Mem_Block		Mem_Block <?>					;; bloc mmoire allou pour le calcul des coordonnes 2D
A_3D_Object	ENDS


.CONST
;
; Constantes Ieee pour ce qui est de la 3D
;



.DATA
;
; Variable dfinies
;
INCLUDE Font_LucidaCalligraphy_20_G.inc
INCLUDE Sprite_Focus_01.inc

INCLUDE 3D_Object_Sword_Guard.inc
INCLUDE 3D_Object_Sword_Blade.inc
INCLUDE 3D_Object_Sword_Handle.inc
INCLUDE 3D_Object_Stones_Circle.inc


ALIGN 16
; pour les crans
OS_Screen_Width			DWORD ?						;; ) sert pour centerr l'cran/la fentre
OS_Screen_Height			DWORD ?						;; )
OS_Screen_Half_Width		DWORD ?						;;	) sert pour replacer le curseur au center  la sortie
OS_Screen_Half_Height		DWORD ?						;;	)
Work_Screen_Width			DWORD 1024	;1440	;720
Work_Screen_Height			DWORD 768	;900	;450
Work_Screen_Half_Width		DWORD ?						;; Work_Screen_Width/2
Work_Screen_Half_Height		DWORD ?						;; Work_Screen_Height/2
Final_Screen_Width			DWORD 1024	;1440	;720		;; ) ralentissement lorsque la taille diffre du bloc de travail, a cause du retaillage...
Final_Screen_Height			DWORD 768 ;900	;450				;; ) mais reste rapide si le redimensionnement est *2
Final_Screen_Half_Width		DWORD ?						;; Final_Screen_Width/2
Final_Screen_Half_Height		DWORD ?						;; Final_Screen_Height/2

Screen_Position_X			DWORD ?						;; ) pour positionner notre cran si celui-ci a une taiile
Screen_Position_Y			DWORD ?						;; ) infrieure  celui de l'OS
Half_Screen_Position_X		DWORD ?						;;	) sert pour les mouvements souris
Half_Screen_Position_Y		DWORD ?						;;	)


App_Instance				DWORD ?
Dlg_Box_Instance			DWORD ?
Command_Line_Pointer		DWORD ?
Win_Pointer				DWORD ?
Screen_DC_Pointer			HDC ?
Main_Process_Pointer		DWORD ?
Main_Win_Messages_Pointer	DWORD ?						;; servira pour la clture du programme


;
; WARNING : for the number of 3D objects, you MUST update the adress list, and place the added object after Object_3D_0001 before modifying the value...
;
Number_Of_3D_Objects		DWORD 4						;; nombre d'objets 3D

;
; address list of the 3D objetcs (WARNING : the list must be >= to the number of objects)
;
Objects_3D_Locations		DWORD OFFSET Sword_Blade_Header	;; ) mettre les adresses des donnes des objets 3D
						DWORD OFFSET Sword_Guard_Header	;; )
						DWORD OFFSET Sword_Handle_Header	;; )
						DWORD OFFSET Stones_Circle_Header	;; )



ALIGN 16
;
; some counters
;
Fps_Counter				DWORD 0


ALIGN 16
;
; some flags
;

;
; variables permettant de connaitre  tout moment le statut des boutons de la souris, et ses mouvements
;
Mouse_Movment_X			DWORD ?						;; ) (align 16) valeurs ngatives ou positives de la width et de la height de l'cran par rapport au center
Mouse_Movment_Y			DWORD ?						;; ) (ne doivent pas tre spars  cause du traitement en paralle)
;Mouse_Z_Movments			DWORD ?						;; (inutile puisqu'on utilise la variable Mouse_Button_Flags)
Mouse_Button_Flags			DWORD ?						;; masque binaire du statut de la souris avec les bits :
;; les bits 11  6 sont des tmoins des anciens statuts des boutons, les bits 5  0 sont les valeurs actives
;; bit 16 =
;; bit 15 =							/	bit 7 = ancien bouton milieu
;; bit 14 =							/	bit 6 = ancien bouton droit
;; bit 13 =							/	bit 5 = double clique gauche
;; bit 12 =							/	bit 4 = double clique milieu
;; bit 11 = ancien double clique gauche		/	bit 3 = double clique doit
;; bit 10 = ancien double clique milieu		/	bit 2 = bouton gauche
;; bit 9 = ancien double clique droit		/	bit 1 = bouton milieu
;; bit 8 = ancien bouton gauche			/	bit 0 = bouton droit / touche haut

;
; variable permettant de savoir  tout moment s'il y a une rotation, et dans quel sens
;
Rotation_Direction_Flags		DWORD ?						;; masque binaire du sens de rotation avec les bits :
;; les bits 11  6 sont des tmoins de l'ancienne rotation, les bits 5  0 sont les valeurs actives
;; bit 11 = ancien X ngatif	/	bit 5 = X ngatif
;; bit 10 = ancien X positif	/	bit 4 = X positif
;; bit 9 = ancien Y ngatif	/	bit 3 = Y ngatif
;; bit 8 = ancien Y positif	/	bit 2 = Y positif
;; bit 7 = ancien Z ngatif	/	bit 1 = Z ngatif
;; bit 6 = ancien Z positif	/	bit 0 = Z positif

Keys_Flags				DWORD 0						;; bit 3 = touche haut, b bit 2 = touche gauche, bit 1 = touche bas, bit 0 = touche droite

Dlg_Box_Flags				DWORD 0						;; bit 0=boite pour quitter
Selected_Object_Flags		DWORD 0						;; numro de l'objet de dpart (de 0  Number_Of_3D_Objects -1)

Stat_Flags				BYTE 1						;; 0=inactives, 1=actives
;Temoin_Filtre_Son			BYTE 1						;; 0=pas de filtre, 1= filtre activ
Resizing_Flags				BYTE ?						;; 0=pas de redimensionnement, 1=redimensionnement *2, 2=redimensionnement autre que *2
Continue_Main_Process_Flags	BYTE 2						;; 0=processus termin, 1=demande fin du processus, 2=poursuite de processus
Suspend_Main_Process_Flags	BYTE 0						;; 0=actif, 1=suspendu
Zoom_Flags				BYTE 0						;; 0=zoom*1 (inactif), 1=zoom*2, 2=zoom*4, 3=zoom*8
Particules_Flags			BYTE 1						;; 0=inactives, 1=actives
Focus_Flags				BYTE 1						;; 0=inactif, 1=actif
Breath_Flags				BYTE 1						;; 0=inactif, 1=actif
Blur_Flags				BYTE 0						;; 0=cran normal, 1=cran/2 avec fondu
Gray_Screen_Flags			BYTE 0						;; 0=cran non gris, 1=cran gris


;;;;;;;;;;;;;;;;;;
Debug_Infos_Flags			DWORD 01111b					;; bit 3 = axis, bit 2 = 3d area, bit 1 = polygons, bit 0 = infos
;; bit 3 = axes actifs/inactifs
;; bit 2 = zone active/inactive
;; bit 1 = polygones actifs/inactifs
;; bit 0 = infos actives/inactives
;;;;;;;;;;;;;;;;;;


ALIGN 16
;
; variables diverses
;


; table concernant la respiration
Breath					DWORD 03cc49ba6h				;; 0.0240
						DWORD 03cac0831h				;; 0.0210
						DWORD 03c95182bh				;; 0.0182
						DWORD 03c7f9724h				;; 0.0156
						DWORD 03c5844d0h				;; 0.0132
						DWORD 03c343958h				;; 0.0110
						DWORD 03c1374bch				;; 0.0090
						DWORD 03bebedfah				;; 0.0072
						DWORD 03bb78034h				;; 0.0056
						DWORD 03b89a027h				;; 0.0042
						DWORD 03b449ba6h				;; 0.0030
						DWORD 03b03126fh				;; 0,0020
						DWORD 03a9d4952h				;; 0.0012
						DWORD 03a1d4952h				;; 0.0006
						DWORD 03951b717h				;; 0.0002
						DWORD 000000000h				;; 0.0
						DWORD 0b951b717h				;; -0.0002
						DWORD 0ba1d4952h				;; -0.0006
						DWORD 0ba9d4952h				;; -0.0012
						DWORD 0bb03126fh				;; -0,0020
						DWORD 0bb449ba6h				;; -0.0030
						DWORD 0bb89a027h				;; -0.0042
						DWORD 0bbb78034h				;; -0.0056
						DWORD 0bbebedfah				;; -0.0072
						DWORD 0bc1374bch				;; -0.0090
						DWORD 0bc343958h				;; -0.0110
						DWORD 0bc5844d0h				;; -0.0132
						DWORD 0bc7f9724h				;; -0.0156
						DWORD 0bc95182bh				;; -0.0182
						DWORD 0bcac0831h				;; -0.0210
						DWORD 0bcc49ba6h				;; -0.0240
						DWORD 0bcac0831h				;; -0.0210
						DWORD 0bc95182bh				;; -0.0182
						DWORD 0bc7f9724h				;; -0.0156
						DWORD 0bc5844d0h				;; -0.0132
						DWORD 0bc343958h				;; -0.0110
						DWORD 0bc1374bch				;; -0.0090
						DWORD 0bbebedfah				;; -0.0072
						DWORD 0bbb78034h				;; -0.0056
						DWORD 0bb89a027h				;; -0.0042
						DWORD 0bb449ba6h				;; -0.0030
						DWORD 0bb03126fh				;; -0,0020
						DWORD 0ba9d4952h				;; -0.0012
						DWORD 0ba1d4952h				;; -0.0006
						DWORD 0b951b717h				;; -0.0002
						DWORD 000000000h				;; 0.0
						DWORD 03951b717h				;; 0.0002
						DWORD 03a1d4952h				;; 0.0006
						DWORD 03a9d4952h				;; 0.0012
						DWORD 03b03126fh				;; 0,0020
						DWORD 03b449ba6h				;; 0.0030
						DWORD 03b89a027h				;; 0.0042
						DWORD 03bb78034h				;; 0.0056
						DWORD 03bebedfah				;; 0.0072
						DWORD 03c1374bch				;; 0.0090
						DWORD 03c343958h				;; 0.0110
						DWORD 03c5844d0h				;; 0.0132
						DWORD 03c7f9724h				;; 0.0156
						DWORD 03c95182bh				;; 0.0182
						DWORD 03cac0831h				;; 0.0210

Breath_Counter				DWORD 16*DWORD					;; valeur de dpart



;
; misc strings
;
sz_Win_Title				BYTE "WIP 3D Engine by NightWare",0
sz_Win_Class				BYTE "3D Engine",0

sz_FPS					BYTE "Fps :"
sz_FPS_Value				BYTE 12 dup (?)

;
; debug strings
;
sz_Object_On_Screen			BYTE "Object on screen !",0
sz_Object_Out				BYTE "Object out !",0

sz_Object_Number_ID			BYTE "Object n "
sz_Object_Number			BYTE "00000000000",0

sz_View_Position_X_ID		BYTE "View position X : "
sz_View_Position_X			BYTE "S0000000000.00000000",0
sz_View_Position_Y_ID		BYTE "View position Y : "
sz_View_Position_Y			BYTE "S0000000000.00000000",0
sz_View_Position_Z_ID		BYTE "View position Z : "
sz_View_Position_Z			BYTE "S0000000000.00000000",0
sz_View_Angle_X_ID			BYTE "View angle X : "
sz_View_Angle_X			BYTE "S0000000000.00000000",0
sz_View_Angle_Y_ID			BYTE "View angle Y : "
sz_View_Angle_Y			BYTE "S0000000000.00000000",0
sz_View_Angle_Z_ID			BYTE "View angle Z : "
sz_View_Angle_Z			BYTE "S0000000000.00000000",0
sz_View_Real_Angle_X_ID		BYTE "Real view angle X : "
sz_View_Real_Angle_X		BYTE "S0000000000.00000000",0
sz_View_Real_Angle_Y_ID		BYTE "Real view angle Y : "

sz_View_Real_Angle_Y		BYTE "S0000000000.00000000",0
sz_View_Real_Angle_Z_ID		BYTE "Real view angle Z : "
sz_View_Real_Angle_Z		BYTE "S0000000000.00000000",0

sz_Objetc_Position_X_ID		BYTE "Object position X : "
sz_Objetc_Position_X		BYTE "S0000000000.00000000",0
sz_Objetc_Position_Y_ID		BYTE "Object position Y : "
sz_Objetc_Position_Y		BYTE "S0000000000.00000000",0
sz_Objetc_Position_Z_ID		BYTE "Object position Z : "
sz_Objetc_Position_Z		BYTE "S0000000000.00000000",0
sz_Objetc_Angle_X_ID		BYTE "Object angle X : "
sz_Objetc_Angle_X			BYTE "S0000000000.00000000",0
sz_Objetc_Angle_Y_ID		BYTE "Object angle Y : "
sz_Objetc_Angle_Y			BYTE "S0000000000.00000000",0
sz_Objetc_Angle_Z_ID		BYTE "Object angle Z : "
sz_Objetc_Angle_Z			BYTE "S0000000000.00000000",0
sz_Objetc_Size_X_ID			BYTE "Object size X : "
sz_Objetc_Size_X			BYTE "S0000000000.00000000",0
sz_Objetc_Size_Y_ID			BYTE "Object size Y : "
sz_Objetc_Size_Y			BYTE "S0000000000.00000000",0
sz_Objetc_Size_Z_ID			BYTE "Object size Z : "
sz_Objetc_Size_Z			BYTE "S0000000000.00000000",0

sz_Variable_01_ID			BYTE "Variable 1 : "
sz_Variable_01				BYTE "S0000000000.00000000",0
sz_Variable_02_ID			BYTE "Variable 2 : "
sz_Variable_02				BYTE "S0000000000.00000000",0
sz_Variable_03_ID			BYTE "Variable 3 : "
sz_Variable_03				BYTE "S0000000000.00000000",0
sz_Variable_04_ID			BYTE "Variable 4 : "
sz_Variable_04				BYTE "S0000000000.00000000",0
sz_Variable_05_ID			BYTE "Variable 5 : "
sz_Variable_05				BYTE "S0000000000.00000000",0
sz_Variable_06_ID			BYTE "Variable 6 : "
sz_Variable_06				BYTE "S0000000000.00000000",0
sz_Variable_07_ID			BYTE "Variable 7 : "
sz_Variable_07				BYTE "S0000000000.00000000",0
sz_Variable_08_ID			BYTE "Variable 8 : "
sz_Variable_08				BYTE "S0000000000.00000000",0
sz_Variable_09_ID			BYTE "Variable 9 : "
sz_Variable_09				BYTE "S0000000000.00000000",0
sz_Variable_10_ID			BYTE "Variable 10 : "
sz_Variable_10				BYTE "S0000000000.00000000",0
sz_Variable_11_ID			BYTE "Variable 11 : "
sz_Variable_11				BYTE "S0000000000.00000000",0
sz_Variable_12_ID			BYTE "Variable 12 : "
sz_Variable_12				BYTE "S0000000000.00000000",0
sz_Variable_13_ID			BYTE "Variable 13 : "
sz_Variable_13				BYTE "S0000000000.00000000",0
sz_Variable_14_ID			BYTE "Variable 14 : "
sz_Variable_14				BYTE "S0000000000.00000000",0
sz_Variable_15_ID			BYTE "Variable 15 : "
sz_Variable_15				BYTE "S0000000000.00000000",0
sz_Variable_16_ID			BYTE "Variable 16 : "
sz_Variable_16				BYTE "S0000000000.00000000",0

;
; file names strings
;
sz_Start_Screen_Name		BYTE "StartScreen.bmp",0
sz_End_Screen_Name			BYTE "EndScreen.bmp",0


.DATA?
ALIGN 16
;
; structured variables
;

; pour l'instance mmoire
Mem_Instance				Mem_Info <?>

; pour les crans
Work_Screen				Screen_Block <?>
Final_Screen				Screen_Block <?>
Resizing_Table				Screen_Block <?>

; pour le monde 3D
World_3D_0001				A_3D_World <?>

; pour les objets 3D, ATTENTION : les objets 3D doivent imprativement tre placs derrire et  la suite de Object_3D_0001
Object_3D_0001				A_3D_Object <?>
Object_3D_0002				A_3D_Object <?>
Object_3D_0003				A_3D_Object <?>
Object_3D_0004				A_3D_Object <?>

; pour les sprites
Sprite_0001				Sprite_Info <?>				;; le viseur

; enfin les structures pour windows...
Win_Infos					WNDCLASSEX <?>					;; 12 Dwords
; note : la structure BITMAPINFO (BITMAPINFOHEADER+RGBQUAD) est dcompose
Bmp_Infos					BITMAPINFOHEADER <?>			;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords)
Bmp_Infos_2				RGBQUAD 256 dup (<?>)			;; ) + bmiColors (RGBQUAD) (4 octets) * 256
OS_Messages				MSG <?>						;; 5 Dwords + 2 Words


.CODE
;
; Macros
;




;INCLUDE Generic_Procs.asm
;
; MISC
;
.DATA
ALIGN 16
Simd_Alphas_Mask			DWORD 0FF000000h,0FF000000h,0FF000000h,0FF000000h
Simd_RGBs_Mask				DWORD 000FFFFFFh,000FFFFFFh,000FFFFFFh,000FFFFFFh
Simd_RGBs_unpck_1			DWORD 000010001h,000000001h,000010001h,000000001h
Simd_RGBs_unpck_256			DWORD 001000100h,000000100h,001000100h,000000100h
Simd_Temp_Values			DWORD ?,?,?,?
Simd_Ieee_Mul_100000000		REAL4 100000000.0f


Processor_Flags	DWORD ?


.CODE
ALIGN 16
;
; get informations on the processor used by the program
;
; Syntax :
; call GetProcessorInfos
;
; Return :
; eax and the variable Processor_Flags are defined with wanted bits
;
GetProcessorInfos PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi

		xor esi,esi									;; mettre esi (le registre qui stockera les bits)  0
; l'instruction CPUID est supporte, seulement s'il est possible de positionner/enlever le flag ID (EFLAGS bit 21).
		pushfd										;; ) copier les flags+flags etendus dans eax et edx
		pop eax										;; )
		mov edx,eax									;; )
		btc eax,21									;; inverser le flag ID (bit 21)
		push eax										;; ) et recopier le rsultat dans les flags
		popfd										;; )
		pushfd										;;	) puis on recopie  nouveau les flags dans eax
		pop eax										;;	)
		cmp eax,edx									;; comparer le rsultat  notre prcdente sauvegarde
		je NoCpuidSupport								;; si c'est semblable, c'est que notre modif n'a eu aucun effet, alors aller NoCpuidSupport
		bts esi,0										;; positionner le bit correspondant dans esi

; ici, l'instruction cpuid est supporte, on va donc s'en servir pour connaitre les aptitudes du processeur
;		mov eax,0										;; ici, on dtermine le type d'infos que l'on veut rcuprer
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
;													;; (eax contient le nombre d'entres cpuid maximales)

; ici, on passe aux informations suivantes
		mov eax,1										;; ici, on dtermine les infos les plus importantes (du moins pour la programmation)
		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
													;; (eax contient le type, le model,la famille,...)
													;; (edx contient les caractristiques disponibles)
; les instructions fpu sont disponibles ?
		bt edx,0										;; tester le bit 0
		jnc NoFpuSupport								;; si le flag carry n'est pas positionn, aller NoFpuSupport
		bts esi,1										;; positionner le bit correspondant dans esi
NoFpuSupport:
; l'instruction rdtsc est disponible ?
		bt edx,4										;; tester le bit 4
		jnc NoRdtscSupport								;; si le flag carry n'est pas positionn, aller NoRdtscSupport
		bts esi,2										;; positionner le bit correspondant dans esi
NoRdtscSupport:
; l'instruction CmpXchg8b est disponible ?
		bt edx,8										;; tester le bit 8
		jnc NoCmpXchg8bSupport							;; si le flag carry n'est pas positionn, aller NoCmpXchg8bSupport
		bts esi,3										;; positionner le bit correspondant dans esi
NoCmpXchg8bSupport:
; les instructions cmov sont disponibles ?
		bt edx,15										;; tester le bit 15
		jnc NoCmovSupport								;; si le flag carry n'est pas positionn, aller NoCmovSupport
		bts esi,4										;; positionner le bit correspondant dans esi
NoCmovSupport:
; les instructions clfsh sont disponibles ?
		bt edx,19										;; tester le bit 19
		jnc NoClfshSupport								;; si le flag carry n'est pas positionn, aller NoClfshSupport
		bts esi,5										;; positionner le bit correspondant dans esi
NoClfshSupport:
; les instructions mmx sont disponibles ?
		bt edx,23										;; tester le bit 23
		jnc NoMmxSupport								;; si le flag carry n'est pas positionn, aller NoMmxSupport
		bts esi,6										;; positionner le bit correspondant dans esi
NoMmxSupport:
; les instructions fxsr sont disponibles ?
		bt edx,24										;; tester le bit 24
		jnc NoFxsrSupport								;; si le flag carry n'est pas positionn, aller NoFxsrSupport
		bts esi,7										;; positionner le bit correspondant dans esi
NoFxsrSupport:
; les instructions sse sont disponibles ?
		bt edx,25										;; tester le bit 25
		jnc NoSseSupport								;; si le flag carry n'est pas positionn, aller NoSseSupport
		bts esi,8										;; positionner le bit correspondant dans esi
NoSseSupport:
; les instructions sse2 sont disponibles ?
		bt edx,26										;; tester le bit 26
		jnc NoSse2Support								;; si le flag carry n'est pas positionn, aller NoSse2Support
		bts esi,9										;; positionner le bit correspondant dans esi
NoSse2Support:
; les instructions htt sont disponibles ?
		bt edx,28										;; tester le bit 28
		jnc NoHttSupport								;; si le flag carry n'est pas positionn, aller NoHttSupport
		bts esi,10									;; positionner le bit correspondant dans esi
NoHttSupport:
; les instructions sse3 sont disponibles ?
		bt ecx,0										;; tester le bit 0
		jnc NoSse3Support								;; si le flag carry n'est pas positionn, aller NoSse3Support
		bts esi,11									;; positionner le bit correspondant dans esi
NoSse3Support:
;; les instructions Xxx sont disponibles ?
;		bt edx,Xxx									;; tester le bit 
;		jnc PasSupportXxx								;; si le flag carry n'est pas positionn, aller
;		bts esi,x										;; positionner le bit correspondant dans esi
;PasSupportXxx:

; ici, on passe aux informations suivantes
;		mov eax,2										;; ici, on dtermine les infos concernant le cache
;		cpuid										;; fixer les registres eax,ebx,ecx et edx avec les informations du cpu
NoCpuidSupport:
		mov Processor_Flags,esi							;; sauvegarder les tmoins dans notre variable
		mov eax,esi									;; et les recopier dans eax

		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner, sortir de la procdure
GetProcessorInfos ENDP


;
; FILE / MEM / SCREEN
;
.DATA
; les pointeurs
Capture_Temporary_DC_Pointer		HDC ?
Capture_Compatible_DC_Pointer		HDC ?
Capture_Temporary_File_Pointer	HANDLE ?
Capture_New_Dib_Pointer			HBITMAP ?
Capture_Pixels_To_Catch_Pointer	DWORD ?
; les pixels
Capture_Bits_Per_Pixel_Number		DWORD ?
Capture_Screen_Width			DWORD ?
Capture_Screen_Height			DWORD ?
Capture_Bitmap_Size				DWORD ?
; la palette
Capture_Number_Of_Colours		DWORD ?
Capture_Colours_List_Size		DWORD ?
; divers
Capture_Capture_Number			DWORD ?
Capture_Alignment_Value			DWORD ?
Capture_Bytes_Written			DWORD ?
; les chanes
Capture_Alignment				BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
Capture_sz_Display				BYTE "DISPLAY",0
Capture_sz_Production			BYTE "NightWare Production",0
Capture_sz_Complete_Name			BYTE MAX_PATH dup (?)		;; MAX_PATH = 260
Capture_sz_Directory_Name		BYTE MAX_PATH dup (?)		;; MAX_PATH = 260
Capture_sz_Separator			BYTE "\",0
Capture_sz_File_Name			BYTE "ScreenCapture",0
Capture_sz_Capture_Number		BYTE 0,0,0,0,0,0,0,0,0,0,0,0
Capture_sz_Bmp_Extension			BYTE ".bmp",0
; la structure du fichier
Capture_Bmp_File_Header			BITMAPFILEHEADER <?>
; note : la structure BITMAPINFO est dcompose...
Capture_Bmp_Info_Header			BITMAPINFOHEADER <?>
Capture_Colours_List			RGBQUAD 256 dup (<?>)	;; strucutre RGBQUAD * 256


File_Bytes_Read				DWORD ?
File_Temporary_File_Pointer		DWORD ?
File_File_Info					WIN32_FIND_DATA <?>


Resizing_Bmp_Info_Pointer		DWORD ?
Resizing_Temporary_Instance		DWORD ?
Resizing_Temporary_Pointer		DWORD ?
Resizing_Temporary_DC_Pointer		DWORD ?
Resizing_Center_Decay			DWORD ?
Resizing_Lines_Counter			DWORD ?
Resizing_Screen_Width			DWORD ?
Resizing_Screen_Height			DWORD ?
Resizing_Width_Multiplier		DWORD ?
Resizing_Height_Multiplier		DWORD ?
ALIGN 16
Resizing_Bmp_Datas				Mem_Block <?>
Resizing_Bmp_Pointers			Bitmap_Pointers <?>
Resizing_Temporary_Table			Screen_Block <?>


.CODE
ALIGN 16
;
; clean a memory block (fill with 0)
; note : the memory block must be 16 bytes aligned, otherwise crash..., and XMM0 modified
;
; Syntax :
; mov edi,OFFSET of the Screen_Block structure of the screen to clean
; call CleanScreen_Sse
;
; Return :
; eax = size of the screen (in bytes)
;
CleanScreen_Sse PROC
		push ecx										;; empiler ecx
		push edi										;; empiler edi

		xorps XMM0,XMM0								;; effacer XMM0
		mov eax,(Screen_Block PTR [edi]).Block_Size			;; mettre la taille  traiter dans eax
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre l'adresse de dpart dans edi
; ici on traite les 4x owords
Label1:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b			;; ne conserver que les bits 4x owords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
Label2:	movaps OWORD PTR[edi],XMM0						;; mettre 0 en edi
		movaps OWORD PTR[edi+16],XMM0						;; mettre 0 en edi+16
		movaps OWORD PTR[edi+32],XMM0						;; mettre 0 en edi+32
		movaps OWORD PTR[edi+48],XMM0						;; mettre 0 en edi+48
		add edi,OWORD*4								;; on ajoute 64  edi
		sub ecx,OWORD*4								;; on enleve 64  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les owords
Label3:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b			;; ne conserver que les bits owords en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label4:	movaps OWORD PTR[edi+ecx],XMM0					;; mettre 0 en edi+ecx
		add ecx,OWORD									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les dwords
Label5:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label7										;; si ecx est gal  0, aller Label7
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label6:	mov DWORD PTR [edi+ecx],0						;; mettre 0 en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label6									;; tant que ecx est diffrent de 0, aller Label6
; ici on ne traite pas les octets (puisqu'au minimum ce sont des dwords)
Label7:
		pop edi										;; dsempiler edi
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CleanScreen_Sse ENDP


ALIGN 16
;
; alloc a screen (memory block) to a pointer (this block is 16 bytes aligned)
; note : the Mem_Info structure have to be created and defined previously. since a memory block is allocated, it have to be freed at the end
; of the program.
;
; Syntax :
; mov eax,width of the screen (in pixels)
; mov ebx,height of the screen (in pixels)
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Screen_Block structure who gonna be created for the screen
; call CreateScreen
;
; Return :
; eax = OFFSET of the 16 bytes aligned memory block of the screen
;
CreateScreen PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (Screen_Block PTR [edi]).Screen_Width,eax		;; mettre eax dans x.Screen_Width
		mov (Screen_Block PTR [edi]).Screen_Height,ebx		;; mettre eax dans x.Screen_Height
		shl eax,2										;; multiplier la width par 4
		mov (Screen_Block PTR [edi]).Screen_Width_x4,eax		;; mettre eax dans x.Screen_Width_x4
		mul ebx										;; multiplier Screen_Width_x4 par Screen_Height
		mov (Screen_Block PTR [edi]).Block_Size,eax			;; mettre eax dans x.Block_Size
		add eax,16									;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (Screen_Block PTR [edi]).Pointer_To_Free,eax		;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (Screen_Block PTR [edi]).Pointer,eax			;; sauvegarder eax dans x.Pointer
		mov (Screen_Block PTR [edi]).DBuffer_Pointer,eax		;; sauvegarder eax dans x.DBuffer_Pointer
		mov (Screen_Block PTR [edi]).ZBuffer_Pointer,eax		;; sauvegarder eax dans x.ZBuffer_Pointer (ca vite des dsagrments de mauvaise utilisation CreateScreen/CreateScreenWithZBuffer)
		mov (Screen_Block PTR [edi]).Face_Limits_Pointer,eax	;; sauvegarder eax dans x.Face_Limits_Pointer

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreateScreen ENDP


ALIGN 16
;
; alloc a screen (memory block) to a pointer (this block is 16 bytes aligned). also alloc another screen to a seconf pointer (Dbuffer,
; generally used to avoid flicker effect). also alloc another screen to a third pointer (Zbuffer, generally used for collision detection in 2D,
; or depth for 3D). to finish it also alloc an area for 3d faces limits (screen height * (4 Dwords))
; note : the Mem_Info structure have to be created and defined previously. the size of the screen have to be multiple of 4 (16 bytes, because
; of the use of sse instructions...). since a memory block is allocated, it have to be freed at the end of the program.
;
; Syntax :
; mov eax,width of the screen (in pixels)
; mov ebx,height of the screen (in pixels)
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Screen_Block structure who gonna be created for the screen
; call CreateScreenWithDBufferAndZBuffer
;
; Return :
; eax = OFFSET of the 16 bytes aligned memory block of the screen
;
CreateScreenWithDBufferAndZBuffer PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (Screen_Block PTR [edi]).Screen_Width,eax		;; mettre eax dans x.Screen_Width
		mov (Screen_Block PTR [edi]).Screen_Height,ebx		;; mettre ebx dans x.Screen_Height
		mov ecx,ebx									;; copier ebx dans ecx
		shl ecx,4										;; multiplier ecx par 16 octets (4*DWORD)
		shl eax,2										;; multiplier la width par 4
		mov (Screen_Block PTR [edi]).Screen_Width_x4,eax		;; mettre eax dans x.Screen_Width_x4
		mul ebx										;; multiplier Screen_Width_x4 par Screen_Height
		mov (Screen_Block PTR [edi]).Block_Size,eax			;; mettre eax dans x.Block_Size
		lea eax,[eax*2+eax]								;; multiplier la taille par 3 (l'cran normal + le Dbuffer + le zbuffer)
		add eax,ecx									;; ajouter la zone de calcul des limites d'une face 3D et des Z correspondants
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (Screen_Block PTR [edi]).Pointer_To_Free,eax		;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (Screen_Block PTR [edi]).Pointer,eax			;; sauvegarder eax dans x.Pointer
		push eax										;; empiler eax
		add eax,(Screen_Block PTR [edi]).Block_Size			;; ajouter la taille cran (pour passer au deuxime)
		mov (Screen_Block PTR [edi]).DBuffer_Pointer,eax		;; sauvegarder eax dans x.DBuffer_Pointer
		add eax,(Screen_Block PTR [edi]).Block_Size			;; ajouter la taille cran (pour passer au deuxime)
		mov (Screen_Block PTR [edi]).ZBuffer_Pointer,eax		;; sauvegarder eax dans x.ZBuffer_Pointer
		add eax,(Screen_Block PTR [edi]).Block_Size			;; ajouter la taille cran (pour passer  la zone de calcul des limites d'une face 3D)
		mov (Screen_Block PTR [edi]).Face_Limits_Pointer,eax	;; sauvegarder eax dans x.Face_Limits_Pointer
		mov eax,(Screen_Block PTR [edi]).Pointer			;; mettre le pointeur normal dans eax

		pop eax										;; dsempiler eax
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreateScreenWithDBufferAndZBuffer ENDP


ALIGN 16
;
; alloc a screen (memory block) to a pointer (this block is 16 bytes aligned). also alloc another screen to a third pointer (Zbuffer,
; generally used for collision detection in 2D, or depth for 3D). to finish it also alloc an area for 3d faces limits (screen height * (4 Dwords))
; note : the Mem_Info structure have to be created and defined previously. the size of the screen have to be multiple of 4 (16 bytes, because
; of the use of sse instructions...). since a memory block is allocated, it have to be freed at the end of the program.
;
; Syntax :
; mov eax,width of the screen (in pixels)
; mov ebx,height of the screen (in pixels)
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Screen_Block structure who gonna be created for the screen
; call CreateScreenWithZBuffer
;
; Return :
; eax = OFFSET of the 16 bytes aligned memory block of the screen
;
CreateScreenWithZBuffer PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov (Screen_Block PTR [edi]).Screen_Width,eax		;; mettre eax dans x.Screen_Width
		mov (Screen_Block PTR [edi]).Screen_Height,ebx		;; mettre ebx dans x.Screen_Height
		mov ecx,ebx									;; copier ebx dans ecx
		shl ecx,4										;; multiplier ecx par 16 octets (4*DWORD)
		shl eax,2										;; multiplier la width par 4
		mov (Screen_Block PTR [edi]).Screen_Width_x4,eax		;; mettre eax dans x.Screen_Width_x4
		mul ebx										;; multiplier Screen_Width_x4 par Screen_Height
		mov (Screen_Block PTR [edi]).Block_Size,eax			;; mettre eax dans x.Block_Size
		add eax,eax									;; multiplier la taille par 2 (l'cran normal + le zbuffer)
		add eax,ecx									;; ajouter la zone de calcul des limites d'une face 3D et des Z correspondants
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (Screen_Block PTR [edi]).Pointer_To_Free,eax		;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (Screen_Block PTR [edi]).Pointer,eax			;; sauvegarder eax dans x.Pointer
		push eax										;; empiler eax
		mov (Screen_Block PTR [edi]).DBuffer_Pointer,eax		;; recopier eax dans x.DBuffer_Pointer
		add eax,(Screen_Block PTR [edi]).Block_Size			;; ajouter la taille cran (pour passer au deuxime)
		mov (Screen_Block PTR [edi]).ZBuffer_Pointer,eax		;; sauvegarder eax dans x.ZBuffer_Pointer
		add eax,(Screen_Block PTR [edi]).Block_Size			;; ajouter la taille cran (pour passer  la zone de calcul des limites d'une face 3D)
		mov (Screen_Block PTR [edi]).Face_Limits_Pointer,eax	;; sauvegarder eax dans x.Face_Limits_Pointer
		mov eax,(Screen_Block PTR [edi]).Pointer			;; mettre le pointeur normal dans eax

		pop eax										;; dsempiler eax
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CreateScreenWithZBuffer ENDP


ALIGN 16
;
; fill a memory block (with a value)
; note : the memory block have to be 16 bytes alignes, otherwise crash..., and XMM0 is modified
;
; Syntax :
; mov eax,size of the block to fill (in bytes)
; mov edx,value/colour used to fill
; mov edi,OFFSET of the memory block
; call FillMem_NT_Sse
;
; Return :
; nothing
;
FillMem_NT_Sse PROC
		push ecx										;; empiler ecx

; on place la valeur dans le registre simd
		mov Simd_Temp_Values,edx							;; sauvegarder la valeur dans une oprande mmoire
		movss XMM0,DWORD PTR Simd_Temp_Values				;; lire l'oprande construite
		shufps XMM0,XMM0,000h							;; rpartir la valeur dans le registre XMM0
; ici on traite les 4x owords
Label1:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b			;; ne conserver que les bits 4x owords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
Label2:	movntps OWORD PTR[edi],XMM0						;; mettre 0 en edi
		movntps OWORD PTR[edi+16],XMM0					;; mettre 0 en edi+16
		movntps OWORD PTR[edi+32],XMM0					;; mettre 0 en edi+32
		movntps OWORD PTR[edi+48],XMM0					;; mettre 0 en edi+48
		add edi,OWORD*4								;; on ajoute 64  edi
		sub ecx,OWORD*4								;; on enleve 64  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les owords
Label3:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b			;; ne conserver que les bits owords en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label4:	movntps OWORD PTR[edi+ecx],XMM0					;; mettre 0 en edi+ecx
		add ecx,OWORD									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les dwords
Label5:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label7										;; si ecx est gal  0, aller Label7
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label6:	mov DWORD PTR [edi+ecx],edx						;; mettre edx en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label6									;; tant que ecx est diffrent de 0, aller Label6
; ici on traite les octets
Label7:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000000011b			;; ne conserver que les bits octets en ecx
		jz Label9										;; si ecx est gal  0, aller Label9
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label8:	mov BYTE PTR [edi+ecx],dl						;; mettre 0 en edi+ecx
		inc ecx										;; on ajoute 1  ecx (notre pas de boucle)
		jnz Label8									;; tant que ecx est diffrent de 0, aller Label8
Label9:	sub edi,eax									;; soustraire la taille  edi (pour retrouver l'adresse originelle)

		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
FillMem_NT_Sse ENDP


ALIGN 16
;
; clean/fill the ZBuffer (with a value, generally the max depth)
; note : the memory block have to be 16 bytes alignes, otherwise crash..., and XMM0 is modified
;
; Syntax :
; mov edx,value used to fill (generally the depth in 3D)
; mov edi,OFFSET of the Screen_Block structure
; call FillZBuffer_NT_Sse
;
; Return :
; eax = size of the screen/zbuffer (in bytes)
;
FillZBuffer_NT_Sse PROC
		push ecx										;; empiler ecx
		push edi										;; empiler edi

; on place la valeur dans le registre simd
		mov Simd_Temp_Values,edx							;; sauvegarder la valeur dans une oprande mmoire
		movss XMM0,DWORD PTR Simd_Temp_Values				;; lire l'oprande construite
		shufps XMM0,XMM0,000h							;; rpartir la valeur dans le registre XMM0
		mov eax,(Screen_Block PTR [edi]).Block_Size			;; mettre la taille  traiter dans eax
		mov edi,(Screen_Block PTR [edi]).ZBuffer_Pointer		;; mettre l'adresse de dpart dans edi
; ici on traite les 4x owords
Label1:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,11111111111111111111111111000000b			;; ne conserver que les bits 4x owords en ecx
		jz Label3										;; si ecx est gal  0, aller Label3
Label2:	movntps OWORD PTR[edi],XMM0						;; mettre 0 en edi
		movntps OWORD PTR[edi+16],XMM0					;; mettre 0 en edi+16
		movntps OWORD PTR[edi+32],XMM0					;; mettre 0 en edi+32
		movntps OWORD PTR[edi+48],XMM0					;; mettre 0 en edi+48
		add edi,OWORD*4								;; on ajoute 64  edi
		sub ecx,OWORD*4								;; on enleve 64  ecx (notre pas de boucle)
		jnz Label2									;; tant que ecx est diffrent de 0, aller Label2
; ici on traite les owords
Label3:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000110000b			;; ne conserver que les bits owords en ecx
		jz Label5										;; si ecx est gal  0, aller Label5
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label4:	movntps OWORD PTR[edi+ecx],XMM0					;; mettre 0 en edi+ecx
		add ecx,OWORD									;; on ajoute 16  ecx (notre pas de boucle)
		jnz Label4									;; tant que ecx est diffrent de 0, aller Label4
; ici on traite les dwords
Label5:	mov ecx,eax									;; mettre la taille  copier dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label7										;; si ecx est gal  0, aller Label7
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
Label6:	mov DWORD PTR [edi+ecx],edx						;; mettre edx en edi+ecx
		add ecx,DWORD									;; on ajoute 4  ecx (notre pas de boucle)
		jnz Label6									;; tant que ecx est diffrent de 0, aller Label6
; ici on ne traite pas les octets (puisqu'au minimum ce sont des dwords)
Label7:
		pop edi										;; dsempiler edi
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
FillZBuffer_NT_Sse ENDP


ALIGN 16
;
; liberate a memory block
; note : if there is no more memory block, don't forget to free the mem instance, at the end of the program.
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Mem_Block structure
; call FreeMemBlock
;
; Return :
; nothing
;
FreeMemBlock PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(Mem_Block PTR [edi]).Pointer_To_Free	;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
FreeMemBlock ENDP


ALIGN 16
;
; liberate the memory instance (it have to be done, before quitting the app, if a memory instance has previously been defined)
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure
; call FreeMemInstance
;
; Return :
; nothing
;
FreeMemInstance PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapDestroy,(Mem_Info PTR [esi]).Instance		;; librer l'instance mmoire

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
FreeMemInstance ENDP


ALIGN 16
;
; liberate a resizing table
; note : if there is no more memory block, don't forget to free the mem instance, at the end of the program.
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Screen_Block structure (buffer of the table)
; call FreeResizingTable
;
; Return :
; nothing
;
FreeResizingTable PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(Screen_Block PTR [edi]).Pointer_To_Free	;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
FreeResizingTable ENDP


ALIGN 16
;
; liberate a screen
; note : if there is no more memory block, don't forget to free the mem instance, at the end of the program.
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of the Screen_Block structure
; call FreeScreenBlock
;
; Return :
; nothing
;
FreeScreenBlock PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(Screen_Block PTR [edi]).Pointer_To_Free	;; librer le bloc mmoire correspondant au pointeur

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
FreeScreenBlock ENDP


ALIGN 16
;
; create/define a memory instance (it have to be done once, before allocate memory blocks)
; note : usually just one instance is enough for your program, remember to liberate the memory instance (it have to be done, before quitting
; the app, with FreeMemInstance
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure to create
; call GetMemInstance
;
; Return :
; eax = the instance
;
GetMemInstance PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapCreate,HEAP_NO_SERIALIZE,(Mem_Info PTR [esi]).Init_Size,(Mem_Info PTR [esi]).Maxi_Size	;; cr une instance mmoire, et defini des valeurs mmoire
		mov (Mem_Info PTR [esi]).Instance,eax				;; sauvegarde du pointeur de l'instance

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
GetMemInstance ENDP


ALIGN 16
;
; alterate the colours of a screen (with preservation of the alphas)
; (here in the worst case there is 1 pixel not altered, if the screen isn't multiple of 2...)
; note : MM0 to MM6 modified
;
; Syntax :
; mov edi,OFFSET of the Screen_Block stucture of the screen to gray
; call GrayScreen_Mmx
;
; Return :
; nothing
;
GrayScreen_Mmx PROC
		push ecx										;; empiler ecx
		push edi										;; empiler edi

		mov ecx,(Screen_Block PTR [edi]).Block_Size			;; mettre la taille du bloc cran dans ecx
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre l'adresse de dpart du bloc dans ecx
; ici on traite les dwords
		and ecx,11111111111111111111111111111000b			;; ne conserver que les qwords en ecx (au pire, il ne restera qu'un dword...)
		jz Label2										;; si ecx est gal  0, aller Label2
		add edi,ecx									;; on ajoute ecx  edi
		neg ecx										;; inverser ecx
		pxor MM0,MM0									;; MM0 = 0,0,0,0 , 0,0,0,0
		movq MM1,QWORD PTR Simd_Alphas_Mask				;; MM1 = 0,0,0,M , 0,0,0,M
		movq MM2,QWORD PTR Simd_RGBs_Mask					;; MM2 = M,M,M,0 , M,M,M,0
Label1:	movq MM3,QWORD PTR [edi+ecx]						;; MM3 = B,V,R,A , B,V,R,A
		movq MM5,MM3									;; MM5 = B,V,R,A , B,V,R,A
		pand MM5,MM2									;; MM5 = B,V,R,0 , B,V,R,0
		pand MM3,MM1									;; MM3 = 0,0,0,A , 0,0,0,A
		movq MM4,MM5									;; MM4 = B,V,R,0 , B,V,R,0
		punpcklbw MM4,MM0								;; MM4 = 0,B,0,V , 0,R,0,0
		punpckhbw MM5,MM0								;; MM5 = 0,B,0,V , 0,R,0,0
		movq MM6,MM4									;; MM6 = 0,B,0,V , 0,R,0,0
		pshufw MM4,MM4,0C6h								;; MM4 = 0,R,0,V , 0,B,0,0 (ici c'est pour accentuer le vert, qui est visuellement la couleur dominante, comme a on pourra diviser par 4)
		paddw MM4,MM6									;; MM4 = B+R,V+V , R+B,0+0
		movq MM6,MM4									;; MM6 = B+R,V+V , R+B,0+0
		pshufw MM4,MM4,0D1h								;; MM4 = V+V,R+B , V+V,0+0
		paddw MM4,MM6									;; MM4 = B+R+V+V , V+V+R+B , B+R+V+V , 0+0+0+0
		movq MM6,MM5									;; MM6 = 0,B,0,V , 0,R,0,0
		pshufw MM5,MM5,0C6h								;; MM5 = 0,R,0,V , 0,B,0,0 (ici c'est pour accentuer le vert, qui est visuellement la couleur dominante, comme a on pourra diviser par 4)
		paddw MM5,MM6									;; MM5 = B+R,V+V , R+B,0+0
		movq MM6,MM5									;; MM6 = B+R,V+V , R+B,0+0
		pshufw MM5,MM5,0D1h								;; MM5 = V+V,R+B , V+V,0+0
		paddw MM5,MM6									;; MM5 = B+R+V+V , V+V+R+B , B+R+V+V , 0+0+0+0
		psrlw MM5,2									;; MM5 = 0,B,0,V , 0,R,0,0
		psrlw MM4,2									;; MM4 = 0,B,0,V , 0,R,0,0
		packuswb MM4,MM5								;; MM4 = B,V,R,0 , B,V,R,0
		por MM3,MM4									;; MM3 = B,V,R,A , B,V,R,A
		movq QWORD PTR [edi+ecx],MM3						;; mettre les couleurs (les 2 pixels)  l'adresse en edi+ecx
		add ecx,QWORD									;; on ajoute 8  ecx (notre pas de boucle)
		jnz Label1									;; tant que ecx est diffrent de 0, aller Label1
; ici on ne traite pas les octets puisqu'au minimum ce sont des dwords
Label2:
		pop edi										;; dsempiler edi
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
GrayScreen_Mmx ENDP


ALIGN 16
;
; load and display a bmp file (WARNING : it must be a 16 bytes aligned 32 bits screen, and it must be located in the current directory.
; (it's automatically proportionally resized and centered on the screen).
;
; Syntax :
; mov eax,OFFSET of the screen DC
; mov ebx,OFFSET of the filename string
; mov ecx,OFFSET of the BITMAPINFOHEADER structure of the screen used for the display
; mov esi,OFFSET of the Mem_Info structure (we need to alloc memory)
; mov edi,OFFSET of the Screen_Block structure of the screen used to display
; call LoadAndDisplayScreen
;
; Return :
; nothing
;
LoadAndDisplayScreen PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; premirement, on sauvegarde les valeurs qui seront utilises ultrieurement, ou qui reserviront...
		mov Resizing_Temporary_DC_Pointer,eax
		mov Resizing_Bmp_Info_Pointer,ecx
		mov Resizing_Temporary_Instance,esi
		mov Resizing_Temporary_Pointer,edi
; ici, on charge le bitmap
;		mov ebx,OFFSET 								;; mettre l'adresse de la chane qui contient le nom du fichier
		mov ecx,OFFSET Resizing_Bmp_Pointers				;; mettre la liste des pointeurs  dfinir dans ecx
;		mov esi,Resizing_Temporary_Instance				;; mettre l'adresse de la structure dans esi
		mov edi,OFFSET Resizing_Bmp_Datas					;; mettre l'adresse de la structure dans edi
		call LoadBmpFile
;
		cmp eax,0										;; comparer eax  0
		jle AvoidToDisplayScreen							;; si c'est infrieur ou gal  0, aller AvoidToDisplayScreen

; sinon, un fichier bmp est charg, alors on va obtenir la width et la height du DIB (Device Independant Bitmap)
		mov ebx,(Bitmap_Pointers PTR [ecx]).Info_Pointer
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biWidth			;; obtenir la width du bitmap
		mov ebx,(BITMAPINFOHEADER PTR [ebx]).biHeight		;; ) obtenir la height du bitmap
		test ebx,ebx									;; )
		jns NoNeedToNeg								;; )
		neg ebx										;; )
NoNeedToNeg:
; dfinir la taille proportionnelle par rapport  l'cran
		mov edi,Resizing_Temporary_Pointer					;; lire l'adresse de l'cran
;		mov eax,										;; ) dfinir la taille de redimensionnement proportionnelle
;		mov ebx,										;; )
		mov ecx,(Screen_Block PTR [edi]).Screen_Width		;; )
		mov edx,(Screen_Block PTR [edi]).Screen_Height		;; )
		call SetResizingSizes							;; )
; dfinir la table de redimensionnement
;		mov eax,										;; ) dfinir la table de redimensionnement (la mmoire est alloue avec)
;		mov ebx,										;; )
;		mov ecx,(Screen_Block PTR [edi]).Screen_Width		;; )
;		mov edx,(Screen_Block PTR [edi]).Screen_Height		;; )
		mov esi,Resizing_Temporary_Instance				;; )
		mov edi,OFFSET Resizing_Temporary_Table				;; )
;		call DefinirTableDeRedimensionnement				;; )
		call SetResizingTable							;; )

; maintenant que la table de redimensionnement est dfinie, dfinir le centrage
		mov ebx,edi									;; copier l'adresse de la table utilise dans ebx
		mov edi,Resizing_Temporary_Pointer					;; lire l'adresse de l'cran de destination
; on va voir si il y a un dcalage en width
		mov eax,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre la width de l'cran de destination dans ecx
		sub eax,(Screen_Block PTR [ebx]).Screen_Width_x4		;; soustraire la width de l'cran source
		sar eax,1										;; diviser la width obtenue par 2 (signe)
		and eax,0FFFFFFFCh								;; ici, c'est pour tre sr que les couleurs soient bien aligns par dwords (si la width source est impaire)
		test eax,eax									;; fixer les flags de eax
		jnz ApplyDecay									;; si eax est diffrent de 0, aller ApplyDecay
; sinon, c'est qu'il y a un dcalage en height...
		mov eax,(Screen_Block PTR [edi]).Screen_Height		;; mettre la height de l'cran de destination dans ebx
		sub eax,(Screen_Block PTR [ebx]).Screen_Height		;; soustraire la height de l'cran source
		sar eax,1										;; diviser la height obtenue par 2 (signe)
		mul (Screen_Block PTR [edi]).Screen_Width_x4			;; multiplier la height par la width * 4
ApplyDecay:
		mov Resizing_Center_Decay,eax						;; sauvegarder le dcalage
		add (Screen_Block PTR [edi]).Pointer,eax			;; ajouter le dcalage au pointeur de l'cran de destination

; redimensionner simplement les pixels vers l'cran
		mov eax,ebx									;; copier l'adresse de la table dans eax
		mov edi,Resizing_Temporary_Pointer					;; lire l'adresse de l'cran
		mov ebx,(Screen_Block PTR [eax]).Pointer			;; mettre Mem_BlockTable_De_Redimensionnement_.Pointer dans ebx
		mov ebp,(Screen_Block PTR [eax]).Screen_Height		;; mettre x.Screen_Height dans ebp
		mov eax,(Screen_Block PTR [eax]).Screen_Width_x4		;; mettre x.Screen_Width_x4 dans eax
		mov Resizing_Lines_Counter,ebp					;; dfinir le compteur de lignes
		mov esi,Resizing_Bmp_Pointers.Pixels_Pointer			;; )
		mov ebp,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre x.Screen_Width_x4 de l'cran destination dans ebp 
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre le pointeur destination dans edi
		sub ebp,eax									;; dfinir le complment (en pixels*dword) d'une ligne destination
		sub edi,ebx									;; soustraire ebx  edi, pour que edi reprsente la diffrence entre ebx et edi
; ici, on traite les owords
Label0:	mov ecx,eax									;; mettre x.Screen_Width_x4 dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label2										;; si ecx est gal  0, aller Label2
Label1:	mov edx,DWORD PTR [ebx]							;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx],edx						;; et la recopier dans edi+ebx 
		mov edx,DWORD PTR [ebx+4]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+4],edx						;; et la recopier dans edi+ebx+4
		mov edx,DWORD PTR [ebx+8]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+8],edx						;; et la recopier dans edi+ebx+8
		mov edx,DWORD PTR [ebx+12]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+12],edx					;; et la recopier dans edi+ebx+12
		add ebx,DWORD*4								;; augmenter l'adresse en ebx de 4 dwords
		sub ecx,DWORD*4								;; enlever 1 oword  ecx
		jnz Label1									;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,eax									;; mettre x.Screen_Width_x4 dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits owords en ecx
		jz Label4										;; si ecx est gal  0, aller Label4
Label3:	mov edx,DWORD PTR [ebx]							;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx],edx						;; et la recopier dans edi+ebx 
		add ebx,DWORD									;; augmenter l'adresse en ebx d'1 dword
		sub ecx,DWORD									;; enlever 1 dword  ecx
		jnz Label3									;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:	add edi,ebp									;; ajouter le complment de ligne de l'cran de destination  edi
		dec Resizing_Lines_Counter						;; dcrmenter notre comteur de ligne de pixels trait
		jnz Label0									;; tant que c'est diffrent de 0, aller Label0

; maintenant que le redimensionnement est fait, on peut restaurer le pointeur
		mov eax,Resizing_Center_Decay						;; lire le dcalage
		mov edi,Resizing_Temporary_Pointer					;; lire l'adresse de l'cran de destination
		sub (Screen_Block PTR [edi]).Pointer,eax			;; enlever le dcalage ajout au pointeur
; et envoyer le rsultat  l'affichage
		invoke SetDIBitsToDevice,Resizing_Temporary_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,Resizing_Bmp_Info_Pointer,DIB_RGB_COLORS

; enfin, supprimer les blocs mmoire devenus inutiles
		mov esi,Resizing_Temporary_Instance				;;	) la table de redimensionnement relative au bitmap
		mov edi,OFFSET Resizing_Temporary_Table				;;	)
		call FreeResizingTable							;;	)
;		mov esi,Resizing_Temporary_Instance				;; ) le bloc contenant le bitmap
		mov edi,OFFSET Resizing_Bmp_Datas					;; )
		call FreeMemBlock								;; )

AvoidToDisplayScreen:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
LoadAndDisplayScreen ENDP


ALIGN 16
;
; load a bmp file in memory (need comdlg32.lib)
; note : the structure OPENFILENAME concerning the file have to be updated if we use this structure.
;
; Syntax :
; mov ebx,OFFSET of the complete filename string (could be OPENFILENAME.lpstrFile)}
; mov ecx,OFFSET of the Bitmap_Pointers structure to receive the pointers
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of hte Mem_Block structure to receive the file
; call LoadBmpFile
;
; Return :
; eax = number of bytes read (or 0 if there is an error, or -1 if impossible to obtain the file size)
;
LoadBmpFile PROC
		push edx										;; empiler edx
		push ecx										;; empiler ecx

; obtenir la taille (en octets) du fichier
		invoke FindFirstFile,ebx,ADDR File_File_Info			;; rcuprer les infos du fichier slectionn
		cmp eax,INVALID_HANDLE_VALUE						;; comparer eax  -1
		je NoFileToload								;; si c'est gal (erreur pointeur), aller NoFileToload
; sinon, le pointeur est valide
		invoke FindClose,eax							;; alors, supprimer le pointeur dont on n'a plus besion
;		cmp File_File_Info.nFileSizeHigh,0					;; ) fichier trop volumineux ?
;		jne Label03									;; )
		mov eax,File_File_Info.nFileSizeLow				;; sinon, rcuprer la taille du fichier
; definir la taille du bloc mmoire ncessaire pour charger le fichier
		mov (Mem_Block PTR [edi]).Block_Size,eax			;; mettre cette taille dans x.Block_Size
		add eax,000000011h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; et ajouter 1 galement pour tre sr d'avoir 1 octet pour un zro final (ce qui est pratique pour du texte)
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (Mem_Block PTR [edi]).Pointer_To_Free,eax		;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (Mem_Block PTR [edi]).Pointer,eax				;; sauvegarder eax dans x.Pointer
; lire le fichier
		invoke CreateFile,ebx,GENERIC_READ,NULL,NULL,OPEN_EXISTING,NULL,NULL
		mov File_Temporary_File_Pointer,eax				;; sauvegarder le pointeur obtenu dans File_Temporary_File_Pointer
		invoke ReadFile,File_Temporary_File_Pointer,(Mem_Block PTR [edi]).Pointer,(Mem_Block PTR [edi]).Block_Size,ADDR File_Bytes_Read,NULL
		invoke CloseHandle,File_Temporary_File_Pointer		;; fermer File_Temporary_File_Pointer, devenu inutile maintenant

		pop ecx										;; dsempiler ecx, pour restaurer l'adresse de la structure Bitmap_Pointers
; obtenir les pointeurs pour la structure Bitmap_Pointers
		mov eax,(Mem_Block PTR [edi]).Pointer				;; mettre l'adresse de dbut du fichier dans esi
		mov (Bitmap_Pointers PTR [ecx]).Header_Pointer,eax	;; sauvegarder le pointeur Pointeur_Entete_Bitmap
		add eax,SIZEOF BITMAPFILEHEADER					;; ajouter la longueur de l'entete
		mov (Bitmap_Pointers PTR [ecx]).Info_Pointer,eax		;; sauvegarder l'adresse des informations du bitmap
		add eax,SIZEOF BITMAPINFOHEADER					;; ajouter la longueur des informations
		mov (Bitmap_Pointers PTR [ecx]).Colours_Pointer,eax	;; sauvegarder l'adresse de la palette du bitmap
		mov eax,(Bitmap_Pointers PTR [ecx]).Header_Pointer	;; replacer l'adresse de dbut du fichier dans eax
		add eax,(BITMAPFILEHEADER PTR [eax]).bfOffBits		;; ajouter le nombre d'octets qui spare l'adresse de l'entete du dpart des pixels
		mov (Bitmap_Pointers PTR [ecx]).Pixels_Pointer,eax	;; sauvegarder l'adresse du dpart des pixels
		mov eax,File_Bytes_Read							;; retourne le nombre d'octets lus dans eax

;		pop ecx										;; dsempiler ecx (done previously)
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)

; cas o il n'y a rien  charger...
NoFileToload:

		pop ecx										;; dsempiler ecx (pas fait auparavant)
		pop edx										;; dsempiler edx
	ret												;; retourner (sortir de la procdure)
LoadBmpFile ENDP


ALIGN 16
;
; resizing a screen (in fact, we're going to subtitute values with other values, to avoid slow mul/div operations)
; of course, a resizing table have to be defined previously with SetResizingTable.
;
; Syntax :
; mov eax,OFFSET of a Screen_Block structure (the buffer of the table)
; mov esi,OFFSET of a Screen_Block structure (source screen)
; mov edi,OFFSET of a Screen_Block structure (destination screen)
; call Resizing
;
; Return :
; nothing
;
Resizing PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

		mov ebx,(Screen_Block PTR [eax]).Pointer			;; mettre x.Pointer table dans ebx
		mov esi,(Screen_Block PTR [esi]).Pointer			;; mettre x.Pointer source dans esi
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre x.Pointer destination dans edi
		sub edi,ebx									;; soustraire ebx  edi, pour que edi reprsente la diffrence entre ebx et edi
; ici, on traite les owords
Label0:	mov ecx,(Screen_Block PTR [eax]).Block_Size			;; mettre x.Block_Size dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label2										;; si ecx est gal  0, aller Label2
Label1:	mov edx,DWORD PTR [ebx]							;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx],edx						;; et la recopier dans edi+ebx 
		mov edx,DWORD PTR [ebx+4]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+4],edx						;; et la recopier dans edi+ebx+4
		mov edx,DWORD PTR [ebx+8]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+8],edx						;; et la recopier dans edi+ebx+8
		mov edx,DWORD PTR [ebx+12]						;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx+12],edx					;; et la recopier dans edi+ebx+12
		add ebx,DWORD*4								;; augmenter l'adresse en ebx de 4 dwords
		sub ecx,DWORD*4								;; enlever 1 oword  ecx
		jnz Label1									;; tant que ecx est diffrent de 0, aller Label1
; ici, on traite les dwords
Label2:	mov ecx,(Screen_Block PTR [eax]).Block_Size			;; mettre x.Block_Size dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits owords en ecx
		jz Label4										;; si ecx est gal  0, aller Label4
Label3:	mov edx,DWORD PTR [ebx]							;; mettre la position relative de la table dans edx
		mov edx,DWORD PTR [esi+edx]						;; mettre la valeur de l'cran originel en esi+edx dans edx
		mov DWORD PTR [edi+ebx],edx						;; et la recopier dans edi+ebx 
		add ebx,DWORD									;; augmenter l'adresse en ebx d'1 dword
		sub ecx,DWORD									;; enlever 1 dword  ecx
		jnz Label3									;; tant que ecx est diffrent de 0, aller Label3
; on ne traite pas les octets car il ne peut y avoir que des dwords (alpha,rouge,vert,bleu) au minimum
Label4:
		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
Resizing ENDP


ALIGN 16
;
; blur on screen area
;
; Syntax :
; mov eax,width (in pixels) of the area (must be below or equal to the width of the screen)
; mov ebx,height (in pixels) of the area (must be below or equal to the height of the screen)
; mov ecx,position X (in pixel, from 0 to screen width)
; mov edx,position Y (in pixel, from 0 to screen height)
; mov edi,OFFSET of the Screen_Block structure
; call PartialBlur_Mmx
;
; Return :
; nothing
;
PartialBlur_Mmx PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		shl eax,2										;; multiplier eax par 4 pour avoir la width x4
		shl ecx,2										;; multiplier ecx par 4 pour avoir la position X x4
		mov esi,eax									;; sauvegarder eax dans esi
		mov eax,edx									;; copier edx dans eax
		mul (Screen_Block PTR [edi]).Screen_Width_x4			;; multiplier eax par la width d'une ligne
		add eax,ecx									;; ajouter la position X x4 au rsultat
		mov ecx,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre la width de l'cran multiplie par 4 dans ecx
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre le pointeur du tampon dans edi
		add edi,eax									;; ajouter la position de dpart  edi
		mov eax,esi									;; puis on restaure eax
		sub ecx,eax									;; soustraire la width x4  traiter  la width cran x4
		mov ebp,ecx									;; mettre le rsultat dans ebp
		neg ebx										;; inverser ebx (qui devient notre compteur de boucle pour les lignes)
		pxor MM7,MM7									;; effacer MM7 (plac ici, pour une question de vitesse)
; ici, commence la boucle pour les lignes
Label1:	mov ecx,eax									;; mettre le nombre de pixels en width x4 dans ecx (on a multipli par 4 parcequ'on va traiter par dwords)
		add edi,eax									;; on ajoute le rsultat  edi
		mov edx,edi									;; copier edi dans edx
		sub edx,eax									;; soustraire Screen_WidthA_Traiter_X4_  edx
		sub edx,ebp									;; soustraire _Fondu_ComplementScreen_Width_x4  edx
		mov esi,edi									;; copier edi dans esi
		add esi,eax									;; ajouter Screen_WidthA_Traiter_X4_  esi
		add esi,ebp									;; ajouter _Fondu_ComplementScreen_Width_x4  esi
		neg ecx										;; et on inverse ecx qui deviendra notre pas de boucle pour la width  traiter
		movd MM1,DWORD PTR [edi+ecx-DWORD]					;; mettre le dword en edi+ecx-4 dans MM1 (n'est effectu qu'une seule fois)
		punpcklbw MM1,MM7								;; entrelacer les octets infrieurs de MM1 et MM7
; ici, commence la boucle pour une ligne
Label2:	movd MM0,DWORD PTR [edi+ecx+DWORD]					;; mettre le dword en edi+ecx+4 dans MM0
		movd MM2,DWORD PTR [edx+ecx]						;; mettre le dword en edx+ecx dans MM2
		movd MM3,DWORD PTR [esi+ecx]						;; mettre le dword en esi+ecx dans MM3
; transformer les octets en words
		punpcklbw MM0,MM7								;; entrelacer les octets infrieurs de MM0 et MM7
		punpcklbw MM2,MM7								;; entrelacer les octets infrieurs de MM2 et MM7
		punpcklbw MM3,MM7								;; entrelacer les octets infrieurs de MM3 et MM7
; faire la somme des valeurs
		paddw MM0,MM1									;; ajouter en parallle MM1  MM0
		paddw MM0,MM2									;; ajouter en parallle MM2  MM0
		paddw MM0,MM3									;; ajouter en parallle MM3  MM0
; diviser la sommes par le nombre de valeurs
		psrlw MM0,2									;; diviser en parallle les words en MM0 par 4 (par un dcalage  droite de 2 bits)
		movq MM1,MM0									;; transferer MM0 dans MM1 (ce qui vitera de le relire)
		packuswb MM0,MM7								;; compacter les words en octets dans MM0
		movd DWORD PTR [edi+ecx],MM0						;; mettre le rsultat en MM0  l'adresse en edi
		add ecx,4										;; augmenter l'adresse (notre pas de boucle) d'1 dword
		jnz Label2									;; tant que ecx est diffrent de 0, retourner Label2
		add edi,ebp									;; ajouter le complment d'une ligne  edi
		inc ebx										;; augmenter l'adresse (notre pas de boucle) d'1 ligne
		jnz Label1									;; tant que ebx est diffrent de 0, retourner Label1
		shr eax,2										;; pour retrouver la valeur originelle en eax

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
PartialBlur_Mmx ENDP


ALIGN 16
;
; scale a screen (by multiplying width and height by 2, with blur for "doubled values", the source and destination screen must have the
; corresponding size, and should be 16 bytes aligned for speed...
;
; Syntax :
; mov esi,OFFSET of the Screen_Block structure of the source screen
; mov edi,OFFSET of the Screen_Block structure of the destination screen
; call ScaleX2WithBlur_Mmx
;
; Return :
; nothing
;
ScaleX2WithBlur_Mmx PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov ebx,(Screen_Block PTR [esi]).Screen_Height		;; mettre la height de l'cran originel dans ebx
		mov esi,(Screen_Block PTR [esi]).Pointer			;; mettre l'adresse du dbut de la zone originelle dans esi
		mov ebp,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre x.Screen_Width_x4
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre l'adresse du dbut de la zone de destination dans edi
		neg ebx										;; on inverse ebx, qui sera notre compteur de boucle pour les lignes
		pxor MM7,MM7									;; effacer MM7
Label0:	lea edx,[edi+ebp]								;; edx = Pointer + Screen_Width_x4
		lea edi,[edi+2*ebp]								;; edi = Pointer + Screen_Width_x4*2
		mov ecx,ebp									;; mettre Screen_WidthDestination_X4_ dans ecx
		shr ecx,1										;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx									;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx										;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite la premire ligne (que l'on va doubler)
		movd MM0,DWORD PTR [ecx+esi]						;; mettre la premire couleur dans MM0
		punpcklbw MM0,MM7								;; mettre 00XX00XX00XX00XX dans MM0
Label1:	movd MM1,DWORD PTR [ecx+esi]						;; mettre la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7								;; mettre 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1									;; ajouter en parallle MM1  MM0
		psrlw MM0,1									;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1								;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0					;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq QWORD PTR [2*ecx+edx],MM0					;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1									;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add ecx,DWORD									;; augmenter ecx d'1 dword
		jnz Label1									;; tant que ecx est diffrent de 0, aller Label1
		inc ebx										;; incrmener ebx d'une ligne
; maintenant que la premire ligne (double) a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov eax,edi									;; copier edi dans eax
		lea edx,[edi+ebp]								;; edx = Pointer + Screen_Width_x4
		lea edi,[edi+2*ebp]								;; edi = Pointer + Screen_Width_x4*2
		mov ecx,ebp									;; mettre Screen_WidthDestination_X4_ dans ecx
		shr ecx,1										;; on divise ensuite ecx par 2 pour avoir LargeurEcranOriginelX4 dans eax
		add esi,ecx									;; ajouter LargeurEcranOriginelX4 au pointeur source
		neg ecx										;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, on traite les lignes
		movd MM0,DWORD PTR [ecx+esi]						;; mettre la premire couleur dans MM0
		punpcklbw MM0,MM7								;; mettre 00XX00XX00XX00XX dans MM0
Label3:	movd MM1,DWORD PTR [ecx+esi]						;; mettre la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7								;; mettre 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1									;; ajouter en parallle MM1  MM0
		psrlw MM0,1									;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		movq MM2,MM0									;; faire une copie de MM0 en MM2 (qui servira pour les lignes intermdiaires)
		packuswb MM0,MM1								;; compacter les words de MM0 et MM1 en octets dans MM0
		movq QWORD PTR [2*ecx+edi],MM0					;; et recopier la premire couleur (inchange) + notre valeur casse dans edi+(ecx*2)
		movq MM0,MM1									;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
; ici, on traite les lignes intermediaires (les lignes juste au dessus de celles qui viennent d'tre traites)
		movq MM3,QWORD PTR [2*ecx+eax]					;; mettre le qword de 2 lignes avant dans MM3
		movq MM4,MM3									;; recopier MM3 dans MM4
		punpcklbw MM3,MM7								;; mettre 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7								;; mettre 00XX00XX00XX00XX dans MM4
		paddw MM3,MM2									;; ajouter en parallle MM2  MM3
		paddw MM4,MM1									;; ajouter en parallle MM1  MM4
		psrlw MM3,1									;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM4,1									;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM3,MM4								;; compacter les words de MM3 et MM4 en octets dans MM3
		movq QWORD PTR [2*ecx+edx],MM3					;; et recopier les deux couleurs casses dans edx+(ecx*2) (la ligne prcdente)
Label4:	add ecx,DWORD									;; augmenter ecx d'1 dword
		jnz Label3									;; tant que ecx est diffrent de 0, aller Label3
		inc ebx										;; incrmener ebx d'une ligne
		jnz Label2									;; tant que ebx est diffrent de 0, aller Label2

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
ScaleX2WithBlur_Mmx ENDP


ALIGN 16
;
; screen blur, 1/4 of the pixels are read, and the blur is done for the others values
; note : the width and the height of the screen have to be multiple of 2
;
; Syntax :
; mov edi,OFFSET of the Screen_Block structure
; call ScreenBlur_Mmx
;
; Return :
; nothing
;
ScreenBlur_Mmx PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov eax,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre x.Screen_Width_x4
		mov ebx,(Screen_Block PTR [edi]).Screen_Height		;; mettre la height de l'cran originel dans ebx
		mov edi,(Screen_Block PTR [edi]).Pointer			;; mettre l'adresse du dbut de la zone dans edi
		and eax,0FFFFFFF8h								;; pour tre sr que la width est un multiple de 2 pixels (2 dwords)...
		shr ebx,1										;; diviser la height cran par 2 (puisqu'on va traiter les lignes par 2, et du mme coup on s'assure que la height est un multiple de 2)
Label0:	add edi,eax									;; edi = Pointer + Screen_Width_x4
		mov ecx,eax									;; mettre Screen_WidthDestination_X4_ dans ecx
		mov esi,edi									;; esi = Pointer + Screen_Width_x4
		neg ecx										;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
		pxor MM7,MM7									;; effacer MM7
; ici, c'est pour doubler la premire valeur des 2 premires lignes
		movd MM0,DWORD PTR [edi+DWORD]					;; mettre la premire couleur dans MM0
		punpcklbw MM0,MM7								;; mettre 00XX00XX00XX00XX dans MM0
; ici, on traite les 2 premires lignes
Label1:	movd MM1,DWORD PTR [edi+DWORD]					;; mettre la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		punpcklbw MM1,MM7								;; mettre 00XX00XX00XX00XX dans MM1
		paddw MM0,MM1									;; ajouter en parallle MM1  MM0
		psrlw MM0,1									;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1								;; compacter les words de MM0 et MM1 en octets dans MM0
		movd DWORD PTR [edi],MM0							;; et recopier les 2 couleurs dans edi
		movq QWORD PTR [esi+ecx],MM0						;; mettre la premire couleur dans esi+ecx
		movq MM0,MM1									;; recopier MM1 (la deuxime couleur qui devient la premire) dans MM0
		add edi,DWORD*2								;; augmenter edi de 2 dwords
		add ecx,DWORD*2								;; augmenter ecx de 2 dwords
		jnz Label1									;; tant que ecx est diffrent de 0, aller Label1
		dec ebx										;; decrmener ebx d'une ligne
		jz Label5										;; si ebx est gal  0, aller Label5 (la sortie)
; maintenant que la premire ligne (double) a t calcule, on va pouvoir calculer les lignes intermediaires en plus...
Label2:	mov edx,edi									;; copier l'adresse edi actuelle dans edx
		add edi,eax									;; edi = Pointer + Screen_Width_x4
		mov ecx,eax									;; mettre Screen_WidthDestination_X4_ dans ecx, qui sera notre compteur de boucle pour les colonnes
		mov esi,edi									;; esi = Pointer + Screen_Width_x4
		neg ecx										;; inverser ecx, qui sera notre compteur de boucle pour les colonnes
; ici, c'est pour doubler la premire valeur des lignes
		movd MM0,DWORD PTR [edi+DWORD]					;; mettre la deuxime couleur dans MM0
		punpcklbw MM0,MM7								;; mettre 00XX00XX00XX00XX dans MM0
; ici, on traite les lignes
Label3:	movq MM3,QWORD PTR [edx+ecx]						;; mettre le qword de 2 lignes avant dans MM3
		movd MM1,DWORD PTR [edi+DWORD]					;; mettre la deuxime couleur (qui servira  crer notre valeur casse) dans MM1
		movq MM4,MM3									;; recopier MM3 dans MM4
		punpcklbw MM1,MM7								;; mettre 00XX00XX00XX00XX dans MM1
		punpcklbw MM3,MM7								;; mettre 00XX00XX00XX00XX dans MM3
		punpckhbw MM4,MM7								;; mettre 00XX00XX00XX00XX dans MM4
		paddw MM0,MM1									;; ajouter en parallle MM1  MM0
		psrlw MM0,1									;; diviser en parallle les words en MM0 par 2 (par un dcalage  droite de 2 bits)
		paddw MM4,MM1									;; ajouter en parallle MM1  MM4
		paddw MM3,MM0									;; ajouter en parallle MM2  MM3
		psrlw MM4,1									;; diviser en parallle les words en MM4 par 2 (par un dcalage  droite de 2 bits)
		psrlw MM3,1									;; diviser en parallle les words en MM3 par 2 (par un dcalage  droite de 2 bits)
		packuswb MM0,MM1								;; compacter les words de MM0 et MM1 en octets dans MM0
		packuswb MM3,MM4								;; compacter les words de MM3 et MM4 en octets dans MM3
		movd DWORD PTR [edi],MM0							;; et recopier la premire couleur (inchange) + notre valeur casse dans edi
		movq QWORD PTR [esi+ecx],MM3						;; et recopier les deux couleurs casses dans esi+ecx (la ligne prcdente)
		movq MM0,MM1									;; recopier MM1 (la premire couleur qui devient la deuxime) dans MM0
Label4:	add edi,DWORD*2								;; augmenter edi de 2 dwords
		add ecx,DWORD*2								;; augmenter ecx de 2 dwords
		jnz Label3									;; tant que ecx est diffrent de 0, aller Label3
		dec ebx										;; decrmener ebx d'une ligne
		jnz Label2									;; tant que ebx est diffrent de 0, aller Label2
Label5:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
ScreenBlur_Mmx ENDP


ALIGN 16
;
; capture of the current screen, and save.
;
; Syntax :
; call ScreenCapture
;
; Return :
; nothing
;
ScreenCapture PROC

		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; lier le chemin et le nom du fichier
		mov esi,OFFSET Capture_sz_Directory_Name			;; ) copier le chemin
		mov edi,OFFSET Capture_sz_Complete_Name				;; )
		call CopyAsciiString							;; )
		mov esi,OFFSET Capture_sz_File_Name				;;	) ajouter le nom du fichier
		add edi,eax									;;	)
		call AddAsciiString								;;	)
		add edi,eax									;; ajouter eax  edi ici, puisqu'on a dj la valeur
		mov eax,Capture_Capture_Number					;; ) convertir le numro de capture en chane
		mov esi,OFFSET Capture_sz_Capture_Number			;; )
		call DwordToDecAsciiString						;; )
		mov esi,OFFSET Capture_sz_Capture_Number			;;	) ajouter le numro de capture
		call AddAsciiString								;;	)
		mov esi,OFFSET Capture_sz_Bmp_Extension				;; ) ajouter l'extension bmp
		add edi,eax									;; )
		call AddAsciiString								;; )
; crer un device context temporaire
;		mov ebp,OFFsET _Capturer_Chaine_PasDeviceContext_		;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateDC,ADDR Capture_sz_Display,NULL,NULL,NULL
		test eax,eax									;; fixer les flags de eax
		jz NoDC										;; si eax est gal  0 (erreur cration DC), aller NoDC
		mov Capture_Temporary_DC_Pointer,eax				;; sauvegarder le pointeur obtenu
; obtenir les informations de l'cran  capturer
		invoke GetDeviceCaps,Capture_Temporary_DC_Pointer,HORZRES	;; ) obtenir la width de l'cran
		mov Capture_Screen_Width,eax							;; )
		invoke GetDeviceCaps,Capture_Temporary_DC_Pointer,VERTRES	;;	) obtenir la height de l'cran
		mov Capture_Screen_Height,eax							;;	)
		invoke GetDeviceCaps,Capture_Temporary_DC_Pointer,BITSPIXEL	;; ) obtenir la depth (en plans) de l'cran
		mov Capture_Bits_Per_Pixel_Number,eax					;; )
		cmp eax,8										;; comparer le nombre de bits par pixels  8
		ja MoreThan256Colours							;; si c'est suprieur, aller MoreThan256Colours
		invoke GetDeviceCaps,Capture_Temporary_DC_Pointer,NUMCOLORS	;; sinon, rcuprer le nombre de couleurs
;		mov Capture_Number_Of_Colours,eax					;; ) ici, -1 peut etre retourn si il y a moins de 256 couleurs et une depth suprieur,
		mov Capture_Number_Of_Colours,256					;; ) on va donc mettre une palette de 256 couleurs par dfaut
		jmp NumberOfColoursDefined						;; aller NumberOfColoursDefined
MoreThan256Colours:
		mov Capture_Number_Of_Colours,0					;; mettre 0 dans Capture_Number_Of_Colours (plus rapide pour savoir s'il y a plus de 256 couleurs)
NumberOfColoursDefined:
; crer un devic context compatible
;		mov ebp,OFFsET _Capturer_Chaine_PasDeviceCompatible_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateCompatibleDC,Capture_Temporary_DC_Pointer
		test eax,eax									;; fixer les flags de eax
		jz NoCompatibleDC								;; si eax est gal  0 (erreur cration DC), aller NoCompatibleDC
		mov Capture_Compatible_DC_Pointer,eax				;; sauvegarder le pointeur obtenu
; remplir la structure BITMAPINFOHEADER
		mov Capture_Bmp_Info_Header.biSize,SIZEOF BITMAPINFOHEADER	;; mettre la taiile de la structure BITMAPINFOHEADER
		mov eax,Capture_Screen_Width						;; ) mettre la width
		mov Capture_Bmp_Info_Header.biWidth,eax				;; )
		mov eax,Capture_Screen_Height						;;	) mettre la height
		mov Capture_Bmp_Info_Header.biHeight,eax			;;	)
		mov Capture_Bmp_Info_Header.biPlanes,1				;; nombre de plans (doit tre gal  1)
		mov eax,Capture_Bits_Per_Pixel_Number				;; ) mettre le nombre de bits par pixels
		mov Capture_Bmp_Info_Header.biBitCount,ax			;; )
		mov Capture_Bmp_Info_Header.biCompression,BI_RGB		;; mettre le format non comprss
		mov Capture_Bmp_Info_Header.biSizeImage,0			;; ) s'assurer que c'est vide
		mov Capture_Bmp_Info_Header.biXPelsPerMeter,0		;; )
		mov Capture_Bmp_Info_Header.biYPelsPerMeter,0		;; )
		mov eax,Capture_Number_Of_Colours					;;	) mettre le nombre de couleurs
		mov Capture_Bmp_Info_Header.biClrUsed,eax			;;	)
		mov Capture_Bmp_Info_Header.biClrImportant,eax		;; mettre le nombre des couleurs importantes
; crer un DIB
		invoke CreateDIBSection,Capture_Temporary_DC_Pointer,ADDR Capture_Bmp_Info_Header,DIB_PAL_COLORS,ADDR Capture_Pixels_To_Catch_Pointer,NULL,0
		test eax,eax									;; fixer les flags de eax
		jz NoCompatibleBitmap							;; si eax est gal  0 (erreur cration DIB), aller NoCompatibleBitmap
		mov Capture_New_Dib_Pointer,eax					;; sauvegarder le pointeur du nouveau DIB (dont les pixels se situent  l'adresse Capture_Pixels_To_Catch_Pointer)
; slectionner l'objet
;		mov ebp,OFFsET _Capturer_Chaine_PasSelectionnerBitmap_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke SelectObject,Capture_Compatible_DC_Pointer,Capture_New_Dib_Pointer
		test eax,eax									;; fixer les flags de eax
		jz NoCompatibleBitmap							;; si eax est gal  0 (erreur de selection), aller NoCompatibleBitmap
		cmp eax,GDI_ERROR								;; comparer eax  GDI_ERROR
		je NoCompatibleBitmap							;; si c'est une erreur GDI, aller NoCompatibleBitmap
; ici, on va tester si la rcupration des pixels est possible (et on le fait si c'est le cas...)
;		mov ebp,OFFsET _Capturer_Chaine_PasCopierBitmap_		;; n'activer que si l'on a besoin des messages d'erreur
		invoke BitBlt,Capture_Compatible_DC_Pointer,0,0,Capture_Screen_Width,Capture_Screen_Height,Capture_Temporary_DC_Pointer,0,0,SRCCOPY
		test eax,eax									;; fixer les flags de eax
		jz NoCompatibleBitmap							;; si eax est gal  0 (erreur de copie), aller NoCompatibleBitmap
; rcuprer la palette (si c'est ncessaire)
		mov eax,Capture_Number_Of_Colours					;; mettre le nombre de couleurs dans eax
		test eax,eax									;; fixer les flags de eax
		jz AvoidToGetColoursList							;; si le nombre de couleurs est gal  0, aller AvoidToGetColoursList
		invoke GetDIBColorTable,Capture_Compatible_DC_Pointer,0,Capture_Number_Of_Colours,ADDR Capture_Colours_List
		mov Capture_Number_Of_Colours,eax					;; mise  jour du nombre de couleurs
AvoidToGetColoursList:
; dfinir la taille de la palette
		mov eax,SIZEOF RGBQUAD							;; mettre la taille de la structure RGBQUAD dans eax
		mul Capture_Number_Of_Colours						;; multiplier cette taille par le nombre de couleurs
		mov Capture_Colours_List_Size,eax					;; sauvegarder la taille de la palette
; dfinir la taille de l'entete du fichier  sauvegarder
		mov ebx,SIZEOF BITMAPFILEHEADER					;; mettre la taille de l'entete dans ebx
		add ebx,SIZEOF BITMAPINFOHEADER					;; ajouter les informations
		add ebx,Capture_Colours_List_Size					;; ajouter la taille de la palette
		add ebx,(SIZEOF Capture_sz_Production)-1			;; ajouter la chane concernant la production (moins le zro final)
		xor ecx,ecx									;; ) obtenir le complment pour un alignement sur 16 octets
		mov edx,ebx									;; )
		and edx,00000000Fh								;; )
		jz AlignmentNotNeeded							;; )
		mov ecx,000000010h								;; )
		sub ecx,edx									;; )
AlignmentNotNeeded:
		mov Capture_Alignment_Value,ecx					;; sauvegarder la taille du complment
		add ebx,ecx									;; ajouter le complement pour l'alignement
; dfinir la taille du bitmap du fichier  sauvegarder
		mov eax,Capture_Bits_Per_Pixel_Number				;; lire le nombre de bits par pixels
		mul Capture_Screen_Width							;; multiplier cette valeur par la width du bitmap
		mul Capture_Screen_Height						;; multiplier le rsultat par la height du bitmap
		shr eax,3										;; diviser le rsultat par 8 (pour avoir la taille en octets)
		mov Capture_Bitmap_Size,eax						;; sauvegarder la taille du bitmap (reservira plus tard)
; dfinir la taille complte du fichier  sauvegarder
		add eax,ebx									;; ajouter l'entete du fichier
; remplir la structure BITMAPFILEHEADER
		mov Capture_Bmp_File_Header.bfType,4D42h			;; mettre "MB" pour BitMap
		mov Capture_Bmp_File_Header.bfSize,eax				;; sauvegarder la taille du fichier
		mov Capture_Bmp_File_Header.bfReserved1,0			;; ) s'assurer que c'est vide
		mov Capture_Bmp_File_Header.bfReserved2,0			;; )
		mov Capture_Bmp_File_Header.bfOffBits,ebx			;; sauvegarder la taille de l'entte (pour pouvoir retrouver l'emplacement des pixels)
; une fois toutes les valeurs initialises, on va sauvegarder
;		mov ebp,OFFsET _Capturer_Chaine_PasSauvegarderFichierBmp_	;; n'activer que si l'on a besoin des messages d'erreur
		invoke CreateFile,ADDR Capture_sz_Complete_Name,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
		cmp eax,INVALID_HANDLE_VALUE						;; comparer le pointeur obtenu  INVALID_HANDLE_VALUE
		je NoBitmapFile								;; si c'est le cas, aller NoBitmapFile
		mov Capture_Temporary_File_Pointer,eax				;; sinon, sauvegarder le Capture_Temporary_File_Pointer
; sauvegarder l'entte du fichier bmp
		invoke WriteFile,Capture_Temporary_File_Pointer,ADDR Capture_Bmp_File_Header,SIZEOF BITMAPFILEHEADER,ADDR Capture_Bytes_Written,NULL
; sauvegarder les informations du fichier bmp 
		invoke WriteFile,Capture_Temporary_File_Pointer,ADDR Capture_Bmp_Info_Header,SIZEOF BITMAPINFOHEADER,ADDR Capture_Bytes_Written,NULL
; sauvegarder (ventuellement) la palette du fichier bmp
		cmp Capture_Number_Of_Colours,0					;; comparer le nombre de couleurs  0
		je NoNeedToSaveColoursList						;; si c'est le cas, aller NoNeedToSaveColoursList
		invoke WriteFile,Capture_Temporary_File_Pointer,ADDR Capture_Colours_List,Capture_Colours_List_Size,ADDR Capture_Bytes_Written,NULL
NoNeedToSaveColoursList:
; sauvegarder l'information de production 
		invoke WriteFile,Capture_Temporary_File_Pointer,ADDR Capture_sz_Production,(SIZEOF Capture_sz_Production)-1,ADDR Capture_Bytes_Written,NULL
; sauvegarder le complment ncessaire  un alignement sur 16 octets (ce qui permettra d'utiliser ultrieurement les instructions simd directement sur les pixels)
		invoke WriteFile,Capture_Temporary_File_Pointer,ADDR Capture_Alignment,Capture_Alignment_Value,ADDR Capture_Bytes_Written,NULL
; sauvegarder les pixels du fichier bmp 
		invoke WriteFile,Capture_Temporary_File_Pointer,Capture_Pixels_To_Catch_Pointer,Capture_Bitmap_Size,ADDR Capture_Bytes_Written,NULL
		invoke CloseHandle,Capture_Temporary_File_Pointer		;; supprimer Capture_Temporary_File_Pointer (qui est devenu inutile...)
		inc Capture_Capture_Number						;; incrmenter le numro de la capture
;		invoke MessageBox,0,ADDR _Capturer_Chaine_Travail_Effectue_,NULL,0	;; n'activer que si l'on a besoin d'un message de confirmation
; on fini en supprimant ce qui a t temporairement utilis
		invoke DeleteObject,Capture_New_Dib_Pointer			;; ) supprimer les pointeurs/devices devenus inutiles
		invoke DeleteDC,Capture_Compatible_DC_Pointer		;; )
		invoke DeleteDC,Capture_Temporary_DC_Pointer			;; )

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)

; la sortie, si une erreur est survenue
NoBitmapFile:
		invoke DeleteObject,Capture_New_Dib_Pointer			;; ) supprimer les pointeurs/devices devenus inutiles
NoCompatibleBitmap:										;; )
		invoke DeleteDC,Capture_Compatible_DC_Pointer		;; )
NoCompatibleDC:										;; )
		invoke DeleteDC,Capture_Temporary_DC_Pointer			;; )
NoDC:
;		invoke MessageBox,0,ebp,NULL,0
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
ScreenCapture ENDP


ALIGN 16
;
; set the screen capture directory, (the current directory)
;
; Syntax :
; call SetCaptureDirectory
;
; Return :
; nothing
;
SetCaptureDirectory PROC

		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		invoke GetCurrentDirectory,MAX_PATH,ADDR Capture_sz_Directory_Name
		mov esi,OFFSET Capture_sz_Separator
		mov edi,OFFSET Capture_sz_Directory_Name
		call AddAsciiString

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
SetCaptureDirectory ENDP


ALIGN 16
;
; set the proportionnal width and height of a screen to fit in another screen
; note : be sure eax and ebx are different of 0, otherwise division by 0...)
;
; Syntax :
; mov eax,width of the screen (in pixels)
; mov ebx,height of the screen (in pixels)
; mov ecx,width of the screen used for display (in pixels)
; mov edx,height of the screen used for display (in pixels)
; call SetResizingSizes
;
; Return :
; ecx = proportionnal width of the screen we want to obtain
; edx = proportionnal height of the screen we want to obtain
;
SetResizingSizes PROC
		push eax										;; empiler eax
		push esi										;; empiler esi
		push edi										;; empiler edi

; on regarde si la width redimensionne est infrieure  la lageur maxi
		mov esi,eax									;; copier la width dans esi
		mov edi,edx									;; copier la height maxi dans edi
		mul edi										;; multiplier la width par la height maxi
		xor edx,edx									;; ) diviser par la height
		div ebx										;; )
		cmp eax,ecx									;; comparer la width obtenue  la width maxi
		jl Label01									;; si c'est infrieur, aller Label01
; sinon, c'est que c'est la height redimensionne qui est infrieure  la height maxi
		mov eax,ebx									;; sinon, mettre la height dans eax
		mul ecx										;; multiplier par la width maxi
		xor edx,edx									;; ) diviser par la width
		div esi										;; )
		mov edx,eax									;; mettre la height obtenue dans edx
		jmp Label02									;; aller Label02

Label01:	mov ecx,eax									;; mettre la width obtenue dans ecx
		mov edx,edi									;; replacer la height maxi dans edx
Label02:
		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SetResizingSizes ENDP


ALIGN 16
;
; reate and define a resizing table
; note : ne pas oublier de supprimer la table de redimensionnement prcdente (s'il y en a une) avant d'en crer
; une nouvelle (le cumul injustifi causera un crash). et videment, il faut s'assurer qu'une instance mmoire a
; t cre
; note : cette version turbo utilise des multiplicateurs "magiques", si ceux-ci manquent de prcision (arrondis)
; sur de grandes valeurs, il sont parfait pour de petites valeurs (sauf 0 et 1, l ca doit tre trait autrement).
; c'est test sans erreurs lorsque la valeur  diviser va de 0  65536, et que le diviseur va de de 2  65536
; (ce qui est amplement suffisant pour traiter des crans... ben ouip, des crans de plus de 65536 pixels en
; width ou en height, ben j'en ai pas encore vu...)
; NOTE 2 : les "crans" de 0 ou 1 pixel en width ou en height (ha... mais ils y en a qui en seraient capables)
; ne doivent pas tre traits par cette routine, mais par DefinirTableDeRedimensionnement
;
; Syntax :
; mov eax,width of the screen (in pixels) (width obtained by SetResizingSizes if it must be proportionnal)
; mov ebx,height of the screen (in pixels) (height obtained by SetResizingSizes if it must be proportionnal)
; mov ecx,width of the screen used for display (in pixels)
; mov edx,height of the screen used for display (in pixels)
; mov esi,OFFSET of the Mem_Info structure (we need to alloc memory)
; mov edi,OFFSET of a Screen_Block structure (the buffer for the table)
; call SetResizingTable
;
; Return :
; nothing
;
SetResizingTable PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde les entres, ca va reservir...
		mov Resizing_Screen_Width,eax						;; sauvegarder ecx dans Resizing_Screen_Width
		mov Resizing_Screen_Height,ebx					;; sauvegarder edx dans Resizing_Screen_Height
		mov (Screen_Block PTR [edi]).Screen_Width,ecx		;; sauvegarder ecx dans x.Screen_Width
		mov (Screen_Block PTR [edi]).Screen_Height,edx		;; sauvegarder edx dans x.Screen_Height
; ici, on calcule nos multiplicateurs "magiques", pour la height :
		mov ebx,edx									;; mettre la height dans ebx
		mov eax,0FFFFFFFFh								;; remplir le registre eax
		xor edx,edx									;; effacer edx pour la division qui suit
		div ebx										;; diviser eax par la height
		inc eax										;; augmenter le rsultat obtenu de 1 (pour faire passer virtuellement FFFFFFFF  100000000)
		mov Resizing_Height_Multiplier,eax					;; sauvegarder le multiplicateur obtenu
; pour la width :
		mov ebx,ecx									;; mettre la width dans ebx
		mov eax,0FFFFFFFFh								;; remplir le registre eax
		xor edx,edx									;; effacer edx pour la division qui suit
		div ebx										;; diviser eax par la width
		inc eax										;; augmenter le rsultat obtenu de 1 (pour faire passer virtuellement FFFFFFFF  100000000)
		mov Resizing_Width_Multiplier,eax					;; sauvegarder le multiplicateur obtenu
; puis on calcul la taille mmoire  allouer...
		mov eax,ecx									;; mettre la width maximale dans eax
		shl eax,2										;; multiplier x.Screen_Width par 4 (1 dword)
		mov (Screen_Block PTR [edi]).Screen_Width_x4,eax		;; mettre eax dans x.Screen_Width_x4
		mul (Screen_Block PTR [edi]).Screen_Height			;; multiplier x.Screen_Width*DWORD par x.Screen_Height
		mov (Screen_Block PTR [edi]).Block_Size,eax			;; mettre eax dans x.Block_Size
		add eax,000000010h								;; ajouter 16  la taille (pour aligner le bloc mmoire sur 16 octets)
; on alloue l'espace mmoire (qui est en fait gal  la taille cran) pour la table (ce sera la zone de substitution de valeur)
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov (Screen_Block PTR [edi]).Pointer_To_Free,eax		;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov (Screen_Block PTR [edi]).Pointer,eax			;; sauvegarder eax dans x.Pointer
;		mov (Screen_Block PTR [edi]).DBuffer_Pointer,eax		;; sauvegarder eax dans x.DBuffer_Pointer
;		mov (Screen_Block PTR [edi]).ZBuffer_Pointer,eax		;; sauvegarder eax dans x.ZBuffer_Pointer (ca vite des dsagrments de mauvaise utilisation CreateScreen/CreateScreenWithZBuffer)
;		mov (Screen_Block PTR [edi]).Face_Limits_Pointer,eax	;; sauvegarder eax dans x.Face_Limits_Pointer
; maintenant on va remplir chaque valeur de la premire ligne de notre table de substitution par la position relative dans l'cran originel
		mov esi,eax									;; copier x.Pointer dans esi
;		mov ebx,(Screen_Block PTR [edi]).Screen_Width		;; mettre x.Screen_Width dans ebx
		xor ecx,ecx									;; effacer ecx
; ici, on calcule les valeurs de substitution de la width
Label1:	mov eax,ecx									;; copier ecx dans eax
		mul Resizing_Screen_Width						;; multiplier eax par Resizing_Screen_Width
		mul Resizing_Width_Multiplier						;; diviser par la width
		shl edx,2										;; multiplier le rsultat obtenu en edx par 4
		mov DWORD PTR [4*ecx+esi],edx						;; et le mettre dans le dword en 4*ecx+esi
		inc ecx										;; incrmenter le pas de boucle
		cmp ecx,ebx									;; comparer ecx  x.Screen_Width
		jb Label1										;; tant que ecx est infrieur  x.Screen_Width, aller Label1
; ici, la premire ligne est calcule, on va la recopier dans toutes les autres lignes
		shl ebx,2										;; multiplier ebx par 4
		mov eax,(Screen_Block PTR [edi]).Screen_Height		;; mettre x.Screen_Height (le nombre de lignes) dans eax
		dec eax										;; enlever une ligne  eax (ben oui, on en a dja calcul une...)
; ici on traite les owords
		mov ebp,ebx
Label2:	mov ecx,ebx									;; copier x.Screen_Width x4 dans ecx
		and ecx,11111111111111111111111111110000b			;; ne conserver que les bits owords en ecx
		jz Label4										;; si ecx est gal  0, aller Label4
Label3:	mov edx,DWORD PTR [esi]							;; mettre le dword en esi dans ebx
		mov DWORD PTR [ebp+esi],edx						;; mettre le dword en ebp+esi
		mov edx,DWORD PTR [esi+4]						;; mettre le dword en esi+4 dans edx
		mov DWORD PTR [ebp+esi+4],edx						;; mettre le dword en ebp+esi+4
		mov edx,DWORD PTR [esi+8]						;; mettre le dword en esi+8 dans ebx
		mov DWORD PTR [ebp+esi+8],edx						;; mettre le dword en ebp+esi+8
		mov edx,DWORD PTR [esi+12]						;; mettre le dword en esi+12 dans edx
		mov DWORD PTR [ebp+esi+12],edx					;; mettre le dword en ebp+esi+12
		add esi,DWORD*4								;; augmenter l'adresse en esi de 4 dwords
		sub ecx,DWORD*4								;; enlever 1 oword  ecx
		jnz Label3									;; tant que ecx est diffrent de 0, aller Label3
; ici on traite les dwords
Label4:	mov ecx,ebx									;; copier x.Screen_Width x4 dans ecx
		and ecx,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ecx
		jz Label6										;; si ecx est gal  0, aller Label6
Label5:	mov edx,DWORD PTR [esi]							;; mettre le dword en esi dans ebx
		mov DWORD PTR [ebp+esi],edx						;; mettre le dword en ebx+esi
		add esi,DWORD									;; augmenter l'adresse en esi d'1 dword
		sub ecx,DWORD									;; enlever 1 dword  ecx
		jnz Label5									;; tant que ecx est sign, aller Label5
; ici on ne traite pas les octets (car au minimum ce sont des dwords)


Label6:	add ebp,ebx									;; ajouter la ligne copie  ebp
		sub esi,ebx									;; soustraire la ligne copie  esi (pour retrouver l'adresse originelle)
		dec eax										;; dcrmenter eax
		jnz Label2									;; tant que eax est diffrent de 0, aller Label2
; ici, notre table est remplie de premires ligne, on initialise la boucle pour la height
		xor ecx,ecx									;; mettre ecx  0

; ici, on calcule les valeurs de substitution de la height
Label7:	mov eax,ecx									;; copier ecx dans eax
		mul Resizing_Screen_Height						;; multiplier eax par Resizing_Screen_Height
		mul Resizing_Height_Multiplier					;; diviser par la height
		mov eax,edx									;; mettre le rsultat obtenu en edx dans eax
		mul Resizing_Screen_Width						;; et multiplier le rsultat en eax par une width de ligne
		shl eax,2										;; on multiplie eax par 4 (comme ca on a multipli par Largeur de ligne x4)

; ici, la height est dfinie, on l'ajoute sur toutes les valeurs de la ligne, on traite les owords
		mov ebp,ebx									;; copier x.Screen_Width x4 dans ebp
		and ebp,11111111111111111111111111110000b			;; ne conserver que les bits owords en ebp
		jz Label9										;; si ebp est gal  0, aller Label9
Label8:	add DWORD PTR [esi],eax							;; mettre le dword en esi+ebp
		add DWORD PTR [esi+4],eax						;; mettre le dword en esi+ebp+4
		add DWORD PTR [esi+8],eax						;; mettre le dword en esi+ebp+8
		add DWORD PTR [esi+12],eax						;; mettre le dword en esi+ebp+12
		add esi,DWORD*4								;; on ajoute 4 dwords  esi
		sub ebp,DWORD*4								;; on enleve 16  ebp (notre pas de boucle)
		jnz Label8									;; tant que ebp est diffrent de 0, aller Label8
; ici on traite les dwords
Label9:	mov ebp,ebx									;; copier x.Screen_Width x4 dans ebp
		and ebp,00000000000000000000000000001100b			;; ne conserver que les bits dwords en ebp
		jz Label11									;; si ebp est gal  0, aller Label11
		add esi,ebp									;; on ajoute ebp  esi
		neg ebp										;; inverser ebp
Label10:	add DWORD PTR [esi+ebp],eax						;; mettre le dword en esi+ebp
		add ebp,4										;; on ajoute 4  ebp (notre pas de boucle)
		jnz Label10									;; tant que ebp est sign, aller Label10
; ici on ne traite pas les octets (car au minimum ce sont des dwords)
Label11:	inc ecx										;; incrmenter le pas de boucle
		cmp ecx,(Screen_Block PTR [edi]).Screen_Height		;; comparer ecx  x.Screen_Height
		jb Label7										;; tant que ecx est infrieur  x.Screen_Height, aller Label7

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
SetResizingTable ENDP


ALIGN 16
;
; mettre  jour l'cran sur lequel on va travailler (cette routine n'est utile que lorsqu'il y a un dbuffer. et
; ne devrait pas tre employe s'il n'y en a pas... mme si ca ne causera pas de crash). cette mise  jour doit
; tre positionne au dbut de la boucle principale de votre programme (ou tout au moins avant d'crire pour la
; premire fois dans l'cran), ou alors en toute fin de boucle (aprs l'utilisation de SetDIBitsToDevice)
;
; Syntax :
; mov edi,OFFSET of the Screen_Block structure
; call UpdateDBuffer
;
; Return :
; nothing
;
UpdateDBuffer PROC

		push (Screen_Block PTR [edi]).Pointer				;; ) changer les pointeurs (c'est plus rapide que d'changer les blocs...)
		push (Screen_Block PTR [edi]).DBuffer_Pointer		;; )
		pop (Screen_Block PTR [edi]).Pointer				;; )
		pop (Screen_Block PTR [edi]).DBuffer_Pointer			;; )

	ret												;; retourner (sortir de la procdure)
UpdateDBuffer ENDP


;
; LINE / SPRITE
;
.DATA
Line_Y_Decay					DWORD ?
Line_Maxi_Distance				DWORD ?
Line_Line_Colour				DWORD ?


Sprite_Line_x4_To_Complete		DWORD ?
Sprite_Width_Loop				DWORD ?
Sprite_Height_Loop				DWORD ?


.CODE
ALIGN 16
;
; dessiner une ligne de X1,Y1  X2,Y2 (quelque soit la validit des valeurs)
;
; Syntax :
; mov eax,position X of the fisrt point (in pixels)
; mov ebx,position Y of the fisrt point (in pixels)
; mov ecx,position X of the second point (in pixels)
; mov edx,position Y of the second point (in pixels)
; mov esi,OFFSET of the Screen_Block structure
; mov edi,the colour of the line
; call DrawLine
;
; Return :
; nothing
;
DrawLine PROC

;
; ici, on teste si les points se situent bien dans l'cran, sinon on va effectuer d'autres tests...
;
		cmp eax,(Screen_Block PTR [esi]).Screen_Width		;; comparer eax  la width
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp ecx,(Screen_Block PTR [esi]).Screen_Width		;; comparer X2  x.Screen_Width
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp ebx,(Screen_Block PTR [esi]).Screen_Height		;; comparer ebx  la height
		jae Label12									;; si c'est suprieur ou gal, aller Label12
		cmp edx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y2  x.Screen_Height
		jae Label12									;; si c'est suprieur ou gal, aller Label12

;
; l, les 2 points sont situs dans l'cran, alors on fait dans la rapidit...
;
Label00:	pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on sauvegarde la couleur (ce qui permettra d'utiliser le registre edi)
		mov Line_Line_Colour,edi							;; sauvegarder la couleur dans Line_Line_Colour
		cmp eax,ecx									;; comparer la coordonne X1  X2
		ja Label01									;; si X1 est suprieur  X2, aller Label01
; ici, eax est le plus  gauche, donc on n'change pas la position des points
		lea edi,[4*eax]								;; sauvegarder la coordonne X1 *4 dans edi
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov ebp,edx									;; sauvegarder l'cart Y (Y2-Y1) dans ebp
		mov eax,ebx									;; mettre Y1 dans eax
		mov ebx,ecx									;; mettre l'cart X (X2-X1) dans ebx
		jmp Label02									;; aller Label02
; ici, ecx est le plus  gauche, donc on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label01:	lea edi,[4*ecx]								;; sauvegarder la coordonne X1 (en fait X2) *4 dans edi
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov ebp,ebx									;; sauvegarder l'cart Y (Y1-Y2) dans ebp
		mov ebx,eax									;; mettre l'cart X (X1-X2) dans ebx
		mov eax,edx									;; mettre Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label02:	mov ecx,(Screen_Block PTR [esi]).Screen_Width_x4		;; mettre x.Screen_Width_x4 dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier Y1 par x.Screen_Width_x4
		add edi,eax									;; ajouter Y1 * x.Screen_Width_x4  edi
		add edi,(Screen_Block PTR [esi]).Pointer			;; on ajoute  edi le pointeur de dbut du bloc mmoire (qui contient dsormais la position du point)
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,ebp									;; mettre ebp dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label03									;; si eax n'est pas sign, aller Label03
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en height positif
		neg ecx										;; inverser ecx (x.Screen_Width_x4), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label03:	mov ebp,ecx									;; sauvegarder ecx dans ebp (cart Y * width ligne)
; ici,
; eax = cart en height
; ebx = cart en width
; esi = adresse de la structure Screen_Block
; edi = adresse cran + position Y + position X

; ici, on dtermine laquelle des 2 boucles on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label07									;; si eax est suprieur, aller Label07
;
; ici, on traite le cas o la width est la plus importante
;
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		mov ecx,ebx									;; copier ebx (l'cart en width) dans ecx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label06									;; si ecx est gal  zro, aller Label06
		lea esi,[4*ebx]								;; mettre ebx*4 dans esi, qui devient notre pas de boucle
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc ax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label04:	mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
; calcul des nouvelles coordonnes
		sub cx,ax										;; soustraire l'cart en height  ecx
		jns Label05									;; si c'est positif, aller Label05
		add cx,bx										;; sinon, ajouter l'cart en width  ecx
		add edi,ebp									;; ajouter ebp (cart Y * width ligne)  edi
Label05:	add esi,DWORD									;; augmenter esi de DWORD
		jnz Label04									;; tant que esi n'est pas gal  0, retourner Label04
; on place le dernier point
		mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
; on place le seul point
Label06:	mov DWORD PTR [edi],edx							;; mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)

	ret												;; retourner (sortir de la procdure)
;
; ici, on traite le cas o la height est la plus importante
;
Label07:	mov ecx,eax									;; copier eax (l'cart en height) dans ecx
		imul ebp										;; multiplier eax par ebp (cart Y * width ligne) (sign car ebp peut tre ngatif)
		mov esi,eax									;; mettre eax dans esi, qui va devenir notre pas de boucle
		mov eax,ecx									;; replacer l'cart en height dans eax
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label10									;; si ecx est gal  zro, aller Label10
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc bx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label08:	mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
; calcul des nouvelles coordonnes
		sub cx,bx										;; soustraire l'cart en width  ecx
		jns Label09									;; si c'est positif, aller Label09
		add cx,ax										;; sinon, ajouter l'cart en height  ecx
		add edi,DWORD									;; ajouter DWORD  edi
Label09:	add esi,ebp									;; augmenter esi de ebp (cart Y * width ligne)
		jnz Label08									;; tant que esi n'est pas gal  0, retourner Label08
; on place le dernier point
		mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
; on place le seul point
Label10:	mov DWORD PTR [edi],edx							;; mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label11:
	ret												;; retourner (sortir de la procdure)


;
; ici, on va determiner s'il y a un travail  effectuer ou pas (si la ligne est compltement hors cran on sort)
;

; ici, on va effectuer une serie de test en fonction des positions X
Label12:	cmp eax,ecx									;; comparer eax  ecx
		jg Label14									;; si eax est suprieur sign, aller Label14
;
; ici, ecx >= eax
;
		bt ecx,31										;; tester le bit du signe de X2
		jc Label11									;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp eax,(Screen_Block PTR [esi]).Screen_Width		;; comparer X1  x.Screen_Width
		jge Label11									;; si c'est suprieure ou gale sign (X1 et X2 > width), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx									;; comparer ebx  edx
		jg Label13									;; si eax est infrieur sign, aller Label13

; ici, ecx >= eax et edx >= ebx
		bt edx,31										;; tester le bit du signe de Y2
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y1  x.Screen_Height
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > height), aller Label11 (la sortie)
; on initialise quelques valeurs
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov Line_Line_Colour,edi							;; sauvegarder la couleur dans Line_Line_Colour
		mov ebp,esi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31										;; tester le bit du signe de X1
		jc Label27									;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y1  x.Screen_Height
		jae Label27									;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > height), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov Line_Y_Decay,edx							;; sauvegarder l'cart Y (Y2-Y1) dans Line_Y_Decay
		mov eax,ebx									;; mettre Y1 dans eax
		mov ebx,ecx									;; mettre l'cart X (X2-X1) dans ebx
		jmp Label16									;; aller Label16

; ici, ecx >= eax et ebx > edx
Label13:	bt ebx,31										;; tester le bit du signe de Y1
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y2  x.Screen_Height
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > height), aller Label11 (la sortie)
; on initialise quelques valeurs
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov Line_Line_Colour,edi							;; sauvegarder la couleur dans Line_Line_Colour
		mov ebp,esi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt eax,31										;; tester le bit du signe de X1
		jc Label27									;; s'il est positionn (X1 < 0), aller Label27
		cmp ebx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y1  x.Screen_Height
		jae Label27									;; si c'est suprieure ou gale (Y1 > 0 ou Y1 > height), aller Label27
; ici, on n'change pas les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov Line_Y_Decay,edx							;; sauvegarder l'cart Y (Y2-Y1) dans Line_Y_Decay
		mov eax,ebx									;; mettre Y1 dans eax
		mov ebx,ecx									;; mettre l'cart X (X2-X1) dans ebx
		jmp Label16									;; aller Label16

;
; ici, eax > ecx
;
Label14:	bt eax,31										;; tester le bit du signe de X1
		jc Label11									;; s'il est positionn (X1 et X2 < 0), aller Label11 (la sortie)
		cmp ecx,(Screen_Block PTR [esi]).Screen_Width		;; comparer X2  x.Screen_Width
		jge Label11									;; si c'est suprieure ou gale sign (X1 et X2 > width), aller Label11 (la sortie)
; ici, on va effectuer une serie de test en fonction des positions Y
		cmp ebx,edx									;; comparer ebx  edx
		jg Label15									;; si ebx est suprieur sign, aller Label15

; ici, edx >= ebx
		bt edx,31										;; tester le bit du signe de Y2
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp ebx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y1  x.Screen_Height
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > height), aller Label11 (la sortie)
; on initialise quelques valeurs
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov Line_Line_Colour,edi							;; sauvegarder la couleur dans Line_Line_Colour
		mov ebp,esi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31										;; tester le bit du signe de X2
		jc Label27									;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y2  x.Screen_Height
		jae Label27									;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > height), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov Line_Y_Decay,ebx							;; sauvegarder l'cart Y (Y1-Y2) dans Line_Y_Decay
		mov ebx,eax									;; mettre l'cart X (X1-X2) dans ebx
		mov eax,edx									;; mettre Y1 (en fait Y2)
		jmp Label16									;; aller Label16

; ici, ebx > edx
Label15:	bt ebx,31										;; tester le bit du signe de Y1
		jc Label11									;; s'il est positionn (Y1 et Y2 < 0), aller Label11 (la sortie)
		cmp edx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y2  x.Screen_Height
		jge Label11									;; si c'est suprieure ou gale sign (Y1 et Y2 > height), aller Label11 (la sortie)
; on initialise quelques valeurs
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
		mov Line_Line_Colour,edi							;; sauvegarder la couleur dans Line_Line_Colour
		mov ebp,esi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
; ici, on teste si l'on doit calculer l'entre du point dans l'cran
		bt ecx,31										;; tester le bit du signe de X2
		jc Label27									;; s'il est positionn (X2 < 0), aller Label27
		cmp edx,(Screen_Block PTR [esi]).Screen_Height		;; comparer Y2  x.Screen_Height
		jae Label27									;; si c'est suprieure ou gale (Y2 > 0 ou Y2 > height), aller Label27
; ici, on change les positions et on saute  l'endroit appropri de l'algorythme
		mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov Line_Y_Decay,ebx							;; sauvegarder l'cart Y (Y1-Y2) dans Line_Y_Decay
		mov ebx,eax									;; mettre l'cart X (X1-X2) dans ebx
		mov eax,edx									;; mettre Y1 (en fait Y2)
;		jmp Label16									;; aller Label16



;
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
;
Label16:	mov ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; mettre x.Screen_Width_x4 dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier eax (Y1) par x.Screen_Width_x4
		mov edi,eax									;; mettre Y1 * x.Screen_Width_x4 dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,Line_Y_Decay							;; mettre Line_Y_Decay dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label17									;; si eax n'est pas sign, aller Label17
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en height positif
		neg ecx										;; inverser ecx (x.Screen_Width_x4), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label17:	mov Line_Y_Decay,ecx							;; sauvegarder ecx dans Line_Y_Decay
; ici,
; eax = cart en height
; ebx = cart en width
; esi = position X *4
; edi = position Y * (width cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label22									;; si eax est suprieur, aller Label22


;
; ici, on traite le cas o la width est la plus importante
;
		mov ecx,eax									;; sauvegarder l'cart en height dans ecx
		mov eax,ebx									;; mettre l'cart en width dans eax
		lea eax,[4*eax+esi]								;; multiplier l'cart en width par 4 et jouter esi (position X *4)
		mov Line_Maxi_Distance,eax						;; sauvegarder le rsultat obtenu dans Line_Maxi_Distance
		mov eax,ecx									;; replacer l'cart en height dans eax
		mov ecx,ebx									;; copier ebx (l'cart en width) dans ecx
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label20									;; si ecx est gal  zro, aller Label20
		inc eax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label18:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label21									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label21									;;	)
; on place la couleur
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
		sub edi,(Screen_Block PTR [ebp]).Pointer			;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax									;; soustraire l'cart en height  ecx
		jns Label19									;; si c'est positif, aller Label19
		add ecx,ebx									;; sinon, ajouter l'cart en width  ecx
		add edi,Line_Y_Decay							;; ajouter Line_Y_Decay  edi
Label19:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,Line_Maxi_Distance						;; comparer esi  l'cart maximal en width
		jne Label18									;; tant que c'est diffrent, retourner Label18
; le dernier point
Label20:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label21									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label21									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label21:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)

;
; ici, on traite le cas o la height est la plus importante
;
Label22:	mov ecx,eax									;; sauvegarder l'cart en height dans ecx
		imul Line_Y_Decay								;; multiplier eax par Line_Y_Decay (sign car Line_Y_Decay peut tre ngatif)
		add eax,edi									;; ajouter edi  eax
		mov Line_Maxi_Distance,eax						;; sauvegarder le rsultat obtenu dans Line_Maxi_Distance
		mov eax,ecx									;; replacer l'cart en height dans eax
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label25									;; si esi est gal  zro, aller Label25
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label23:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label26									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label26									;;	)
; on place la couleur
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
		sub edi,(Screen_Block PTR [ebp]).Pointer			;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx									;; soustraire l'cart en width  ecx
		jns Label24									;; si c'est positif, aller Label24
		add ecx,eax									;; sinon, ajouter l'cart en height  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label24:	add edi,Line_Y_Decay							;; augmenter edi de Line_Y_Decay
		cmp edi,Line_Maxi_Distance						;; comparer edi  l'cart maximal en height
		jne Label23									;; tant que c'est diffrent, retourner Label23
; le dernier point
Label25:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label26									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label26									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label26:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, c'est l'algorythme le plus lent, la ligne entre (ou entre et sort) dans l'cran
;
Label27:	cmp eax,ecx									;; comparer la coordonne X1  X2
		jg Label28									;; si X1 est suprieur (sign, puisque l c'est possible)  X2, aller Label28
; ici on n'change pas la position des points
		mov esi,eax									;; sauvegarder la coordonne X1 dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub ecx,eax									;; enlever X1  X2
		sub edx,ebx									;; enlever Y1  Y2
		mov Line_Y_Decay,edx							;; sauvegarder l'cart Y (Y2-Y1) dans Line_Y_Decay
		mov eax,ebx									;; mettre Y1 dans eax
		mov ebx,ecx									;; mettre l'cart X (X2-X1) dans ebx
		jmp Label29									;; aller Label29
; ici on change la position des points (ce qui evitera les lignes "doubles" et le dcalage X sera automatiquement Positif)
Label28:	mov esi,ecx									;; sauvegarder la coordonne X1 (en fait X2) dans esi
		shl esi,2										;; multiplier esi par 4, pour obtenir position X *4
		sub eax,ecx									;; enlever X2  X1
		sub ebx,edx									;; enlever Y2  Y1
		mov Line_Y_Decay,ebx							;; sauvegarder l'cart Y (Y1-Y2) dans Line_Y_Decay
		mov ebx,eax									;; mettre l'cart X (X1-X2) dans ebx
		mov eax,edx									;; mettre Y1 (en fait Y2)
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
Label29:	mov ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; mettre x.Screen_Width_x4 dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier eax (Y1) par x.Screen_Width_x4
		mov edi,eax									;; mettre Y1 * x.Screen_Width_x4 dans edi
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,Line_Y_Decay							;; mettre Line_Y_Decay dans eax
		test eax,eax									;; fixer les flags de eax
		jns Label30									;; si eax n'est pas sign, aller Label30
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en height positif
		neg ecx										;; inverser ecx (x.Screen_Width_x4), pour obtenir un pas Y ngatif
; ici, on sauvegarde le dcalage de ligne obtenu
Label30:	mov Line_Y_Decay,ecx							;; sauvegarder ecx dans Line_Y_Decay
; ici,
; eax = cart en height
; ebx = cart en width
; esi = position X *4
; edi = position Y * (width cran *4)
;

; ici, on dtermine laquelle des 2 types de boucle on va utiliser
		cmp eax,ebx									;; comparer eax  ebx
		ja Label40									;; si eax est suprieur, aller Label40
;
; ici, on traite le cas o la width est la plus importante
;
		mov ecx,eax									;; sauvegarder l'cart en height dans ecx
		mov eax,ebx									;; mettre l'cart en width dans eax
		lea eax,[4*eax+esi]								;; multiplier l'cart en width par 4 et jouter esi (position X *4)
		mov Line_Maxi_Distance,eax						;; sauvegarder le rsultat obtenu dans Line_Maxi_Distance
		mov eax,ecx									;; replacer l'cart en height dans eax
		mov ecx,ebx									;; copier ebx (l'cart en width) dans ecx
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label34									;; si ecx est gal  zro, aller Label34
		inc eax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label31:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label32									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jb Label37									;;	)
; ici, on calcul les prochaines coordonnes
Label32:	sub ecx,eax									;; soustraire l'cart en height  ecx
		jns Label33									;; si c'est positif, aller Label33
		add ecx,ebx									;; sinon, ajouter l'cart en width  ecx
		add edi,Line_Y_Decay							;; ajouter Line_Y_Decay  edi
Label33:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,Line_Maxi_Distance						;; comparer esi  l'cart maximal en width
		jne Label31									;; tant que c'est diffrent, retourner Label31
; le dernier point
Label34:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label35									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label35									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label35:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
; dbut de la boucle
Label36:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label39									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label39									;;	)
Label37:	add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; mettre la couleur  l'endroit dfini
		sub edi,(Screen_Block PTR [ebp]).Pointer			;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,eax									;; soustraire l'cart en height  ecx
		jns Label38									;; si c'est positif, aller Label38
		add ecx,ebx									;; sinon, ajouter l'cart en width  ecx
		add edi,Line_Y_Decay							;; ajouter Line_Y_Decay  edi
Label38:	add esi,DWORD									;; augmenter esi d'1 DWORD
		cmp esi,Line_Maxi_Distance						;; comparer esi  l'cart maximal en width
		jne Label36									;; tant que c'est diffrent, retourner Label36
; le dernier point
		cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label39									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label39									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label39:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, on traite le cas o la height est la plus importante
;
Label40:	mov ecx,eax									;; sauvegarder l'cart en height dans ecx
		imul Line_Y_Decay								;; multiplier eax par Line_Y_Decay (sign car Line_Y_Decay peut tre ngatif)
		add eax,edi									;; ajouter edi  eax
		mov Line_Maxi_Distance,eax						;; sauvegarder le rsultat obtenu dans Line_Maxi_Distance
		mov eax,ecx									;; replacer l'cart en height dans eax
		mov edx,Line_Line_Colour							;; mettre la couleur dans edx
		test ecx,ecx									;; fixer les flags de ecx
		jz Label44									;; si esi est gal  zro, aller Label44
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle
Label41:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label42									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jb Label47									;;	)
; ici, on calcul les prochaines coordonnes
Label42:	sub ecx,ebx									;; soustraire l'cart en width  ecx
		jns Label43									;; si c'est positif, aller Label43
		add ecx,eax									;; sinon, ajouter l'cart en height  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label43:	add edi,Line_Y_Decay							;; augmenter edi de Line_Y_Decay
		cmp edi,Line_Maxi_Distance						;; comparer edi  l'cart maximal en height
		jne Label41									;; tant que c'est diffrent, retourner Label41
; le dernier point
Label44:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label45									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label45									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label45:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


; ici, le point le plus  gauche est dfini alors on trace ce qui reste de la ligne
; dbut de la boucle
Label46:	cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label49									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label49									;;	)
Label47:	add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
		sub edi,(Screen_Block PTR [ebp]).Pointer			;; et enlever l'adresse de dbut d'cran
; ici, on calcul les prochaines coordonnes
		sub ecx,ebx									;; soustraire l'cart en width  ecx
		jns Label48									;; si c'est positif, aller Label48
		add ecx,eax									;; sinon, ajouter l'cart en height  ecx
		add esi,DWORD									;; ajouter DWORD  esi
Label48:	add edi,Line_Y_Decay							;; augmenter edi de Line_Y_Decay
		cmp edi,Line_Maxi_Distance						;; comparer edi  l'cart maximal en height
		jne Label46									;; tant que c'est diffrent, retourner Label46
; le dernier point
		cmp esi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de prsence cran X
		jae Label49									;; )
		cmp edi,(Screen_Block PTR [ebp]).Block_Size			;;	) test de prsence cran Y
		jae Label49									;;	)
		add edi,(Screen_Block PTR [ebp]).Pointer			;; ajouter l'adresse de dbut d'cran  edi
		mov DWORD PTR [edi+esi],edx						;; et mettre la couleur  l'endroit dfini
; enfin, on restaure les registres...
Label49:	popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
DrawLine ENDP


ALIGN 16
;
; initialiser un sprite (on va remplir une structure Sprite_Info relatif au sprite)
;
; Syntax :
; mov edx,OFFSET of the sprite datas
; mov esi,OFFSET of a Sprite_Info structure
; mov edi,OFFSET of the Screen_Block structure (display screen)
; call InitSprite
;
; Return :
; nothing
;
InitSprite PROc
		push eax										;; empiler eax
		push edx										;; empiler edx

		mov eax,[edx+8]								;; mettre l'adresse des donnes dans eax
		mov (Sprite_Info PTR [esi]).Sprite_Pointer,eax		;; sauvegarder l'adresse des donnes
		mov eax,[edx+12]								;; mettre la couleur de transparence dans eax
		mov (Sprite_Info PTR [esi]).Background_Color,eax		;; sauvegarder la couleur de transparence
		mov eax,[edx]									;; mettre la width du sprite dans eax
		mov (Sprite_Info PTR [esi]).Sprite_Width,eax			;; sauvegarder la width
		mov edx,[edx+4]								;; mettre la height du sprite dans edx
		mov (Sprite_Info PTR [esi]).Sprite_Height,edx		;; sauvegarder la height
		mul edx										;; multiplier eax (la width) par la height
		mov (Sprite_Info PTR [esi]).Sprite_Size,eax			;; sauvegarder la taille
		shl eax,2										;; multiplier la taille par 4 (pour avoir le nombre de dwords)
		mov (Sprite_Info PTR [esi]).Sprite_Size_x4,eax		;; sauvegarder la taille *4
		mov eax,(Sprite_Info PTR [esi]).Sprite_Width			;; lire la width
		shl eax,2										;; multiplier la width par 4 (pour avoir le nombre de dwords)
		mov (Sprite_Info PTR [esi]).Sprite_Width_x4,eax		;; sauvegarder la width *4
; calcul de la height virtuelle
		mov eax,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre une ligne cran dans eax
		mul (Sprite_Info PTR [esi]).Sprite_Height			;; la multiplier par la height du sprite
		mov (Sprite_Info PTR [esi]).Virtual_Height,eax		;; sauvegarder la height virtuelle en ligne cran
; definir le niveau de transparence du sprite
		mov (Sprite_Info PTR [esi]).Transparency_Level,000FFFFFFh	;; mettre le niveau de transparence par dfaut dans la structure

		pop edx										;; dsempiler edx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
InitSprite ENDP


ALIGN 16
;
; dfinir la position X,y d'un sprite  un emplacement de l'cran (dfinir les informations dans la structure)
;
; Syntax :
; mov eax,position X (in pixels) of the sprite
; mov ebx,position Y (in pixels) of the sprite
; mov esi,OFFSET of the Sprite_Info structure
; mov edi,OFFSET of the Screen_Block structure
; call SetSpritePosition
;
; Return :
; nothing
;
SetSpritePosition PROC
		push eax										;; empiler eax
		push edx										;; empiler edx
; calculer la position X
		shl eax,2										;; multiplier la position X par 4
		mov (Sprite_Info PTR [esi]).Position_X,eax			;; sauvegarder la position dans la variable x.Position_X
; on dfini la position Y dans l'cran
		mov eax,(Screen_Block PTR [edi]).Screen_Width_x4		;; mettre la width d'une ligne cran x4 dans eax
		imul ebx										;; multiplier eax par la height
		mov (Sprite_Info PTR [esi]).Position_Y,eax			;; sauvegarder la position Y

		pop edx										;; dsempiler edx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
SetSpritePosition ENDP


ALIGN 16
;
; mettre un sprite  un emplacement X,Y de l'cran
;
; Syntax :
; mov esi,OFFSET of the Sprite_Info structure
; mov edi,OFFSET of the Screen_Block structure
; call SpritePositionned_Mmx
;
; Return :
; nothing, (attention, tous les registre MMx sont modifis)
;
SpritePositionned_Mmx PROC

		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; on va dterminer les limites du sprite
		mov ebp,edi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
		mov eax,(Sprite_Info PTR [esi]).Position_X			;; mettre x.Position_X dans eax
		mov ebx,(Sprite_Info PTR [esi]).Position_Y			;; mettre x.Position_Y dans ebx
		mov ecx,eax									;; copier la position X dans ecx
		mov edx,ebx									;; copier la position Y dans edx
		add ecx,(Sprite_Info PTR [esi]).Sprite_Width_x4		;; ajouter la width du sprite  ecx
		add edx,(Sprite_Info PTR [esi]).Virtual_Height		;; ajouter la height du sprite  edx
; ici, on teste si les limites du sprite se situent bien dans l'cran, sinon on sort...
		test eax,eax									;; fixer les flags de eax
		js Label001									;; si c'est sign, aller Label001
		cmp eax,(Screen_Block PTR [ebp]).Screen_Width_x4		;; comparer eax  la width
		jge Label002									;; si c'est suprieur ou gal, aller Label002
		cmp ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; comparer X2  x.Screen_Width
		jae Label009									;; si la coordonne X2 est suprieure ou gale  LargeurEcranVirtuel, aller Label009
		test ebx,ebx									;; fixer les flags de ebx
		js Label003									;; si c'est sign, aller Label003
		cmp ebx,(Screen_Block PTR [ebp]).Block_Size			;; comparer ebx  la height
		jge Label004									;; si c'est suprieur ou gal, aller Label004
		cmp edx,(Screen_Block PTR [ebp]).Block_Size			;; comparer Y2  x.Screen_Height
		jae Label009									;; si la coordonne Y2 est suprieure ou gale  HauteurEcranVirtuel, aller Label009
		jmp Label005									;; sinon, les 2 points sont  l'cran, alors aller Label005
; ici on s'assure que les limites ne sortent pas de l'cran du mme cot, sinon on sort
Label001:	test ecx,ecx									;; fixer les flags de ecx
		jns Label009									;; si ce n'est pas sign, aller Label009
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Label002:	cmp ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; comparer ecx  la width
		jl Label009									;; si c'est infrieur sign, aller Label009
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Label003:	test edx,edx									;; fixer les flags de edx
		jns Label009									;; si ce n'est pas sign, aller Label009
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Label004:	cmp edx,(Screen_Block PTR [ebp]).Block_Size			;; comparer edx  la height
		jl Label009									;; si c'est infrieur sign, aller Label009
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, le sprite est entirement dans l'cran
;

; on initialise les variables que l'on va utiliser, on dfini la position Y dans l'cran
Label005:	mov edi,(Screen_Block PTR [ebp]).Pointer			;; mettre l'adresse de dpart de l'cran dans edx
		add edi,(Sprite_Info PTR [esi]).Position_Y			;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi									;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(Sprite_Info PTR [ecx]).Sprite_Pointer		;; mettre l'adresse du sprite dans esi
		add edi,(Sprite_Info PTR [ecx]).Position_X			;; l on dfini clairement edi
		mov eax,(Sprite_Info PTR [ecx]).Sprite_Height		;; ) dfinir le ompteur de boucle pour la height
		mov Sprite_Height_Loop,eax						;; )
		mov eax,(Sprite_Info PTR [ecx]).Background_Color		;; mettre la couleur de la transparence dans eax
		mov ebx,(Screen_Block PTR [ebp]).Screen_Width_x4		;;	) l on calcule le complment d'une ligne (width cran - width sprite)
		sub ebx,(Sprite_Info PTR [ecx]).Sprite_Width_x4		;;	)
		mov Sprite_Line_x4_To_Complete,ebx					;;	)
		movq MM5,QWORD PTR Simd_RGBs_unpck_1				;; MM5 = 0,0,0,1 , 0,1,0,1
		movq MM6,QWORD PTR Simd_RGBs_unpck_256				;; MM6 = 0,0,0,256 , 0,256,0,256
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
; boucle pour la height, on dfini la boucle pour la width
Label006:	mov ebx,(Sprite_Info PTR [ecx]).Sprite_Width_x4		;; mettre la width du sprite *4 dans edx
		add esi,ebx									;; ajouter la width (*4) du sprite  esi
		add edi,ebx									;; ajouter la width (*4) du sprite  edi
		neg ebx										;; inverser ebx (qui devient notre compteur de boucle pour la width)
; boucle pour la width, mettre le pixel en fonction de la couleur
Label007:	mov edx,DWORD PTR [esi+ebx]						;; mettre la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,eax									;; comparer la couleur  celle de la transparence
		je Label008									;; si c'est gal, aller Label008
; sinon, application de la transparence alpha sur le pixel
		movd MM0,edx									;; MM0 = _,_,_,_ , A,R,V,B (lire la couleur  appliquer)
		movd MM1,DWORD PTR [edi+ebx]						;; MM1 = _,_,_,_ , A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		movq MM2,MM0									;; MM2 = 0,A,0,R , 0,V,0,B
		pshufw MM2,MM2,0FFh								;; MM2 = 0,A,0,A , 0,A,0,A
		movq MM3,MM6									;; MM3 = 0,0,0,256 , 0,256,0,256
		psubw MM3,MM2									;; MM3 = 0,~A,0,~A , 0,~A,0,~A
		paddw MM2,MM5									;; MM2 = 0,A+1,0,A+1 , 0,A+1,0,A+1
		pmullw MM1,MM3									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM2									;; MM0 = A*A,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = _,_,_,_ , A,R,V,B
		movd DWORD PTR [edi+ebx],MM0						;; mettre la couleur (le pixel)  l'adresse en edi+ebx
; fin boucle width
Label008:	add ebx,4										;; enlever 1 pixel  notre compteur de boucle
		jnz Label007									;; tant que c'est diffrent de 0, aller Label007
; sinon, on passe  la ligne suivante
		add edi,Sprite_Line_x4_To_Complete					;; ajouter le complement d'une width de ligne pour passer  la ligne de pixels suivante
; fin boucle height
		dec Sprite_Height_Loop							;; fixer les flags du compteur en height (le compteur de boucle pour la height)
		jnz Label006									;; tant que eax n'est pas gal  zro, aller Label006
; sinon, on sort puisque le sprite est entirement dessin
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; ici, le sprite n'est pas entirement dans l'cran
;

; on initialise les variables que l'on va utiliser, on dfini la position Y dans l'cran
Label009:	mov edi,(Screen_Block PTR [ebp]).Pointer			;; mettre l'adresse de dpart de l'cran dans edx
		add edi,(Sprite_Info PTR [esi]).Position_Y			;; ajouter la position Y  l'adresse de dpart
; on traite le sprite
		mov ecx,esi									;; sauvegarder l'adresse de la structure du sprite  afficher dans ecx
		mov esi,(Sprite_Info PTR [ecx]).Sprite_Pointer		;; mettre l'adresse du sprite dans esi
		mov eax,(Sprite_Info PTR [ecx]).Sprite_Size_x4		;; lire la taille *4 du sprite
		add esi,eax									;; ajouter eax  esi
		neg eax										;; inverser eax (qui devient notre compteur de boucle pour la height)
		mov ebx,(Sprite_Info PTR [ecx]).Position_X			;; mettre la position cran X dans ebx
		movq MM5,QWORD PTR Simd_RGBs_unpck_1				;; MM5 = 0,0,0,1 , 0,1,0,1
		movq MM6,QWORD PTR Simd_RGBs_unpck_256				;; MM6 = 0,0,0,256 , 0,256,0,256
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
; boucle pour la height
Label010:	mov edx,edi									;; ) test de prsence cran Y
		sub edx,(Screen_Block PTR [ebp]).Pointer			;; )
		cmp edx,(Screen_Block PTR [ebp]).Block_Size			;; )
		jae Label013									;; )
; sinon, on dfini la boucle pour la width
		mov edx,(Sprite_Info PTR [ecx]).Sprite_Width_x4		;; mettre la width du sprite *4 dans edx
		mov Sprite_Width_Loop,edx						;; et la recopier dans Sprite_Width_Loop (qui sera notre compteur de boucle)
; boucle pour la width, mettre la couleur approprie en fonction du bit positionn
Label011:	cmp ebx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de presence cran X
		jae Label012									;; )
		mov edx,DWORD PTR [esi+eax]						;; mettre la couleur (le pixel)  l'adresse en esi+eax dans edx
		cmp edx,(Sprite_Info PTR [ecx]).Background_Color		;; comparer la couleur  celle de la transparence
		je Label012									;; si c'est gal, aller Label012
; sinon, application de la transparence alpha sur le pixel
		movd MM0,edx									;; MM0 = _,_,_,_ , A,R,V,B (lire la couleur  appliquer)
		movd MM1,DWORD PTR [edi+ebx]						;; MM1 = _,_,_,_ , A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		punpcklbw MM1,MM7								;; MM1 = 0,A,0,R , 0,V,0,B
		movq MM2,MM0									;; MM2 = 0,A,0,R , 0,V,0,B
		pshufw MM2,MM2,0FFh								;; MM2 = 0,A,0,A , 0,A,0,A
		movq MM3,MM6									;; MM3 = 0,0,0,256 , 0,256,0,256
		psubw MM3,MM2									;; MM3 = 0,~A,0,~A , 0,~A,0,~A
		paddw MM2,MM5									;; MM2 = 0,A+1,0,A+1 , 0,A+1,0,A+1
		pmullw MM1,MM3									;; MM1 = A*0,R*A , V*A,B*A
		pmullw MM0,MM2									;; MM0 = A*A,R*A , V*A,B*A
		paddw MM0,MM1									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = _,_,_,_ , A,R,V,B
		movd DWORD PTR [edi+ebx],MM0						;; mettre la couleur (le pixel)  l'adresse en edi+ebx
Label012:	add eax,4										;; pour lire le pixel suivant du sprite
		add ebx,4										;; pour aller traiter le pixel suivant de la ligne cran
; fin boucle width
		sub Sprite_Width_Loop,4							;; enlever 1 pixel  notre compteur de boucle
		jnz Label011									;; tant que c'est diffrent de 0, aller Label011
; sinon, on passe  la ligne suivante
		sub ebx,(Sprite_Info PTR [ecx]).Sprite_Width_x4		;; soustraire la width traite, pour paser  la ligne suivante
		add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		test eax,eax									;; fixer les flags de eax (le compteur de boucle pour la height)
		jnz Label010									;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)

; ici, la ligne du sprite n'a pas  tre traite
Label013:	add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		add eax,(Sprite_Info PTR [ecx]).Sprite_Width_x4		;; fixer les flags de eax (le compteur de boucle pour la height)
		jnz Label010									;; tant que eax n'est pas gal  zro, aller Label010
; sinon, on sort puisque le sprite est entirement dessin
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
SpritePositionned_Mmx ENDP


;
; STRING
;
.DATA
ALIGN 16
String_Screen_Position_X		DWORD ?
String_Font_Pointer			DWORD ?
String_Font_Colour			DWORD 000FFFFFFh
String_Background_Colour		DWORD 000000000h
String_Width_Loop			DWORD ?
String_Digit_Pointer		DWORD ?
String_Font_Height			DWORD ?
String_Next_Digit			DWORD ?
String_Digit_Width_x4		DWORD ?


.CODE
ALIGN 16
;
; fusionner des chaines de caractres
; note : c'est plus rapide si edi pointe exactement  l'emplacement o on ajoutera la chane, mais dans ce cas l,
; eax retournera uniquement la taille de la chane ajoute
;
; Syntax :
; mov esi,OFFSET of the string to add
; mov edi,OFFSET of the destination string (can be the real position or the start position of the string)
; call AddAsciiString
;
; Return :
; eax = the length of the destination string, or the length of the string added (depending of the OFFSET passing in edi)
;
AddAsciiString PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push edi										;; empiler edi

; premirement on va trouver le zro final de la chaine de destination
Label1:	mov eax,DWORD PTR [edi]							;; mettre le dword de l'adresse actuelle dans eax
		add edi,4										;; incrmenter edi (l'adresse) de 4 (un dword)
		lea edx,[eax-01010101h]							;; mettre eax (- 1  chaque octets du dword) dans edx
		xor eax,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and eax,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and eax,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		bsf edx,eax									;; sinon, scanner le premier bit arm en eax, en commencant par la droite. et mettre le numro du bit en edx
		sub edx,4										;; soustraire 4 au numro du bit obtenu
		shr edx,3										;; dcaler edx  droite de 3 bits pour obtenir le nombre d'octets
		lea edi,[edi+edx-4]								;; mettre edi + edx - 1 dword dans edi
; et on effectue la copie
		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label3									;; aller Label3
Label2:	add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov DWORD PTR [edi+eax],ecx						;; mettre cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label3:	mov edx,DWORD PTR [esi+eax]						;; mettre le dword de l'adresse actuelle dans edx
		lea ecx,[edx-01010101h]							;; mettre edx (- 1  chaque octets du dword) dans ecx
		xor edx,ecx									;; inverser les bits en edx, en utilisant le rsultat obtenu dans ecx comme masque
		and edx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en edx
		jz Label2										;; si le filtrage est gal  0, aller Label2
		and edx,ecx									;; ne conserver en edx que les bits positionns en ecx
		jz Label2										;; si le filtrage est gal  0, aller Label2
		add ecx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de edx
		mov [edi+eax],cl								;; mettre cl  l'adresse en edi+eax
		test cl,cl									;; fixer les flags de cl
		jz Label6										;; si c'est gal  0, aller Label6
		mov [edi+eax+1],ch								;; mettre ch  l'adresse en edi+eax+1
		test ch,ch									;; fixer les flags de ch
		jz Label5										;; si c'est gal  0, aller Label5
		shr ecx,16									;; dcaler ecx  droite de 16 bits
		mov [edi+eax+2],cl								;; mettre cl  l'adresse en edi+eax+2
		test cl,cl									;; fixer les flags de cl
		jz Label4										;; si c'est gal  0, aller Label4
		mov [edi+eax+3],ch								;; mettre ch  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label4:	inc eax										;; ajouter 1  eax )
Label5:	inc eax										;; ajouter 1  eax )
Label6:	add eax,edi									;; ajouter edi  eax

		pop edi										;; dsempiler edi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		sub eax,edi									;; et on soustrait l'adresse originelle  eax pour obtenir la nouvelle taille de la chane
	ret												;; retourner (sortir de la procdure)
AddAsciiString ENDP


ALIGN 16
;
; copier une chane de caractres dans une autre chane
; note : videment, les tailles doivent tre valides pour les chanes source et destination
;
; Syntax :
; mov esi,OFFSET of the source string
; mov edi,OFFSET of the destination string
; Syntax : CopyAsciiString
;
; Return :
; eax = nombre de caractres copis (c-a-d la taille ajoute  la chane)
;
CopyAsciiString PROC
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		xor eax,eax									;; effacer eax (notre compteur d'octets)
		jmp Label2									;; aller Label2
Label1:	add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de eax
		mov DWORD PTR [edi+eax],edx						;; mettre cette valeur  l'adresse de destination
		add eax,4										;; incrmenter esi (l'adresse) de 4 (un dword)
Label2:	mov ecx,DWORD PTR [esi+eax]						;; mettre le dword de l'adresse actuelle dans eax
		lea edx,[ecx-01010101h]							;; mettre eax (- 1  chaque octets du dword) dans edx
		xor ecx,edx									;; inverser les bits en eax, en utilisant le rsultat obtenu dans edx comme masque
		and ecx,80808080h								;; ne conserver que le bit de poids fort de chaques octets en eax
		jz Label1										;; si le filtrage est gal  0, aller Label1
		and ecx,edx									;; ne conserver en eax que les bits positionns en edx
		jz Label1										;; si le filtrage est gal  0, aller Label1
		add edx,01010101h								;; ajouter ce que l'on a enlev prcedemment pour retrouver la valeur de ecx
		mov [edi+eax],dl								;; mettre dl  l'adresse en edi+eax
		test dl,dl									;; fixer les flags de dl
		jz Label5										;; si c'est gal  0, aller Label5
		mov [edi+eax+1],dh								;; mettre dh  l'adresse en edi+eax+1
		test dh,dh									;; fixer les flags de dh
		jz Label4										;; si c'est gal  0, aller Label4
		shr edx,16									;; dcaler edx  droite de 16 bits
		mov [edi+eax+2],dl								;; mettre dl  l'adresse en edi+eax+2
		test dl,dl									;; fixer les flags de dl
		jz Label3										;; si c'est gal  0, aller Label3
		mov [edi+eax+3],dh								;; mettre dh  l'adresse en edi+eax+3
		inc eax										;; ajouter 1  eax ) (optionnel) pour obtenir la taille de la chaine dans eax
Label3:	inc eax										;; ajouter 1  eax )
Label4:	inc eax										;; ajouter 1  eax )
Label5:
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
	ret												;; retourner (sortir de la procdure)
CopyAsciiString ENDP


ALIGN 16
;
; Afficher une chane de caractres (width maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...))
; (cette version considre que les alphas de la couleur de la police = FF, ce qui est gnralement le cas...)
;
; Syntax :
; mov eax,position X (in pixels)
; mov ebx,position Y (in pixels)
; mov edx,OFFSET of the font to use
; mov esi,OFFSET of the string to display
; mov edi,OFFSET of the Screen_Block structure
; call DisplayGfxStringWithAlphaBackground_Mmx
;
; Return :
; nothing, mais la chaine est affiche  l'cran (attention, tous les registre MMx sont modifis)
;
DisplayGfxStringWithAlphaBackground_Mmx PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on initialise les variables que l'on va utiliser
		mov ebp,edi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
		mov String_Font_Pointer,edx						;; sauvegarder l'adresse de la police utilise
		mov String_Digit_Pointer,esi						;; sauvegarder l'adresse du caractre  afficher
		mov esi,DWORD PTR [edx]							;; mettre la height de la police dans esi
		mov String_Font_Height,esi						;; mettre la height de la police dans String_Font_Height
; calculer la position X
		shl eax,2										;; multiplier la position X par 4
		mov String_Screen_Position_X,eax					;; sauvegarder la position dans la variable String_Screen_Position_X
; calculer la zone cran
		mov ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; mettre la width d'une ligne cran x4 dans ecx
		mov edi,(Screen_Block PTR [ebp]).Pointer			;; mettre l'adresse de dpart de l'cran dans edi
; calculer la position Y
		mov eax,ecx									;; mettre la width d'une ligne cran x4 dans eax
		imul ebx										;; multiplier par la height
; on dfini la position Y dans l'cran
		add edi,eax									;; ajouter la position Y  l'adresse de dpart
; calculer le dcalage cran pour passer au caractre suivant
		mov eax,ecx									;; mettre la width d'une ligne cran x4 dans eax
		mul String_Font_Height							;; multiplier par la height de la police
		mov String_Next_Digit,eax						;; sauvegarder le dcalage
		mov ebx,String_Screen_Position_X					;; mettre la position  crire dans ebx
		pxor MM7,MM7									;; MM7 = 0,0,0,0 , 0,0,0,0
		movd MM6,String_Background_Colour					;; MM6 = _,_,_,_ , A,R,V,B
		movd MM4,String_Font_Colour						;; MM4 = _,_,_,_ , A,R,V,B
		punpcklbw MM6,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		movq MM3,MM6									;; MM3 = 0,A,0,R , 0,V,0,B
		pshufw MM3,MM3,0FFh								;; MM3 = 0,A,0,A , 0,A,0,A
		movq MM5,QWORD PTR Simd_RGBs_unpck_256				;; MM5 = 0,0,0,256 , 0,256,0,256
		psubw MM5,MM3									;; MM5 = 0,0,0,~A , 0,~A,0,~A
		paddw MM3,QWORD PTR Simd_RGBs_unpck_1				;; MM3 = 0,A+1,0,A+1 , 0,A+1,0,A+1
		pmullw MM6,MM3									;; MM1 = A*A,R*A , V*A,B*A
; on traite la chane de caractres, pour commencer on teste si c'est la fin de chane
Label01:	mov edx,String_Digit_Pointer						;; mettre l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edx]							;; mettre le caractre  afficher dans eax
		test eax,eax									;; fixer les flags de eax
		jz Label14									;; si eax est gal  zro (fin de chane), aller Label14 (la sortie)
; sinon, on teste la validit du caractre
		cmp eax,32									;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07									;; si c'est infrieur  32, aller Label07
		mov esi,String_Font_Pointer						;; mettre l'adresse de la police dans esi
		mov ecx,DWORD PTR [esi]							;; et lire la height des caractres
		shl ecx,2										;; multiplier ecx par 4 (puisque, ici, on lit des dwords)
		cmp eax,DWORD PTR [esi+4]						;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02									;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127									;; sinon, mettre 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32									;; enlever les 32 caractres "non affichables"  eax
; on cherche l'emplacement des donnes du caractre  afficher
		add ecx,4										;; ajouter le dword correspondant  la width du caractre
		mul ecx										;; multiplier le caractre en eax par la "height" des caractres
		add esi,eax									;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; ici, esi+8 = width du caractre, et esi+12 = adresse des donnes du caractre
		mov eax,DWORD PTR [esi+8]						;; mettre la width du caractre dans eax
		shl eax,2										;; multiplier cette width par 4 (puisqu'on lit des dwords)
		mov String_Digit_Width_x4,eax						;; sauvegarder la width du caractre *4 en cours de traitement
; on dfini la boucle pour la height
		mov eax,String_Font_Height						;; lire la height des caractres
		shl eax,2										;; multiplier cette height par 4, (puisqu'on lit des dwords)
		add esi,eax									;; ajouter eax  esi
		neg eax										;; inverser eax (qui devient notre compteur de boucle pour la height)

; on teste si le caractre est pleinement dans l'cran
		mov edx,(Screen_Block PTR [ebp]).Block_Size			;; ) test de prsence cran Y
		mov ecx,edi									;; )
		sub ecx,(Screen_Block PTR [ebp]).Pointer			;; )
		cmp ecx,edx									;; )
		jae Label08									;; )
		add ecx,String_Next_Digit						;; )
		cmp ecx,edx									;; )
		jae Label08									;; )
		mov edx,(Screen_Block PTR [ebp]).Screen_Width_x4		;;	) test de presence cran X
		mov ecx,ebx									;;	)
		cmp ecx,edx									;;	)
		jae Label08									;;	)
		add ecx,String_Digit_Width_x4						;;	)
		cmp ecx,edx									;;	)
		jae Label08									;;	)

; ici, le caractre est entirement dans l'cran, boucle pour la height, on dfini la boucle pour la width
Label03:	mov ecx,DWORD PTR [esi+eax+12]					;; mettre le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la height, le dword du caractre maxi et le dword de la width du caractre)
		mov edx,String_Digit_Width_x4						;; mettre la width du caractre *4 dans edx
		mov String_Width_Loop,edx						;; et la recopier dans String_Width_Loop (qui sera notre compteur de boucle)
; boucle pour la width, mettre la couleur approprie en fonction du bit positionn
Label04:	add ecx,ecx									;; sinon, tester les bits "de 31  31-width"
;		shl ecx,1										;; sinon, tester les bits "de 31  31-width" (moins rapide)
		jnc Label05									;; si le flag carry n'est pas positionn, aller Label05
		movd DWORD PTR [edi+ebx],MM4						;; mettre la couleur (le pixel)  l'adresse en edi+esi
		jmp Label06									;; aller Label06
; ici, application de la transparence alpha sur le pixel
Label05:	movd MM0,DWORD PTR [edi+ebx]						;; MM0 = _,_,_,_ , A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		pmullw MM0,MM5									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM6									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = _,_,_,_ , A,R,V,B
		movd DWORD PTR [edi+ebx],MM0						;; mettre la couleur (le pixel)  l'adresse en edi+ebx
Label06:	add ebx,4										;; pour aller traiter le pixel suivant de la ligne
; fin boucle width
		sub String_Width_Loop,4							;; enlever 1 pixel  notre compteur de boucle
		jnz Label04									;; tant que c'est diffrent de 0, aller Label04
; sinon, on passe  la ligne suivante
		sub ebx,String_Digit_Width_x4						;; soustraire la width traite, pour paser  la ligne suivante
		add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		add eax,4										;; incrmenter d'1 dword le compteur de boucle pour la height
		jnz Label03									;; tant que eax n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		sub edi,String_Next_Digit						;; soustraire le dcalage  edi
		add ebx,String_Digit_Width_x4						;; ajouter la width du caractre trait  ebx
; fin boucle caractres
Label07:	inc String_Digit_Pointer							;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01									;; aller Label01

; ici, le caractre n'est pas entirement dans l'cran, boucle pour la height
Label08:	mov ecx,edi									;; ) test de prsence cran Y
		sub ecx,(Screen_Block PTR [ebp]).Pointer			;; )
		cmp ecx,(Screen_Block PTR [ebp]).Block_Size			;; )
		jae Label13									;; )
; sinon, on dfini la boucle pour la width
		mov ecx,DWORD PTR [esi+eax+12]					;; sinon, mettre le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la height, le dword du caractre maxi et le dword de la width du caractre)
		mov edx,String_Digit_Width_x4						;; mettre la width du caractre *4 dans edx
		mov String_Width_Loop,edx						;; et la recopier dans String_Width_Loop (qui sera notre compteur de boucle)
; boucle pour la width, mettre la couleur approprie en fonction du bit positionn
Label09:	add ecx,ecx									;; sinon, tester les bits "de 31  31-width"
;		shl ecx,1										;; sinon, tester les bits "de 31  31-width" (moins rapide)
		jnc Label10									;; si le flag carry n'est pas positionn, aller Label10
		cmp ebx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de presence cran X
		jae Label12									;; )
		movd DWORD PTR [edi+ebx],MM4						;; mettre la couleur (le pixel)  l'adresse en edi+esi
		jmp Label12									;; aller Label12
Label10:	cmp ebx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de presence cran X
		jae Label12									;; )
; ici, application de la transparence alpha sur le pixel
Label11:	movd MM0,DWORD PTR [edi+ebx]						;; MM0 = _,_,_,_ , A,R,V,B (lire la couleur de fond)
		punpcklbw MM0,MM7								;; MM0 = 0,A,0,R , 0,V,0,B
		pmullw MM0,MM5									;; MM0 = A*0,R*A , V*A,B*A
		paddw MM0,MM6									;; MM0 = A*0+A*0,R*A+R*A , V*A+V*A,B*A+B*A
		psrlw MM0,8									;; MM0 = 0,A,0,R , 0,V,0,B
		packuswb MM0,MM7								;; MM0 = _,_,_,_ , A,R,V,B
		movd DWORD PTR [edi+ebx],MM0						;; mettre la couleur (le pixel)  l'adresse en edi+ebx
Label12:	add ebx,4										;; pour aller traiter le pixel suivant de la ligne
; fin boucle width
		sub String_Width_Loop,4							;; enlever 1 pixel  notre compteur de boucle
		jnz Label09									;; tant que c'est diffrent de 0, aller Label09
; sinon, on passe  la ligne suivante
		sub ebx,String_Digit_Width_x4						;; soustraire la width traite, pour paser  la ligne suivante
Label13:	add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		add eax,4										;; incrmenter d'1 dword le compteur de boucle pour la height
		jnz Label08									;; tant que eax n'est pas gal  zro, aller Label08
; sinon, on passe au caractre  afficher suivant
		sub edi,String_Next_Digit						;; soustraire le dcalage  edi
		add ebx,String_Digit_Width_x4						;; ajouter la width du caractre trait  ebx
		inc String_Digit_Pointer							;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01									;; aller Label01
Label14:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
DisplayGfxStringWithAlphaBackground_Mmx ENDP


ALIGN 16
;
; Afficher une chane de caractres (width maximale des caractres de la police = 32 pixels, (ce qui est suffisant
; dans la plupart des cas...)) sans s'occuper du fond
;
; Syntax :
; mov eax,position X (in pixels)
; mov ebx,position Y (in pixels)
; mov edx,OFFSET of the font to use
; mov esi,OFFSET of the string to display
; mov edi,OFFSET of the Screen_Block structure
; call DisplayGfxStringWithoutBackground
;
; Return :
; nothing, mais la chaine est affiche  l'cran
;
DisplayGfxStringWithoutBackground PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; on initialise les variables que l'on va utiliser
		mov ebp,edi									;; sauvegarder l'adresse de la structure Screen_Block dans ebp
		mov String_Font_Pointer,edx						;; sauvegarder l'adresse de la police utilise
		mov String_Digit_Pointer,esi						;; sauvegarder l'adresse du caractre  afficher
		mov esi,DWORD PTR [edx]							;; mettre la height de la police dans esi
		mov String_Font_Height,esi						;; mettre la height de la police dans String_Font_Height
; calculer la position X
		shl eax,2										;; multiplier la position X par 4
		mov String_Screen_Position_X,eax					;; sauvegarder la position dans la variable String_Screen_Position_X
; calculer la zone cran
		mov ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; mettre la width d'une ligne cran x4 dans ecx
		mov edi,(Screen_Block PTR [ebp]).Pointer			;; mettre l'adresse de dpart de l'cran dans edi
; calculer la position Y
		mov eax,ecx									;; mettre la width d'une ligne cran x4 dans eax
		imul ebx										;; multiplier par la height
; on dfini la position Y dans l'cran
		add edi,eax									;; ajouter la position Y  l'adresse de dpart
; calculer le dcalage cran pour passer au caractre suivant
		mov eax,ecx									;; mettre la width d'une ligne cran x4 dans eax
		mul String_Font_Height							;; multiplier par la height de la police
		mov String_Next_Digit,eax						;; sauvegarder le dcalage
		mov ebx,String_Screen_Position_X					;; mettre la position  crire dans ebx

; on traite la chane de caractres, pour commencer on teste si c'est la fin de chane
Label01:	mov edx,String_Digit_Pointer						;; mettre l'adresse du caractre  afficher dans edi
		movzx eax,BYTE PTR [edx]							;; mettre le caractre  afficher dans eax
		test eax,eax									;; fixer les flags de eax
		jz Label14									;; si eax est gal  zro (fin de chane), aller Label14 (la sortie)
; sinon, on teste la validit du caractre
		cmp eax,32									;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label07									;; si c'est infrieur  32, aller Label07
		mov esi,String_Font_Pointer						;; mettre l'adresse de la police dans esi
		mov ecx,DWORD PTR [esi]							;; et lire la height des caractres
		shl ecx,2										;; multiplier ecx par 4 (puisque, ici, on lit des dwords)
		cmp eax,DWORD PTR [esi+4]						;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02									;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127									;; sinon, mettre 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32									;; enlever les 32 caractres "non affichables"  eax
; on cherche l'emplacement des donnes du caractre  afficher
		add ecx,4										;; ajouter le dword correspondant  la width du caractre
		mul ecx										;; multiplier le caractre en eax par la "height" des caractres
		add esi,eax									;; ajouter le rsultat obtenu  l'adresse de dpart de la police
; ici, esi+8 = width du caractre, et esi+12 = adresse des donnes du caractre
		mov eax,DWORD PTR [esi+8]						;; mettre la width du caractre dans eax
		shl eax,2										;; multiplier cette width par 4 (puisqu'on lit des dwords)
		mov String_Digit_Width_x4,eax						;; sauvegarder la width du caractre *4 en cours de traitement
; on dfini la boucle pour la height
		mov eax,String_Font_Height						;; lire la height des caractres
		shl eax,2										;; multiplier cette height par 4, (puisqu'on lit des dwords)
		add esi,eax									;; ajouter eax  esi
		neg eax										;; inverser eax (qui devient notre compteur de boucle pour la height)

; on teste si le caractre est pleinement dans l'cran
		mov edx,(Screen_Block PTR [ebp]).Block_Size			;; ) test de prsence cran Y
		mov ecx,edi									;; )
		sub ecx,(Screen_Block PTR [ebp]).Pointer			;; )
		cmp ecx,edx									;; )
		jae Label08									;; )
		add ecx,String_Next_Digit						;; )
		cmp ecx,edx									;; )
		jae Label08									;; )
		mov edx,(Screen_Block PTR [ebp]).Screen_Width_x4		;;	) test de presence cran X
		mov ecx,ebx									;;	)
		cmp ecx,edx									;;	)
		jae Label08									;;	)
		add ecx,String_Digit_Width_x4						;;	)
		cmp ecx,edx									;;	)
		jae Label08									;;	)

; ici, le caractre est entirement dans l'cran, boucle pour la height, on dfini la boucle pour la width
Label03:	mov ecx,DWORD PTR [esi+eax+12]					;; mettre le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la height, le dword du caractre maxi et le dword de la width du caractre)
		mov edx,String_Digit_Width_x4						;; mettre la width du caractre *4 dans edx
		mov String_Width_Loop,edx						;; et la recopier dans String_Width_Loop (qui sera notre compteur de boucle)
		mov edx,String_Font_Colour						;; mettre la couleur de la police dans edx
; boucle pour la width, mettre la couleur approprie en fonction du bit positionn
Label04:	add ecx,ecx									;; sinon, tester les bits "de 31  31-width"
;		shl ecx,1										;; sinon, tester les bits "de 31  31-width" (moins rapide)
		jnc Label05									;; si le flag carry n'est pas positionn, aller Label05
		mov DWORD PTR [edi+ebx],edx						;; mettre la couleur  l'adresse en edi+ebx
Label05:	add ebx,4										;; pour aller traiter le pixel suivant de la ligne
; fin boucle width
		sub String_Width_Loop,4							;; enlever 1 pixel  notre compteur de boucle
		jnz Label04									;; tant que c'est diffrent de 0, aller Label04
; sinon, on passe  la ligne suivante
		sub ebx,String_Digit_Width_x4						;; soustraire la width traite, pour paser  la ligne suivante
		add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		add eax,4										;; incrmenter d'1 dword le compteur de boucle pour la height
		jnz Label03									;; tant que eax n'est pas gal  zro, aller Label03
; sinon, on passe au caractre  afficher suivant
		sub edi,String_Next_Digit						;; soustraire le dcalage  edi
		add ebx,String_Digit_Width_x4						;; ajouter la width du caractre trait  ebx
; fin boucle caractres
Label07:	inc String_Digit_Pointer							;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01									;; aller Label01

; ici, le caractre n'est pas entirement dans l'cran, boucle pour la height
Label08:	mov ecx,edi									;; ) test de prsence cran Y
		sub ecx,(Screen_Block PTR [ebp]).Pointer			;; )
		cmp ecx,(Screen_Block PTR [ebp]).Block_Size			;; )
		jae Label13									;; )
; sinon, on dfini la boucle pour la width
		mov ecx,DWORD PTR [esi+eax+12]					;; sinon, mettre le dword  l'adresse en esi+eax+12 dans ecx (+12,  pour le dword de la height, le dword du caractre maxi et le dword de la width du caractre)
		mov edx,String_Digit_Width_x4						;; mettre la width du caractre *4 dans edx
		mov String_Width_Loop,edx						;; et la recopier dans String_Width_Loop (qui sera notre compteur de boucle)
		mov edx,String_Font_Colour						;; mettre la couleur de la police dans edx
; boucle pour la width, mettre la couleur approprie en fonction du bit positionn
Label09:	add ecx,ecx									;; sinon, tester les bits "de 31  31-width"
;		shl ecx,1										;; sinon, tester les bits "de 31  31-width" (moins rapide)
		jnc Label10									;; si le flag carry n'est pas positionn, aller Label10
		cmp ebx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ) test de presence cran X
		jae Label10									;; )
		mov DWORD PTR [edi+ebx],edx						;; mettre la couleur  l'adresse en edi+ebx
Label10:	add ebx,4										;; pour aller traiter le pixel suivant de la ligne
; fin boucle width
		sub String_Width_Loop,4							;; enlever 1 pixel  notre compteur de boucle
		jnz Label09									;; tant que c'est diffrent de 0, aller Label09
; sinon, on passe  la ligne suivante
		sub ebx,String_Digit_Width_x4						;; soustraire la width traite, pour paser  la ligne suivante
Label13:	add edi,(Screen_Block PTR [ebp]).Screen_Width_x4		;; ajouter la width d'une ligne pour passer  la ligne de pixels suivante
; fin boucle height
		add eax,4										;; incrmenter d'1 dword le compteur de boucle pour la height
		jnz Label08									;; tant que eax n'est pas gal  zro, aller Label08
; sinon, on passe au caractre  afficher suivant
		sub edi,String_Next_Digit						;; soustraire le dcalage  edi
		add ebx,String_Digit_Width_x4						;; ajouter la width du caractre trait  ebx
		inc String_Digit_Pointer							;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01									;; aller Label01
Label14:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
DisplayGfxStringWithoutBackground ENDP


ALIGN 16
;
; Afficher une chane de caractres centre (width maximale des caractres de la police = 32 pixels, (ce qui
; est suffisant dans la plupart des cas...))
;
; Syntax :
; mov eax,position X (in pixels)
; mov ebx,position Y (in pixels)
; mov edx,OFFSET of the fonnt to use
; mov esi,OFFSET of the string to display
; mov edi,OFFSET of the Screen_Block structure
; call DisplayGfxStringWithoutBackgroundCentered
;
; Return :
; nothing, mais la chaine est affiche  l'cran
;
DisplayGfxStringWithoutBackgroundCentered PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx

		mov ecx,eax									;; copier eax dans ecx
		call GetGfxStringWidth							;; obtenir la width (en pixels) de la chaine qu'on vient d'afficher
		shr eax,1										;; diviser cette height par 2
		sub ecx,eax									;; enlever la moitie de la width  ecx
		mov eax,ecx									;; mettre ecx dans eax
		mov ecx,DWORD PTR [edx]							;; mettre la height de la police dans ecx
		shr ecx,1										;; diviser cette height par 2
		sub ebx,ecx									;; enlever la moitie de la height  ebx
		call DisplayGfxStringWithoutBackground				;; afficher cette chane  la position spcifie

		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
DisplayGfxStringWithoutBackgroundCentered ENDP


ALIGN 16
;
; convertir un dword en texte au format dcimale (routine la plus stable pour le travail)
;
; Syntax :
; mov eax,the value
; mov esi,oFFSET of the string to create
; call DwordToDecAsciiString
;
;
; Return :
; nothing
;
DwordToDecAsciiString PROC
		push eax										;; empiler eax
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		mov ecx,eax									;; copier eax dans ecx
; on va diviser eax par 100000 de manire optimise
		mov edx,2814749768								;; mettre 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; mettre 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; mettre 10 (notre multiplicateur dcimale) dans ebx
		jz Label01									;; si c'est gal  0, aller Label01
; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
		mul ebx										;; multiplier eax par 10
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06
; ici, on traite la partie infrieure du nombre
Label01:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
		jc Label03									;; s'il existe un dpassement, aller Label03
		mul ebx										;; multiplier eax par 10
		jc Label02									;; s'il existe un dpassement, aller Label02
		mul ebx										;; multiplier eax par 10
; ici, on va mettre X et le zro final
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XX et le zro final
Label02:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+1],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXX et le zro final
Label03:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+2],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXX et le zro final
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+3],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXX et le zro final
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+4],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXXX et le zro final
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+5],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXXXX et le zro final
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+6],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXXXXX et le zro final
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+7],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXXXXXX et le zro final
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+8],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi
		jmp Label11									;; aller Label11
; ici, on va mettre XXXXXXXXXX et le zro final
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+8],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dx,30h									;; ajouter le caractre de base "0"  la valeur en dx
		mov WORD PTR [esi+9],dx							;; mettre l'octet en dl et le 0 final en dh  l'adresse en esi

Label11:	pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
DwordToDecAsciiString ENDP


ALIGN 16
;
; obtenir la width (en pixels) d'une chane de caractres a afficher en fonction de la police utilise
;
; Syntax :
; mov edx,OFFSET of the font used/to use
; mov esi,OFFSET of the string
; call GetGfxStringWidth
;
; Return :
; eax = the length of the string (in pixels)
;
GetGfxStringWidth PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

		xor ebx,ebx									;; effacer ebx, qui sera le registre "compteur"
		mov ecx,edx									;; copier edx dans ecx
		mov edi,DWORD PTR [edx]							;; mettre la height des caractres de la police dans edi
		shl edi,2										;; multiplier edi par 4 (puisque, ici, on lit des dwords)
		add edi,DWORD									;; ajouter le dword correspondant  la width du caractres
; on teste si c'est la fin de chane
Label01:	movzx eax,BYTE PTR [esi]							;; mettre le caractre  afficher dans eax
		test eax,eax									;; fixer les flags de eax
		jz Label04									;; si eax est gal  zro (fin de chane), aller Label04 (la sortie)
; sinon, on simule la lecture du caractre
		cmp eax,32									;; comparer le caractre  32 (caractre minimal  afficher)
		jb Label03									;; si c'est infrieur  32, aller Label03
		cmp eax,DWORD PTR [ecx+4]						;; comparer notre caractre au caractre maximal trait par la police
		jbe Label02									;; si c'est infrieur ou gal au caractre maximal, aller Label02
		mov eax,127									;; sinon, mettre 127 (le caractre maxi d'une police restreinte) dans eax
Label02:	sub eax,32									;; enlever les 32 caractres "non affichables"  eax
; on calcule l'emplacement des donnes du caractre  afficher
		mul edi										;; multiplier le caractre par la "height" des caractres
		add eax,ecx									;; ajouter l'adresse de dpart de la police au rsultat obtenu en eax
; on ajoute la width du caractre en cours
		add ebx,DWORD PTR [eax+8]						;; ajouter la width du caractre  ebx (+8,  pour le dword de la height, et le dword du caractre maxi)
Label03:	inc esi										;; augmenter l'adresse du caractre  afficher d'1 caractre
		jmp Label01									;; aller Label01
Label04:	mov eax,ebx									;; mettre la width obtenue dans eax

		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
	ret												;; retourner (sortir de la procdure)
GetGfxStringWidth ENDP


ALIGN 16
;
; convertir une valeur IEEE en texte au format dcimale sign  (format : -x xxx xxx xxx . xxx xxx xx, soit 20 caractres
; en comptant le signe...). les aproximations vont de -99999995  -0.00000001, 0, et de 0.00000001  99999995
; note : XMM0 et XMM1 sont modifis
;
; Syntax :
; mov eax,the (real4) value
; mov esi,OFFSET of the string
; call Real4ToSignedDecAsciiString_Sse
;
; Return :
; eax = the length of the screen created
;
Real4ToSignedDecAsciiString_Sse PROC
		push ebx										;; empiler ebx
		push ecx										;; empiler ecx
		push edx										;; empiler edx
		push esi										;; empiler esi
		push edi										;; empiler edi

; on commence par obtenir la valeur absolue, on teste si la valeur est signe
		bt eax,31										;; tester le bit de signe de la valeur en eax
		jnc Label01									;; si le bit n'est pas positionn, aller Label01
		and eax,7FFFFFFFh								;; sinon, on suprime le signe de la valeur en eax
		mov BYTE PTR [esi],"-"							;; sinon, on place le signe - dans le premier octet de la chaine
		inc esi										;; et on incrmente l'adresse en esi
Label01:	mov Simd_Temp_Values,eax							;; on la recopie dans SCISECDS_ValeurTemporaire
; ensuite on va sparer la partie entire et la partie dcimales
		movss XMM1,Simd_Temp_Values						;; mettre la variable das XMM1
		cvttss2si eax,XMM1								;; mettre l'entier (sans arrondi) de XMM1 dans eax
		cvtsi2ss XMM0,eax								;; mettre l'entier en eax dans XMM0 au format rel4
		subss XMM1,XMM0								;; soustraire XMM0  XMM1
		mulss XMM1,Simd_Ieee_Mul_100000000					;; multiplier les dcimales restantes par le multiplicateur (maintenant XMM0 possde les dcimales dans la partie entire)
; l on teste s'il y a un arrondi  l'entier suprieur
		cvtss2si edi,XMM1								;; mettre l'entier (les dcimales multiplies par notre multiplicateur) de XMM1 dans edi
		cmp edi,99999999								;; on teste si il reste quelquechose dans edi (aprs un traitement dcimale virtuel)
		jnae Label02									;; si ce n'est pas suprieur ou gal, il n'y a pas d'arrondi, alors aller Label02
		inc eax										;; sinon, c'est qu'il faut arrondir  la valeur suprieure, donc on augmente eax d'1

; on commence avec la partie entire, on va diviser eax par 100000 de manire optimise
Label02:	mov edx,2814749768								;; mettre 2814749768 (remplacement de 2814749767 et eax+1) dans edx
		mov ecx,eax									;; copier eax dans ecx
		mul edx										;; multiplier eax par 2814749768
		shr edx,16									;; dcaler edx de 16 bits  droite
		mov eax,100000									;; mettre 100000 dans eax
		mov ebx,edx									;; copier edx dans ebx
		mul edx										;; multiplier edx par 100000
		sub ecx,eax									;; soustraire le rsultat en eax  ecx
		test ebx,ebx									;; fixer les flags de ebx
		mov edx,ebx									;; replacer ebx dans edx
		mov ebx,10									;; mettre 10 (notre multiplicateur dcimale) dans ebx
		jz Label03									;; si c'est gal  0, aller Label03
; sinon, on traite la partie suprieure du nombre
		mov eax,429497									;; on remplace eax par 429497
		mul edx										;; multiplier edx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label12									;; s'il existe un dpassement, aller Label12
		mul ebx										;; multiplier eax par 10
		jc Label11									;; s'il existe un dpassement, aller Label11
		mul ebx										;; multiplier eax par 10
		jc Label10									;; s'il existe un dpassement, aller Label10
		mul ebx										;; multiplier eax par 10
		jc Label09									;; s'il existe un dpassement, aller Label09
		mul ebx										;; multiplier eax par 10
		jc Label08									;; s'il existe un dpassement, aller Label08
; ici, on traite la partie infrieure du nombre
Label03:	mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		jc Label07									;; s'il existe un dpassement, aller Label07
		mul ebx										;; multiplier eax par 10
		jc Label06									;; s'il existe un dpassement, aller Label06
		mul ebx										;; multiplier eax par 10
		jc Label05									;; s'il existe un dpassement, aller Label05
		mul ebx										;; multiplier eax par 10
		jc Label04									;; s'il existe un dpassement, aller Label04
		mul ebx										;; multiplier eax par 10
; ici, on va mettre X et le zro final
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		inc esi										;; et on incrmente l'adresse en esi
		jmp Label13									;; aller Label13
; ici, on va mettre XX et le zro final
Label04:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,2										;; ajouter 2  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXX et le zro final
Label05:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,3										;; ajouter 3  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXX et le zro final
Label06:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,4										;; ajouter 4  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXX et le zro final
Label07:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,5										;; ajouter 5  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXXX et le zro final
Label08:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,6										;; ajouter 6  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXXXX et le zro final
Label09:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,7										;; ajouter 7  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXXXXX et le zro final
Label10:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,8										;; ajouter 8  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXXXXXX et le zro final
Label11:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+8],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,9										;; ajouter 9  l'adresse
		jmp Label13									;; aller Label13
; ici, on va mettre XXXXXXXXXX et le zro final
Label12:	add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+1],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+2],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+3],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+4],dl							;; mettre l'octet en dl  l'adresse en esi
		mov eax,429497									;; on remplace eax par 429497
		mul ecx										;; multiplier ecx par 429497 (pour pouvoir extraire correctement les 5 dcimales suprieures)
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+5],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+6],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+7],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+8],dl							;; mettre l'octet en dl  l'adresse en esi
		mul ebx										;; multiplier eax par 10
		add dl,30h									;; ajouter le caractre de base "0"  la valeur en edx
		mov BYTE PTR [esi+9],dl							;; mettre l'octet en dl  l'adresse en esi
		add esi,10									;; ajouter 10  l'adresse

; ensuite on teste si il y a une partie dcimale
Label13:	test edi,edi									;; ) pas de dcimales ?, alors aller Label17
		jz Label17									;; )
		cmp edi,99999999								;;	) on a dj arrondi le nombre ?, alors aller Label17
		ja Label17									;;	)

; on poursuis en placant le point de sparation et les dcimales
		mov eax,edi									;; mettre les dcimales dans eax
		lea edi,[esi+1]								;; sauvegarder l'adresse (du dbut des dcimales) dans edi
		mov BYTE PTR [esi],"."							;; sinon, crire le point de sparation
		add esi,9										;; mettre la limite de la chane (adresse de dbut des dcimales + le nombre de dcimales maxi) dans esi
		mov ecx,3435973837								;; mettre notre multiplicateur magique dans ecx
Label14:	dec esi										;; dcrmenter l'adresse  crire
		mov ebx,eax									;; sauvegarder eax dans ebx
		mul ecx										;; ) diviser eax par 10
		shr edx,3										;; )
		mov eax,edx									;; copier le dpassement obtenu en edx dans eax
		lea edx,[edx*4+eax]								;; ) multiplier eax par 10, et mettre le rsultat dans edx
		add edx,edx									;; )
		sub ebx,edx									;; soustraire edx  ebx
		jz Label14									;; si ebx est gal  0, aller Label14
		add bl,"0"									;; ajouter le caractre de base
		mov BYTE PTR [esi],bl							;; sauvegarde du caractre
		cmp esi,edi									;; ) test  effectuer, s'il n'y a qu'un seul caractre
		jbe Label16									;; )
		push esi										;; sauvegarder l'adresse du dernier caractre
; ici, on n'a plus a se soucier des zros de fin
Label15:	dec esi										;; dcrmenter l'adresse  crire
		mov ebx,eax									;; sauvegarder eax dans ebx
		mul ecx										;; ) diviser eax par 10
		shr edx,3										;; )
		mov eax,edx									;; copier le dpassement obtenu en edx dans eax
		lea edx,[edx*4+edx]								;; ) multiplier edx par 10
		add edx,edx									;; )
		sub ebx,edx									;; soustraire edx  ebx
		add bl,"0"									;; ajouter le caractre de base
		mov BYTE PTR [esi],bl							;; sauvegarde du caractre
		cmp esi,edi									;; comparer l'adresse  celle de dbut de la partie dcimale
		ja Label15									;; tant que c'est suprieur, aller Label15
; enfin, on sort
		pop esi										;; restaurer l'adresse du dernier caractre
Label16:	inc esi										;; incrmenter l'adresse pour mettre le zro final
; sortie alternative... (quand pas de partie dcimale)
Label17:	mov BYTE PTR [esi],0							;; mettre le 0 final
		mov eax,esi									;; copier esi (l'adresse en cours) dans eax

		pop edi										;; dsempiler edi
		pop esi										;; dsempiler esi
		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop ebx										;; dsempiler ebx
		sub eax,esi									;; pour obtenir la taille de la chane dans eax
	ret												;; retourner (sortir de la procdure)
Real4ToSignedDecAsciiString_Sse ENDP


ALIGN 16
;
; dfinir les couleurs (caractres + fond) d'une chane de caractres
; note : ca peut paraitre stupide de crer une procdure avec seulement 2 instructions, mais ca permet d'eviter
; de rpeter cette opration systmatiquement dans AfficherChaine (gain de vitesse), et c'est aussi quelque chose
; qui peut tre appel un nombre de fois considrable (donc, une macro prendrai beucoup plus d'espace mmoire)
;
; Syntax :
; mov eax,colour of the font (format A,R,G,B)
; mov ebx,colour of the background of the font (format A,R,V,B)
; call SetGfxStringColours
;
; Return :
; nothing, mais les variables String_Font_Colour et String_Background_Colour qui servent pour AfficherChaine est dfinie
;
SetGfxStringColours PROC
		mov String_Font_Colour,eax						;; sauvegarder la couleur de la police
		mov String_Background_Colour,ebx					;; sauvegarder la couleur de fond de la police
	ret												;; retourner (sortir de la procdure)
SetGfxStringColours ENDP


;INCLUDE 3D_Engine_Procs.asm
;
; IMPORTANT : pour les instructions, l'ordre des dwords est invers lors de la lecture/criture
;
.DATA
ALIGN 16
Identity_Matrix_1			REAL4 1.0f,?,?,?				;; ) matrice d'identit
Identity_Matrix_2			REAL4 ?,1.0f,?,?				;; )
Identity_Matrix_3			REAL4 ?,?,1.0f,?				;; )
Identity_Matrix_4			REAL4 ?,?,?,1.0f				;; )
;Invert_Matrix_1			REAL4 -1.0f,?,?,?				;;	) matrice d'inversion
;Invert_Matrix_2			REAL4 ?,-1.0f,?,?				;;	)
;Invert_Matrix_3			REAL4 ?,?,-1.0f,?				;;	)
;Invert_Matrix_4			REAL4 ?,?,?,-1.0f				;;	)
;Resizing_Matrix_1			REAL4 1.0f,?,?,?				;; ) matrice de redimensionnement
;Resizing_Matrix_2			REAL4 ?,1.0f,?,?				;; )
;Resizing_Matrix_3			REAL4 ?,?,1.0f,?				;; )
;Resizing_Matrix_4			REAL4 ?,?,?,1.0f				;; )
;Reflexion_Matrix_1			REAL4 ?,?,?,?					;;	) matrice utilise pour les reflexions
;Reflexion_Matrix_2			REAL4 ?,?,?,?					;;	)
;Reflexion_Matrix_3			REAL4 ?,?,?,?					;;	)
;Reflexion_Matrix_4			REAL4 ?,?,?,?					;;	)

Simd_Values_0p5_0p5_0p5_0p5	REAL4 0.5f,0.5f,0.5f,0.5f
Simd_Values_0_0_1_1			REAL4 1.0f,1.0f,0.0f,0.0f
Simd_Values_1_1_1_1			REAL4 1.0f,1.0f,1.0f,1.0f
Simd_Values_1p5_1p5_1p5_1p5	REAL4 1.5f,1.5f,1.5f,1.5f
Simd_Values_0_180_180_180	REAL4 180.0f,180.0f,180.0f,0.0f

Simd_Mask_3_2_x_x			DWORD 0FFFFFFFFh,0FFFFFFFFh,000000000h,000000000h
Simd_Mask_3_x_x_x			DWORD 0FFFFFFFFh,0FFFFFFFFh,0FFFFFFFFh,000000000h
Simd_Mask_Abs_Values		DWORD 07FFFFFFFh,07FFFFFFFh,07FFFFFFFh,07FFFFFFFh
Simd_Mask_Signs_x_x_1_0		DWORD 080000000h,080000000h,000000000h,000000000h

Simd_Temporary_Values_0_1	DWORD ?						;;	) pratique pour accder a chacun des dwords
Simd_Temporary_Values_0_2	DWORD ?						;;	)
Simd_Temporary_Values_0_3	DWORD ?						;;	)
Simd_Temporary_Values_0_4	DWORD ?						;;	)
Simd_Temporary_Values_1_1	DWORD ?						;;	)
Simd_Temporary_Values_1_2	DWORD ?						;;	)
Simd_Temporary_Values_1_3	DWORD ?						;;	)
Simd_Temporary_Values_1_4	DWORD ?						;;	)
Simd_Temporary_Values_2_1	DWORD ?						;;	)
Simd_Temporary_Values_2_2	DWORD ?						;;	)
Simd_Temporary_Values_2_3	DWORD ?						;;	)
Simd_Temporary_Values_2_4	DWORD ?						;;	)
Simd_Temporary_Values_3_1	DWORD ?						;;	)
Simd_Temporary_Values_3_2	DWORD ?						;;	)
Simd_Temporary_Values_3_3	DWORD ?						;;	)
Simd_Temporary_Values_3_4	DWORD ?						;;	)
Simd_Temporary_Values_4_1	DWORD ?						;;	)
Simd_Temporary_Values_4_2	DWORD ?						;;	)
Simd_Temporary_Values_4_3	DWORD ?						;;	)
Simd_Temporary_Values_4_4	DWORD ?						;;	)
Simd_Temporary_Values_5_1	DWORD ?						;;	)
Simd_Temporary_Values_5_2	DWORD ?						;;	)
Simd_Temporary_Values_5_3	DWORD ?						;;	)
Simd_Temporary_Values_5_4	DWORD ?						;;	)
Simd_Temporary_Values_6_1	DWORD ?						;;	)
Simd_Temporary_Values_6_2	DWORD ?						;;	)
Simd_Temporary_Values_6_3	DWORD ?						;;	)
Simd_Temporary_Values_6_4	DWORD ?						;;	)
Simd_Temporary_Values_7_1	DWORD ?						;;	)
Simd_Temporary_Values_7_2	DWORD ?						;;	)
Simd_Temporary_Values_7_3	DWORD ?						;;	)
Simd_Temporary_Values_7_4	DWORD ?						;;	)
Simd_Temporary_Values_8_1	DWORD ?						;; ) ici c'est pour le cas o une sauvegarde des registres smid est actuellement utilise
Simd_Temporary_Values_8_2	DWORD ?						;; )
Simd_Temporary_Values_8_3	DWORD ?						;; )
Simd_Temporary_Values_8_4	DWORD ?						;; )
Simd_Temporary_Values_9_1	DWORD ?						;; )
Simd_Temporary_Values_9_2	DWORD ?						;; )
Simd_Temporary_Values_9_3	DWORD ?						;; )
Simd_Temporary_Values_9_4	DWORD ?						;; )

; ici, ce sont les variables utilises, elles sont alignes sur 16 octets pour une question de rapidit
Faces_Loop_Counter			DWORD ?						;; (align 16)
Temporary_3D_World_Pointer	DWORD ?	
Temporary_3D_Object_Pointer	DWORD ?	
Temporary_Font_Pointer		DWORD ?	
Temporary_Face_Pointer		DWORD ?						;; (align 16)	
Temporary_Screen_Pointer		DWORD ?	
Temporary_Depth			DWORD ?	


Axis_sz_X_Axis				BYTE "X",0
Axis_sz_Y_Axis				BYTE "Y",0
Axis_sz_Z_Axis				BYTE "Z",0


; sse notes :
; unpcklps faster than unpckhps
; movlhps faster than movhlps


.CODE
ALIGN 16
;
; draw a polygon
; WARNING : here, it's a Draw3DPolygon_Sse subroutine, it doesn't preserve registers and should be used as is, unless you perfectly
; know what you're doing
;
; Syntax :
; MM0 = the color of the object
; XMM0 = _,Z1,Y1,X1 (the first point)
; XMM1 = _,Z2,Y2,X2 (the second point)
; XMM6 = 0,0,0,0
; XMM7 = height-1,width-1,height-1,width-1
; call _DrawPolygon_Sse
;
; Return :
; nothing
;
_DrawPolygon_Sse PROC

		mov esi,Temporary_3D_World_Pointer					;; mettre l'adresse de la structure A_3D_World dans esi
		mov edi,Temporary_3D_Object_Pointer				;; mettre l'adresse de la structure A_3D_Object dans edi
		mov ebp,Temporary_Screen_Pointer					;; mettre l'adresse de la structure Screen_Block dans ebp
; here to ensure X1 is the left point, otherwise we swap the points (needed for the algo to draw the line)
		comiss XMM1,XMM0								;; comparer _,_,_,X2  _,_,_,X1
		jnc Label00									;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller Label00
		xorps XMM1,XMM0								;; ) sinon, changer les registres XMM0 et XMM1
		xorps XMM0,XMM1								;; )
		xorps XMM1,XMM0								;; )
Label00:


; test if both points are on screen
		movaps XMM3,XMM0								;; XMM3 = _,Z1,Y1,X1
		movlhps XMM3,XMM1								;; XMM3 = Y2,X2,Y1,X1
		movaps XMM2,XMM3								;; XMM2 = Y2,X2,Y1,X1
		cmpgtps XMM3,XMM7								;; comparer Y2,X2,Y1,X1  height-1,width-1,height-1,width-1
		cmpltps XMM2,XMM6								;; comparer Y2,X2,Y1,X1  0,0,0,0
		movmskps ebx,XMM3								;; mettre le masque obtenu pour les maximales dans ebx
		movmskps eax,XMM2								;; mettre le masque obtenu pour les minimales dans eax
		shl ebx,4										;; dcaler ebx de 4 bits  gauche
		or ebx,eax									;; fusionner eax avec ebx (dcal)
		jnz Label12									;; si ebx est diffrent de 0 (au moins 1 des points est hors cran), aller Label12

;
; here, the 2 points are on screen (they've been fixed if needed), so we draw the line...
;

; ici, X1 tant le plus  gauche, il suffit de convertir et dispatcher les valeurs obtenues
Label01:	cvttps2pi MM1,XMM0								;; convertir _,_,Y1,X1 en entiers
		cvttps2pi MM2,XMM1								;; convertir _,_,Y2,X2 en entiers
		psubd MM2,MM1									;; MM2 = Y2-Y1,X2-X1
		movd edi,MM1									;; mettre _,X1 dans edi
		movd ebx,MM2									;; mettre l'cart X (X2-X1) dans ebx
		punpckhdq MM2,MM2								;; ) dcaler les copies de 32 bits  droite (pour obtenir les Y)
		punpckhdq MM1,MM1								;; )
		movd esi,MM2									;; mettre l'cart Y (Y2-Y1) dans esi
		movd eax,MM1									;; mettre _,Y1 dans eax
; ici, on defini le premier point (enfin... celui qui est le plus  gauche)
		mov ecx,(Screen_Block PTR [ebp]).Screen_Width_x4		;; mettre x.Screen_Width_x4 dans ecx, pour obtenir un pas Y
		mul ecx										;; multiplier Y1 par x.Screen_Width_x4
		lea edi,[4*edi+eax]								;; multiplier edi par 4 (DWORD) et ajouter Y1 * x.Screen_Width_x4
		add edi,(Screen_Block PTR [ebp]).Pointer			;; on ajoute  edi le pointeur de dbut du bloc mmoire (qui contient dsormais la position du point)
; ici, on dfini si le dcalage Y est ngatif ou positif
		mov eax,esi									;; mettre esi l'cart Y (Y2-Y1) dans eax
		test esi,esi									;; fixer les flags de esi
		jns Label02									;; si eax n'est pas sign, aller Label02
		neg eax										;; sinon, on inverse eax, pour obtenir un cart en height positif
		neg ecx										;; inverser ecx (x.Screen_Width_x4), pour obtenir un pas Y ngatif
; here,
; eax = distance in height (or y direction)
; ebx = distance in width (or x direction)
; edi = screen position (screen start + y position + x position)
; we're going to determine wich loop we're going to use
Label02:	cmp eax,ebx									;; comparer eax  ebx
		ja Label07									;; si eax est suprieur, aller Label07

;
; here, case where width is bigger
;
		mov ebp,ebx									;; copier ebx (l'cart en width) dans ebp
		cmp ebx,0										;; comparer ebx  0
		jle Label05									;; si c'est infrieur ou gal, aller Label05
		lea esi,[4*ebx]								;; mettre ebx*4 dans esi, qui devient notre pas de boucle
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc ax										;; incrmenter eax (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle (ici, edx inutilis)
Label03:	movd DWORD PTR [edi+esi],MM0						;; mettre la couleur  l'endroit dfini
; calcul des nouvelles coordonnes
		sub bp,ax										;; soustraire l'cart en height  ebp
		jns Label04									;; si c'est positif, aller Label04
		add bp,bx										;; sinon, ajouter l'cart en width  ebp
		add edi,ecx									;; augmenter/rduire edi d'1 ligne (x.Screen_Width_x4)
Label04:	add esi,DWORD									;; augmenter esi d'1 pixel (1 DWORD)
		jnz Label03									;; tant que esi n'est pas gal  0, retourner Label03
; on place le dernier (ou le seul) point
Label05:	movd DWORD PTR [edi],MM0							;; mettre la couleur  l'endroit dfini
Label06:
	ret												;; retourner (sortir de la procdure)

;
; here, case where height is bigger
;
Label07:	mov ebp,eax									;; copier eax (l'cart en height) dans ebp
		cmp eax,0										;; comparer eax  0
		jle Label10									;; si c'est infrieur ou gal, aller Label10
		imul ecx										;; multiplier eax par ecx (x.Screen_Width_x4) (sign car ecx peut tre ngatif)
		mov esi,eax									;; mettre eax dans esi, qui va devenir notre pas de boucle
		mov ax,bp										;; replacer l'cart en height dans eax
		add edi,esi									;; ajouter esi  edi
		neg esi										;; inverser esi (qui devient notre pas de boucle)
		inc ebx										;; incrmenter ebx (pour compenser le dcalage occasionn par le 0)
; dbut de la boucle (ici, edx inutilis)
Label08:	movd DWORD PTR [edi+esi],MM0						;; mettre la couleur  l'endroit dfini
; calcul des nouvelles coordonnes
		sub bp,bx										;; soustraire l'cart en width  ebp
		jns Label09									;; si c'est positif, aller Label09
		add bp,ax										;; sinon, ajouter l'cart en height  ebp
		add edi,DWORD									;; augmenter edi d'1 pixel (1 DWORD)
Label09:	add esi,ecx									;; augmenter/rduire esi d'1 ligne (x.Screen_Width_x4)
		jnz Label08									;; tant que esi n'est pas gal  0, retourner Label08
; on place le dernier (ou le seul) point
Label10:	movd DWORD PTR [edi],MM0							;; mettre la couleur  l'endroit dfini
Label11:
	ret												;; retourner (sortir de la procdure)

;
; test to avoid useless calc
;

; eax = Y2>height-1 , X2>width-1 , Y1>height-1 , X1>width-1, Y2<0 , X2<0 , Y1<0 , X1<0
Label12:	bt bx,2										;; tester le bit 2 (le bit 0 tant inutile, puisque X2 > X1)
		jc Label11									;; si le flag carry est positionn, aller Label11
		bt bx,4										;; tester le bit 4 (le bit 6 tant inutile, puisque X2 > X1)
		jc Label11									;; si le flag carry est positionn, aller Label11
		and ax,00001010b								;; ne conserver que les Y
		cmp ax,00001010b								;; ils sont tous les 2 plus petits que 0 ?
		je Label11									;; si c'est le cas, aller Label11
		mov ax,bx										;; copier ebx dans eax
		and bx,10100000b								;; ne conserver que les Y
		cmp bx,10100000b								;; ils sont tous les 2 plus grands que height-1 ?
		je Label11									;; si c'est le cas, aller Label11

;
; here, we recalc the points (coz in the minimum one of them have to be recalc)
;

; x' = ((y'-Y1) * dx / dy) + X1	) (where dx=X2-X1 and dy=Y2-Y1)
; y' = ((x'-X1) * dy / dx) + Y1	)
		movaps XMM2,XMM0								;; mettre _,Z1,Y1,X1 dans XMM2
		movaps XMM3,XMM1								;; mettre _,Z2,Y2,X2 dans XMM3
		movhlps XMM4,XMM6								;; XMM4 = _,_,0,0
		movlhps XMM2,XMM2								;; XMM2 = Y1,X1,Y1,X1
		movlhps XMM3,XMM3								;; XMM3 = Y2,X2,Y2,X2
		movlhps XMM4,XMM7								;; XMM4 = height-1,width-1,0,0
		subps XMM4,XMM2								;; XMM4 = height-1-Y1,width-1-X1,0-Y1,0-X1
		subps XMM3,XMM2								;; XMM3 = Y2-Y1,X2-X1,Y2-Y1,X2-X1
		shufps XMM4,XMM4,0B1h							;; XMM4 = width-1-X1,height-1-Y1,0-X1,0-Y1
		mulps XMM4,XMM3								;; XMM4 = (width-1-X1)*(Y2-Y1),(height-1)*(X2-X1),(0-X1)*(Y2-Y1),(0-Y1)*(X2-X1)
		shufps XMM3,XMM3,0B1h							;; XMM3 = X2-X1,Y2-Y1,X2-X1,Y2-Y1
		rcpps XMM5,XMM3								;; XMM5 = 1/(X2-X1),1/(Y2-Y1),1/(X2-X1),1/(Y2-Y1)
;		mulps XMM3,XMM5								;; ) (optionnel) formule newton-raphson pour une prcision
;		mulps XMM3,XMM5								;; ) de 23 bits au lieu de 12 bits. ces 4 lignes sont
;		addps XMM5,XMM5								;; ) activables/dsactivables
;		subps XMM5,XMM3								;; )
		mulps XMM5,XMM4								;; XMM5 = ((width-1-X1)*(Y2-Y1))*(1/(X2-X1)),((height-1-Y1)*(X2-X1))*(1/(Y2-Y1)),((0-X1)*(Y2-Y1))*(1/(X2-X1)),((0-Y1)*(X2-X1))*(1/(Y2-Y1))
		addps XMM5,XMM2								;; ajouter Y1,X1,Y1,X1  XMM5
; here, XMM5 = Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)

;
; then, we replace with our new values
;
		movaps XMM2,XMM5								;; XMM2 = Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)
		movaps XMM3,XMM5								;; XMM3 = Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)
		movaps XMM4,XMM5								;; XMM4 = Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)
		cmpgtps XMM3,XMM7								;; comparer Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)  height-1,width-1,height-1,width-1
		cmpltps XMM2,XMM6								;; comparer Y(of X=width-1),X(of Y=height-1),Y(of X=0),X(of Y=0)  0,0,0,0
		orps XMM2,XMM3									;; fusionner les masques obtenus
		movmskps edx,XMM2								;; mettre le masque obtenu dans edx
		mov bx,ax										;; recopier eax dans ebx (eax servira pour le premier point et ebx pour le second)
; here, eax and ebx = 11101011 possible, edx = 1111 possible

; the fisrt point :
; eax = Y2>height-1 , X2>width-1 , Y1>height-1 , X1>width-1, Y2<0 , X2<0 , Y1<0 , X1<0
; edx = nYl<0 ou nYl>height-1, nXh<0 ou nXh>width-1, nY0<0 ou nY0>height-1, nX0<0 ou nX0>width-1
		and ax,00100011b								;; conserver _,_,Y1>height-1,_,_,_,Y1<0,X1<0
		jz Label16									;; si eax est gal  zro, aller Label16
		bt ax,1										;; Y1<0 ?
		jc Label13									;; si c'est le cas, aller Label13
		bt ax,5										;; Y1>height-1 ?
		jnc Label15									;; si ce n'est pas le cas, aller Label15
; here, oldY1 > height-1
		bt dx,2										;; nXh<0 ou nXh>width-1 ?
		jc Label14									;; si c'est le cas, aller Label14
		movhlps XMM4,XMM7								;; XMM4 = nYl,nXh,height-1,width-1
		shufps XMM4,XMM4,066h							;; XMM4 = height-1,nXh,height-1,nXh
		movhlps XMM0,XMM4								;; XMM0 = _,z,height-1,nXh
		jmp Label16									;; aller Label16
; here, oldY1 < 0
Label13:	bt dx,0										;; nX0<0 ou nX0>width-1 ?
		jc Label14									;; si c'est le cas, aller Label14
		movlhps XMM4,XMM6								;; XMM4 = 0,0,nY0,nX0
		shufps XMM4,XMM4,0CCh							;; XMM4 = 0,nX0,0,nX0
		movhlps XMM0,XMM4								;; XMM0 = _,z,0,nX0
		jmp Label16									;; aller Label16
; here, oldY1 < 0 ou oldY1 > height-1, alors on va tester oldX1<0
Label14:	bt ax,0										;; X1<0 ?
		jnc Label20									;; si ce n'est pas le cas, aller Label20
; here, oldX1 < 0
Label15:	bt dx,1										;; nY0<0 ou nY0>height-1 ?
		jc Label20									;; si c'est le cas, aller Label20
		movlhps XMM4,XMM6								;; XMM4 = 0,0,nY0,nX0
		shufps XMM4,XMM4,066h							;; XMM4 = nY0,0,nY0,0
		movhlps XMM0,XMM4								;; XMM0 = _,z,nY0,0
;		jmp Label16									;; aller Label16

; the second point :
; ebx = Y2>height-1 , X2>width-1 , Y1>height-1 , X1>width-1, Y2<0 , X2<0 , Y1<0 , X1<0
; edx = nYl<0 ou nYl>height-1, nXh<0 ou nXh>width-1, nY0<0 ou nY0>height-1, nX0<0 ou nX0>width-1
Label16:	and bx,11001000b								;; conserver Y2>height-1,X2>width-1,_,_,Y2<0,_,_,_
		jz Label01									;; si ebx est gal  zro, aller Label01
		bt bx,7										;; Y2>height-1 ?
		jc Label17									;; si c'est le cas, aller Label17
		bt bx,3										;; Y2<0 ?
		jnc Label19									;; si ce n'est pas le cas, aller Label19
; here, oldY2 < 0
		bt dx,0										;; nX0<0 ou nX0>width-1 ?
		jc Label18									;; si c'est le cas, aller Label18
		movlhps XMM5,XMM6								;; XMM5 = 0,0,nY0,nX0
		shufps XMM5,XMM5,0CCh							;; XMM5 = 0,nX0,0,nX0
		movhlps XMM1,XMM5								;; XMM1 = _,z,0,nX0
		jmp Label01									;; aller Label01
; here, oldY2 > height-1
Label17:	bt dx,2										;; nXh<0 ou nXh>width-1 ?
		jc Label18									;; si c'est le cas, aller Label18
		movhlps XMM5,XMM7								;; XMM5 = nYl,nXh,height-1,width-1
		shufps XMM5,XMM5,066h							;; XMM5 = height-1,nXh,height-1,nXh
		movhlps XMM1,XMM5								;; XMM1 = _,z,height-1,nXh
		jmp Label01									;; aller Label01
; here, oldY2 < 0 ou oldY2 > height-1
Label18:	bt bx,6										;; X2>width-1 ?
		jnc Label20									;; si ce n'est pas le cas aller Label20
; here, oldX2 > width-1
Label19:	bt dx,3										;; nYl<0 ou nYl>height-1 ?
		jc Label20									;; si ce n'est pas le cas aller Label20
		movhlps XMM5,XMM7								;; XMM5 = nYl,nXh,height-1,width-1
		shufps XMM5,XMM5,0CCh							;; XMM5 = nYl,width-1,nYl,width-1
		movhlps XMM1,XMM5								;; XMM1 = _,z,nYl,width-1
		jmp Label01									;; aller Label01
; par ici la sortie...
Label20:
	ret												;; retourner (sortir de la procdure)
_DrawPolygon_Sse ENDP


ALIGN 16
;
; (debug) draw the axis of the current objet
;
; Syntax :
; mov ecx,OFFSET of the font to use
; mov edx,OFFSET of the Screen_Block structure
; mov esi,OFFSET of a A_3D_World structure
; mov edi,OFFSET de a A_3D_Object structure
; call Draw3DAxis_Sse
;
; Return :
; nothing
;
Draw3DAxis_Sse PROC

		bt (A_3D_Object PTR [edi]).Object_Flags,31			;; tester le bit de signe du statut (objet apparait, ou pas)
		jnc Label02									;; si le bit n'est pas positionn (hors cran), aller Label02 (la sortie)
; ici, l'objet peut apparaitre, alors on fait le calcul
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on va sauvegarder les pointeurs
		mov Temporary_Font_Pointer,ecx					;; le pointeur de la police
		mov Temporary_Screen_Pointer,edx					;; le pointeur de l'cran
		mov Temporary_3D_World_Pointer,esi					;; le pointeur du monde
		mov Temporary_3D_Object_Pointer,edi				;; le pointeur de l'objet

;
; calc of the points (centerX,centerY,centerZ) (maxX,centerY,centerZ) (centerX,maxY,centerZ) (centerX,centerY,maxZ)
;

; donc on va calculer les coordonnes des limites de l'ojet 3D par rapport  la position et l'angle de la camra
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; mettre la position camra _,Z,Y,X dans XMM4
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Center_X	;; mettre les _,centerZ,centerY,centerX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).X_Axis_1	;; mettre les _,centerZ,centerY,maxX dans XMM1
		movaps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Y_Axis_1	;; mettre les _,centerZ,maxY,centerX dans XMM1
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Z_Axis_1	;; mettre les _,maxZ,centerY,centerX dans XMM1
		subps XMM0,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,centerX
		subps XMM1,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,maxX
		subps XMM2,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,maxY,centerX
		subps XMM3,XMM4								;; substract the view position _,Z,Y,X to coords _,maxZ,centerY,centerX
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM5,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM0,XMM4								;;	) et on additionne le tout
		addps XMM0,XMM5								;;	)
; ici XMM0 contient les nouvelles coordonnes _,centerZ,centerY,centerX
		movaps XMM4,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM1,XMM4								;;	) et on additionne le tout
		addps XMM1,XMM5								;;	)
; ici XMM1 contient les nouvelles coordonnes _,centerZ,centerY,maxX
		movaps XMM4,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM5								;;	)
; ici XMM2 contient les nouvelles coordonnes _,centerZ,maxY,centerX
		movaps XMM4,XMM3								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM3								;; )
		shufps XMM3,XMM3,000h							;; XMM3 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM3,XMM4								;;	) et on additionne le tout
		addps XMM3,XMM5								;;	)
; ici XMM3 contient les nouvelles coordonnes _,maxZ,centerY,centerX


;
; transform to 2D coords
;
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0
		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth
; pour _,centerZ,centerY,centerX
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert01								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert01
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert01:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; pour _,centerZ,centerY,maxX
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert02								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert02
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert02:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; pour _,centerZ,maxY,centerX
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert03								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert03
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert03:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; pour _,maxZ,centerY,centerX
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert04								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert04
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert04:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; on ajoute la moitie de l'cran (pour n'obtenir que des valeurs positives pour les points  afficher)
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width	;; mettre _,_,Hauteur/2,Largeur/2 dans XMM4
		addps XMM0,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM0
		addps XMM1,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM1
		addps XMM2,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM2
		addps XMM3,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM3
; on converti les rsultats obtenus en entier X et Y
		cvttps2pi MM0,XMM0								;; ) convertir les rsultats obtenus en entiers
		cvttps2pi MM1,XMM1								;; )
		cvttps2pi MM2,XMM2								;; )
		cvttps2pi MM3,XMM3								;; )
		movq MM4,MM0									;;	) copier MM0,MM1,MM2,MM3 dans les registres libres
		movq MM5,MM1									;;	)
		movq MM6,MM2									;;	)
		movq MM7,MM3									;;	)
		punpckhdq MM4,MM4								;; ) copier les Y dans les dwords rapidement accessibles
		punpckhdq MM5,MM5								;; )
		punpckhdq MM6,MM6								;; )
		punpckhdq MM7,MM7								;; )


;
; here, we draw the axis
;
		movd eax,MM0									;;	) on dfini X1,Y1 (le center)
		movd ebx,MM4									;;	)
		movd ecx,MM1									;; ) on dfini X2,Y2 (axe X)
		movd edx,MM5									;; )
		mov esi,Temporary_Screen_Pointer					;; mettre l'adresse de la structure TamponEcranTravail dans esi
		mov edi,Colour_Red_Bright						;; mettre la couleur rouge vif
		call DrawLine									;; on trace la ligne qui relie les points
		movd ecx,MM2									;; ) on dfini X2,Y2 (axe Y)
		movd edx,MM6									;; )
		call DrawLine									;; on trace la ligne qui relie les points
		movd ecx,MM3									;; ) on dfini X2,Y2 (axe Z)
		movd edx,MM7									;; )
		call DrawLine									;; on trace la ligne qui relie les points


;
; here, we name the axis
;

; ici on dfini la couleur par dfaut des axes  afficher dans l'cran
		mov eax,Colour_Orange							;;	) dfinir les couleurs police + fond
;		mov ebx,Colour_Blue								;;	) (inutile si DisplayGfxStringWithoutBackground)
		call SetGfxStringColours							;;	)
; afficher le X
		movd eax,MM1									;; position X (en pixels)
		movd ebx,MM5									;; position Y (en pixels)
		mov edx,Temporary_Font_Pointer					;; adresse de la police utilise
		mov esi,OFFSET Axis_sz_X_Axis						;; adresse de la chane  afficher
		mov edi,Temporary_Screen_Pointer					;; mettre l'adresse du Work_Screen dans edi
		call DisplayGfxStringWithoutBackgroundCentered		;; afficher cette chane  la position spcifie
; afficher le Y
		movd eax,MM2									;; position X (en pixels)
		movd ebx,MM6									;; position Y (en pixels)
;		mov edx,Temporary_Font_Pointer					;; adresse de la police utilise (done previously)
		mov esi,OFFSET Axis_sz_Y_Axis						;; adresse de la chane  afficher
;		mov edi,Temporary_Screen_Pointer					;; mettre l'adresse du Work_Screen dans edi (done previously)
		call DisplayGfxStringWithoutBackgroundCentered		;; afficher cette chane  la position spcifie
; afficher le Z
		movd eax,MM3									;; position X (en pixels)
		movd ebx,MM7									;; position Y (en pixels)
;		mov edx,Temporary_Font_Pointer					;; adresse de la police utilise (done previously)
		mov esi,OFFSET Axis_sz_Z_Axis						;; adresse de la chane  afficher
;		mov edi,Temporary_Screen_Pointer					;; mettre l'adresse du Work_Screen dans edi (done previously)
		call DisplayGfxStringWithoutBackgroundCentered		;; afficher cette chane  la position spcifie


;
; here, we name the object
;

; ici on dfini la couleur par dfaut des axes  afficher dans l'cran
		mov eax,Colour_Yellow							;;	) dfinir les couleurs police + fond
;		mov ebx,Colour_Blue								;;	) (inutile si DisplayGfxStringWithoutBackground)
		call SetGfxStringColours							;;	)
; afficher le nom centr de l'objet
		movd eax,MM0									;; mettre la position X du center dans eax
		movd ebx,MM4									;; mettre la position Y du center dans ebx
		mov ecx,Temporary_3D_Object_Pointer				;; le pointeur de l'objet
;		mov edx,Temporary_Font_Pointer				;; adresse de la police utilise (done previously)
		mov esi,DWORD PTR (A_3D_Object PTR [ecx]).Objetc_Name_Pointer	;; mettre l'adresse du nom dans esi
;		mov edi,Temporary_Screen_Pointer					;; mettre l'adresse du Work_Screen dans edi (done previously)
		call DisplayGfxStringWithoutBackgroundCentered		;; afficher cette chane  la position spcifie
Label01:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label02:
	ret												;; retourner (sortir de la procdure)
Draw3DAxis_Sse ENDP


ALIGN 16
;
; draw a 3d object, called just after Update3DWorld_Sse, and called for each object.
;
; Syntax :
; mov edx,OFFSET of the Screen_Block structure
; mov esi,OFFSET of a A_3D_World structure
; mov edi,OFFSET of a A_3D_Object structure
; call Draw3DObject_Sse
;
; Return :
; nothing
;
Draw3DObject_Sse PROC
; premirement on va sauvegarder les pointeurs
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
;		mov ebp,edx									;; le pointeur de l'cran	) impratif pour pour l'utilisation de _DrawPolygon_Sse
		mov Temporary_Screen_Pointer,edx					;; le pointeur de l'cran	)
		mov Temporary_3D_World_Pointer,esi					;; le pointeur du monde		)
		mov Temporary_3D_Object_Pointer,edi				;; le pointeur de l'objet	)

;
; here we calc the direction matrix of the object or use the global rotation matrix, depending of the angles.
;


; si l'angle de l'objet est gal  celui du monde, on utilise la matrice de rotation globale
; sinon, on cr celle propre  l'objet et on l'utilise
		movaps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Angle_X	;; mettre les angles de la matrice de rotation globale dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Angle_X	;; mettre les angles de l'objet dans XMM1
		movaps XMM2,XMM0								;; copier les angles du monde dans XMM2
		cmpneqps XMM2,XMM1								;; comparer les angles du monde et de l'objet
		movmskps eax,XMM2								;; mettre le masque obtenu dans eax
		test eax,eax									;; fixer les flags de eax
		jnz RotationObjet								;; si c'est diffrent de 0 (il y a une diffrence), aller RotationObjet
; here, no rotation, so we just copy the global rotation matrix in the direction matix of the object
		movaps XMM5,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_00	;; ) on lit les lignes de la matrice de rotation globale
		movaps XMM6,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_04	;; )
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_08	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00,XMM5	;; ) on sauvegarde les lignes de la matrice de rotation pour l'objet
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04,XMM6	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08,XMM7	;; )
		jmp ObjetOriente								;; aller ObjetOriente


; here, there is a rotation, we're going to calc the direction matrix of the object
RotationObjet:
		subps XMM0,XMM1

		movaps XMM5,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_00	;; ) on lit les lignes de la matrice de rotation globale
		movaps XMM6,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_04	;; )
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_08	;; )




		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00,XMM5	;; ) on sauvegarde les lignes de la matrice de rotation pour l'objet
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04,XMM6	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08,XMM7	;; )
ObjetOriente:


;
; here, we're going to calc the area limits of the object, to test the presence on screen...
; usefull to avoid useless calc for object outside of the screen (later it will also be usefull for collisions tests)
;
CalculerLimites:
;
; firstly, we calc the points 1,2,3,4 of the area, with our point of view matrix
;
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; mettre la position camra _,Z,Y,X dans XMM4
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X	;; mettre _,minZ,minY,minX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_1_1	;; mettre _,maxZ,minY,minX dans XMM1
		movaps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_2_1	;; mettre _,minZ,maxY,minX dans XMM2
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_3_1	;; mettre _,maxZ,maxY,minX dans XMM3
		subps XMM0,XMM4								;; substract the view position _,Z,Y,X to coords _,minZ,minY,minX
		subps XMM1,XMM4								;; substract the view position _,Z,Y,X to coords _,maxZ,minY,minX
		subps XMM2,XMM4								;; substract the view position _,Z,Y,X to coords _,minZ,maxY,minX
		subps XMM3,XMM4								;; substract the view position _,Z,Y,X to coords _,maxZ,maxY,minX
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM5,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM0,XMM4								;;	) et on additionne le tout
		addps XMM0,XMM5								;;	)
; here, XMM0 = _,minZ,minY,minX
		movaps XMM4,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM1,XMM4								;;	) et on additionne le tout
		addps XMM1,XMM5								;;	)
; here, XMM1 = _,maxZ,minY,minX
		movaps XMM4,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM5								;;	)
; here, XMM2 = _,minZ,maxY,minX
		movaps XMM4,XMM3								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM3								;; )
		shufps XMM3,XMM3,000h							;; XMM3 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM3,XMM4								;;	) et on additionne le tout
		addps XMM3,XMM5								;;	)
; here XMM3 = _,maxZ,maxY,minX


;
; and transform to 2D coords
;
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0
		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth

; for _,minZ,minY,minX
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert01								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert01
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert01:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,minY,minX
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert02								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert02
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert02:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,maxY,minX
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert03								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert03
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert03:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,maxY,minX
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert04								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert04
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert04:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; temporary save the results
		movaps OWORD PTR Simd_Temporary_Values_1_1,XMM0		;; ) sauvegarder les valeurs que l'on rutilisera le moment venu
		movaps OWORD PTR Simd_Temporary_Values_2_1,XMM1		;; )
		movaps OWORD PTR Simd_Temporary_Values_3_1,XMM2		;; )
		movaps OWORD PTR Simd_Temporary_Values_4_1,XMM3		;; )


;
; secondly, we calc the points 5,6,7,8 of the area, with our point of view matrix
;
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; mettre la position camra _,Z,Y,X dans XMM4
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; mettre _,maxZ,maxY,maxX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_4_1	;; mettre _,minZ,maxY,maxX dans XMM1
		movaps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_5_1	;; mettre _,maxZ,minY,maxX dans XMM2
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_6_1	;; mettre _,minZ,minY,maxX dans XMM3
		subps XMM0,XMM4								;; substract the view position _,Z,Y,X to coords _,maxZ,maxY,maxX
		subps XMM1,XMM4								;; substract the view position _,Z,Y,X to coords _,minZ,maxY,maxX
		subps XMM2,XMM4								;; substract the view position _,Z,Y,X to coords _,maxZ,minY,maxX
		subps XMM3,XMM4								;; substract the view position _,Z,Y,X to coords _,minZ,minY,maxX
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM5,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM0,XMM4								;;	) et on additionne le tout
		addps XMM0,XMM5								;;	)
; here, XMM0 = _,maxZ,maxY,maxX
		movaps XMM4,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM1,XMM4								;;	) et on additionne le tout
		addps XMM1,XMM5								;;	)
; here, XMM1 = _,minZ,maxY,maxX
		movaps XMM4,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM5								;;	)
; here, XMM2 = _,maxZ,minY,maxX
		movaps XMM4,XMM3								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM3								;; )
		shufps XMM3,XMM3,000h							;; XMM3 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM3,XMM4								;;	) et on additionne le tout
		addps XMM3,XMM5								;;	)
; here, XMM3 = _,minZ,minY,maxX


;
; and transform to 2D coords
;
;		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (done previously)
;		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth (done previously)
; for _,maxZ,maxY,maxX
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert05								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert05
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert05:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,maxY,maxX
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert06								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert06
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert06:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,minY,maxX
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert07								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert07
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert07:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,minY,maxX
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert08								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert08
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert08:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; now we're going to keep the min and max values
		movaps XMM4,XMM0								;; recopier le premier registre dans un registre libre
		minps XMM0,XMM1								;;	) conserver les valeurs minimales
		minps XMM0,XMM2								;;	)
		minps XMM0,XMM3								;;	)
		minps XMM0,OWORD PTR Simd_Temporary_Values_1_1		;;	)
		minps XMM0,OWORD PTR Simd_Temporary_Values_2_1		;;	)
		minps XMM0,OWORD PTR Simd_Temporary_Values_3_1		;;	)
		minps XMM0,OWORD PTR Simd_Temporary_Values_4_1		;;	)
		maxps XMM1,XMM2								;; ) conserver les valeurs maximales
		maxps XMM1,XMM3								;; )
		maxpS XMM1,XMM4								;; )
		maxps XMM1,OWORD PTR Simd_Temporary_Values_1_1		;; )
		maxps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; )
		maxps XMM1,OWORD PTR Simd_Temporary_Values_3_1		;; )
		maxps XMM1,OWORD PTR Simd_Temporary_Values_4_1		;; )
; here, XMM0=min values, and XMM1=max values


;
; now we have our limits, we're going to see if it's on screen or not...
;

; here, z limit test, for useless objects
;		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (done previously)
		movhlps XMM5,XMM1								;; XMM5 = _,_,_,maxZ
		comiss XMM5,XMM6								;; comparer la depth  0
		jc SitueHorsEcran								;; si c'est infrieur (c=lt et nc=ge pour comiss), aller SitueHorsEcran


; here, X and Y screen limits test
		cmpltps XMM1,OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_X_Mini	;; comparer les valeurs maximales en XMM1  celles en x.Visual_Limit_X_Mini
		cmpnleps XMM0,OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_X_Maxi	;; comparer les valeurs minimales en XMM0  celles en x.Visual_Limit_X_Maxi
		orps XMM0,XMM1									;; fusionner les masques obtenus dans XMM0 (puisqu'il suffit qu'une seule condition soit remplie pour que l'objet soit situ hors cran)
		movmskps eax,XMM0								;; mettre le masque obtenu dans eax
		and eax,00000011b								;; ici, on ne conserve que les bits 2 (les Zs) 1 (les Ys) et 0 (les Xs)
		jz CalculerPoints								;; si c'est gal  0 (c'est (ou partiellement) dans l'cran), aller CalculerPoints

; here, it's not on screen
SitueHorsEcran:
		btr (A_3D_Object PTR [edi]).Object_Flags,31			;; sinon, dsactiver le bit de signe du statut (n'apparaitra pas)
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)


;
; here, it's (or partially, or maybe) on screen. for more precision we need to do raytracing..., so we're going to recalc all the points
; of the object (by 4)
;
CalculerPoints:
; loop init
		bts (A_3D_Object PTR [edi]).Object_Flags,31			;; positionner le bit de signe du statut (l'objet va apparaitre, du moins partiellement)
		mov eax,3*DWORD								;; mettre 12 (3*DWORD) dans eax
		mul (A_3D_Object PTR [edi]).Number_Of_Points_treated	;; on multipli eax par le nombre de points  traiter
		mov ebx,(A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer	;; mettre l'adresse du bloc mmoire dans ebx
		mov ecx,(A_3D_Object PTR [edi]).Points_Pointer		;; mettre le pointeur des points de l'objet 3D dans eax
		add ecx,eax									;; aouter eax  ecx
		neg eax										;; inverser eax, qui devient notre compteur de boucle

; maintenant, on va calculer les coordonnes des points de l'ojet 3D par rapport  la position et l'angle de la camra
NumberOfPointsLoop:
		movaps XMM0,OWORD PTR [ecx+eax]					;; mettre les X2,Z1,Y1,X1 dans XMM0
		movaps XMM1,OWORD PTR [ecx+eax+16]					;; mettre les Y3,X3,Z2,Y2 dans XMM6
		movaps XMM2,OWORD PTR [ecx+eax+32]					;; mettre les Z4,Y4,X4,Z3 dans XMM7
		subps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_01	;; substract the view position X,Z,Y,X to coords X2,Z1,Y1,X1
		subps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_05	;; substract the view position Y,X,Z,Y to coords Y3,X3,Z2,Y2
		subps XMM2,OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_09	;; substract the view position Z,Y,X,Z to coords Z4,Y4,X4,Z3
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM3,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		movaps XMM5,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X1,X1,X1,X1 ) on repositionne les valeurs
		shufps XMM3,XMM3,055h							;; XMM3 = Y1,Y1,Y1,Y1 )
		shufps XMM4,XMM4,0AAh							;; XMM4 = Z1,Z1,Z1,Z1 )
		shufps XMM5,XMM5,0FFh							;; XMM5 = X2,X2,X2,X2	)  utiliser aprs
; on effectue nos calculs...
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; )
		addps XMM0,XMM3								;;	) et on additionne le tout
		addps XMM0,XMM4								;;	)
; here, XMM0 = Z1,Y1,X1
		movaps XMM3,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM1								;; )
		movaps XMM6,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = Y2,Y2,Y2,Y2 ) on repositionne les valeurs
		shufps XMM3,XMM3,055h							;; XMM3 = Z2,Z2,Z2,Z2 )
		shufps XMM4,XMM4,0AAh							;; XMM4 = X3,X3,X3,X3	)
		shufps XMM6,XMM6,0FFh							;; XMM6 = Y3,Y3,Y3,Y3	)  utiliser aprs
; on effectue nos calculs...
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; )
		mulps XMM6,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		addps XMM1,XMM5								;;	) et on additionne le tout
		addps XMM1,XMM3								;;	)
; here, XMM1 = Z2,Y2,X2
		movaps XMM3,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		movaps XMM7,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = Z3,Z3,Z3,Z3 ) on repositionne les valeurs
		shufps XMM3,XMM3,055h							;; XMM3 = X4,X4,X4,X4	)
		shufps XMM5,XMM5,0AAh							;; XMM5 = Y4,Y4,Y4,Y4	)
		shufps XMM7,XMM7,0FFh							;; XMM7 = Z4,Z4,Z4,Z4	)  utiliser aprs
; on effectue nos calculs... pour les dernire coordonnes
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM7,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM6								;;	)
; here, XMM2 = Z3,Y3,X3
		addps XMM3,XMM5								;; ) et on additionne le tout
		addps XMM3,XMM7								;; )
; here, XMM3 = Z4,Y4,X4


;
; and transform to 2D coords
;
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0
		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth
; for the 1st point
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert09								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert09
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert09:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for the 2nd point
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert10								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert10
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert10:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for the 3rd point
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert11								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert11
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert11:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for the 4th point
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert12								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert12
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert12:

		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; and we add half screen width/height (to obtain the corresponding screen positions)
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width	;; mettre _,_,Hauteur/2,Largeur/2 dans XMM4
		addps XMM0,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM0
		addps XMM1,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM1
		addps XMM2,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM2
		addps XMM3,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM3
; and we save the new 2D coords in the mem block of the object
		movaps OWORD PTR [ebx],XMM0						;; mettre les nouvelles coordonnes X,Y,Z dans ebx
		movaps OWORD PTR [ebx+16],XMM1					;; mettre les nouvelles coordonnes X,Y,Z dans ebx+16
		movaps OWORD PTR [ebx+32],XMM2					;; mettre les nouvelles coordonnes X,Y,Z dans ebx+32
		movaps OWORD PTR [ebx+48],XMM3					;; mettre les nouvelles coordonnes X,Y,Z dans ebx+48


;
; and of the loop for the points
;
EndNumberOfPointsLoop:
		add ebx,4*4*DWORD								;; augmenter l'adresse o l'on rempli la mmoire
		add eax,3*4*DWORD								;; augmenter notre compteur de boucle des 4*3 coordonne traites
		jnz NumberOfPointsLoop							;; tant que ce n'est pas gal  zro, aller NumberOfPointsLoop


;
; now, we're going to draw the faces
;
		mov eax,4*DWORD								;; ) on dfini notre compteur de boucle
		mul (A_3D_Object PTR [edi]).Number_Of_Faces			;; )
		sub eax,4*DWORD								;; ) (on enlve une serie (pour que le 0 soit trait))
		mov Faces_Loop_Counter,eax						;; )
		mov eax,(A_3D_Object PTR [edi]).Faces_Pointer		;;	) mettre le pointeur des faces dans une variable temporaire (pour eviter d'avoir besoin de edi)
		mov Temporary_Face_Pointer,eax					;;	)
;		movaps XMM5,OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1		;; XMM5 = depth,depth,depth,depth
;		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (done previously)
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1
;		movaps Temporary_Depth,XMM5						;; sauvegarder les depths (permet de ne faire qu'une lecture dans la boucle qui suit)


NumberOfFacesLoop:
; dessiner les trois polygones
		mov eax,Temporary_Face_Pointer					;; ) positionner le pointeur des faces dans eax
		add eax,Faces_Loop_Counter						;; )
		mov ebx,DWORD PTR [eax]							;;	) obtenir les adresses des points constituant la face
		mov ecx,DWORD PTR [eax+4]						;;	)
		mov edx,DWORD PTR [eax+8]						;;	)
		mov eax,00000000h								;; ) mettre la couleur de l'objet dans MM0
		movd MM0,eax									;; )
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (done previously)
; ici, on teste si les polygones doivent tre dssins, on dfini les variables  comparer
		movss XMM0,DWORD PTR [ebx+8]						;; XMM0 = _,_,_,Z1
		shufps XMM0,OWORD PTR [ecx],0E4h					;; XMM0 = _,Z2,_,Z1
		shufps XMM0,OWORD PTR [edx],0E8h					;; XMM0 = _,Z3,Z2,Z1
; on compare les valeurs z  0 (si les 3 sont infrieures, on sort)
		cmpgtps XMM0,XMM6								;; comparer _,Z3,Z2,Z1  0,0,0,0
		movmskps eax,XMM0								;; mettre le masque obtenu dans un registre
		and eax,0111b									;; ne conserver que les bits des 3 premires valeurs
		jz EndNumberOfFacesLoop							;; si eax est gal  0, aller EndNumberOfFacesLoop (la sortie de la boucle)
; sinon, ici on dessine au moins 2 polygones
		cmp eax,0001b									;; les valeurs 2 et 3 sont ngatives ?
		je Dessiner12et13								;; si c'est le cas, aller Dessiner12et13
		cmp eax,0010b									;; les valeurs 1 et 3 sont ngatives ?
		je Dessiner12et23								;; si c'est le cas, aller Dessiner12et23
		cmp eax,0100b									;; les valeurs 1 et 2 sont ngatives ?
		je Dessiner13et23								;; si c'est le cas, aller Dessiner13et23
; sinon, ici on dessine les 3 polygones
push ebx
push edx
push ecx
push edx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [ecx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
pop edx
pop ecx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ecx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
pop edx
pop ebx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
	jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; ici, on dessine les polygones 1,2 et 1,3
Dessiner12et13:
push ebx
push ebx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [ecx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
pop edx
pop ebx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
	jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; ici, on dessine les polygones 1,2 et 2,3
Dessiner12et23:
push ecx
push edx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [ecx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
pop edx
pop ecx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ecx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
	jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; ici, on dessine les polygones 1,3 et 2,3
Dessiner13et23:
push ecx
push edx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse
pop edx
pop ecx
;	mov esi,Temporary_3D_World_Pointer					;; lire le pointeur de la structure A_3D_World (inutile, fait auparavant)
	movaps XMM0,OWORD PTR [ecx]						;; on lit _,Z1,Y1,X1
	movaps XMM1,OWORD PTR [edx]						;; on lit _,Z2,Y2,X2
;	movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 (inutile, fait auparavant)
;	xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (inutile, fait auparavant)
	call _DrawPolygon_Sse

; fin de la boucle
EndNumberOfFacesLoop:
		sub Faces_Loop_Counter,4*DWORD					;; dcrmenter notre compteur de boucle d'une face
		jns NumberOfFacesLoop							;; tant que ce n'est pas sign, aller NumberOfFacesLoop
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Draw3DObject_Sse ENDP


ALIGN 16
;
; (debug) draw the polygons of the current object
;
; Syntax :
; mov edx,OFFSET of the Screen_Block structure
; mov esi,OFFSET of a A_3D_World structure
; mov edi,OFFSET of a A_3D_Object structure
; call Draw3DPolygon_Sse
;
; Return :
; nothing
;
Draw3DPolygon_Sse PROC
		bt (A_3D_Object PTR [edi]).Object_Flags,31			;; tester le bit de signe du statut (objet apparait, ou pas)
		jnc AlgoEnd									;; si le bit n'est pas positionn (hors cran), aller AlgoEnd (la sortie)
; ici, l'objet peut apparaitre, alors on fait le calcul
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on va sauvegarder les pointeurs
;		mov Temporary_Font_Pointer,ecx					;; le pointeur de la police
		mov Temporary_Screen_Pointer,edx					;; le pointeur de l'cran	) impratif pour pour l'utilisation de _DrawPolygon_Sse
		mov Temporary_3D_World_Pointer,esi					;; le pointeur du monde		)
		mov Temporary_3D_Object_Pointer,edi				;; le pointeur de l'objet	)

		mov eax,4*DWORD								;; ) on dfini notre compteur de boucle
		mul (A_3D_Object PTR [edi]).Number_Of_Faces			;; )
		sub eax,4*DWORD								;; ) (on enlve une serie (pour que le 0 soit trait))
		mov Faces_Loop_Counter,eax						;; )
		mov eax,(A_3D_Object PTR [edi]).Faces_Pointer		;;	) mettre le pointeur des faces dans une variable temporaire (pour eviter d'avoir besoin de edi)
		mov Temporary_Face_Pointer,eax					;;	)
		movd MM0,DWORD PTR (A_3D_Object PTR [edi]).Default_Colour	;; mettre x.Default_Colour dans un registre MM inutilis
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1	;; XMM7 = height-1,width-1,height-1,width-1 dans XMM7

NumberOfFacesLoop:
; we read the points
		mov eax,Temporary_Face_Pointer					;; ) positionner le pointeur des faces dans eax
		add eax,Faces_Loop_Counter						;; )
		mov ebx,DWORD PTR [eax]							;;	) obtenir les adresses des points constituant la face
		mov ecx,DWORD PTR [eax+4]						;;	)
		mov edx,DWORD PTR [eax+8]						;;	)
		movaps XMM0,OWORD PTR [ebx]						;; on lit _,Z1,Y1,X1
		movaps XMM1,OWORD PTR [ecx]						;; on lit _,Z2,Y2,X2
		movaps XMM2,OWORD PTR [edx]						;; on lit _,Z3,Y3,X3
		movaps OWORD PTR Simd_Temporary_Values_0_1,XMM0		;;
		movaps OWORD PTR Simd_Temporary_Values_1_1,XMM1		;;
		movaps OWORD PTR Simd_Temporary_Values_2_1,XMM2		;;
; here,
; XMM0 = _,Z1,Y1,X1
; XMM1 = _,Z2,Y2,X2
; XMM2 = _,Z3,Y3,X3
; XMM6 = 0,0,0,0
; XMM7 = height-1,width-1,height-1,width-1

; test if the polygons have to be draw
		movhlps XMM3,XMM0								;; XMM3 = _,_,_,Z1
		shufps XMM3,XMM1,0E4h							;; XMM3 = _,Z2,_,Z1
		shufps XMM3,XMM2,0E8h							;; XMM3 = _,Z3,Z2,Z1
; we compare the z values to 0 (if the 3 are below, we quit)
		cmpgtps XMM3,XMM6								;; comparer _,Z3,Z2,Z1  0,0,0,0
		movmskps eax,XMM3								;; mettre le masque obtenu dans un registre
		and eax,0111b									;; ne conserver que les bits des 3 premires valeurs (pour s'assurer que le saut sera valide)
		jmp DWORD PTR [Table_Traitement_Nombre_Polygones+eax*4]	;; sauter  l'adresse correspondante au saut de la table
.DATA
ALIGN 4
; ici, notre table des sauts  effectuer
Table_Traitement_Nombre_Polygones	DWORD EndNumberOfFacesLoop,Dessiner12et13,Dessiner12et23,Dessiner12et13et23,Dessiner13et23,Dessiner12et13et23,Dessiner12et13et23,Dessiner12et13et23

.CODE
; ici, les sauts

; draw polygons 1,2 and 1,3
Dessiner12et13:
;		movaps XMM0,XMM0								;; on dfini X1,Y1
;		movaps XMM1,XMM1								;; on dfini X2,Y2
		call _DrawPolygon_Sse							;; dessiner le polygone
		movaps XMM0,OWORD PTR Simd_Temporary_Values_0_1		;; on dfini X1,Y1
		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
		jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; draw polygons 1,2 and 2,3
Dessiner12et23:
;		movaps XMM0,XMM0								;; on dfini X1,Y1
;		movaps XMM1,XMM1								;; on dfini X2,Y2
		call _DrawPolygon_Sse							;; dessiner le polygone
		movaps XMM0,OWORD PTR Simd_Temporary_Values_1_1		;; on dfini X2,Y2
		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
		jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; draw polygons 1,3 and 2,3
Dessiner13et23:
;		movaps XMM0,XMM0								;; on dfini X1,Y1
;		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3 (ici, si je met XMM2 il y a problme graphique...)
		movaps XMM1,XMM2								;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
		movaps XMM0,OWORD PTR Simd_Temporary_Values_1_1		;; on dfini X2,Y2
		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
		jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
; draw all polygons
Dessiner12et13et23:
;		movaps XMM0,XMM0								;; on dfini X1,Y1
;		movaps XMM1,XMM1								;; on dfini X2,Y2
		call _DrawPolygon_Sse							;; dessiner le polygone
		movaps XMM0,OWORD PTR Simd_Temporary_Values_1_1		;; on dfini X2,Y2
		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
		movaps XMM0,OWORD PTR Simd_Temporary_Values_0_1		;; on dfini X1,Y1
		movaps XMM1,OWORD PTR Simd_Temporary_Values_2_1		;; on dfini X3,Y3
		call _DrawPolygon_Sse							;; dessiner le polygone
;		jmp EndNumberOfFacesLoop							;; aller EndNumberOfFacesLoop (la sortie de la boucle)
EndNumberOfFacesLoop:
		sub Faces_Loop_Counter,4*DWORD					;; dcrmenter notre compteur de boucle d'une face
		jns NumberOfFacesLoop							;; tant que ce n'est pas sign, aller NumberOfFacesLoop
; sinon, on a dessin tous les polygones de toutes les faces, donc on restaure les registres...
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
AlgoEnd:
	ret												;; retourner (sortir de la procdure)
Draw3DPolygon_Sse ENDP


ALIGN 16
;
; (debug) draw the object area
;
; Syntax :
; mov edx,OFFSET of the Screen_Block structure
; mov esi,OFFSET of a A_3D_World structure
; mov edi,OFFSET of a A_3D_Object structure
; call Draw3DArea_Sse
;
; Return :
; nothing
;
Draw3DArea_Sse PROC
		bt (A_3D_Object PTR [edi]).Object_Flags,31			;; tester le bit de signe du statut (objet apparait, ou pas)
		jnc AlgoEnd									;; si le bit n'est pas positionn (hors cran), aller AlgoEnd
; ici, l'objet peut apparaitre, alors on fait le calcul
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)
; premirement on va sauvegarder les pointeurs
;		mov Temporary_Font_Pointer,ecx					;; le pointeur de la police
		mov Temporary_Screen_Pointer,edx					;; le pointeur de l'cran
		mov Temporary_3D_World_Pointer,esi					;; le pointeur du monde
		mov Temporary_3D_Object_Pointer,edi				;; le pointeur de l'objet

;
; we calc the points 1,2,3,4,5,6,7,8 of the area
;

; donc on va calculer les 4 premires coordonnes des limites de l'ojet 3D par rapport  la position et l'angle de la camra
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; mettre la position camra _,Z,Y,X dans XMM4
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X	;; mettre _,minZ,minY,minX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_1_1	;; mettre _,maxZ,minY,minX dans XMM1
		movaps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_2_1	;; mettre _,minZ,maxY,minX dans XMM2
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_3_1	;; mettre _,maxZ,maxY,minX dans XMM3
		subps XMM0,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,centerX
		subps XMM1,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,maxX
		subps XMM2,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,centerX
		subps XMM3,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,maxX
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM5,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM0,XMM4								;;	) et on additionne le tout
		addps XMM0,XMM5								;;	)
; here, XMM0 = _,minZ,minY,minX
		movaps XMM4,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM1,XMM4								;;	) et on additionne le tout
		addps XMM1,XMM5								;;	)
; here, XMM1 = _,maxZ,minY,minX
		movaps XMM4,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM5								;;	)
; here, XMM2 = _,minZ,maxY,minX
		movaps XMM4,XMM3								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM3								;; )
		shufps XMM3,XMM3,000h							;; XMM3 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM3,XMM4								;;	) et on additionne le tout
		addps XMM3,XMM5								;;	)
; here, XMM3 = _,maxZ,maxY,minX


;
; and transform to 2D coords
;
		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0
		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth
; for _,minZ,minY,minX
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert01								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert01
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert01:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,minY,minX
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert02								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert02
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert02:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,maxY,minX
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert03								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert03
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert03:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,maxY,minX
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert04								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert04
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert04:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; and we add half screen width/height (to obtain the corresponding screen positions)
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width	;; mettre _,_,Hauteur/2,Largeur/2 dans XMM4
		addps XMM0,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM0
		addps XMM1,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM1
		addps XMM2,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM2
		addps XMM3,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM3
; we convert the obtained results to X and Y integer
		cvttps2pi MM0,XMM0								;; ) convertir les rsultats obtenus en entiers
		cvttps2pi MM1,XMM1								;; )
		cvttps2pi MM2,XMM2								;; )
		cvttps2pi MM3,XMM3								;; )
		movq QWORD PTR Simd_Temporary_Values_1_1,MM0			;; ) sauvegarder les valeurs que l'on rutilisera le moment donn
		movq QWORD PTR Simd_Temporary_Values_2_1,MM1			;; )
		movq QWORD PTR Simd_Temporary_Values_3_1,MM2			;; )
		movq QWORD PTR Simd_Temporary_Values_4_1,MM3			;; )
		movq MM4,MM0									;;	) copier MM0,MM1,MM2,MM3 dans les registres libres
		movq MM5,MM1									;;	)
		movq MM6,MM2									;;	)
		movq MM7,MM3									;;	)
		punpckhdq MM4,MM4								;; ) copier les Y dans les dwords rapidement accessibles
		punpckhdq MM5,MM5								;; )
		punpckhdq MM6,MM6								;; )
		punpckhdq MM7,MM7								;; )


;
; here, we draw the rectangle (the mini rectangle)
;
		movd eax,MM0									;;	) on dfini X1,Y1 (_,minZ,minY,minX)
		movd ebx,MM4									;;	)
		movd ecx,MM1									;; ) on dfini X2,Y2 (_,maxZ,minY,minX)
		movd edx,MM5									;; )
		mov esi,Temporary_Screen_Pointer					;; mettre l'adresse de la structure TamponEcranTravail dans esi
		mov edi,Colour_Magenta_Bright						;; mettre la couleur mauve vif
		call DrawLine									;; on trace la ligne qui relie les points
		movd eax,MM3									;; ) on dfini X2,Y2 (_,maxZ,maxY,minX)
		movd ebx,MM7									;; )
		call DrawLine									;; on trace la ligne qui relie les points
		movd ecx,MM2									;; ) on dfini X2,Y2 (_,minZ,maxY,minX)
		movd edx,MM6									;; )
		call DrawLine									;; on trace la ligne qui relie les points
		movd eax,MM0									;; ) on dfini X2,Y2 (_,minZ,minY,minX)
		movd ebx,MM4									;; )
		call DrawLine									;; on trace la ligne qui relie les points


;
; on remet les adresses des structures dans les registres esi et edi (pour pouvoir calculer les 4 coordonnes suivantes)
;
		mov esi,Temporary_3D_World_Pointer					;; le pointeur du monde
		mov edi,Temporary_3D_Object_Pointer				;; le pointeur de l'objet

; on va calculer les 4 dernires coordonnes des limites de l'ojet 3D par rapport  la position et l'angle de la camra
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; mettre la position camra _,Z,Y,X dans XMM4
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; mettre _,maxZ,maxY,maxX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_4_1	;; mettre _,minZ,maxY,maxX dans XMM1
		movaps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_5_1	;; mettre _,maxZ,minY,maxX dans XMM2
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_6_1	;; mettre _,minZ,minY,maxX dans XMM3
		subps XMM0,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,centerX
		subps XMM1,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,maxX
		subps XMM2,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,centerX
		subps XMM3,XMM4								;; substract the view position _,Z,Y,X to coords _,centerZ,centerY,maxX
; we multiply the coords by the global rotation matrix of the object...
		movaps XMM5,XMM0								;; ) copier les coordonnes dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,000h							;; XMM0 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM0,XMM4								;;	) et on additionne le tout
		addps XMM0,XMM5								;;	)
; here, XMM0 = _,maxZ,maxY,maxX
		movaps XMM4,XMM1								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM1								;; )
		shufps XMM1,XMM1,000h							;; XMM1 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM1,XMM4								;;	) et on additionne le tout
		addps XMM1,XMM5								;;	)
; here, XMM1 = _,minZ,maxY,maxX
		movaps XMM4,XMM2								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM2								;; )
		shufps XMM2,XMM2,000h							;; XMM2 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM2,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM2,XMM4								;;	) et on additionne le tout
		addps XMM2,XMM5								;;	)
; here, XMM2 = _,maxZ,minY,maxX
		movaps XMM4,XMM3								;; ) copier les coordonnes dans des registres libres
		movaps XMM5,XMM3								;; )
		shufps XMM3,XMM3,000h							;; XMM3 = X,X,X,X ) on repositionne les valeurs
		shufps XMM4,XMM4,055h							;; XMM4 = Y,Y,Y,Y )
		shufps XMM5,XMM5,0AAh							;; XMM5 = Z,Z,Z,Z )
		mulps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00	;; ) on multiplie chaque copie par les lignes de la matrice de rotation globale
		mulps XMM4,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04	;; )
		mulps XMM5,OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08	;; )
		addps XMM3,XMM4								;;	) et on additionne le tout
		addps XMM3,XMM5								;;	)
; here, XMM3 = _,minZ,minY,maxX


;
; and transform to 2D coords
;
;		xorps XMM6,XMM6								;; XMM6 = 0,0,0,0 (done previously)
		movss XMM7,DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1	;; XMM7 = 0,0,0,depth
; for _,maxZ,maxY,maxX
		movhlps XMM4,XMM0								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert05								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert05
		xorps XMM0,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert05:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM0,XMM0								;; XMM0 = _,_,Y*2,X*2
		mulps XMM0,XMM5								;; XMM0 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM0,XMM4								;; XMM0 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,maxY,maxX
		movhlps XMM4,XMM1								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert06								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert06
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert06:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM1,XMM1								;; XMM1 = _,_,Y*2,X*2
		mulps XMM1,XMM5								;; XMM1 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM1,XMM4								;; XMM1 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,maxZ,minY,maxX
		movhlps XMM4,XMM2								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert07								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert07
		xorps XMM2,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert07:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM2,XMM2								;; XMM2 = _,_,Y*2,X*2
		mulps XMM2,XMM5								;; XMM2 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM2,XMM4								;; XMM2 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)
; for _,minZ,minY,maxX
		movhlps XMM4,XMM3								;; XMM4 = _,_,0,Z
		movss XMM5,XMM7								;; XMM5 = 0,0,0,depth
		addss XMM5,XMM4								;; XMM5 = _,_,0,Z+depth
		comiss XMM5,XMM6								;; comparer Z+depth  0
		jnc AvoidInvert08								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller AvoidInvert08
		xorps XMM3,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; sinon, inverser les signes de X et Y
AvoidInvert08:
		rcpss XMM5,XMM5								;; XMM5 = 0,0,0,1/Z+depth
		unpcklps XMM5,XMM5								;; XMM5 = _,_,1/Z+depth,1/Z+depth
		addps XMM3,XMM3								;; XMM3 = _,_,Y*2,X*2
		mulps XMM3,XMM5								;; XMM3 = _,_,Y*2*(1/Z+depth),X*2*(1/Z+depth)
		movlhps XMM3,XMM4								;; XMM3 = _,Z,Y*2*(1/Z+depth),X*2*(1/Z+depth)


; and we add half screen width/height (to obtain the corresponding screen positions)
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width	;; mettre _,_,Hauteur/2,Largeur/2 dans XMM4
		addps XMM0,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM0
		addps XMM1,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM1
		addps XMM2,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM2
		addps XMM3,XMM4								;; ajouter 0,0,Hauteur/2,Largeur/2  XMM3
; we convert the obtained results to X and Y integer
		cvttps2pi MM0,XMM0								;; ) convertir les rsultats obtenus en entiers
		cvttps2pi MM1,XMM1								;; )
		cvttps2pi MM2,XMM2								;; )
		cvttps2pi MM3,XMM3								;; )
		movq MM4,MM0									;;	) copier MM0,MM1,MM2,MM3 dans les registres libres
		movq MM5,MM1									;;	)
		movq MM6,MM2									;;	)
		movq MM7,MM3									;;	)
		punpckhdq MM4,MM4								;; ) copier les Y dans les dwords rapidement accessibles
		punpckhdq MM5,MM5								;; )
		punpckhdq MM6,MM6								;; )
		punpckhdq MM7,MM7								;; )


;
; here, we draw the rectangle (the maxi rectangle)
;
		movd eax,MM0									;;	) on dfini X1,Y1 (_,maxZ,maxY,maxX)
		movd ebx,MM4									;;	)
		movd ecx,MM1									;; ) on dfini X2,Y2 (_,minZ,maxY,maxX)
		movd edx,MM5									;; )
		mov esi,Temporary_Screen_Pointer					;; mettre l'adresse de la structure TamponEcranTravail dans esi
		mov edi,Colour_Magenta_Bright						;; mettre la couleur mauve vif
		call DrawLine									;; on trace la ligne qui relie les points
		movd eax,MM3									;; ) on dfini X2,Y2 (_,minZ,minY,maxX)
		movd ebx,MM7									;; )
		call DrawLine									;; on trace la ligne qui relie les points
		movd ecx,MM2									;; ) on dfini X2,Y2 (_,maxZ,minY,maxX)
		movd edx,MM6									;; )
		call DrawLine									;; on trace la ligne qui relie les points
		movd eax,MM0									;; ) on dfini X2,Y2 (_,maxZ,maxY,maxX)
		movd ebx,MM4									;; )
		call DrawLine									;; on trace la ligne qui relie les points


;
; and add mini/maxi rectangles lines
;
		mov eax,Simd_Temporary_Values_2_1					;; ) on dfini X1,Y1 (_,maxZ,minY,minX)
		mov ebx,Simd_Temporary_Values_2_2					;; )
;		movd ecx,MM2									;;	) on dfini X2,Y2 (_,maxZ,minY,maxX) (done previously)
;		movd edx,MM6									;;	)
		call DrawLine									;; on trace la ligne qui relie les points
		mov eax,Simd_Temporary_Values_1_1					;; ) on dfini X1,Y1 (_,minZ,minY,minX)
		mov ebx,Simd_Temporary_Values_1_2					;; )
		movd ecx,MM3									;;	) on dfini X2,Y2 (_,minZ,minY,maxX)
		movd edx,MM7									;;	)
		call DrawLine									;; on trace la ligne qui relie les points
		mov eax,Simd_Temporary_Values_4_1					;; ) on dfini X1,Y1 (_,maxZ,maxY,minX)
		mov ebx,Simd_Temporary_Values_4_2					;; )
		movd ecx,MM0									;;	) on dfini X2,Y2 (_,maxZ,maxY,maxX)
		movd edx,MM4									;;	)
		call DrawLine									;; on trace la ligne qui relie les points
		mov eax,Simd_Temporary_Values_3_1					;; ) on dfini X1,Y1 (_,minZ,maxY,minX)
		mov ebx,Simd_Temporary_Values_3_2					;; )
		movd ecx,MM1									;;	) on dfini X2,Y2 (_,minZ,maxY,maxX)
		movd edx,MM5									;;	)
		call DrawLine									;; on trace la ligne qui relie les points
; et voil, la zone 3D est compltement dessine
Label01:
		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
AlgoEnd:
	ret												;; retourner (sortir de la procdure)
Draw3DArea_Sse ENDP


ALIGN 16
;
; init the 3D world, in fact we init all the variables needed by our "world" (the A_3D_World structure)
; note : this function is only called once in the beginning of the program (once per 3D worlds created...)
;
; Syntax :
; mov eax,width of the screen used for display
; mov ebx,height of the screen used for display
; mov esi,OFFSET of a A_3D_World structure (our 3d world)
; call Init3DWorld_Sse
;
; Return :
; nothing
;
Init3DWorld_Sse PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

;
; on place des commodits
;
		movaps XMM0,OWORD PTR Simd_Values_0_180_180_180			;; ) 180 
		movaps OWORD PTR (A_3D_World PTR [esi]).Value_180_1,XMM0	;; )

;
; we init the view matrices of the world, with the identity matrix
;
		movaps XMM0,OWORD PTR Identity_Matrix_1				;; ) lire la matrice d'identit de nos routines 3D
		movaps XMM1,OWORD PTR Identity_Matrix_2				;; )
		movaps XMM2,OWORD PTR Identity_Matrix_3				;; )
		movaps XMM3,OWORD PTR Identity_Matrix_4				;; )
; et on la recopie dans les matrices d'orientation de notre monde
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_00,XMM0	;; ) dans la matrice de rotation autour de l'axe X
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_04,XMM1	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_08,XMM2	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_12,XMM3	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_00,XMM0	;;	) dans la matrice de rotation autour de l'axe Y
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_04,XMM1	;;	)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08,XMM2	;;	)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_12,XMM3	;;	)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_00,XMM0	;; ) dans la matrice de rotation autour de l'axe Z
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_04,XMM1	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_08,XMM2	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_12,XMM3	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_00,XMM0	;;	) dans la matrice de rotation globale
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_04,XMM1	;;	)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_08,XMM2	;;	)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_12,XMM3	;;	)

;
; here, we're going to convert some values to real4 format real4, to avoid to constantly repeat the operation in the main loop
;
		mov DWORD PTR Simd_Temporary_Values_1_1,eax			;; save width screen
		mov DWORD PTR Simd_Temporary_Values_1_2,ebx			;; save height screen
		movq MM0,QWORD PTR Simd_Temporary_Values_1_1			;; read the qword
; ensuite on converti les valeurs au format real4
		cvtpi2ps XMM0,MM0								;; convert to real4
		andps XMM0,OWORD PTR Simd_Mask_3_2_x_x				;; XMM0 = 0,0,height,width
; et on defini les variables qui en dcoulent, ici, pour la taille cran
		movaps XMM1,XMM0								;; copy 0,0,height,width in XMM1
		movlhps XMM1,XMM1								;; XMM1 = height,width,height,width
		movaps OWORD PTR (A_3D_World PTR [esi]).Screen_Width,XMM1	;; and save them in x.Screen_Width
; ici, des dclinaisons
		subps XMM1,OWORD PTR Simd_Values_1_1_1_1			;; substract 1 to width and height screen limits
		movaps OWORD PTR (A_3D_World PTR [esi]).Screen_Width_m1,XMM1	;; and save them in x.Screen_Width_m1
		mulps XMM0,OWORD PTR Simd_Values_0p5_0p5_0p5_0p5		;; multiply the width and the height by 0.5 for half sizes
		xorps XMM2,XMM2								;; XMM2 = 0,0,0,0
		movlhps XMM0,XMM2								;; XMM0 = 0,0,height/2,width/2
		movaps XMM1,XMM0								;; XMM1 = _,_,height/2,width/2
		movlhps XMM1,XMM2								;; XMM0 = 0,0,height/2,width/2
		xorps XMM1,OWORD PTR Simd_Mask_Signs_x_x_1_0			;; XMM1 = 0,0,-height/2,-width/2
		movaps OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width,XMM0	;; and save in x.Half_Screen_Width

		subps XMM0,OWORD PTR Simd_Values_0_0_1_1			;; enlever 1 aux 2 premires valeurs
		movaps OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_X_Maxi,XMM0	;; et sauvegarder dans x.Visual_Limit_X_Maxi
		movaps OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_X_Mini,XMM1	;; et sauvegarder dans x.Visual_Limit_X_Mini

		mov DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Mini,0	;; save 0 as min Z limit
		mov eax,DWORD PTR (A_3D_World PTR [esi]).View_Screen_Depth
		mov DWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi,eax	;; save depth as max Z limit


;
; now we calc our visual multiplier (max(width/height))/2 * 1,5. for a view of 120 (for screen width) instead of the math 180,
; and get a 1:1 ratio for any screen width/height
;
		movaps XMM0,OWORD PTR (A_3D_World PTR [esi]).Half_Screen_Width	;; lire x.Half_Screen_Width
		movaps XMM1,XMM0								;; XMM1 = 0,0,height/2,width/2
		shufps XMM0,XMM0,0E0h							;; XMM0 = 0,0,width/2,width/2
		shufps XMM1,XMM1,0E5h							;; XMM1 = 0,0,height/2,height/2
		maxps XMM0,XMM1								;; keep the max value (the same for both if we want a visual 1:1 ratio)
		mulps XMM0,OWORD PTR Simd_Values_1p5_1p5_1p5_1p5		;; multiply the max by 1.5 (for 120 instead of 180)
		movaps XMM2,OWORD PTR (A_3D_World PTR [esi]).View_Screen_Width	;; XMM2 = 0,depth,_,_
		movhlps XMM2,XMM2								;; XMM2 = 0,depth,0,depth
		movaps XMM1,XMM2								;; XMM1 = 0,depth,0,depth
		unpcklps XMM1,XMM1								;; XMM1 = 0,0,depth,depth
		movlhps XMM1,XMM1								;; XMM1 = depth,depth,depth,depth
		movaps OWORD PTR (A_3D_World PTR [esi]).Visual_Limit_Z_Maxi_1,XMM1	;; save depth,depth,depth,depth
; maintenant, on peut crer notre multiplicateur
		mulps XMM0,XMM1								;; XMM0 = _,_,height view*depth,width view*depth
		movlps QWORD PTR (A_3D_World PTR [esi]).View_Screen_Width,XMM0	;; and we save our multiplier

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Init3DWorld_Sse ENDP


ALIGN 16
;
; init a 3d object, en fait on initialise toutes les variables ncessaires  notre objet
; note : tous les registres XMMx sont utiliss, et une instance mmoire doit avoir t cre au pralable
;
; Syntax :
; mov ebx,OFFSET of the Mem_Info structure
; mov edx,OFFSET  = adresse (offset) des donnes de l'objet 3D
; esi = adresse (offset) d'une structure A_3D_World
; edi = adresse (offset) d'une structure A_3D_Object
; call Init3DObject_Sse
;
; Return :
; nothing
;
Init3DObject_Sse PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

		mov Temporary_3D_World_Pointer,esi					;; sauvegarder le pointeur du monde
		mov esi,ebx									;; copier dans l'adresse de la structure Mem_Info dans esi
;
; we init the direction matrices of the object, with the identity matrix
;
		movaps XMM0,OWORD PTR Identity_Matrix_1				;; ) lire la matrice d'identit de nos routines 3D
		movaps XMM1,OWORD PTR Identity_Matrix_2				;; )
		movaps XMM2,OWORD PTR Identity_Matrix_3				;; )
		movaps XMM3,OWORD PTR Identity_Matrix_4				;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.X_Axis_00,XMM0	;; ) dans la matrice de rotation autour de l'axe X
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.X_Axis_04,XMM1	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.X_Axis_08,XMM2	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.X_Axis_12,XMM3	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Y_Axis_00,XMM0	;;	) dans la matrice de rotation autour de l'axe Y
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Y_Axis_04,XMM1	;;	)
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Y_Axis_08,XMM2	;;	)
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Y_Axis_12,XMM3	;;	)
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Z_Axis_00,XMM0	;; ) dans la matrice de rotation autour de l'axe Z
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Z_Axis_04,XMM1	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Z_Axis_08,XMM2	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.Z_Axis_12,XMM3	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_00,XMM0	;; ) et la recopier dans la matrice d'orientation de notre objet
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_04,XMM1	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_08,XMM2	;; )
		movaps OWORD PTR (A_3D_Object PTR [edi]).Direction_Matrix.XYZ_Axis_12,XMM3	;; )



;
; place the address of the name of the object dans the structure A_3D_Object of the object
;
		mov eax,edx									;; copier edx dans eax
		add eax,44									;; ajouter 11 dword
		mov DWORD PTR (A_3D_Object PTR [edi]).Objetc_Name_Pointer,eax	;; et sauvegarder l'adresse dans la structure de l'objet

;
; we fill the structure of our 3d object with infos we have
;
		movaps XMM0,OWORD PTR [edx]						;; lire la position originelle de l'objet
		andps XMM0,OWORD PTR Simd_Mask_3_x_x_x				;; pour s'assurer que la dernire valeur du quartet soit zro
		movaps OWORD PTR (A_3D_Object PTR [edi]).Position_X,XMM0	;; sauvegarder la position de l'objet
		mov eax,DWORD PTR [edx+28]						;; mettre l'adresse de dpart des points dans eax
		mov ebx,DWORD PTR [edx+32]						;; mettre le nombre de points dans ebx
		mov ecx,DWORD PTR [edx+36]						;; mettre la couleur par dfaut de l'objet dans ecx
		mov DWORD PTR (A_3D_Object PTR [edi]).Faces_Pointer,eax	;; mettre eax dans x.Faces_Pointer
		mov DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Faces,ebx	;; mettre ebx dans x.Number_Of_Faces
		mov DWORD PTR (A_3D_Object PTR [edi]).Default_Colour,ecx	;; mettre ecx dans x.Default_Colour
		and ecx,0FF000000h								;; ne conserver que l'alpha
		mov eax,ecx									;; ) recopier l'alpha dans deux autres registres
		mov ebx,ecx									;; )
		shr eax,8										;; dcaler eax  droite de 8 bits
		shr ebx,16									;; dcaler ebx  droite de 16 bits
		shr ecx,24									;; dcaler ecx  droite de 24 bits
		or ecx,eax									;; ) fusionner ecx avec eax et ebx
		or ecx,ebx									;; )
		mov DWORD PTR (A_3D_Object PTR [edi]).Colour_Aplha,ecx	;; mettre ecx dans x.Colour_Aplha
		mov eax,DWORD PTR [edx+16]						;; mettre l'adresse de dpart des points dans eax
		mov ebx,DWORD PTR [edx+20]						;; mettre le nombre de points dans ebx
		mov ecx,DWORD PTR [edx+24]						;; mettre le nombre de points " traiter" dans ecx
		mov DWORD PTR (A_3D_Object PTR [edi]).Points_Pointer,eax	;; mettre eax dans x.Points_Pointer
		mov DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Points,ebx	;; mettre ebx dans x.Number_Of_Points
		mov DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Points_treated,ecx	;; mettre ebx dans x.Number_Of_Points_treated


;
; here, we allocate a memory block (aligned), needed to receive the calculated coords
;
		mov eax,4*DWORD								;; (X,Y,Z,_)*DWORD
		mul DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Points_treated	;; multiplier eax par Number_Of_Points_treated
		mov DWORD PTR (A_3D_Object PTR [edi]).Coords_Mem_Block.Block_Size,eax	;; mettre eax dans x.Block_Size
		add eax,000000010h								;; ajouter 16  la taille, ce qui servira pour aligner le bloc mmoire sur 16 octets
		invoke HeapAlloc,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE or HEAP_ZERO_MEMORY,eax	;; la taille en octets du bloc mmoire  crer
		mov DWORD PTR (A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer_To_Free,eax	;; sauvegarder eax dans x.Pointer_To_Free
		and eax,0FFFFFFF0h								;; ) ncessaire pour aligner le bloc mmoire sur 16 octets
		add eax,000000010h								;; )
		mov DWORD PTR (A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer,eax	;; sauvegarder eax dans x.Pointer


;
; here, we modify the positions of all the points, depending of the position of the object
;
		mov ebx,DWORD PTR (A_3D_Object PTR [edi]).Points_Pointer	;; mettre l'adresse de dpart des points dans ebx
		mov ecx,DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Points	;; mettre le nombre de points dans ecx
		movss XMM3,DWORD PTR (A_3D_Object PTR [edi]).Position_X	;; mettre la position X de l'objet dans XMM3
		movss XMM4,DWORD PTR (A_3D_Object PTR [edi]).Position_Y	;; mettre la position Y de l'objet dans XMM4
		movss XMM5,DWORD PTR (A_3D_Object PTR [edi]).Position_Z	;; mettre la position Z de l'objet dans XMM5
NumberOfPointsLoop:
		movss XMM0,DWORD PTR [ebx]						;; mettre le point dans XMM00
		movss XMM1,DWORD PTR [ebx+4]						;; mettre le point dans XMM00
		movss XMM2,DWORD PTR [ebx+8]						;; mettre le point dans XMM00
		addss XMM0,XMM3								;; ajouter la position de l'objet  notre point
		addss XMM1,XMM4								;; ajouter la position de l'objet  notre point
		addss XMM2,XMM5								;; ajouter la position de l'objet  notre point
		movss DWORD PTR [ebx],XMM0						;; sauvegarder le point
		movss DWORD PTR [ebx+4],XMM1						;; sauvegarder le point
		movss DWORD PTR [ebx+8],XMM2						;; sauvegarder le point
		add ebx,3*DWORD								;; augmenter ebx de 3*DWORD
		dec ecx										;; augmenter le compteur de boucle d'1 point
		jnz NumberOfPointsLoop							;; tant que c'est diffrent de 0, aller NumberOfPointsLoop


		mov esi,Temporary_3D_World_Pointer					;; on replace l'adresse de la structure A_3D_World dans esi, ce qui permet des liens entre la structure monde et les structures objets
;
; now, set the effective area of the object
;
		mov ebx,DWORD PTR (A_3D_Object PTR [edi]).Points_Pointer	;; mettre l'adresse de dpart des points dans ebx
		mov ecx,DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Points	;; mettre le nombre de points  traiter dans ecx
		neg ecx										;; inverser ecx (qui devient notre compteur de boucle)
		movss XMM0,DWORD PTR [ebx]						;; mettre la 1re coordonne X du point dans XMM0
		movss XMM1,DWORD PTR [ebx+4]						;; mettre la 1re coordonne Y du point dans XMM1
		movss XMM2,DWORD PTR [ebx+8]						;; mettre la 1re coordonne Z du point dans XMM2
		movss XMM3,XMM0								;; mettre une copie de XMM0 dans XMM3
		movss XMM4,XMM1								;; mettre une copie de XMM1 dans XMM4
		movss XMM5,XMM2								;; mettre une copie de XMM2 dans XMM5
; boucle pour obtenir les coordonnes minimales/maximales (pour dfinir la zone de l'objet)
Label01:	minss XMM0,DWORD PTR [ebx]						;; conserver le X minimal dans XMM0
		minss XMM1,DWORD PTR [ebx+4]						;; conserver le Y minimal dans XMM1
		minss XMM2,DWORD PTR [ebx+8]						;; conserver le Z minimal dans XMM2
		maxss XMM3,DWORD PTR [ebx]						;; conserver le X maximal dans XMM3
		maxss XMM4,DWORD PTR [ebx+4]						;; conserver le Y maximal dans XMM4
		maxss XMM5,DWORD PTR [ebx+8]						;; conserver le Z maximal dans XMM5
		add ebx,3*DWORD								;; ajouter 12 octets (3*DWORD) a notre compteur de boucle, pour passer au point suivant
		inc ecx										;; augmenter ecx d'1 point
		jnz Label01									;; tant que c'est diffrent de 0, aller Label01
; bon, ben reste plus qu'a sauvegarder...
		movss DWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X,XMM0	;; sauvegarder la position X minimale
		movss DWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_Y,XMM1	;; sauvegarder la position Y minimale
		movss DWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_Z,XMM2	;; sauvegarder la position Z minimale
		movss DWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X,XMM3	;; sauvegarder la position X maximale
		movss DWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_Y,XMM4	;; sauvegarder la position Y maximale
		movss DWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_Z,XMM5	;; sauvegarder la position Z maximale


;
; set the effective object sizes
;
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X	;; lire les positions minimales
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; lire les positions maximales
		subps XMM3,XMM0								;; soustraire les positions minimales aux positions maximales
;		andps XMM0,OWORD PTR Simd_Mask_Abs_Values			;; ne conserver que les valeurs absolues (ben on supprime les signes ngatifs quoi !!!)
		movaps OWORD PTR (A_3D_Object PTR [edi]).Size_X,XMM3	;; sauvegarder les nouvelles tailles de l'objet


;
; set the object center
;
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X	;; lire les positions minimales
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Size_X	;; lire les nouvelles tailles de l'objet
		mulps XMM3,OWORD PTR Simd_Values_0p5_0p5_0p5_0p5		;; diviser le rsultat (la taille) par 2
		addps XMM3,XMM0								;; et rajouter les positions minimales pour obtenir le center
;		andps XMM0,OWORD PTR Simd_Mask_3_x_x_x				;; pour s'assurer que la dernire valeur du quartet soit zro
		movaps OWORD PTR (A_3D_Object PTR [edi]).Center_X,XMM3	;; sauvegarder le center de l'objet


;
; set the max ray of the object
;

; rappel : plus courte distance entre deux point 3D = racine de [(x1-x2)^2 + (y1-y2)^2 + (z1-Z2)^2]

; on commence par calculer le rayon maximal
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; lire les positions maximales
		movaps XMM3,OWORD PTR (A_3D_Object PTR [edi]).Center_X	;; lire le center de l'objet
		subps XMM0,XMM3								;; XMM0 = _,Z1-Z2,Y1-Y2,X1-X2,_  (soustraire le center)
		mulps XMM0,XMM0								;; XMM0 = _,(Z1-Z2)^2,(Y1-Y2)^2,(X1-X2)^2 (mettre XMM0 au carr)
		movaps XMM1,XMM0								;; XMM1 = _,(Z1-Z2)^2,(Y1-Y2)^2,(X1-X2)^2
		movaps XMM2,XMM0								;; XMM2 = _,(Z1-Z2)^2,(Y1-Y2)^2,(X1-X2)^2
		shufps XMM0,XMM0,0C0h							;; XMM0 = _,(X1-X2)^2,(X1-X2)^2,(X1-X2)^2	) on repositionne les valeurs
		shufps XMM1,XMM1,0D5h							;; XMM1 = _,(Y1-Y2)^2,(Y1-Y2)^2,(Y1-Y2)^2	)
		shufps XMM2,XMM2,0EAh							;; XMM2 = _,(Z1-Z2)^2,(Z1-Z2)^2,(Z1-Z2)^2	)
		addps XMM0,XMM1								;; ajouter (Y1-Y2)^2  (X1-X2)^2
		addps XMM0,XMM2								;; ajouter (Z1-Z2)^2  (X1-X2)^2+(Y1-Y2)^2
		movaps XMM1,XMM0								;; copier (Z1-Z2)^2+(Y1-Y2)^2+(X1-X2)^2 dans XMM1
		rsqrtps XMM1,XMM1								;; mettre la rciprocit de la racine carre dans XMM1
		mulps XMM0,XMM1								;; multiplier (Z1-Z2)^2+(Y1-Y2)^2+(X1-X2)^2 par la rciprocit de la racine carre
		andps XMM0,OWORD PTR Simd_Mask_3_x_x_x				;; pour s'assurer que la dernire valeur du quartet soit zro (rsqrtps c'est pas top...)
		movaps OWORD PTR (A_3D_Object PTR [edi]).Maxi_Ray_Area_1,XMM0	;; sauvegarder racine de [(Z1-Z2)^2+(Y1-Y2)^2+(X1-X2)^2]


;
; set the object axis
;
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Center_X	;; mettre _,centerZ,centerY,centerX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; mettre _,maxZ,maxY,maxX dans XMM1
		movaps XMM2,XMM1								;; XMM2 = _,maxZ,maxY,maxX
		movlhps XMM2,XMM0								;; XMM2 = centerY,centerX,maxY,maxX
		movaps XMM3,XMM2								;; XMM3 = centerY,centerX,maxY,maxX
		movaps XMM4,XMM2								;; XMM4 = centerY,centerX,maxY,maxX
		shufps XMM2,XMM0,0ECh							;; XMM2 = _,centerZ,centerY,maxX
		shufps XMM3,XMM0,0E6h							;; XMM3 = _,centerZ,maxY,centerX
		shufps XMM4,XMM1,0EEh							;; XMM4 = _,maxZ,centerY,centerX
		movaps OWORD PTR (A_3D_Object PTR [edi]).X_Axis_1,XMM2	;; sauvegarder _,centerZ,centerY,maxX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Y_Axis_1,XMM3	;; sauvegarder _,centerZ,maxY,centerX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Z_Axis_1,XMM4	;; sauvegarder _,maxZ,centerY,centerX


;
; set object limits (we already have 2 points with the minimum and maximum values, we're going to set the 6 others)
;
		movaps XMM0,OWORD PTR (A_3D_Object PTR [edi]).Mini_Area_Limit_X	;; mettre _,minZ,minY,minX dans XMM0
		movaps XMM1,OWORD PTR (A_3D_Object PTR [edi]).Maxi_Area_Limit_X	;; mettre _,maxZ,maxY,maxX dans XMM1
		movaps XMM2,XMM1								;; XMM2 = _,maxZ,maxY,maxX
		movlhps XMM2,XMM0								;; XMM2 = minY,minX,maxY,maxX
		movaps XMM3,XMM2								;; XMM3 = minY,minX,maxY,maxX
		movaps XMM4,XMM2								;; XMM4 = minY,minX,maxY,maxX
		shufps XMM2,XMM0,0ECh							;; XMM2 = _,minZ,minY,maxX
		shufps XMM3,XMM0,0E6h							;; XMM3 = _,minZ,maxY,minX
		shufps XMM4,XMM1,0EEh							;; XMM4 = _,maxZ,minY,minX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_6_1,XMM2	;; sauvegarder _,minZ,minY,maxX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_2_1,XMM3	;; sauvegarder _,minZ,maxY,minX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_1_1,XMM4	;; sauvegarder _,maxZ,minY,minX
		movaps XMM2,XMM0								;; XMM2 = _,minZ,minY,minX
		movlhps XMM2,XMM1								;; XMM2 = maxY,maxX,minY,minX
		movaps XMM3,XMM2								;; XMM3 = maxY,maxX,minY,minX
		movaps XMM4,XMM2								;; XMM4 = maxY,maxX,minY,minX
		shufps XMM2,XMM1,0ECh							;; XMM2 = _,maxZ,maxY,minX
		shufps XMM3,XMM1,0E6h							;; XMM3 = _,maxZ,minY,maxX
		shufps XMM4,XMM0,0EEh							;; XMM4 = _,minZ,maxY,maxX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_3_1,XMM2	;; sauvegarder _,maxZ,maxY,minX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_5_1,XMM3	;; sauvegarder _,maxZ,minY,maxX
		movaps OWORD PTR (A_3D_Object PTR [edi]).Area_Limit_4_1,XMM4	;; sauvegarder _,minZ,maxY,maxX


;
; now, for the faces we're going to directly put the address instead of the point number (it will be faster)
;
		mov eax,4*DWORD								;; mettre 16 (4*DWORD) dans eax
		mul DWORD PTR (A_3D_Object PTR [edi]).Number_Of_Faces	;; multiplier 16 par le nombre de faces de l'objet
		mov ebx,eax									;; copier le rsultat obtenu dans ebx
		mov ecx,eax									;; et aussi dans ecx
		add ebx,DWORD PTR (A_3D_Object PTR [edi]).Faces_Pointer	;; ajouter l'adresse de dbut des faces  ebx
		neg ecx										;; inverser ecx (qui devient notre compteur de boucle)
LoopFacesTreatment:
; pour le premier sommet du triangle
		mov eax,4*DWORD								;; mettre 16 (4*DWORD) dans eax
		mov edx,[ebx+ecx]								;; mettre le numro du premier point dans edx
		mul edx										;; multiplier l6 par le numro
		add eax,(A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer	;; ajouter l'adresse de dbut des coordonnes 2D calcule
		mov [ebx+ecx],eax								;; et sauvegarder l'adresse  la place du numro du premier point
; pour le deuxime sommet du triangle
		mov eax,4*DWORD								;; mettre 16 (4*DWORD) dans eax
		mov edx,[ebx+ecx+4]								;; mettre le numro du deuxime point dans edx
		mul edx										;; multiplier l6 par le numro
		add eax,(A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer	;; ajouter l'adresse de dbut des coordonnes 2D calcule
		mov [ebx+ecx+4],eax								;; et sauvegarder l'adresse  la place du numro du deuxime point
; pour le troisime sommet du triangle
		mov eax,4*DWORD								;; mettre 16 (4*DWORD) dans eax
		mov edx,[ebx+ecx+8]								;; mettre le numro du troisime point dans edx
		mul edx										;; multiplier l6 par le numro
		add eax,(A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer	;; ajouter l'adresse de dbut des coordonnes 2D calcule
		mov [ebx+ecx+8],eax								;; et sauvegarder l'adresse  la place du numro du troisime point
; fin de la boucle
		add ecx,4*DWORD								;; on augmente ecx de 16 (4*DWORD)
		jnz LoopFacesTreatment							;; tant que ecx est diffrent de zro, aller LoopFacesTreatment
; et voil, notre objet 3D est totalement initialis

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Init3DObject_Sse ENDP


ALIGN 16
;
; update the 3d world (after a movments, a point of view rotation, etc...)
; note : this function is called just before to draw the 3d objects
;
; Syntax :
; mov esi,OFFSET of a A_3D_World structure
; call Update3DWorld_Sse
;
; Return :
; nothing
;
Update3DWorld_Sse PROC
		pushad										;; empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)


;
; on regarde s'il faut obtenir de nouveaux sinus/cosinus, et s'il faut recalculer la matrice de rotation globale...
;
		movaps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Angle_X	;; lire les nouveaux angles
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real,XMM0

;
; here, we're going to define the sine and cosine of the x,y,z axis, depending of the view angles of the point of view (to calculate
; the rotations around the x,y,z axis of our view of the "world"), and mettre them dans the variables : View_Sine_X_Axis, View_Sine_Y_Axis,
; View_Sine_Z_Axis, View_Cosine_X_Axis, View_Cosine_Y_Axis, View_Cosine_Z_Axis, (it will serve for "without matrix" manipulations)
;


; remember :
;; X axis rotation matrix
;	_Ligne_1_					DWORD ?,?,?,?				;; 1,0,0,0
;	_Ligne_2_					DWORD ?,?,?,?				;; 0,Cos(Angle_X),Sin(Angle_X),0
;	_Ligne_3_					DWORD ?,?,?,?				;; 0,-Sin(Angle_X),Cos(Angle_X),0
;	_Ligne_4_					DWORD ?,?,?,?				;; 0,0,0,1
;; Y axis rotation matrix
;	_Ligne_1_					DWORD ?,?,?,?				;; Cos(Angle_Y),0,-Sin(Angle_Y),0
;	_Ligne_2_					DWORD ?,?,?,?				;; 0,1,0,0
;	_Ligne_3_					DWORD ?,?,?,?				;; Sin(Angle_Y),0,Cos(Angle_Y),0
;	_Ligne_4_					DWORD ?,?,?,?				;; 0,0,0,1
;; Z axis rotation matrix
;	_Ligne_1_					DWORD ?,?,?,?				;; Cos(Angle_Z),Sin(Angle_Z),0,0
;	_Ligne_2_					DWORD ?,?,?,?				;; -Sin(Angle_Z),Cos(Angle_Z),0,0
;	_Ligne_3_					DWORD ?,?,?,?				;; 0,0,1,0
;	_Ligne_4_					DWORD ?,?,?,?				;; 0,0,0,1


; get sine and cosine of Y, (temporary code, should be replaced by AMATH later...)
		emms											;; vider les regsitres fpu
		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Real	;; ) obtenir le sinus d'angle Y
		invoke FpuSin,0,0,SRC1_FPU or ANG_DEG or DEST_FPU		;; )
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Sine_Y_Axis	;; )
		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Real		;;	) obtenir le cosinus d'angle y
		invoke FpuCos,0,0,SRC1_FPU or ANG_DEG or DEST_FPU			;;	)
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Cosine_Y_Axis	;;	)

; and copy it dans Y axis rotation matrix
		mov eax,DWORD PTR (A_3D_World PTR [esi]).View_Cosine_Y_Axis	;; mettre le cosinus de l'axe Y dans eax
		mov ebx,DWORD PTR (A_3D_World PTR [esi]).View_Sine_Y_Axis	;; mettre le sinus de l'axe Y dans ebx
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_00,eax	;; mettre le cosinus  l'offset 0
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_10,eax	;; mettre le cosinus  l'offset 40
; for normal direction :
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08,ebx	;; mettre le sinus  l'offset 32
		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_02,ebx	;; mettre l'inverse du sinus  l'offset 8
;; for reversed direction :
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_02,ebx	;; mettre le sinus  l'offset 8 (sens inverse)
;		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08,ebx	;; mettre l'inverse du sinus  l'offset 32 (sens inverse)


;						Cos(Angle_Y),0,-Sin(Angle_Y),0
; Y axis rotation matrix =	0,1,0,0
;						Sin(Angle_Y),0,Cos(Angle_Y),0
;						0,0,0,1
;
; Translation_Z = Translation_Z*Cos(Angle_Y)-Translation_X*Sin(Angle_Y)
; Translation_X = Translation_X*Cos(Angle_Y)+Translation_Z*Sin(Angle_Y)
		movaps XMM1,OWORD PTR (A_3D_World PTR [esi]).Value_180_1	;; XMM1 = 180,180,180,180
		subps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real	;; XMM1 = _,180-Angle_Z,_,180-Angle_X
		movhlps XMM0,XMM1								;; XMM0 = _,_,_,180-Angle_Z
		shufps XMM1,XMM1,044h							;; XMM1 = _,180-Angle_X,_,180-Angle_X
		shufps XMM0,XMM0,044h							;; XMM0 = _,180-Angle_Z,_,180-Angle_Z
		mulps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_00	;; XMM1 = _,180-Angle_X*(-Sin(Angle_Y)),_,180-Angle_X*Cos(Angle_Y)
		mulps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08	;; XMM0 = _,180-Angle_Z*Cos(Angle_Y),_,180-Angle_Z*Sin(Angle_Y)
		addps XMM0,XMM1								;; XMM0 = _,nouveau Angle_Z,_,nouveau Angle_X
		movhlps XMM1,XMM0								;; XMM1 = _,_,_,nouveau Angle_Z
; here, Angle_X is dans XMM0 and Angle_Z is dans XMM1


; Angle_X < 0 ?
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Mini	;; comparer le rsultat  0
		jnc EviterModificationAngle01						;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller EviterModificationAngle01
		addss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, ajouter 360   la valeur
EviterModificationAngle01:
; Angle_X >= 360 ?
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; comparer le rsultat  360
		jc EviterModificationAngle02						;; si c'est infrieur (c=lt et nc=ge pour comiss), aller EviterModificationAngle02
		subss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, enlever 360   la valeur
EviterModificationAngle02:
		movss DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real,XMM0	;; sauvegarder le rsultat dans Angle_Vue_Y
; Angle_Z < 0 ?
		comiss XMM1,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Mini	;; comparer le rsultat  0
		jnc EviterModificationAngle03						;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller EviterModificationAngle03
		addss XMM1,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, ajouter 360   la valeur
EviterModificationAngle03:
; Angle_Z >= 360 ?
		comiss XMM1,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; comparer le rsultat  360
		jc EviterModificationAngle04						;; si c'est infrieur (c=lt et nc=ge pour comiss), aller EviterModificationAngle04
		subss XMM1,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, enlever 360   la valeur
EviterModificationAngle04:
		movss DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Real,XMM1	;; sauvegarder le rsultat dans Angle_Vue_Y


; get sine and cosine for X and Z, (temporary code, should be replaced by AMATH later...)
		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real	;; ) obtenir le sinus d'angle x
		invoke FpuSin,0,0,SRC1_FPU or ANG_DEG or DEST_FPU		;; )
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Sine_X_Axis	;; )
		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real		;;	) obtenir le cosinus d'angle x
		invoke FpuCos,0,0,SRC1_FPU or ANG_DEG or DEST_FPU			;;	)
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Cosine_X_Axis	;;	)

		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Real	;; ) obtenir le sinus d'angle Z
		invoke FpuSin,0,0,SRC1_FPU or ANG_DEG or DEST_FPU		;; )
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Sine_Z_Axis	;; )
		fld DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Real		;;	) obtenir le cosinus d'angle z
		invoke FpuCos,0,0,SRC1_FPU or ANG_DEG or DEST_FPU			;;	)
		fstp DWORD PTR (A_3D_World PTR [esi]).View_Cosine_Z_Axis	;;	)

; and copy it dans X and Z axis rotation matrix
		mov eax,DWORD PTR (A_3D_World PTR [esi]).View_Cosine_X_Axis	;; mettre le cosinus de l'axe X dans eax
		mov ebx,DWORD PTR (A_3D_World PTR [esi]).View_Sine_X_Axis	;; mettre le sinus de l'axe X dans ebx
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_05,eax	;; mettre le cosinus  l'offset 20
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_10,eax	;; mettre le cosinus  l'offset 40
; for normal direction :
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_06,ebx	;; mettre l'inverse du sinus  l'offset 24
		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_09,ebx	;; mettre le sinus  l'offset 36
;; for reversed direction :
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_09,ebx	;; mettre l'inverse du sinus  l'offset 36 (sens inverse)
;		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_06,ebx	;; mettre le sinus  l'offset 24 (sens inverse)

		mov eax,DWORD PTR (A_3D_World PTR [esi]).View_Cosine_Z_Axis	;; mettre le cosinus de l'axe Z dans eax
		mov ebx,DWORD PTR (A_3D_World PTR [esi]).View_Sine_Z_Axis	;; mettre le sinus de l'axe Z dans ebx
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_00,eax	;; mettre le cosinus  l'offset 0
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_05,eax	;; mettre le cosinus  l'offset 20
; for normal direction :
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_01,ebx	;; mettre l'inverse du sinus  l'offset 4
		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_04,ebx	;; mettre le sinus  l'offset 16
;; for reversed direction :
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_04,ebx	;; mettre l'inverse du sinus  l'offset 16 (sens inverse)
;		btc ebx,31									;; inversion du sinus (c'est une valeur real4, donc on change seulement le signe)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_01,ebx	;; mettre le sinus  l'offset 4 (sens inverse)


;
; calc of the global rotation matrix (GRM = MX*MY*MZ), note for matrices the mul must be made in the reversed order
;

; on commence par multiplier la matrice de rotation Z avec celle de rotation X, alors on lit la matrice Z
		movaps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_00	;; XMM0 = _,Zz1,Zy1,Zx1
		movaps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_04	;; XMM1 = _,Zz2,Zy2,Zx2
		movaps XMM2,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Z_Axis_08	;; XMM2 = _,Zz3,Zy3,Zx3
; puis, on lit la matrice x
		movaps XMM5,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_00	;; XMM6 = _,Xz1,Xy1,Xx1
		movaps XMM6,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_04	;; XMM7 = _,Xz2,Xy2,Xx2
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.X_Axis_08	;; XMM5 = _,Xz3,Xy3,Xx3
; c'est parti, on initialise nos valeurs de dpart...
		movaps XMM3,XMM0								;; ) copier la premire ligne de la matrice multiplicatrice dans des registres libres
		movaps XMM4,XMM0								;; )
		shufps XMM0,XMM0,0C0h							;; XMM0 = A1, A1, A1, A4
		shufps XMM3,XMM3,0D5h							;; XMM3 = A2, A2, A2, A4
		shufps XMM4,XMM4,0EAh							;; XMM4 = A3, A3, A3, A4
; on effectue nos calculs...
		mulps XMM0,XMM5								;; XMM0 = A1*X1, A1*X2, A1*X3, A4*X4 ) que l'on multiplie la matrice X
		mulps XMM3,XMM6								;; XMM3 = A2*Y1, A2*Y2, A2*Y3, A4*Y4 )
		mulps XMM4,XMM7								;; XMM4 = A3*Z1, A3*Z2, A3*Z3, A4*Z4 )
		addps XMM0,XMM3								;;	) et on additionne le tout
		addps XMM0,XMM4								;;	)
; here, XMM0 contain the first line of our matrix...
		movaps XMM3,XMM1								;; ) copier la deuxime ligne de la matrice 1 dans des registres libres
		movaps XMM4,XMM1								;; )
		shufps XMM1,XMM1,0C0h							;; XMM1 = B1, B1, B1, B4
		shufps XMM3,XMM3,0D5h							;; XMM3 = B2, B2, B2, B4
		shufps XMM4,XMM4,0EAh							;; XMM4 = B3, B3, B3, B4
; on effectue nos calculs...
		mulps XMM1,XMM5								;; XMM1 = B1*X1, B1*X2, B1*X3, B4*X4 ) que l'on multiplie la matrice X
		mulps XMM3,XMM6								;; XMM3 = B2*Y1, B2*Y2, B2*Y3, B4*Y4 )
		mulps XMM4,XMM7								;; XMM4 = B3*Z1, B3*Z2, B3*Z3, B4*Z4 )
		addps XMM1,XMM3								;;	) et on additionne le tout
		addps XMM1,XMM4								;;	)
; here, XMM1 contain the second line of our matrix...
		movaps XMM3,XMM2								;; ) copier la troisime ligne de la matrice 1 dans des registres libres
		movaps XMM4,XMM2								;; )
		shufps XMM2,XMM2,0C0h							;; XMM2 = C1, C1, C1, C4
		shufps XMM3,XMM3,0D5h							;; XMM3 = C2, C2, C2, C4
		shufps XMM4,XMM4,0EAh							;; XMM4 = C3, C3, C3, C4
; on effectue nos calculs...
		mulps XMM2,XMM5								;; XMM2 = C1*X1, C1*X2, C1*X3, C4*X4 ) que l'on multiplie la matrice X
		mulps XMM3,XMM6								;; XMM3 = C2*Y1, C2*Y2, C2*Y3, C4*Y4 )
		mulps XMM4,XMM7								;; XMM4 = C3*Z1, C3*Z2, C3*Z3, C4*Z4 )
		addps XMM2,XMM3								;;	) et on additionne le tout
		addps XMM2,XMM4								;;	)
; here, XMM2 contain the third line of our matrix... (finally our matrix is in XMM0, XMM1, XMM2)

; puis, on lit la matrice Y (qui servira aprs...)
		movaps XMM6,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_00	;; XMM6 = _,Yz1,Yy1,Yx1
		movaps XMM7,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_04	;; XMM7 = _,Yz2,Yy2,Yx2
		movaps XMM5,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08	;; XMM5 = _,Yz3,Yy3,Yx3
; on poursuis en multipliant la matrice de rotation Z*X avec celle de rotation Y
		movaps XMM3,XMM6								;; ) copier la premire ligne de la matrice multiplicatrice dans des registres libres
		movaps XMM4,XMM6								;; )
		shufps XMM6,XMM6,0C0h							;; XMM6 = A1, A1, A1, A4
		shufps XMM3,XMM3,0D5h							;; XMM3 = A2, A2, A2, A4
		shufps XMM4,XMM4,0EAh							;; XMM4 = A3, A3, A3, A4
; on effectue nos calculs...
		mulps XMM6,XMM0								;; ) on multiplie chaque ligne par la matrice prcdemment obtenue
		mulps XMM3,XMM1								;; )
		mulps XMM4,XMM2								;; )
		addps XMM6,XMM3								;;	) et on additionne le tout
		addps XMM6,XMM4								;;	)
; here, XMM6 contain the first line of our matrix...
		movaps XMM3,XMM7								;; ) copier la deuxime ligne de la matrice 1 dans des registres libres
		movaps XMM4,XMM7								;; )
		shufps XMM7,XMM7,0C0h							;; XMM7 = B1, B1, B1, B4
		shufps XMM3,XMM3,0D5h							;; XMM3 = B2, B2, B2, B4
		shufps XMM4,XMM4,0EAh							;; XMM4 = B3, B3, B3, B4
; on effectue nos calculs...
		mulps XMM7,XMM0								;; ) on multiplie chaque ligne par la matrice prcdemment obtenue
		mulps XMM3,XMM1								;; )
		mulps XMM4,XMM2								;; )
		addps XMM7,XMM3								;;	) et on additionne le tout
		addps XMM7,XMM4								;;	)
; here, XMM7 contain the second line of our matrix...
		movaps XMM3,XMM5								;; ) copier la troisime ligne de la matrice 1 dans des registres libres
		movaps XMM4,XMM5								;; )
		shufps XMM5,XMM5,0C0h							;; XMM5 = C1, C1, C1, C4
		shufps XMM3,XMM3,0D5h							;; XMM3 = C2, C2, C2, C4
		shufps XMM4,XMM4,0EAh							;; XMM4 = C3, C3, C3, C4
; on effectue nos calculs...
		mulps XMM5,XMM0								;; ) on multiplie chaque ligne par la matrice prcdemment obtenue
		mulps XMM3,XMM1								;; )
		mulps XMM4,XMM2								;; )
		addps XMM4,XMM5								;;	) et on additionne le tout
		addps XMM4,XMM3								;;	)
; here, XMM4 contain the third line of our matrix... (finally our matrix is in XMM6, XMM7, XMM4)


;
; here, we're going to transpose the global rotation matrix (in XMM6, XMM7 et XMM4) to increase speed calc later...
;
TransposeMatrix:
; we start our qword movments... (remember the 4th value is alway 0)
		movaps XMM5,XMM6								;; XMM5 = _,Gz1,Gy1,Gx1
		movlhps XMM5,XMM7								;; XMM5 = Gy2,Gx2,Gy1,Gx1 (Gy2,Gx2 viennent de XMM7)
		movhlps XMM7,XMM6								;; XMM7 = _,Gz2,_,Gz1 (_,Gz1 viennent de XMM6)
		movaps XMM6,XMM5								;; XMM6 = Gy2,Gx2,Gy1,Gx1
; and we mix it...
		shufps XMM5,XMM4,0C8h							;; XMM5 = _,Gx3,Gx2,Gx1 (_,Gx3 from XMM4)
		shufps XMM6,XMM4,0DDh							;; XMM6 = _,Gy3,Gy2,Gy1 (_,GY3 from XMM4)
		shufps XMM7,XMM4,0E8h							;; XMM7 = _,Gz3,Gz2,Gz1 (_,Gz3 from XMM4)
; (finally our transposed matrix is dans XMM5, XMM6 et XMM7)

;
; apply our coords system, and the zoom factor on the obtained matrix
;
		movaps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Screen_Width	;; mettre _,depth,(height vue*depth*2),(width vue*depth*2)
		mulps XMM4,OWORD PTR (A_3D_World PTR [esi]).View_Zoom_X	;; application du zoom
		mulps XMM5,XMM4								;; ) multiplier la matrice transpose par le multiplicateur obtenu
		mulps XMM6,XMM4								;; )
		mulps XMM7,XMM4								;; )
; it's done... we save it (coz it's THE thing that will serve...)
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_00,XMM5	;; XMM5 = _,Gx3,Gx2,Gx1
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_04,XMM6	;; XMM6 = _,Gy3,Gy2,Gy1
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Matrix.XYZ_Axis_08,XMM7	;; XMM7 = _,Gz3,Gz2,Gz1


;
; now, we're going to calc the movment of our point of view (it's why we had to calc the rotations before...)
;

; set the direction (rotation of the movment value, around the Y axis of the point of view) of the movment (translation), and apply
; 
; note : the following algo advantageously replace an Y rotation matrix, and if we invert signs of the calc (or sine in matrices)
; we invert the movment (so equally the rotation direction)
;
;							Cos(Angle_Y),0,-Sin(Angle_Y),0
; y axis rotation matrix =		0,1,0,0
;							Sin(Angle_Y),0,Cos(Angle_Y),0
;							0,0,0,1
;
; Translation_Z = Translation_Z*Cos(Angle_Y)-Translation_X*Sin(Angle_Y)
; Translation_X = Translation_X*Cos(Angle_Y)+Translation_Z*Sin(Angle_Y)
CalcMovment:
; we calc the movment depending of the rotation around the Y axis
		movaps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Movment_X	;; XMM1 = _,Translation_Z (dplacement frontale),_,Translation_X (dplacement latrale)
		movhlps XMM0,XMM1								;; XMM0 = _,_,_,Translation_Z
		shufps XMM1,XMM1,044h							;; XMM1 = _,Translation_X,_,Translation_X
		shufps XMM0,XMM0,044h							;; XMM0 = _,Translation_Z,_,Translation_Z
		mulps XMM1,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_00	;; XMM1 = _,Translation_X*(-Sin(Angle_Y)),_,Translation_X*Cos(Angle_Y)
		mulps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Matrix.Y_Axis_08	;; XMM0 = _,Translation_Z*Cos(Angle_Y),_,Translation_Z*Sin(Angle_Y)
		addps XMM0,XMM1								;; XMM0 = _,Translation_Z,_Translation_X
; we add our current position to the movment, and sauvegarder it...
		addps XMM0,OWORD PTR (A_3D_World PTR [esi]).View_Position_X	;; ajouter position camra _,z,y,x  la translation _,z,y,x
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Position_X,XMM0	;; sauvegarder pour pouvoir rutiliser ces infos au prochain dplacement
; here, we're going to create 4 time the obtained data dans 3 owords (it will serve to treat the coords by 4 dans parallel by 3 operation)
		movaps XMM1,XMM0								;; ) copier XMM0 (la position de la camra) dans XMM1 et XMM2
		movaps XMM2,XMM0								;; )
		shufps XMM0,XMM0,24h							;; mettre X,Z,Y,X dans XMM0
		shufps XMM1,XMM1,49h							;; mettre Y,X,Z,Y dans XMM1
		shufps XMM2,XMM2,92h							;; mettre Z,Y,X,Z dans XMM2
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_01,XMM0	;; ) sauvegarder notre position camra particulire
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_05,XMM1	;; )
		movaps OWORD PTR (A_3D_World PTR [esi]).View_Position_Plus_09,XMM2	;; )
; arriv ici, les variables utiles du monde ont entirement t mises  jour

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
	ret												;; retourner (sortir de la procdure)
Update3DWorld_Sse ENDP


ALIGN 16
;
; free a 3d object (in fact we free the memory block allocated to the object)
;
; Syntax :
; mov esi,OFFSET of the Mem_Info structure
; mov edi,OFFSET of a A_3D_Object structure
; call Free3DObject
;
; Return :
; nothing
;
Free3DObject PROC
		push eax										;; empiler eax
		push ecx										;; empiler ecx
		push edx										;; empiler edx

		invoke HeapFree,(Mem_Info PTR [esi]).Instance,HEAP_NO_SERIALIZE,(A_3D_Object PTR [edi]).Coords_Mem_Block.Pointer_To_Free		;; librer le bloc mmoire correspondant  l'objet

		pop edx										;; dsempiler edx
		pop ecx										;; dsempiler ecx
		pop eax										;; dsempiler eax
	ret												;; retourner (sortir de la procdure)
Free3DObject ENDP




.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * specific procs created for the program
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *


ALIGN 16
;
; proc to constantly evaluate elapsed time (just used to obtain the fps)
;
ReadTimer PROC HWndc:DWORD,uMsg2:DWORD,Elapsed_Time:DWORD,dwtime:DWORD

		cmp Elapsed_Time,1								;; comparer evnement priodique  1
		jne Label01									;; si c'est diffrent, aller Label01
		pushad										;; sinon, empiler tous les registres (ordre : eax,ecx,edx,ebx,esp,ebp,esi,edi)

; pour le nombre d'images :
		mov eax,Fps_Counter								;; mettre le Fps_Counter (nombre d'images obtenues) dans eax
		mov esi,OFFSET sz_FPS_Value						;; mettre l'adresse qui doit contenir la chane du nombre dans esi
		call DwordToDecAsciiString						;; et convertir la valeur en chane dcimale
		mov Fps_Counter,0								;; effacer Fps_Counter

		popad										;; dsempiler tous les registres (ordre : edi,esi,ebp,esp,ebx,edx,ecx,eax)
Label01:
	ret												;; retourner (sortir de la procdure)
ReadTimer ENDP


ALIGN 16
;
; display debug infos
;
DebugInfo PROC

; ici on dfini la couleur par dfaut des textes  afficher dans l'cran
		mov eax,Colour_Red								;; ) dfinir les couleurs police + fond
		mov ebx,07F1F1F1Fh								;; ) (ligne inutile si DisplayGfxStringWithoutBackground)
		call SetGfxStringColours							;; )

; convertir le numro de l'objet
		mov eax,Selected_Object_Flags						;; mettre le Fps_Counter (nombre d'images obtenues) dans eax
		mov esi,OFFSET sz_Object_Number					;; mettre l'adresse qui doit contenir la chane du nombre dans esi
		call DwordToDecAsciiString						;; et convertir la valeur en chane dcimale

; afficher objet dessin ou pas
		mov eax,SIZEOF A_3D_Object						;; mettre la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		mul DWORD PTR Selected_Object_Flags				;; multiplier la taille de la structure par le tmoin contenant le numro de l'objet (de 0  x)
		mov ecx,eax									;; mettre le rsultat obtenu dans ecx
		add ecx,OFFSET Object_3D_0001						;; ajouter l'adresse de la structure _Objet3D_ de dpart  ecx
		xor eax,eax									;; position X (en pixels)
		xor ebx,ebx									;; position Y (en pixels)
		mov edx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov ebx,DWORD PTR [edx]							;; mettre la taille de la police pour la position y (pour passer  la 2me ligne)
		bt DWORD PTR (A_3D_Object PTR [ecx]).Object_Flags,31	;; tester le bit de signe du statut
		jc ObjectAppear								;; si le flag carry est positionn (l'objet va apparaitre, du moins partiellement), aller ObjectAppear
		mov esi,OFFSET sz_Object_Out						;; adresse de la chaine  afficher
		jmp ObjectAppearEnd								;; aller ObjectAppearEnd
ObjectAppear:
		mov esi,OFFSET sz_Object_On_Screen					;; adresse de la chaine  afficher
ObjectAppearEnd:
		mov edi,OFFSET Work_Screen						;; mettre l'adresse du Work_Screen dans edi
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; afficher le numro de l'objet
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
;		mov ebx,DWORD PTR [edx]							;; mettre la taille de la police pour la position y (pour passer  la 2me ligne)
;		mov edx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov esi,OFFSET sz_Object_Number_ID					;; adresse de la chaine  afficher
;		mov edi,OFFSET Work_Screen						;; mettre l'adresse du Work_Screen dans edi
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; ici on dfini la couleur par dfaut des textes  afficher dans l'cran
		push ebx										;; empiler ebx
		mov eax,Colour_Blue								;; ) dfinir les couleurs police + fond
		mov ebx,07F1F1F1Fh								;; ) noir  moiti transparent (ligne inutile si DisplayGfxStringWithoutBackground)
		call SetGfxStringColours							;; )
		pop ebx										;; dsempiler ebx

;
; on converti des valeurs
;
		mov ecx,OFFSET World_3D_0001						;; mettre l'adresse du tampon 3D dans ecx
; convertir position X
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Position_X
		mov esi,OFFSET sz_View_Position_X
		call Real4ToSignedDecAsciiString_Sse
; convertir position Y
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Position_Y
		mov esi,OFFSET sz_View_Position_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir position Z
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Position_Z
		mov esi,OFFSET sz_View_Position_Z
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle X
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_X
		mov esi,OFFSET sz_View_Angle_X
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle Y
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_Y
		mov esi,OFFSET sz_View_Angle_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle Z
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_Z
		mov esi,OFFSET sz_View_Angle_Z
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle X reel
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_X_Real
		mov esi,OFFSET sz_View_Real_Angle_X
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle Y reel
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_Y_Real
		mov esi,OFFSET sz_View_Real_Angle_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle Z reel
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Angle_Z_Real
		mov esi,OFFSET sz_View_Real_Angle_Z
		call Real4ToSignedDecAsciiString_Sse

		mov eax,SIZEOF A_3D_Object						;; mettre la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		mul DWORD PTR Selected_Object_Flags				;; multiplier la taille de la structure par le tmoin contenant le numro de l'objet (de 0  x)
		mov ecx,eax									;; mettre le rsultat obtenu dans ecx
		add ecx,OFFSET Object_3D_0001						;; ajouter l'adresse de la structure _Objet3D_ de dpart  ecx
; convertir la position objet X
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Position_X
		mov esi,OFFSET sz_Objetc_Position_X
		call Real4ToSignedDecAsciiString_Sse
; convertir la position objet Y
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Position_Y
		mov esi,OFFSET sz_Objetc_Position_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir la position objet Z
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Position_Z
		mov esi,OFFSET sz_Objetc_Position_Z
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle objet X
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Angle_X
		mov esi,OFFSET sz_Objetc_Angle_X
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle objet Y
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Angle_Y
		mov esi,OFFSET sz_Objetc_Angle_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir l'angle objet Z
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Angle_Z
		mov esi,OFFSET sz_Objetc_Angle_Z
		call Real4ToSignedDecAsciiString_Sse
; convertir la taille objet X
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Size_X
		mov esi,OFFSET sz_Objetc_Size_X
		call Real4ToSignedDecAsciiString_Sse
; convertir la taille objet Y
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Size_Y
		mov esi,OFFSET sz_Objetc_Size_Y
		call Real4ToSignedDecAsciiString_Sse
; convertir la taille objet Z
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Size_Z
		mov esi,OFFSET sz_Objetc_Size_Z
		call Real4ToSignedDecAsciiString_Sse


;
; et on affiche les infos
;
		mov ecx,OFFSET World_3D_0001						;; mettre l'adresse de la structure du monde dans ecx
		mov edx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov edi,OFFSET Work_Screen						;; mettre l'adresse du Work_Screen dans edi

; Ligne 2 :
; afficher la position monde X
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Position_X_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la position objet X
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Position_X_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 3 :
; afficher la position monde Y
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Position_Y_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la position objet Y
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Position_Y_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 4 :
; afficher la position monde Z
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Position_Z_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la position objet Z
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Position_Z_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 5 :
; afficher l'angle monde X
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Angle_X_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher l'angle objet X
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Angle_X_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 6 :
; afficher l'angle monde Y
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Angle_Y_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher l'angle objet Y
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Angle_Y_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 7 :
; afficher l'angle monde Z
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Angle_Z_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher l'angle objet Z
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Angle_Z_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 8 :
; afficher l'angle monde X reel
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Real_Angle_X_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la taille objet X
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Size_X_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 9 :
; afficher l'angle monde Y reel
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Real_Angle_Y_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la taille objet Y
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Size_Y_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

; Ligne 10 :
; afficher l'angle monde Z reel
		xor eax,eax									;; position X (en pixels)
		add ebx,DWORD PTR [edx]							;; ajouter la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_View_Real_Angle_Z_ID				;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; afficher la taille objet Z
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Objetc_Size_Z_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie


;
; ici on recommence l'opration pour les variables diverses
;

		mov ecx,OFFSET World_3D_0001
; la variable 1
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).Half_Screen_Width
		mov esi,OFFSET sz_Variable_01
		call Real4ToSignedDecAsciiString_Sse
; la variable 2
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).Half_Screen_Height
		mov esi,OFFSET sz_Variable_02
		call Real4ToSignedDecAsciiString_Sse
; la variable 3
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).Screen_Width_m1
		mov esi,OFFSET sz_Variable_03
		call Real4ToSignedDecAsciiString_Sse
; la variable 4
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).Screen_Height_m1
		mov esi,OFFSET sz_Variable_04
		call Real4ToSignedDecAsciiString_Sse
; la variable 5
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Screen_Width
		mov esi,OFFSET sz_Variable_05
		call Real4ToSignedDecAsciiString_Sse
; la variable 6
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Screen_Height
		mov esi,OFFSET sz_Variable_06
		call Real4ToSignedDecAsciiString_Sse
; la variable 7
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).View_Screen_Depth
		mov esi,OFFSET sz_Variable_07
		call Real4ToSignedDecAsciiString_Sse
; la variable 8
		mov eax,DWORD PTR (A_3D_World PTR [ecx]).Visual_Limit_Z_Maxi
		mov esi,OFFSET sz_Variable_08
		call Real4ToSignedDecAsciiString_Sse

		mov eax,SIZEOF A_3D_Object						;; mettre la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		mul DWORD PTR Selected_Object_Flags				;; multiplier la taille de la structure par le tmoin contenant le numro de l'objet (de 0  x)
		mov ecx,eax									;; mettre le rsultat obtenu dans ecx
		add ecx,OFFSET Object_3D_0001						;; ajouter l'adresse de la structure _Objet3D_ de dpart  ecx
; la variable 9
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Center_X
		mov esi,OFFSET sz_Variable_09
		call Real4ToSignedDecAsciiString_Sse
; la variable 10
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Center_Y

		mov esi,OFFSET sz_Variable_10
		call Real4ToSignedDecAsciiString_Sse
; la variable 11
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Center_Z
		mov esi,OFFSET sz_Variable_11
		call Real4ToSignedDecAsciiString_Sse
; la variable 12
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Center
		mov esi,OFFSET sz_Variable_12
		call Real4ToSignedDecAsciiString_Sse
; la variable 13
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Maxi_Ray_Area_1
		mov esi,OFFSET sz_Variable_13
		call Real4ToSignedDecAsciiString_Sse
; la variable 14
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Maxi_Ray_Area_2
		mov esi,OFFSET sz_Variable_14
		call Real4ToSignedDecAsciiString_Sse
; la variable 15
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Maxi_Ray_Area_3
		mov esi,OFFSET sz_Variable_15
		call Real4ToSignedDecAsciiString_Sse
; la variable 16
		mov eax,DWORD PTR (A_3D_Object PTR [ecx]).Maxi_Ray_Area_4
		mov esi,OFFSET sz_Variable_16
		call Real4ToSignedDecAsciiString_Sse

;
; et on affiche ces variables
;
		mov edx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov edi,OFFSET Work_Screen						;; mettre l'adresse du Work_Screen dans edi
		mov ebx,Work_Screen_Height						;; mettre la height de l'cran dans ebx

;
; la variable 8
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_08_ID					;; adresse de la chaine  afficher

		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 16
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_16_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 7
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_07_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 15
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_15_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 6
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_06_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 14
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_14_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 5
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_05_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 13
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_13_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 4
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_04_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 12
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_12_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 3
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_03_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 11
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_11_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 2
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_02_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 10
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_10_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

;
; la variable 1
		xor eax,eax									;; position X (en pixels)
		sub ebx,DWORD PTR [edx]							;; enlever la taille de la police  la position y (pour passer  la ligne suivante)
		mov esi,OFFSET sz_Variable_01_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie
; la variable 9
		mov eax,Work_Screen_Half_Width					;; position X (en pixels)
		mov esi,OFFSET sz_Variable_09_ID					;; adresse de la chaine  afficher
		call DisplayGfxStringWithAlphaBackground_Mmx			;; afficher cette chane  la position spcifie

	ret												;; retourner (sortir de la procdure)
DebugInfo ENDP


ALIGN 16
;
; dialog box message treatment
;
DlgBoxWinMessage PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM

		mov eax,Message								;; mettre Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
; on teste le message obtenu

		cmp eax,WM_COMMAND								;; un contrleur est cliqu ?
		jne DBWM_NoCommands								;; si c'est diffrent, aller DBWM_NoCommands
; sinon, on traite les commandes possibles
		mov eax,WParam									;; mettre WParam en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
; on cherche le bouton cliqu
		cmp eax,Rsrc_IDC_Change							;; Il est temps d'en changer est cliqu ?
		je DBWM_TimeToChange							;; si c'est le cas, aller DBWM_TimeToChange
		cmp eax,Rsrc_IDC_Hmm_Yes							;; Hum... oui est cliqu ?
		je DBWM_HmmYes									;; si c'est le cas, aller DBWM_HmmYes
		cmp eax,Rsrc_IDC_Oh_No							;; Ah a non ! est cliqu ?
		je DBWM_OhNo									;; si c'est le cas, aller DBWM_OhNo
; ici, il n'y a aucun message, donc, traitement par dfaut pour les boites de dialogue
DBWM_NoCommands:
		xor eax,eax									;; effacer eax (ce sera le traitement par dfaut des messages)
	ret												;; retourner

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                       ;;
;; dialog box for insufficient processor ;;
;;                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;
; It's time to change...
;
DBWM_TimeToChange:
		invoke EndDialog,HWndDlg,0						;; fermer la boite de dialogue
		invoke PostQuitMessage,NULL						;; et poster le message de sortie
	ret												;; retourner

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                            ;;
;; dialog box to quit program ;;
;;                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;
; hmm... yes
;
DBWM_HmmYes:
		mov Continue_Main_Process_Flags,1					;; stoper le processus en cours
		btr Dlg_Box_Flags,0								;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndDlg,0						;; et fermer la boite de dialogue
	ret												;; retourner
;
; Oh no !
;
DBWM_OhNo:
		btr Dlg_Box_Flags,0								;; enlever le tmoin de la boite de dialogue pour quitter (bit 0)
		invoke EndDialog,HWndDlg,0						;; et fermer simplement la boite de dialogue
	ret												;; retourner

DlgBoxWinMessage ENDP


ALIGN 16
;
; ici, on inclus l'indispensable procdure de gestion des messages entre l'application et windows...
; elle traite les messages spcifiques, les autres sont retransmis au gestionnaire par defaut de windows.
; chaque message peut avoir une valeur additionnelle associe (situe dans les paramtres WParam et LParam).
; le rang de donnes additionnelle qui peuvent tre obtenues par l'application est dtermin par la nature du message.
;
; Rceptionne :
; nothing (hormis les messages du systme d'exploitation, mais ca se fait automatiquement)
;
; Retourne:
; nothing (mais attention eax est modifi)
;
MainWinMessages PROC HWndGM:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD
;LOCAL DessinEcran :PAINTSTRUCT

; ici c'est le message concernant la poursuite du processus en cours
		cmp Continue_Main_Process_Flags,0					;; le processus est arrt ?
		je MWM_FinApplication							;; si c'est le cas, aller MWM_FinApplication

; ici, on traite les messaes de windows
		mov eax,Message								;; mettre Message en eax (c'est plus rapide si le nombre de tests  effectuer est consquent)
; on cherche le message obtenu
;		cmp eax,WM_CREATE								;; cration de l'affichage ?
;		je MWM_Initialisation							;; si c'est le cas, aller MWM_Initialisation
;		cmp eax,WM_PAINT								;; mise  jour de l'affichage ?
;		je MWM_MiseAJourEcran							;; si c'est le cas, aller MWM_MiseAJourEcran
;		cmp eax,WM_CLOSE								;; message de fermeture reu ?
;		je MWM_Fermeture								;; si c'est le cas, aller MWM_Fermeture
		cmp eax,WM_DESTROY								;; fermeture de l'application par la croix ?
		je MWM_ProcessusTermine							;; si c'est le cas, aller MWM_ProcessusTermine

;
; ici, les messages concernant la souris :
; WM_LBUTTONDOWN, WM_LBUTTONUP, WM_LBUTTONDBLCLK,
; WM_MBUTTONDOWN, WM_MBUTTONUP, WM_MBUTTONDBLCLK,
; WM_RBUTTONDOWN, WM_RBUTTONUP, WM_RBUTTONDBLCLK, WM_MOUSEMOVE
; retournent le rsultat obtenu par les boutons et le mouvement de la souris.
;

; statut du bouton gauche de la souris
		cmp eax,WM_LBUTTONDOWN							;; bouton gauche de la souris press ?
		je MWM_LeftMouseButtonDown						;; si c'est le cas, aller MWM_LeftMouseButtonDown
		cmp eax,WM_LBUTTONUP							;; bouton gauche de la souris relach ?
		je MWM_LeftMouseButtonUp							;; si c'est le cas, aller MWM_LeftMouseButtonUp
;		cmp eax,WM_LBUTTONDBLCLK							;; bouton gauche de la souris double clique ?
;		jne MWM_PasLeftMouseButtonDouble					;; si c'est diffrent, aller MWM_PasLeftMouseButtonDouble
;		or Mouse_Button_Flags,0000100100100100b				;; sinon, on positionne les bits correspondants
;;	ret												;; retourner
;MWM_PasLeftMouseButtonDouble:

; statut du bouton du milieu de la souris
		cmp eax,WM_MBUTTONDOWN							;; bouton milieu de la souris press ?
		je MWM_MiddleMouseButtonDown						;; si c'est le cas, aller MWM_MiddleMouseButtonDown
		cmp eax,WM_MBUTTONUP							;; bouton milieu de la souris relach ?
		je MWM_MiddleMouseButtonUp						;; si c'est le cas, aller MWM_MiddleMouseButtonUp
;		cmp eax,WM_MBUTTONDBLCLK							;; bouton milieu de la souris double clique ?
;		jne MWM_PasMiddleMouseButtonDouble					;; si c'est diffrent, aller MWM_PasMiddleMouseButtonDouble
;		or Mouse_Button_Flags,0000010010010010b				;; sinon, on positionne les bits correspondants
;;	ret												;; retourner
;MWM_PasMiddleMouseButtonDouble:

; statut du bouton gauche de la souris
		cmp eax,WM_RBUTTONDOWN							;; bouton droit de la souris press ?
		je MWM_RightMouseButtonDown						;; si c'est le cas, aller MWM_RightMouseButtonDown
		cmp eax,WM_RBUTTONUP							;; bouton droit de la souris relach ?
		je MWM_RightMouseButtonUp						;; si c'est le cas, aller MWM_RightMouseButtonUp
;		cmp eax,WM_RBUTTONDBLCLK							;; bouton droit de la souris double clique ?
;		jne MWM_PasRightMouseButtonDouble					;; si c'est diffrent, aller MWM_PasRightMouseButtonDouble
;		or Mouse_Button_Flags,0000001001001001b				;; sinon, on positionne les bits correspondants
;;	ret												;; retourner
;MWM_PasRightMouseButtonDouble:

; mouvement de la souris ?
		cmp eax,WM_MOUSEMOVE							;; un mouvement de la souris ?
		jne MWM_PasMouvementsSouris						;; si c'est diffrent, aller MWM_PasMouvementsSouris
; ici, on traite la rotation par rapport  l'axe Y (mouvement souris X)
		mov ebx,Rotation_Direction_Flags					;; lire les tmoins concernant les sens de rotation
		mov eax,LParam									;; sinon on place LParam (Y (word), X (word)) dans eax
		and eax,00000FFFFh								;; filtrer eax (pour avoir uniquement le X)
		sub eax,Final_Screen_Half_Width					;; soustraire la moitie de la width de notre cran  eax
;		sar eax,1										;; (optionnel) diviser le mouvement de la souris par 2 sign
		jnz MWM_MouvementSourisX							;; si c'est diffrent de 0, aller MWM_MouvementSourisX
		and ebx,1111111111110011b						;; effacer tmoins Angle_Y (bits 3 et 2)
		jmp MWM_FinMouvementSourisX						;; aller MWM_FinMouvementSourisX
MWM_MouvementSourisX:
		bt eax,31										;; tester si eax est sign
		jc MWM_MouvementXNegatif							;; si eax est ngatif, aller MWM_MouvementXNegatif
MWM_MouvementXPositif:
		or ebx,0000000100000100b							;; positionner Angle_Y positif (bits 8 et 2)
		and ebx,1111110111110111b						;; effacer Angle_Y ngatif (bits 9 et 3)
		jmp MWM_FinMouvementSourisX						;; aller MWM_FinMouvementSourisX (pour viter les 2 lignes suivantes)
MWM_MouvementXNegatif:
		or ebx,0000001000001000b							;; positionner Angle_Y ngatif (bits 9 et 3)
		and ebx,1111111011111011b						;; effacer Angle_Y positif (bits 8 et 2)
MWM_FinMouvementSourisX:
		mov Mouse_Movment_X,eax							;; sauvegarder le rsultat dans Mouse_Movment_X (peut tre plac ici, puisque ca ne modifie pas les flags)
; ici, on traite la rotation par rapport  l'axe X (mouvement souris Y)
		mov eax,LParam									;; on place LParam (Y (word), X (word)) dans eax
		shr eax,16									;; dcaler eax  droite de 16 bits (pour avoir l'Y au bon endroit)
		sub eax,Final_Screen_Half_Height					;; soustraire la moitie de la height de notre cran  eax
;		sar eax,1										;; (optionnel) diviser le mouvement de la souris par 2 sign
		jnz MWM_MouvementSourisY							;; si c'est diffrent de 0, aller MWM_MouvementSourisY
		and ebx,1111111111001111b						;; effacer tmoins Angle_X (bits 5 et 4)
		jmp MWM_FinMouvementSourisY						;; aller MWM_FinMouvementSourisY
MWM_MouvementSourisY:
		bt eax,31										;; tester si eax est sign
		jc MWM_MouvementYNegatif							;; si eax est ngatif, aller MWM_MouvementYNegatif
MWM_MouvementYPositif:
		or ebx,0000010000010000b							;; positionner Angle_X positif (bits 10 et 4)
		and ebx,1111011111011111b						;; effacer Angle_X ngatif (bits 11 et 5)
		jmp MWM_FinMouvementSourisY						;; aller MWM_FinMouvementSourisY (pour viter les 2 lignes suivantes)
MWM_MouvementYNegatif:
		or ebx,0000100000100000b							;; positionner Angle_X ngatif (bits 11 et 5)
		and ebx,1111101111101111b						;; effacer Angle_X positif (bits 10 et 4)
MWM_FinMouvementSourisY:
		mov Mouse_Movment_Y,eax							;; sauvegarder le rsultat dans Mouse_Movment_Y (peut tre plac ici, puisque ca ne modifie pas les flags)
		mov Rotation_Direction_Flags,ebx					;; sauvegarder les tmoins
;		mov eax,WParam									;; pas utile pour le moment...
	ret												;; retourner
MWM_PasMouvementsSouris:

;; mouvement de la molette de la souris ?
;		cmp eax,WM_MOUSEWHEEL							;; un mouvement de la molette de la souris ?
;		jne MWM_PasMouvementsMoletteSouris					;; si c'est diffrent, aller MWM_PasMouvementsMoletteSouris
;		and eax,0FFFF0000h								;; ne conserver que les 16 bits suprieurs (ce sont eux qui contiennent les infos)
;		js MWM_MouvementMoletteSourisSuivant
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		shr eax,16
;
;
;		jmp MWM_MouvementMoletteSourisPrecedent
;MWM_MouvementMoletteSourisSuivant:
;; il faut diviser la valeur par 120 (?) pour avoir la valeur de dplacement
;		neg eax
;		shr eax,16
;
;
;MWM_MouvementMoletteSourisPrecedent:
;	ret												;; retourner
;MWM_PasMouvementsMoletteSouris:

; une touche presse ?
		cmp eax,WM_KEYDOWN								;; une touche est presse ?
		je MWM_Key_Down								;; si c'est le cas, aller MWM_Key_Down
; une touche relache ?
		cmp eax,WM_KEYUP								;; une touche est relache ?
		je MWM_Key_Up									;; si c'est le cas, aller MWM_Key_Up

;
; sinon, on finit avec le traitement par dfaut des messages de windows
;
		mov eax,HWndGM									;; ) sauvegarder le pointeur du gestionnaire, qui sert pour la clture
		mov Main_Win_Messages_Pointer,eax					;; )
		invoke DefWindowProc,HWndGM,Message,WParam,LParam
	ret


;
; fin de l'application (temoigne que le processus est bien fini)
;
MWM_FinApplication:
		invoke DestroyWindow,HWndGM						;; (pour supprimer les threads qui sont attachs  la fentre)
;		invoke Sleep,20								;; (pour s'assurer que tout aies le temps d'tre fait)
		invoke PostQuitMessage,NULL						;; sinon, poster le message de sortie
		xor eax,eax									;; remettre eax  zro
	ret												;; retourner

;;
;; initialisation de la fentre
;;
;MWM_Initialisation:
;
;	ret												;; retourner

;;
;; dessin de la fentre
;;
;MWM_MiseAJourEcran:
;		invoke BeginPaint,HWndGM,ADDR DessinEcran
;		mov hDC,eax
;		invoke ENDPaint,HWndGM,ADDR DessinEcran
;
;	ret												;; retourner

;;
;; fermeture de l'application ?
;;
;MWM_Fermeture:
;		mov Continue_Main_Process_Flags,1					;; sinon, on place 1 dans Continue_Main_Process_Flags
;		xor eax,eax									;; remettre eax  zro
;	ret												;; retourner

;
; fin du processus principal
;
MWM_ProcessusTermine:
		mov Continue_Main_Process_Flags,1					;; sinon, on place 1 dans Continue_Main_Process_Flags
		xor eax,eax									;; remettre eax  zro
	ret												;; retourner

;
; ici, les messages concernant les touches prsses
;
MWM_Key_Down:
		mov eax,WParam									;; mettre la condition (valeur de 0  nombre de label maximal-1) de saut dans eax
		and eax,0000000FFh								;; pour s'assurer que le saut sera valide
		jmp DWORD PTR [Table_Keys_Down+eax*4]				;; sauter  l'adresse correspondante au saut de la table
.DATA
ALIGN 4
; ici, notre table des sauts  effectuer
Table_Keys_Down	DWORD MWM_NoKeyDown						;; (utile pour avoir les bonnes valeurs dans la table ... )
		DWORD MWM_LeftMouseButtonDown						;; VK_LBUTTON	001h
		DWORD MWM_RightMouseButtonDown					;; VK_RBUTTON	002h
		DWORD MWM_NoKeyDown								;; VK_CANCEL	003h
		DWORD MWM_MiddleMouseButtonDown					;; VK_MBUTTON	004h
		DWORD MWM_NoKeyDown								;; VK_		005h
		DWORD MWM_NoKeyDown								;; VK_		006h
		DWORD MWM_NoKeyDown								;; VK_		007h
		DWORD MWM_KeyBackDown							;; VK_BACK	008h
		DWORD MWM_KeyTabDown							;; VK_TAB		009h
		DWORD MWM_NoKeyDown								;; VK_		00Ah
		DWORD MWM_NoKeyDown								;; VK_		00Bh
		DWORD MWM_NoKeyDown								;; VK_CLEAR	00Ch
		DWORD MWM_KeyReturnDown							;; VK_RETURN	00Dh
		DWORD MWM_NoKeyDown								;; VK_		00Eh
		DWORD MWM_NoKeyDown								;; VK_		00Fh
		DWORD MWM_NoKeyDown								;; VK_SHIFT	010h ) inactifs pour pouvoir faire la diffrence entre droit et gauche
		DWORD MWM_NoKeyDown								;; VK_CONTROL	011h )
		DWORD MWM_NoKeyDown								;; VK_MENU	012h )
		DWORD MWM_NoKeyDown								;; VK_PAUSE	013h
		DWORD MWM_NoKeyDown								;; VK_CAPITAL	014h
		DWORD MWM_NoKeyDown								;; VK_KANA ou VK_HANGEUL ou VK_HANGUL	015h
		DWORD MWM_NoKeyDown								;; VK_		016h
		DWORD MWM_NoKeyDown								;; VK_JUNJA	017h
		DWORD MWM_NoKeyDown								;; VK_FINAL	018h
		DWORD MWM_NoKeyDown								;; VK_HANJA ou VK_KANJI	019h
		DWORD MWM_NoKeyDown								;; VK_		01Ah
		DWORD MWM_KeyEscDown							;; VK_ESCAPE	01Bh
		DWORD MWM_NoKeyDown								;; VK_CONVERT		01Ch
		DWORD MWM_NoKeyDown								;; VK_NONCONVERT	01Dh
		DWORD MWM_NoKeyDown								;; VK_ACCEPT		01Eh
		DWORD MWM_NoKeyDown								;; VK_MODECHANGE	01Fh
		DWORD MWM_KeySpaceDown							;; VK_SPACE	020h
		DWORD MWM_KeyPgUpDown							;; VK_PRIOR ou VK_PGUP	021h
		DWORD MWM_KeyPgDnDown							;; VK_NEXT ou VK_PGDN	022h
		DWORD MWM_KeyEndDown							;; VK_END		023h
		DWORD MWM_KeyHomeDown							;; VK_HOME	024h
		DWORD MWM_KeyLeftDown							;; VK_LEFT	025h
		DWORD MWM_KeyUpDown								;; VK_UP		026h
		DWORD MWM_KeyRightDown							;; VK_RIGHT	027h
		DWORD MWM_KeyDownDown							;; VK_DOWN	028h
		DWORD MWM_NoKeyDown								;; VK_SELECT	029h
		DWORD MWM_NoKeyDown								;; VK_PRINT	02Ah
		DWORD MWM_NoKeyDown								;; VK_EXECUTE	02Bh
		DWORD MWM_NoKeyDown								;; VK_SNAPSHOT	02Ch
		DWORD MWM_KeyInserDown							;; VK_INSERT	02Dh
		DWORD MWM_KeySupprDown							;; VK_DELETE	02Eh
		DWORD MWM_NoKeyDown								;; VK_HELP	02Fh
		DWORD MWM_Key0Down								;; VK_0	030h
		DWORD MWM_Key1Down								;; VK_1	031h
		DWORD MWM_Key2Down								;; VK_2	032h
		DWORD MWM_Key3Down								;; VK_3	033h
		DWORD MWM_Key4Down								;; VK_4	034h
		DWORD MWM_Key5Down								;; VK_5	035h
		DWORD MWM_Key6Down								;; VK_6	036h
		DWORD MWM_Key7Down								;; VK_7	037h
		DWORD MWM_Key8Down								;; VK_8	038h
		DWORD MWM_Key9Down								;; VK_9	039h
		DWORD MWM_NoKeyDown								;; VK_	03Ah
		DWORD MWM_NoKeyDown								;; VK_	03Bh
		DWORD MWM_NoKeyDown								;; VK_	03Ch
		DWORD MWM_NoKeyDown								;; VK_	03Dh
		DWORD MWM_NoKeyDown								;; VK_	03Eh
		DWORD MWM_NoKeyDown								;; VK_	03Fh
		DWORD MWM_NoKeyDown								;; VK_	040h
		DWORD MWM_KeyADown								;; VK_A	041h
		DWORD MWM_KeyBDown								;; VK_B	042h
		DWORD MWM_KeyCDown								;; VK_C	043h
		DWORD MWM_KeyDDown								;; VK_D	044h
		DWORD MWM_KeyEDown								;; VK_E	045h
		DWORD MWM_KeyFDown								;; VK_F	046h
		DWORD MWM_KeyGDown								;; VK_G	047h
		DWORD MWM_KeyHDown								;; VK_H	048h
		DWORD MWM_KeyIDown								;; VK_I	049h
		DWORD MWM_KeyJDown								;; VK_J	04Ah
		DWORD MWM_KeyKDown								;; VK_K	04Bh
		DWORD MWM_KeyLDown								;; VK_L	04Ch
		DWORD MWM_KeyMDown								;; VK_M	04Dh
		DWORD MWM_KeyNDown								;; VK_N	04Eh
		DWORD MWM_KeyODown								;; VK_O	04Fh
		DWORD MWM_KeyPDown								;; VK_P	050h
		DWORD MWM_KeyQDown								;; VK_Q	051h
		DWORD MWM_KeyRDown								;; VK_R	052h
		DWORD MWM_KeySDown								;; VK_S	053h
		DWORD MWM_KeyTDown								;; VK_T	054h
		DWORD MWM_KeyUDown								;; VK_U	055h
		DWORD MWM_KeyVDown								;; VK_V	056h
		DWORD MWM_KeyWDown								;; VK_W	057h
		DWORD MWM_KeyXDown								;; VK_X	058h
		DWORD MWM_KeyYDown								;; VK_Y	059h
		DWORD MWM_KeyZDown								;; VK_Z	05Ah
		DWORD MWM_KeyLWinDown							;; VK_LWIN	05Bh (touche WINDOWS gauche)
		DWORD MWM_KeyRWinDown							;; VK_RWIN	05Ch (touche WINDOWS droit)
		DWORD MWM_NoKeyDown								;; VK_APPS	05Dh
		DWORD MWM_NoKeyDown								;; VK_	05Eh
		DWORD MWM_NoKeyDown								;; VK_	05Fh
		DWORD MWM_KeyNum0Down							;; VK_NUMPAD0	060h
		DWORD MWM_KeyNum1Down							;; VK_NUMPAD1	061h
		DWORD MWM_KeyNum2Down							;; VK_NUMPAD2	062h
		DWORD MWM_KeyNum3Down							;; VK_NUMPAD3	063h
		DWORD MWM_KeyNum4Down							;; VK_NUMPAD4	064h
		DWORD MWM_KeyNum5Down							;; VK_NUMPAD5	065h
		DWORD MWM_KeyNum6Down							;; VK_NUMPAD6	066h
		DWORD MWM_KeyNum7Down							;; VK_NUMPAD7	067h
		DWORD MWM_KeyNum8Down							;; VK_NUMPAD8	068h
		DWORD MWM_KeyNum9Down							;; VK_NUMPAD9	069h
		DWORD MWM_KeyNumMultiplyDown						;; VK_MULTIPLY		06Ah
		DWORD MWM_KeyNumAddDown							;; VK_ADD			06Bh
		DWORD MWM_NoKeyDown								;; VK_SEPARATOR	06Ch
		DWORD MWM_KeyNumSubtractDown						;; VK_SUBTRACT		06Dh
		DWORD MWM_KeyNumDecimalDown						;; VK_DECIMAL		06Eh
		DWORD MWM_KeyNumDivideDown						;; VK_DIVIDE		06Fh
		DWORD MWM_KeyF1Down								;; VK_F1	070h
		DWORD MWM_KeyF2Down								;; VK_F2	071h
		DWORD MWM_KeyF3Down								;; VK_F3	072h
		DWORD MWM_KeyF4Down								;; VK_F4	073h
		DWORD MWM_KeyF5Down								;; VK_F5	074h
		DWORD MWM_KeyF6Down								;; VK_F6	075h
		DWORD MWM_KeyF7Down								;; VK_F7	076h
		DWORD MWM_KeyF8Down								;; VK_F8	077h
		DWORD MWM_KeyF9Down								;; VK_F9	078h
		DWORD MWM_KeyF10Down							;; VK_F10	079h
		DWORD MWM_KeyF11Down							;; VK_F11	07Ah
		DWORD MWM_KeyF12Down							;; VK_F12	07Bh
		DWORD MWM_KeyF13Down							;; VK_F13	07Ch
		DWORD MWM_KeyF14Down							;; VK_F14	07Dh
		DWORD MWM_KeyF15Down							;; VK_F15	07Eh
		DWORD MWM_KeyF16Down							;; VK_F16	07Fh
		DWORD MWM_KeyF17Down							;; VK_F17	080h
		DWORD MWM_KeyF18Down							;; VK_F18	081h
		DWORD MWM_KeyF19Down							;; VK_F19	082h
		DWORD MWM_KeyF20Down							;; VK_F20	083h
		DWORD MWM_KeyF21Down							;; VK_F21	084h
		DWORD MWM_KeyF22Down							;; VK_F22	085h
		DWORD MWM_KeyF23Down							;; VK_F23	086h
		DWORD MWM_KeyF24Down							;; VK_F24	087h
		DWORD MWM_NoKeyDown								;; VK_	088h
		DWORD MWM_NoKeyDown								;; VK_	089h
		DWORD MWM_NoKeyDown								;; VK_	08Ah
		DWORD MWM_NoKeyDown								;; VK_	08Bh
		DWORD MWM_NoKeyDown								;; VK_	08Ch
		DWORD MWM_NoKeyDown								;; VK_	08Dh
		DWORD MWM_NoKeyDown								;; VK_	08Eh
		DWORD MWM_NoKeyDown								;; VK_	08Fh
		DWORD MWM_KeyNumLDown							;; VK_NUMLOCK	090h
		DWORD MWM_NoKeyDown								;; VK_SCROLL	091h
		DWORD MWM_NoKeyDown								;; VK_	092h
		DWORD MWM_NoKeyDown								;; VK_	093h
		DWORD MWM_NoKeyDown								;; VK_	094h
		DWORD MWM_NoKeyDown								;; VK_	095h
		DWORD MWM_NoKeyDown								;; VK_	096h
		DWORD MWM_NoKeyDown								;; VK_	097h
		DWORD MWM_NoKeyDown								;; VK_	098h
		DWORD MWM_NoKeyDown								;; VK_	099h
		DWORD MWM_NoKeyDown								;; VK_	09Ah
		DWORD MWM_NoKeyDown								;; VK_	09Bh
		DWORD MWM_NoKeyDown								;; VK_	09Ch
		DWORD MWM_NoKeyDown								;; VK_	09Dh
		DWORD MWM_NoKeyDown								;; VK_	09Eh
		DWORD MWM_NoKeyDown								;; VK_	09Fh
		DWORD MWM_KeyLShftDown							;; VK_LSHIFT	0A0h
		DWORD MWM_KeyRShftDown							;; VK_RSHIFT	0A1h
		DWORD MWM_KeyLCtrlDown							;; VK_LCONTROL	0A2h
		DWORD MWM_KeyRCtrlDown							;; VK_RCONTROL	0A3h
		DWORD MWM_KeyLAltDown							;; VK_LMENU	0A4h
		DWORD MWM_KeyRAltDown							;; VK_RMENU	0A5h
		DWORD MWM_NoKeyDown								;; VK_	0A6h
		DWORD MWM_NoKeyDown								;; VK_	0A7h
		DWORD MWM_NoKeyDown								;; VK_	0A8h
		DWORD MWM_NoKeyDown								;; VK_	0A9h
		DWORD MWM_NoKeyDown								;; VK_	0AAh
		DWORD MWM_NoKeyDown								;; VK_	0ABh
		DWORD MWM_NoKeyDown								;; VK_	0ACh
		DWORD MWM_NoKeyDown								;; VK_	0ADh
		DWORD MWM_NoKeyDown								;; VK_	0AEh
		DWORD MWM_NoKeyDown								;; VK_	0AFh
		DWORD MWM_NoKeyDown								;; VK_	0B0h
		DWORD MWM_NoKeyDown								;; VK_	0B1h
		DWORD MWM_NoKeyDown								;; VK_	0B2h
		DWORD MWM_NoKeyDown								;; VK_	0B3h
		DWORD MWM_NoKeyDown								;; VK_	0B4h
		DWORD MWM_NoKeyDown								;; VK_	0B5h
		DWORD MWM_NoKeyDown								;; VK_	0B6h
		DWORD MWM_NoKeyDown								;; VK_	0B7h
		DWORD MWM_NoKeyDown								;; VK_	0B8h
		DWORD MWM_NoKeyDown								;; VK_	0B9h
		DWORD MWM_KeyDollardDown							;; VK_	0BAh ()
		DWORD MWM_KeyAddDown							;; VK_	0BBh (+)
		DWORD MWM_KeyInterDown							;; VK_	0BCh (?)
		DWORD MWM_NoKeyDown								;; VK_	0BDh
		DWORD MWM_KeyDecimalDown							;; VK_	0BEh (.)
		DWORD MWM_KeyDivideDown							;; VK_	0BFh (/)
		DWORD MWM_KeyPercentDown							;; VK_	0C0h (%)
		DWORD MWM_NoKeyDown								;; VK_	0C1h
		DWORD MWM_NoKeyDown								;; VK_	0C2h
		DWORD MWM_NoKeyDown								;; VK_	0C3h
		DWORD MWM_NoKeyDown								;; VK_	0C4h
		DWORD MWM_NoKeyDown								;; VK_	0C5h
		DWORD MWM_NoKeyDown								;; VK_	0C6h
		DWORD MWM_NoKeyDown								;; VK_	0C7h
		DWORD MWM_NoKeyDown								;; VK_	0C8h
		DWORD MWM_NoKeyDown								;; VK_	0C9h
		DWORD MWM_NoKeyDown								;; VK_	0CAh
		DWORD MWM_NoKeyDown								;; VK_	0CBh
		DWORD MWM_NoKeyDown								;; VK_	0CCh
		DWORD MWM_NoKeyDown								;; VK_	0CDh
		DWORD MWM_NoKeyDown								;; VK_	0CEh
		DWORD MWM_NoKeyDown								;; VK_	0CFh
		DWORD MWM_NoKeyDown								;; VK_	0D0h
		DWORD MWM_NoKeyDown								;; VK_	0D1h
		DWORD MWM_NoKeyDown								;; VK_	0D2h
		DWORD MWM_NoKeyDown								;; VK_	0D3h
		DWORD MWM_NoKeyDown								;; VK_	0D4h
		DWORD MWM_NoKeyDown								;; VK_	0D5h
		DWORD MWM_NoKeyDown								;; VK_	0D6h
		DWORD MWM_NoKeyDown								;; VK_	0D7h
		DWORD MWM_NoKeyDown								;; VK_	0D8h
		DWORD MWM_NoKeyDown								;; VK_	0D9h
		DWORD MWM_NoKeyDown								;; VK_	0DAh
		DWORD MWM_KeyDegresDown							;; VK_	0DBh ()
		DWORD MWM_KeyMultiplyDown						;; VK_	0DCh ()
		DWORD MWM_KeyPowerDown							;; VK_	0DDh ()
		DWORD MWM_KeyConsoleDown							;; VK_	0DEh ()
		DWORD MWM_KeyExclamDown							;; VK_	0DFh ()
		DWORD MWM_NoKeyDown								;; VK_	0E0h
		DWORD MWM_NoKeyDown								;; VK_	0E1h
		DWORD MWM_KeyGreaterDown							;; VK_	0E2h (>)
		DWORD MWM_NoKeyDown								;; VK_	0E3h
		DWORD MWM_NoKeyDown								;; VK_	0E4h
		DWORD MWM_NoKeyDown								;; VK_PROCESSKEY	0E5h
		DWORD MWM_NoKeyDown								;; VK_	0E6h
		DWORD MWM_NoKeyDown								;; VK_	0E7h
		DWORD MWM_NoKeyDown								;; VK_	0E8h
		DWORD MWM_NoKeyDown								;; VK_	0E9h
		DWORD MWM_NoKeyDown								;; VK_	0EAh
		DWORD MWM_NoKeyDown								;; VK_	0EBh
		DWORD MWM_NoKeyDown								;; VK_	0ECh
		DWORD MWM_NoKeyDown								;; VK_	0EDh
		DWORD MWM_NoKeyDown								;; VK_	0EEh
		DWORD MWM_NoKeyDown								;; VK_	0EFh
		DWORD MWM_NoKeyDown								;; VK_	0F0h
		DWORD MWM_NoKeyDown								;; VK_	0F1h
		DWORD MWM_NoKeyDown								;; VK_	0F2h
		DWORD MWM_NoKeyDown								;; VK_	0F3h
		DWORD MWM_NoKeyDown								;; VK_	0F4h
		DWORD MWM_NoKeyDown								;; VK_	0F5h
		DWORD MWM_NoKeyDown								;; VK_ATTN	0F6h
		DWORD MWM_NoKeyDown								;; VK_CRSEL	0F7h
		DWORD MWM_NoKeyDown								;; VK_EXSEL	0F8h
		DWORD MWM_NoKeyDown								;; VK_EREOF	0F9h
		DWORD MWM_NoKeyDown								;; VK_PLAY	0FAh
		DWORD MWM_NoKeyDown								;; VK_ZOOM	0FBh
		DWORD MWM_NoKeyDown								;; VK_NONAME	0FCh
		DWORD MWM_NoKeyDown								;; VK_PA1		0FDh
		DWORD MWM_NoKeyDown								;; VK_OEM_CLEAR	0FEh
		DWORD MWM_NoKeyDown								;; VK_	0FFh
; ici, les labels correspondants aux sauts
.CODE
; aucune touche n'est presse
MWM_NoKeyDown:											;; aucune touche n'est prsse ?
	ret												;; retourner (sortir de la gestion de ce message)
MWM_LeftMouseButtonDown:									;; VK_LBUTTON	001h
		or Mouse_Button_Flags,0000000100000100b				;; sinon, on positionne le bit correspondant
	ret												;; retourner (sortir de la gestion de ce message)
MWM_RightMouseButtonDown:								;; VK_RBUTTON	002h
		or Mouse_Button_Flags,0000000001000001b				;; sinon, on positionne le bit correspondant
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_CANCEL	003h
MWM_MiddleMouseButtonDown:								;; VK_MBUTTON	004h
		or Mouse_Button_Flags,0000000010000010b				;; sinon, on positionne le bit correspondant
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		005h
;; VK_		006h
;; VK_		007h
MWM_KeyBackDown:										;; VK_BACK	008h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyTabDown:										;; VK_TAB		009h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		00Ah
;; VK_		00Bh
;; VK_CLEAR	00Ch
MWM_KeyReturnDown:										;; VK_RETURN	00Dh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		00Eh
;; VK_		00Fh
;; VK_SHIFT	010h ) inactifs pour pouvoir faire la diffrence entre droit et gauche
;; VK_CONTROL	011h )
;; VK_MENU	012h )
;; VK_PAUSE	013h
;; VK_CAPITAL	014h
;; VK_KANA ou VK_HANGEUL ou VK_HANGUL	015h
;; VK_		016h
;; VK_JUNJA	017h
;; VK_FINAL	018h
;; VK_HANJA ou VK_KANJI	019h
;; VK_		01Ah
; quitter ?
MWM_KeyEscDown:										;; VK_ESCAPE	01Bh
		bts Dlg_Box_Flags,0								;; mettre le tmoin de la boite de dialogue pour quitter (bit 0)
		mov Suspend_Main_Process_Flags,1					;; mettre le tmoin de suspension
MWM_KeyEsc_EcranPasEncoreGrise:
		cmp Gray_Screen_Flags,1							;; l'cran  t gris ?
		jne MWM_KeyEsc_EcranPasEncoreGrise					;; tant que ce n'est pas le cas, aller MWM_KeyEsc_EcranPasEncoreGrise
; faire rapparaitre le pointeur cran
		invoke SuspendThread,Main_Process_Pointer			;; suspendre le processus
		invoke SetCursorPos,Half_Screen_Position_X,Half_Screen_Position_Y	;; on place le pointeur au center de l'cran OS
		invoke ShowCursor,TRUE							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Dlg_Box_Instance,Rsrc_IDD_Quit,0,ADDR DlgBoxWinMessage,0
; faire disparaitre le pointeur cran
		invoke ShowCursor,FALSE							;; faire disparaitre le pointeur cran
		invoke SetCursorPos,Half_Screen_Position_X,Half_Screen_Position_Y	;; on place le pointeur au center de l'cran OS
		invoke ResumeThread,Main_Process_Pointer			;; reprendre le processus
		mov Suspend_Main_Process_Flags,0					;; enlever le tmoin de suspension du processus
		mov Gray_Screen_Flags,0							;; enlever le tmoin de l'cran gris
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_CONVERT		01Ch
;; VK_NONCONVERT	01Dh
;; VK_ACCEPT		01Eh
;; VK_MODECHANGE	01Fh
MWM_KeySpaceDown:										;; VK_SPACE	020h
	ret												;; retourner (sortir de la gestion de ce message)
; objet prcdant
MWM_KeyPgUpDown:										;; VK_PRIOR ou VK_PGUP	021h
		mov eax,Selected_Object_Flags						;; mettre le tmoin contenant le numro de l'objet dans eax
		inc eax										;; incrmenter ce numro
		cmp eax,Number_Of_3D_Objects						;; comparer ce numro  celui du nombre total
		jb MWM_EviterSoustaireNombreObjets					;; si c'est infrieur, aller MWM_EviterSoustaireNombreObjets
		sub eax,Number_Of_3D_Objects						;; sinon, soustraire le nombre d'objets 3D total
MWM_EviterSoustaireNombreObjets:
		mov Selected_Object_Flags,eax						;; on sauvegarde le nouveau numro d'objet
	ret												;; retourner (sortir de la gestion de ce message)
; objet suivant
MWM_KeyPgDnDown:										;; VK_NEXT ou VK_PGDN	022h
		mov eax,Selected_Object_Flags						;; mettre le tmoin contenant le numro de l'objet dans eax
		dec eax										;; dcrmenter ce numro
		test eax,eax									;; fixer les flags de eax
		jns MWM_EviterAdditionnerNombreObjets				;; si ce n'est pas sign, aller MWM_EviterAdditionnerNombreObjets
		add eax,Number_Of_3D_Objects						;; sinon, ajouter le nombre d'objets 3D total
MWM_EviterAdditionnerNombreObjets:
		mov Selected_Object_Flags,eax						;; on sauvegarde le nouveau numro d'objet
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyEndDown:										;; VK_END		023h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyHomeDown:										;; VK_HOME	024h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLeftDown:										;; VK_LEFT	025h
		bts Keys_Flags,2								;; sinon, on positionne le bit correspondant (bit 2)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyUpDown:											;; VK_UP		026h
		bts Mouse_Button_Flags,0							;; sinon, on positionne le bit correspondant (bit 0)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRightDown:										;; VK_RIGHT	027h
		bts Keys_Flags,0								;; sinon, on positionne le bit correspondant (bit 0)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDownDown:										;; VK_DOWN	028h
		bts Keys_Flags,1								;; sinon, on positionne le bit correspondant (bit 1)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SELECT	029h
;; VK_PRINT	02Ah
;; VK_EXECUTE	02Bh
;; VK_SNAPSHOT	02Ch
MWM_KeyInserDown:										;; VK_INSERT	02Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeySupprDown:										;; VK_DELETE	02Eh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_HELP	02Fh
MWM_Key0Down:											;; VK_0	030h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key1Down:											;; VK_1	031h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key2Down:											;; VK_2	032h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key3Down:											;; VK_3	033h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key4Down:											;; VK_4	034h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key5Down:											;; VK_5	035h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key6Down:											;; VK_6	036h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key7Down:											;; VK_7	037h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key8Down:											;; VK_8	038h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key9Down:											;; VK_9	039h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	03Ah
;; VK_	03Bh
;; VK_	03Ch
;; VK_	03Dh
;; VK_	03Eh
;; VK_	03Fh
;; VK_	040h
; afficher les axes d'un objet 3D
MWM_KeyADown:											;; VK_A	041h
		btc Debug_Infos_Flags,3							;; changer le bit correspondant aux axes
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyBDown:											;; VK_B	042h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyCDown:											;; VK_C	043h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDDown:											;; VK_D	044h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyEDown:											;; VK_E	045h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyFDown:											;; VK_F	046h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyGDown:											;; VK_G	047h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyHDown:											;; VK_H	048h
	ret												;; retourner (sortir de la gestion de ce message)
; afficher les informations
MWM_KeyIDown:											;; VK_I	049h
		btc Debug_Infos_Flags,0							;; changer le bit correspondant aux infos debug
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyJDown:											;; VK_J	04Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyKDown:											;; VK_K	04Bh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLDown:											;; VK_L	04Ch
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyMDown:											;; VK_M	04Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNDown:											;; VK_N	04Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyODown:											;; VK_O	04Fh
	ret												;; retourner (sortir de la gestion de ce message)
; afficher les polygones d'un objet 3D
MWM_KeyPDown:											;; VK_P	050h
		btc Debug_Infos_Flags,1							;; changer le bit correspondant aux polygones
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyQDown:											;; VK_Q	051h
	ret												;; retourner (sortir de la gestion de ce message)
; respiration
MWM_KeyRDown:											;; VK_R	052h
		xor Breath_Flags,1								;; inverser le bit
	ret												;; retourner (sortir de la gestion de ce message)
; statistiques
MWM_KeySDown:											;; VK_S	053h
		xor Stat_Flags,1								;; inverser le bit
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyTDown:											;; VK_T	054h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyUDown:											;; VK_U	055h
	ret												;; retourner (sortir de la gestion de ce message)
; viseur
MWM_KeyVDown:											;; VK_V	056h
		xor Focus_Flags,1								;; inverser le bit
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyWDown:											;; VK_W	057h
	ret												;; retourner (sortir de la gestion de ce message)
; particules 3D
MWM_KeyXDown:											;; VK_X	058h
		xor Particules_Flags,1							;; inverser le bit
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyYDown:											;; VK_Y	059h
	ret												;; retourner (sortir de la gestion de ce message)
; afficher la zone d'un objet 3D
MWM_KeyZDown:											;; VK_Z	05Ah
		btc Debug_Infos_Flags,2							;; changer le bit correspondant  la zone
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLWinDown:										;; VK_LWIN	05Bh (touche WINDOWS gauche)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRWinDown:										;; VK_RWIN	05Ch (touche WINDOWS droit)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_APPS	05Dh
;; VK_	05Eh
;; VK_	05Fh
MWM_KeyNum0Down:										;; VK_0	060h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum1Down:										;; VK_1	061h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum2Down:										;; VK_2	062h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum3Down:										;; VK_3	063h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum4Down:										;; VK_4	064h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum5Down:										;; VK_5	065h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum6Down:										;; VK_6	066h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum7Down:										;; VK_7	067h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum8Down:										;; VK_8	068h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum9Down:										;; VK_9	069h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumMultiplyDown:									;; VK_MULTIPLY		06Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumAddDown:										;; VK_ADD			06Bh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SEPARATOR	06Ch
MWM_KeyNumSubtractDown:									;; VK_SUBTRACT		06Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumDecimalDown:									;; VK_DECIMAL		06Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumDivideDown:									;; VK_DIVIDE		06Fh
	ret												;; retourner (sortir de la gestion de ce message)
; sans antialiasing
MWM_KeyF1Down:											;; VK_F1	070h
;		mov eax,Work_Screen_Width						;; mettre la width de l'cran dans eax
;		mov ebx,Work_Screen_Height						;; mettre la height de l'cran dans ebx
;		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
;		call Init3DWorld_Sse							;; valider les nouvelles valeurs dans le monde 3D
		mov Blur_Flags,0								;; mettre 0 dans Blur_Flags
	ret												;; retourner (sortir de la gestion de ce message)
; avec antialiasing
MWM_KeyF2Down:											;; VK_F2	071h
;		mov eax,Work_Screen_Half_Width					;; mettre la width de l'cran dans eax
;		mov ebx,Work_Screen_Half_Height					;; mettre la height de l'cran dans ebx
;		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
;		call Init3DWorld_Sse							;; valider les nouvelles valeurs dans le monde 3D
		mov Blur_Flags,1								;; mettre 1 dans Blur_Flags
	ret												;; retourner (sortir de la gestion de ce message)
; marche
MWM_KeyF3Down:											;; VK_F3	072h
		mov World_3D_0001.View_Movment_SpeedUp,03F800000h		;; 1 vitesse d'acceleration des dplacements
		mov World_3D_0001.View_Movment_SlowDown,03F800000h	;; 1 vitesse de dcleration des dplacements
		mov World_3D_0001.View_Speed_Movment_Maxi,041000000h	;; 8 doit imprativement tre un multiple de x.View_Movment_SpeedUp et de x.View_Movment_SlowDown
	ret												;; retourner (sortir de la gestion de ce message)
; course
MWM_KeyF4Down:											;; VK_F4	073h
		mov World_3D_0001.View_Movment_SpeedUp,040000000h		;; 2 vitesse d'acceleration des dplacements
		mov World_3D_0001.View_Movment_SlowDown,040000000h	;; 2 vitesse de dcleration des dplacements
		mov World_3D_0001.View_Speed_Movment_Maxi,041800000h	;; 16 doit imprativement tre un multiple de x.View_Movment_SpeedUp et de x.View_Movment_SlowDown
	ret												;; retourner (sortir de la gestion de ce message)
; zoom * 1 (soit la vue normale)
MWM_KeyF5Down:											;; VK_F5	074h
		mov World_3D_0001.View_Zoom_X,03F800000h			;; mettre 1.0f dans View_Zoom_X de la structure A_3D_World
		mov World_3D_0001.View_Zoom_Y,03F800000h			;; mettre 1.0f dans View_Zoom_Y de la structure A_3D_World
		mov World_3D_0001.View_Rotation_Speed,03E800000h		;; mouvement camra de 0.25
		mov Zoom_Flags,0								;; vision normale (zoom inactif)
	ret												;; retourner (sortir de la gestion de ce message)
; zoom * 2
MWM_KeyF6Down:											;; VK_F6	075h
		mov World_3D_0001.View_Zoom_X,040000000h			;; mettre 2.0f dans View_Zoom_X de la structure A_3D_World
		mov World_3D_0001.View_Zoom_Y,040000000h			;; mettre 2.0f dans View_Zoom_Y de la structure A_3D_World
		mov World_3D_0001.View_Rotation_Speed,03E000000h		;; mouvement camra de 0.125
		mov Zoom_Flags,1								;; zoom *2 actif
	ret												;; retourner (sortir de la gestion de ce message)
; zoom * 4
MWM_KeyF7Down:											;; VK_F7	076h
		mov World_3D_0001.View_Zoom_X,040800000h			;; mettre 4.0f dans View_Zoom_X de la structure A_3D_World
		mov World_3D_0001.View_Zoom_Y,040800000h			;; mettre 4.0f dans View_Zoom_Y de la structure A_3D_World
		mov World_3D_0001.View_Rotation_Speed,03D800000h		;; mouvement camra de 0.0625
		mov Zoom_Flags,2								;; zoom *4 actif
	ret												;; retourner (sortir de la gestion de ce message)
; zoom * 8
MWM_KeyF8Down:											;; VK_F8	077h
		mov World_3D_0001.View_Zoom_X,041000000h			;; mettre 8.0f dans View_Zoom_X de la structure A_3D_World
		mov World_3D_0001.View_Zoom_Y,041000000h			;; mettre 8.0f dans View_Zoom_Y de la structure A_3D_World
		mov World_3D_0001.View_Rotation_Speed,03D000000h		;; mouvement camra de 0.03125
		mov Zoom_Flags,3								;; zoom *8 actif
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF9Down:											;; VK_F9	078h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF10Down:										;; VK_F10	079h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF11Down:										;; VK_F11	07Ah
	ret												;; retourner (sortir de la gestion de ce message)
; capture cran
MWM_KeyF12Down:										;; VK_F12	07Bh
		call ScreenCapture								;; sauvegarder l'cran en cours d'affichage
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF13Down:										;; VK_F13	07Ch
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF14Down:										;; VK_F14	07Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF15Down:										;; VK_F15	07Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF16Down:										;; VK_F16	07Fh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF17Down:										;; VK_F17	080h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF18Down:										;; VK_F18	081h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF19Down:										;; VK_F19	082h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF20Down:										;; VK_F20	083h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF21Down:										;; VK_F21	084h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF22Down:										;; VK_F22	085h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF23Down:										;; VK_F23	086h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF24Down:										;; VK_F24	087h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	088h
;; VK_	089h
;; VK_	08Ah
;; VK_	08Bh
;; VK_	08Ch
;; VK_	08Dh
;; VK_	08Eh
;; VK_	08Fh
MWM_KeyNumLDown:										;; VK_NUMLOCK	090h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SCROLL	091h
;; VK_	092h
;; VK_	093h
;; VK_	094h
;; VK_	095h
;; VK_	096h
;; VK_	097h
;; VK_	098h
;; VK_	099h
;; VK_	09Ah
;; VK_	09Bh
;; VK_	09Ch
;; VK_	09Dh
;; VK_	09Eh
;; VK_	09Fh
MWM_KeyLShftDown:										;; VK_LSHIFT	0A0h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRShftDown:										;; VK_RSHIFT	0A1h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLCtrlDown:										;; VK_LCONTROL	0A2h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRCtrlDown:										;; VK_RCONTROL	0A3h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLAltDown:										;; VK_LMENU	0A4h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRAltDown:										;; VK_RMENU	0A5h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0A6h
;; VK_	0A7h
;; VK_	0A8h
;; VK_	0A9h
;; VK_	0AAh
;; VK_	0ABh
;; VK_	0ACh
;; VK_	0ADh
;; VK_	0AEh
;; VK_	0AFh
;; VK_	0B0h
;; VK_	0B1h
;; VK_	0B2h
;; VK_	0B3h
;; VK_	0B4h
;; VK_	0B5h
;; VK_	0B6h
;; VK_	0B7h
;; VK_	0B8h
;; VK_	0B9h
MWM_KeyDollardDown:										;; VK_	0BAh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyAddDown:										;; VK_	0BBh (+)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyInterDown:										;; VK_	0BCh (?)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0BDh
MWM_KeyDecimalDown:										;; VK_	0BEh (.)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDivideDown:										;; VK_	0BFh (/)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPercentDown:										;; VK_	0C0h (%)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0C1h
;; VK_	0C2h
;; VK_	0C3h
;; VK_	0C4h
;; VK_	0C5h
;; VK_	0C6h
;; VK_	0C7h
;; VK_	0C8h
;; VK_	0C9h
;; VK_	0CAh
;; VK_	0CBh
;; VK_	0CCh
;; VK_	0CDh
;; VK_	0CEh
;; VK_	0CFh
;; VK_	0D0h
;; VK_	0D1h
;; VK_	0D2h
;; VK_	0D3h
;; VK_	0D4h
;; VK_	0D5h
;; VK_	0D6h
;; VK_	0D7h
;; VK_	0D8h
;; VK_	0D9h
;; VK_	0DAh
MWM_KeyDegresDown:										;; VK_	0DBh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyMultiplyDown:									;; VK_	0DCh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPowerDown:										;; VK_	0DDh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyConsoleDown:										;; VK_	0DEh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyExclamDown:										;; VK_	0DFh ()
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0E0h
;; VK_	0E1h
MWM_KeyGreaterDown:										;; VK_	0E2h (>)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0E3h
;; VK_	0E4h
;; VK_PROCESSKEY	0E5h
;; VK_	0E6h
;; VK_	0E7h
;; VK_	0E8h
;; VK_	0E9h
;; VK_	0EAh
;; VK_	0EBh
;; VK_	0ECh
;; VK_	0EDh
;; VK_	0EEh
;; VK_	0EFh
;; VK_	0F0h
;; VK_	0F1h
;; VK_	0F2h
;; VK_	0F3h
;; VK_	0F4h
;; VK_	0F5h
;; VK_ATTN	0F6h
;; VK_CRSEL	0F7h
;; VK_EXSEL	0F8h
;; VK_EREOF	0F9h
;; VK_PLAY	0FAh
;; VK_ZOOM	0FBh
;; VK_NONAME	0FCh
;; VK_PA1		0FDh
;; VK_OEM_CLEAR	0FEh
;; VK_	0FFh


;
; ici, les messages concernant les touches relaches
;
MWM_Key_Up:
		mov eax,WParam									;; mettre la condition (valeur de 0  nombre de label maximal-1) de saut dans eax
		and eax,0000000FFh								;; pour s'assurer que le saut sera valide
		jmp DWORD PTR [Table_Keys_Up+eax*4]				;; sauter  l'adresse correspondante au saut de la table
.DATA
ALIGN 4
; ici, notre table des sauts  effectuer
Table_Keys_Up	DWORD MWM_NoKeyUp							;; (utile pour avoir les bonnes valeurs dans la table ... )
		DWORD MWM_LeftMouseButtonUp						;; VK_LBUTTON	001h
		DWORD MWM_RightMouseButtonUp						;; VK_RBUTTON	002h
		DWORD MWM_NoKeyUp								;; VK_CANCEL	003h
		DWORD MWM_MiddleMouseButtonUp						;; VK_MBUTTON	004h
		DWORD MWM_NoKeyUp								;; VK_		005h
		DWORD MWM_NoKeyUp								;; VK_		006h
		DWORD MWM_NoKeyUp								;; VK_		007h
		DWORD MWM_KeyBackUp								;; VK_BACK	008h
		DWORD MWM_KeyTabUp								;; VK_TAB		009h
		DWORD MWM_NoKeyUp								;; VK_		00Ah
		DWORD MWM_NoKeyUp								;; VK_		00Bh
		DWORD MWM_NoKeyUp								;; VK_CLEAR	00Ch
		DWORD MWM_KeyReturnUp							;; VK_RETURN	00Dh
		DWORD MWM_NoKeyUp								;; VK_		00Eh
		DWORD MWM_NoKeyUp								;; VK_		00Fh
		DWORD MWM_NoKeyUp								;; VK_SHIFT	010h ) inactifs pour pouvoir faire la diffrence entre droit et gauche
		DWORD MWM_NoKeyUp								;; VK_CONTROL	011h )
		DWORD MWM_NoKeyUp								;; VK_MENU	012h )
		DWORD MWM_NoKeyUp								;; VK_PAUSE	013h
		DWORD MWM_NoKeyUp								;; VK_CAPITAL	014h
		DWORD MWM_NoKeyUp								;; VK_KANA ou VK_HANGEUL ou VK_HANGUL	015h
		DWORD MWM_NoKeyUp								;; VK_		016h
		DWORD MWM_NoKeyUp								;; VK_JUNJA	017h
		DWORD MWM_NoKeyUp								;; VK_FINAL	018h
		DWORD MWM_NoKeyUp								;; VK_HANJA ou VK_KANJI	019h
		DWORD MWM_NoKeyUp								;; VK_		01Ah
		DWORD MWM_KeyEscUp								;; VK_ESCAPE	01Bh
		DWORD MWM_NoKeyUp								;; VK_CONVERT		01Ch
		DWORD MWM_NoKeyUp								;; VK_NONCONVERT	01Dh
		DWORD MWM_NoKeyUp								;; VK_ACCEPT		01Eh
		DWORD MWM_NoKeyUp								;; VK_MODECHANGE	01Fh
		DWORD MWM_KeySpaceUp							;; VK_SPACE	020h
		DWORD MWM_KeyPgUpUp								;; VK_PRIOR ou VK_PGUP	021h
		DWORD MWM_KeyPgDnUp								;; VK_NEXT ou VK_PGDN	022h
		DWORD MWM_KeyEndUp								;; VK_END		023h
		DWORD MWM_KeyHomeUp								;; VK_HOME	024h
		DWORD MWM_KeyLeftUp								;; VK_LEFT	025h
		DWORD MWM_KeyUpUp								;; VK_UP		026h
		DWORD MWM_KeyRightUp							;; VK_RIGHT	027h
		DWORD MWM_KeyDownUp								;; VK_DOWN	028h
		DWORD MWM_NoKeyUp								;; VK_SELECT	029h
		DWORD MWM_NoKeyUp								;; VK_PRINT	02Ah
		DWORD MWM_NoKeyUp								;; VK_EXECUTE	02Bh
		DWORD MWM_NoKeyUp								;; VK_SNAPSHOT	02Ch
		DWORD MWM_KeyInserUp							;; VK_INSERT	02Dh
		DWORD MWM_KeySupprUp							;; VK_DELETE	02Eh
		DWORD MWM_NoKeyUp								;; VK_HELP	02Fh
		DWORD MWM_Key0Up								;; VK_0	030h
		DWORD MWM_Key1Up								;; VK_1	031h
		DWORD MWM_Key2Up								;; VK_2	032h
		DWORD MWM_Key3Up								;; VK_3	033h
		DWORD MWM_Key4Up								;; VK_4	034h
		DWORD MWM_Key5Up								;; VK_5	035h
		DWORD MWM_Key6Up								;; VK_6	036h
		DWORD MWM_Key7Up								;; VK_7	037h
		DWORD MWM_Key8Up								;; VK_8	038h
		DWORD MWM_Key9Up								;; VK_9	039h
		DWORD MWM_NoKeyUp								;; VK_	03Ah
		DWORD MWM_NoKeyUp								;; VK_	03Bh
		DWORD MWM_NoKeyUp								;; VK_	03Ch
		DWORD MWM_NoKeyUp								;; VK_	03Dh
		DWORD MWM_NoKeyUp								;; VK_	03Eh
		DWORD MWM_NoKeyUp								;; VK_	03Fh
		DWORD MWM_NoKeyUp								;; VK_	040h
		DWORD MWM_KeyAUp								;; VK_A	041h
		DWORD MWM_KeyBUp								;; VK_B	042h
		DWORD MWM_KeyCUp								;; VK_C	043h
		DWORD MWM_KeyDUp								;; VK_D	044h
		DWORD MWM_KeyEUp								;; VK_E	045h
		DWORD MWM_KeyFUp								;; VK_F	046h
		DWORD MWM_KeyGUp								;; VK_G	047h
		DWORD MWM_KeyHUp								;; VK_H	048h
		DWORD MWM_KeyIUp								;; VK_I	049h
		DWORD MWM_KeyJUp								;; VK_J	04Ah
		DWORD MWM_KeyKUp								;; VK_K	04Bh
		DWORD MWM_KeyLUp								;; VK_L	04Ch
		DWORD MWM_KeyMUp								;; VK_M	04Dh
		DWORD MWM_KeyNUp								;; VK_N	04Eh
		DWORD MWM_KeyOUp								;; VK_O	04Fh
		DWORD MWM_KeyPUp								;; VK_P	050h
		DWORD MWM_KeyQUp								;; VK_Q	051h
		DWORD MWM_KeyRUp								;; VK_R	052h
		DWORD MWM_KeySUp								;; VK_S	053h
		DWORD MWM_KeyTUp								;; VK_T	054h
		DWORD MWM_KeyUUp								;; VK_U	055h
		DWORD MWM_KeyVUp								;; VK_V	056h
		DWORD MWM_KeyWUp								;; VK_W	057h
		DWORD MWM_KeyXUp								;; VK_X	058h
		DWORD MWM_KeyYUp								;; VK_Y	059h
		DWORD MWM_KeyZUp								;; VK_Z	05Ah
		DWORD MWM_KeyLWinUp								;; VK_LWIN	05Bh (touche WINDOWS gauche)
		DWORD MWM_KeyRWinUp								;; VK_RWIN	05Ch (touche WINDOWS droit)
		DWORD MWM_NoKeyUp								;; VK_APPS	05Dh
		DWORD MWM_NoKeyUp								;; VK_	05Eh
		DWORD MWM_NoKeyUp								;; VK_	05Fh
		DWORD MWM_KeyNum0Up								;; VK_NUMPAD0	060h
		DWORD MWM_KeyNum1Up								;; VK_NUMPAD1	061h
		DWORD MWM_KeyNum2Up								;; VK_NUMPAD2	062h
		DWORD MWM_KeyNum3Up								;; VK_NUMPAD3	063h
		DWORD MWM_KeyNum4Up								;; VK_NUMPAD4	064h
		DWORD MWM_KeyNum5Up								;; VK_NUMPAD5	065h
		DWORD MWM_KeyNum6Up								;; VK_NUMPAD6	066h
		DWORD MWM_KeyNum7Up								;; VK_NUMPAD7	067h
		DWORD MWM_KeyNum8Up								;; VK_NUMPAD8	068h
		DWORD MWM_KeyNum9Up								;; VK_NUMPAD9	069h
		DWORD MWM_KeyNumMultiplyUp						;; VK_MULTIPLY		06Ah
		DWORD MWM_KeyNumAddUp							;; VK_ADD			06Bh
		DWORD MWM_NoKeyUp								;; VK_SEPARATOR	06Ch
		DWORD MWM_KeyNumSubtractUp						;; VK_SUBTRACT		06Dh
		DWORD MWM_KeyNumDecimalUp						;; VK_DECIMAL		06Eh
		DWORD MWM_KeyNumDivideUp							;; VK_DIVIDE		06Fh
		DWORD MWM_KeyF1Up								;; VK_F1	070h
		DWORD MWM_KeyF2Up								;; VK_F2	071h
		DWORD MWM_KeyF3Up								;; VK_F3	072h
		DWORD MWM_KeyF4Up								;; VK_F4	073h
		DWORD MWM_KeyF5Up								;; VK_F5	074h
		DWORD MWM_KeyF6Up								;; VK_F6	075h
		DWORD MWM_KeyF7Up								;; VK_F7	076h
		DWORD MWM_KeyF8Up								;; VK_F8	077h
		DWORD MWM_KeyF9Up								;; VK_F9	078h
		DWORD MWM_KeyF10Up								;; VK_F10	079h
		DWORD MWM_KeyF11Up								;; VK_F11	07Ah
		DWORD MWM_KeyF12Up								;; VK_F12	07Bh
		DWORD MWM_KeyF13Up								;; VK_F13	07Ch
		DWORD MWM_KeyF14Up								;; VK_F14	07Dh
		DWORD MWM_KeyF15Up								;; VK_F15	07Eh
		DWORD MWM_KeyF16Up								;; VK_F16	07Fh
		DWORD MWM_KeyF17Up								;; VK_F17	080h
		DWORD MWM_KeyF18Up								;; VK_F18	081h
		DWORD MWM_KeyF19Up								;; VK_F19	082h
		DWORD MWM_KeyF20Up								;; VK_F20	083h
		DWORD MWM_KeyF21Up								;; VK_F21	084h
		DWORD MWM_KeyF22Up								;; VK_F22	085h
		DWORD MWM_KeyF23Up								;; VK_F23	086h
		DWORD MWM_KeyF24Up								;; VK_F24	087h
		DWORD MWM_NoKeyUp								;; VK_	088h
		DWORD MWM_NoKeyUp								;; VK_	089h
		DWORD MWM_NoKeyUp								;; VK_	08Ah
		DWORD MWM_NoKeyUp								;; VK_	08Bh
		DWORD MWM_NoKeyUp								;; VK_	08Ch
		DWORD MWM_NoKeyUp								;; VK_	08Dh
		DWORD MWM_NoKeyUp								;; VK_	08Eh
		DWORD MWM_NoKeyUp								;; VK_	08Fh
		DWORD MWM_KeyNumLUp								;; VK_NUMLOCK	090h
		DWORD MWM_NoKeyUp								;; VK_SCROLL	091h
		DWORD MWM_NoKeyUp								;; VK_	092h
		DWORD MWM_NoKeyUp								;; VK_	093h
		DWORD MWM_NoKeyUp								;; VK_	094h
		DWORD MWM_NoKeyUp								;; VK_	095h
		DWORD MWM_NoKeyUp								;; VK_	096h
		DWORD MWM_NoKeyUp								;; VK_	097h
		DWORD MWM_NoKeyUp								;; VK_	098h
		DWORD MWM_NoKeyUp								;; VK_	099h
		DWORD MWM_NoKeyUp								;; VK_	09Ah
		DWORD MWM_NoKeyUp								;; VK_	09Bh
		DWORD MWM_NoKeyUp								;; VK_	09Ch
		DWORD MWM_NoKeyUp								;; VK_	09Dh
		DWORD MWM_NoKeyUp								;; VK_	09Eh
		DWORD MWM_NoKeyUp								;; VK_	09Fh
		DWORD MWM_KeyLShftUp							;; VK_LSHIFT	0A0h
		DWORD MWM_KeyRShftUp							;; VK_RSHIFT	0A1h
		DWORD MWM_KeyLCtrlUp							;; VK_LCONTROL	0A2h
		DWORD MWM_KeyRCtrlUp							;; VK_RCONTROL	0A3h
		DWORD MWM_KeyLAltUp								;; VK_LMENU	0A4h
		DWORD MWM_KeyRAltUp								;; VK_RMENU	0A5h
		DWORD MWM_NoKeyUp								;; VK_	0A6h
		DWORD MWM_NoKeyUp								;; VK_	0A7h
		DWORD MWM_NoKeyUp								;; VK_	0A8h
		DWORD MWM_NoKeyUp								;; VK_	0A9h
		DWORD MWM_NoKeyUp								;; VK_	0AAh
		DWORD MWM_NoKeyUp								;; VK_	0ABh
		DWORD MWM_NoKeyUp								;; VK_	0ACh
		DWORD MWM_NoKeyUp								;; VK_	0ADh
		DWORD MWM_NoKeyUp								;; VK_	0AEh
		DWORD MWM_NoKeyUp								;; VK_	0AFh
		DWORD MWM_NoKeyUp								;; VK_	0B0h
		DWORD MWM_NoKeyUp								;; VK_	0B1h
		DWORD MWM_NoKeyUp								;; VK_	0B2h
		DWORD MWM_NoKeyUp								;; VK_	0B3h
		DWORD MWM_NoKeyUp								;; VK_	0B4h
		DWORD MWM_NoKeyUp								;; VK_	0B5h
		DWORD MWM_NoKeyUp								;; VK_	0B6h
		DWORD MWM_NoKeyUp								;; VK_	0B7h
		DWORD MWM_NoKeyUp								;; VK_	0B8h
		DWORD MWM_NoKeyUp								;; VK_	0B9h
		DWORD MWM_KeyDollardUp							;; VK_	0BAh ()
		DWORD MWM_KeyAddUp								;; VK_	0BBh (+)
		DWORD MWM_KeyInterUp							;; VK_	0BCh (?)
		DWORD MWM_NoKeyUp								;; VK_	0BDh
		DWORD MWM_KeyDecimalUp							;; VK_	0BEh (.)
		DWORD MWM_KeyDivideUp							;; VK_	0BFh (/)
		DWORD MWM_KeyPercentUp							;; VK_	0C0h (%)
		DWORD MWM_NoKeyUp								;; VK_	0C1h
		DWORD MWM_NoKeyUp								;; VK_	0C2h
		DWORD MWM_NoKeyUp								;; VK_	0C3h
		DWORD MWM_NoKeyUp								;; VK_	0C4h
		DWORD MWM_NoKeyUp								;; VK_	0C5h
		DWORD MWM_NoKeyUp								;; VK_	0C6h
		DWORD MWM_NoKeyUp								;; VK_	0C7h
		DWORD MWM_NoKeyUp								;; VK_	0C8h
		DWORD MWM_NoKeyUp								;; VK_	0C9h
		DWORD MWM_NoKeyUp								;; VK_	0CAh
		DWORD MWM_NoKeyUp								;; VK_	0CBh
		DWORD MWM_NoKeyUp								;; VK_	0CCh
		DWORD MWM_NoKeyUp								;; VK_	0CDh
		DWORD MWM_NoKeyUp								;; VK_	0CEh
		DWORD MWM_NoKeyUp								;; VK_	0CFh
		DWORD MWM_NoKeyUp								;; VK_	0D0h
		DWORD MWM_NoKeyUp								;; VK_	0D1h
		DWORD MWM_NoKeyUp								;; VK_	0D2h
		DWORD MWM_NoKeyUp								;; VK_	0D3h
		DWORD MWM_NoKeyUp								;; VK_	0D4h
		DWORD MWM_NoKeyUp								;; VK_	0D5h
		DWORD MWM_NoKeyUp								;; VK_	0D6h
		DWORD MWM_NoKeyUp								;; VK_	0D7h
		DWORD MWM_NoKeyUp								;; VK_	0D8h
		DWORD MWM_NoKeyUp								;; VK_	0D9h
		DWORD MWM_NoKeyUp								;; VK_	0DAh
		DWORD MWM_KeyDegresUp							;; VK_	0DBh ()
		DWORD MWM_KeyMultiplyUp							;; VK_	0DCh ()
		DWORD MWM_KeyPowerUp							;; VK_	0DDh ()
		DWORD MWM_KeyConsoleUp							;; VK_	0DEh ()
		DWORD MWM_KeyExclamUp							;; VK_	0DFh ()
		DWORD MWM_NoKeyUp								;; VK_	0E0h
		DWORD MWM_NoKeyUp								;; VK_	0E1h
		DWORD MWM_KeyGreaterUp							;; VK_	0E2h (>)
		DWORD MWM_NoKeyUp								;; VK_	0E3h
		DWORD MWM_NoKeyUp								;; VK_	0E4h
		DWORD MWM_NoKeyUp								;; VK_PROCESSKEY	0E5h
		DWORD MWM_NoKeyUp								;; VK_	0E6h
		DWORD MWM_NoKeyUp								;; VK_	0E7h
		DWORD MWM_NoKeyUp								;; VK_	0E8h
		DWORD MWM_NoKeyUp								;; VK_	0E9h
		DWORD MWM_NoKeyUp								;; VK_	0EAh
		DWORD MWM_NoKeyUp								;; VK_	0EBh
		DWORD MWM_NoKeyUp								;; VK_	0ECh
		DWORD MWM_NoKeyUp								;; VK_	0EDh
		DWORD MWM_NoKeyUp								;; VK_	0EEh
		DWORD MWM_NoKeyUp								;; VK_	0EFh
		DWORD MWM_NoKeyUp								;; VK_	0F0h
		DWORD MWM_NoKeyUp								;; VK_	0F1h
		DWORD MWM_NoKeyUp								;; VK_	0F2h
		DWORD MWM_NoKeyUp								;; VK_	0F3h
		DWORD MWM_NoKeyUp								;; VK_	0F4h
		DWORD MWM_NoKeyUp								;; VK_	0F5h
		DWORD MWM_NoKeyUp								;; VK_ATTN	0F6h
		DWORD MWM_NoKeyUp								;; VK_CRSEL	0F7h
		DWORD MWM_NoKeyUp								;; VK_EXSEL	0F8h
		DWORD MWM_NoKeyUp								;; VK_EREOF	0F9h
		DWORD MWM_NoKeyUp								;; VK_PLAY	0FAh
		DWORD MWM_NoKeyUp								;; VK_ZOOM	0FBh
		DWORD MWM_NoKeyUp								;; VK_NONAME	0FCh
		DWORD MWM_NoKeyUp								;; VK_PA1		0FDh
		DWORD MWM_NoKeyUp								;; VK_OEM_CLEAR	0FEh
		DWORD MWM_NoKeyUp								;; VK_	0FFh
; ici, les labels correspondants aux sauts
.CODE
; aucune touche n'est presse
MWM_NoKeyUp:											;; aucune touche n'est prsse ?
	ret												;; retourner (sortir de la gestion de ce message)
MWM_LeftMouseButtonUp:									;; VK_LBUTTON	001h
		btr Mouse_Button_Flags,2							;; effacer le bit devenu inutile (bit 2)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_RightMouseButtonUp:									;; VK_RBUTTON	002h
		btr Mouse_Button_Flags,0							;; effacer le bit devenu inutile (bit 0)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_CANCEL	003h
MWM_MiddleMouseButtonUp:									;; VK_MBUTTON	004h
		btr Mouse_Button_Flags,1							;; effacer le bit devenu inutile (bit 1)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		005h
;; VK_		006h
;; VK_		007h
MWM_KeyBackUp:											;; VK_BACK	008h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyTabUp:											;; VK_TAB		009h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		00Ah
;; VK_		00Bh
;; VK_CLEAR	00Ch
MWM_KeyReturnUp:										;; VK_RETURN	00Dh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_		00Eh
;; VK_		00Fh
;; VK_SHIFT	010h ) inactifs pour pouvoir faire la diffrence entre droit et gauche
;; VK_CONTROL	011h )
;; VK_MENU	012h )
;; VK_PAUSE	013h
;; VK_CAPITAL	014h
;; VK_KANA ou VK_HANGEUL ou VK_HANGUL	015h
;; VK_		016h
;; VK_JUNJA	017h
;; VK_FINAL	018h
;; VK_HANJA ou VK_KANJI	019h
;; VK_		01Ah
MWM_KeyEscUp:											;; VK_ESCAPE	01Bh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_CONVERT		01Ch
;; VK_NONCONVERT	01Dh
;; VK_ACCEPT		01Eh
;; VK_MODECHANGE	01Fh
MWM_KeySpaceUp:										;; VK_SPACE	020h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPgUpUp:											;; VK_PRIOR ou VK_PGUP	021h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPgDnUp:											;; VK_NEXT ou VK_PGDN	022h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyEndUp:											;; VK_END		023h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyHomeUp:											;; VK_HOME	024h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLeftUp:											;; VK_LEFT	025h
		btr Keys_Flags,2								;; supprimer le tmoin touche gauche (bit 2)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyUpUp:											;; VK_UP		026h
		btr Mouse_Button_Flags,0							;; supprimer le tmoin touche haut (bit 0)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRightUp:										;; VK_RIGHT	027h
		btr Keys_Flags,0								;; supprimer le tmoin touche droite (bit 0)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDownUp:											;; VK_DOWN	028h
		btr Keys_Flags,1								;; supprimer le tmoin touche bas (bit 1)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SELECT	029h
;; VK_PRINT	02Ah
;; VK_EXECUTE	02Bh
;; VK_SNAPSHOT	02Ch
MWM_KeyInserUp:										;; VK_INSERT	02Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeySupprUp:										;; VK_DELETE	02Eh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_HELP	02Fh
MWM_Key0Up:											;; VK_0	030h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key1Up:											;; VK_1	031h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key2Up:											;; VK_2	032h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key3Up:											;; VK_3	033h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key4Up:											;; VK_4	034h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key5Up:											;; VK_5	035h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key6Up:											;; VK_6	036h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key7Up:											;; VK_7	037h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key8Up:											;; VK_8	038h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_Key9Up:											;; VK_9	039h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	03Ah
;; VK_	03Bh
;; VK_	03Ch
;; VK_	03Dh
;; VK_	03Eh
;; VK_	03Fh
;; VK_	040h
MWM_KeyAUp:											;; VK_A	041h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyBUp:											;; VK_B	042h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyCUp:											;; VK_C	043h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDUp:											;; VK_D	044h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyEUp:											;; VK_E	045h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyFUp:											;; VK_F	046h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyGUp:											;; VK_G	047h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyHUp:											;; VK_H	048h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyIUp:											;; VK_I	049h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyJUp:											;; VK_J	04Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyKUp:											;; VK_K	04Bh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLUp:											;; VK_L	04Ch
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyMUp:											;; VK_M	04Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNUp:											;; VK_N	04Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyOUp:											;; VK_O	04Fh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPUp:											;; VK_P	050h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyQUp:											;; VK_Q	051h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRUp:											;; VK_R	052h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeySUp:											;; VK_S	053h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyTUp:											;; VK_T	054h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyUUp:											;; VK_U	055h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyVUp:											;; VK_V	056h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyWUp:											;; VK_W	057h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyXUp:											;; VK_X	058h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyYUp:											;; VK_Y	059h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyZUp:											;; VK_Z	05Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLWinUp:											;; VK_LWIN	05Bh (touche WINDOWS gauche)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRWinUp:											;; VK_RWIN	05Ch (touche WINDOWS droit)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_APPS	05Dh
;; VK_	05Eh
;; VK_	05Fh
MWM_KeyNum0Up:											;; VK_0	060h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum1Up:											;; VK_1	061h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum2Up:											;; VK_2	062h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum3Up:											;; VK_3	063h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum4Up:											;; VK_4	064h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum5Up:											;; VK_5	065h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum6Up:											;; VK_6	066h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum7Up:											;; VK_7	067h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum8Up:											;; VK_8	068h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNum9Up:											;; VK_9	069h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumMultiplyUp:									;; VK_MULTIPLY		06Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumAddUp:										;; VK_ADD			06Bh
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SEPARATOR	06Ch
MWM_KeyNumSubtractUp:									;; VK_SUBTRACT		06Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumDecimalUp:									;; VK_DECIMAL		06Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyNumDivideUp:										;; VK_DIVIDE		06Fh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF1Up:											;; VK_F1	070h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF2Up:											;; VK_F2	071h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF3Up:											;; VK_F3	072h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF4Up:											;; VK_F4	073h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF5Up:											;; VK_F5	074h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF6Up:											;; VK_F6	075h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF7Up:											;; VK_F7	076h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF8Up:											;; VK_F8	077h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF9Up:											;; VK_F9	078h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF10Up:											;; VK_F10	079h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF11Up:											;; VK_F11	07Ah
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF12Up:											;; VK_F12	07Bh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF13Up:											;; VK_F13	07Ch
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF14Up:											;; VK_F14	07Dh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF15Up:											;; VK_F15	07Eh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF16Up:											;; VK_F16	07Fh
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF17Up:											;; VK_F17	080h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF18Up:											;; VK_F18	081h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF19Up:											;; VK_F19	082h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF20Up:											;; VK_F20	083h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF21Up:											;; VK_F21	084h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF22Up:											;; VK_F22	085h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF23Up:											;; VK_F23	086h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyF24Up:											;; VK_F24	087h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	088h
;; VK_	089h
;; VK_	08Ah
;; VK_	08Bh
;; VK_	08Ch
;; VK_	08Dh
;; VK_	08Eh
;; VK_	08Fh
MWM_KeyNumLUp:											;; VK_NUMLOCK	090h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_SCROLL	091h
;; VK_	092h
;; VK_	093h
;; VK_	094h
;; VK_	095h
;; VK_	096h
;; VK_	097h
;; VK_	098h
;; VK_	099h
;; VK_	09Ah
;; VK_	09Bh
;; VK_	09Ch
;; VK_	09Dh
;; VK_	09Eh
;; VK_	09Fh
MWM_KeyLShftUp:										;; VK_LSHIFT	0A0h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRShftUp:										;; VK_RSHIFT	0A1h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLCtrlUp:										;; VK_LCONTROL	0A2h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRCtrlUp:										;; VK_RCONTROL	0A3h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyLAltUp:											;; VK_LMENU	0A4h
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyRAltUp:											;; VK_RMENU	0A5h
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0A6h
;; VK_	0A7h
;; VK_	0A8h
;; VK_	0A9h
;; VK_	0AAh
;; VK_	0ABh
;; VK_	0ACh
;; VK_	0ADh
;; VK_	0AEh
;; VK_	0AFh
;; VK_	0B0h
;; VK_	0B1h
;; VK_	0B2h
;; VK_	0B3h
;; VK_	0B4h
;; VK_	0B5h
;; VK_	0B6h
;; VK_	0B7h
;; VK_	0B8h
;; VK_	0B9h
MWM_KeyDollardUp:										;; VK_	0BAh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyAddUp:											;; VK_	0BBh (+)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyInterUp:										;; VK_	0BCh (?)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0BDh
MWM_KeyDecimalUp:										;; VK_	0BEh (.)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyDivideUp:										;; VK_	0BFh (/)
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPercentUp:										;; VK_	0C0h (%)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0C1h
;; VK_	0C2h
;; VK_	0C3h
;; VK_	0C4h
;; VK_	0C5h
;; VK_	0C6h
;; VK_	0C7h
;; VK_	0C8h
;; VK_	0C9h
;; VK_	0CAh
;; VK_	0CBh
;; VK_	0CCh
;; VK_	0CDh
;; VK_	0CEh
;; VK_	0CFh
;; VK_	0D0h
;; VK_	0D1h
;; VK_	0D2h
;; VK_	0D3h
;; VK_	0D4h
;; VK_	0D5h
;; VK_	0D6h
;; VK_	0D7h
;; VK_	0D8h
;; VK_	0D9h
;; VK_	0DAh
MWM_KeyDegresUp:										;; VK_	0DBh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyMultiplyUp:										;; VK_	0DCh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyPowerUp:										;; VK_	0DDh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyConsoleUp:										;; VK_	0DEh ()
	ret												;; retourner (sortir de la gestion de ce message)
MWM_KeyExclamUp:										;; VK_	0DFh ()
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0E0h
;; VK_	0E1h
MWM_KeyGreaterUp:										;; VK_	0E2h (>)
	ret												;; retourner (sortir de la gestion de ce message)
;; VK_	0E3h
;; VK_	0E4h
;; VK_PROCESSKEY	0E5h
;; VK_	0E6h
;; VK_	0E7h
;; VK_	0E8h
;; VK_	0E9h
;; VK_	0EAh
;; VK_	0EBh
;; VK_	0ECh
;; VK_	0EDh
;; VK_	0EEh
;; VK_	0EFh
;; VK_	0F0h
;; VK_	0F1h
;; VK_	0F2h
;; VK_	0F3h
;; VK_	0F4h
;; VK_	0F5h
;; VK_ATTN	0F6h
;; VK_CRSEL	0F7h
;; VK_EXSEL	0F8h
;; VK_EREOF	0F9h
;; VK_PLAY	0FAh
;; VK_ZOOM	0FBh
;; VK_NONAME	0FCh
;; VK_PA1		0FDh
;; VK_OEM_CLEAR	0FEh
;; VK_	0FFh


MainWinMessages ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * the main process (le groupe de routines qui tournent en boucle)
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainProcess PROC


;
; clean screen
;
		cmp Resizing_Flags,0							;; pas de redimensionnement actif ?
		je CleanStartScreen								;; si c'est le cas, aller CleanStartScreen
		mov edi,OFFSET Final_Screen						;; sinon, mettre l'adresse de la structure Screen_Block dans edi
		jmp EndCleanStartScreen							;; aller EndCleanStartScreen
CleanStartScreen:
		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
EndCleanStartScreen:
		call CleanScreen_Sse							;; effacer l'cran (pour tre sr que rien d'autre ne soit affich)


;
; here, we read the bitmap for the start screen
; (WARNING : it must be a 16 bytes aligned 32 bits bitmap ! and must be in the current directory)
;
		mov eax,Screen_DC_Pointer						;; lire le pointeur du device context de l'cran
		mov ebx,OFFSET sz_Start_Screen_Name				;; mettre l'adresse de la chane qui contient le nom du fichier
		mov ecx,OFFSET Bmp_Infos							;; mettre l'adresse de la structure BITMAPINFOHEADER utilise par nos crans
		mov esi,OFFSET Mem_Instance						;; mettre l'adresse de la structure Mem_Info dans esi
;		cmp Resizing_Flags,0							;; pas de redimensionnement actif ?
;		je StartScreen									;; si c'est le cas, aller StartScreen
;		mov edi,OFFSET Final_Screen						;; sinon, mettre l'adresse de la structure Screen_Block dans edi
;		jmp StartScreenDone								;; aller StartScreenDone
;StartScreen:
;		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
;StartScreenDone:
		call LoadAndDisplayScreen						;; et on affiche


;
; wait 2 seconds
;
	invoke Sleep,1999


;
; c'est ici que seront chargs les fichiers
;



;
; init of the 3d world, (in fact we're going to fill our A_3D_World struct)
;
		mov eax,Work_Screen_Width						;; mettre la moitie de la width de l'ecran de travail dans eax
		mov ebx,Work_Screen_Height						;; mettre la moitie de la height de l'cran de travail dans ebx
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de la structure A_3D_World dans esi
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_X,043340000h	;; 180	) angles de dpart (par dfaut) de la camra
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y,043340000h	;; 180	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z,043340000h	;; 180	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Real,043340000h	;; 180	) angles de dpart (par dfaut) de la camra
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Real,043340000h	;; 180	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Real,043340000h	;; 180	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Mini,042F00000h	;; 120 angle mini pour regarder en l'air (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Mini,000000000h	;; 0 angle mini pour regarder  droite/gauche (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Mini,000000000h	;; 0 angle maxi pour se pencher  gauche (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Maxi,043700000h	;; 240 angle maxi pour regarder par terre (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi,043B40000h	;; 360 angle maxi pour regarder  droite/gauche (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Angle_Z_Maxi,000000000h	;; 0 angle maxi pour se pencher  droite (en degrs)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Zoom_X,03F800000h	;; 1 zoom X normal par dfaut
		mov DWORD PTR (A_3D_World PTR [esi]).View_Zoom_Y,03F800000h	;; 1 zoom Y normal par dfaut
		mov DWORD PTR (A_3D_World PTR [esi]).View_Zoom_Z,03F800000h	;; 1 zoom Z normal par dfaut
		mov DWORD PTR (A_3D_World PTR [esi]).View_Position_X,000000000h	;; 0		) Position de la camra (c'est galement le point de dpart)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Position_Y,000000000h	;; 0		)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Position_Z,0BF800000h	;; -1	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Movment_SpeedUp,03F800000h	;; 1 vitesse d'acceleration des dplacements
		mov DWORD PTR (A_3D_World PTR [esi]).View_Movment_SlowDown,03F800000h	;; 1 vitesse de dcleration des dplacements
		mov DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Mini,000000000h	;; 0 aucun mouvement...
		mov DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Maxi,041000000h	;; 8 doit imprativement tre un multiple de x.View_Movment_SpeedUp et de x.View_Movment_SlowDown
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03F800000h	;; 1.0		) vitesse des changements d'orientation de la camra en degrs
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03F000000h	;; 0.5		)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03E800000h	;; 0.25		)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03E000000h	;; 0.125		)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03D800000h	;; 0.0625	)
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed,03D000000h	;; 0.03125	)
		mov DWORD PTR (A_3D_World PTR [esi]).View_Screen_Depth,047800000h	;; 65536 pour la depth
;		mov DWORD PTR (A_3D_World PTR [esi]).View_Screen_Depth,047000000h	;; 32768 pour la depth
		call Init3DWorld_Sse							;; et initialiser notre univers


;
; now the world is initialised, we're going to init the 3d objetcs
;
		mov eax,Number_Of_3D_Objects						;; mettre le nombre d'objets 3D dans le compteur de boucle
		mov ebx,OFFSET Mem_Instance						;; lire l'instance mmoire
		mov ecx,OFFSET Objects_3D_Locations				;; mettre l'adresse de la liste de adresses dans ecx
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de la structure A_3D_World dans esi
		mov edi,OFFSET Object_3D_0001						;; mettre l'adresse de la structure A_3D_Object  de dpart dans edi
LoopInit3dObjetcs:
		mov edx,DWORD PTR [ecx]							;; mettre l'adresse en ecx dans edx
		call Init3DObject_Sse							;; initialiser l'objet
		add edi,SIZEOF A_3D_Object						;; augmenter edi d'une taille de structure A_3D_Object (pour passer  l'objet suivant)
		add ecx,4										;; augmenter ecx de 4 (pour lire l'adresse suivante)
		dec eax										;; dcrmenter le compteur de boucle
		jnz LoopInit3dObjetcs							;; tant que c'est diffrent de zro, aller LoopInit3dObjetcs


ALIGN 16
;
; here, it's the beginning of the loop (our main process)
;
LoopMainProcess:

;		invoke Sleep,1									;; patienter un peu... (c'est ncessaire pour ne pas avoir un fps norme...)


;
; clean the ZBuffer, we start with the zbuffer because it will be used first
;
		mov edx,World_3D_0001.View_Screen_Depth				;; ) effacer le ZBuffer (le remplir avec la depth maximale)
		mov edi,OFFSET Work_Screen						;; )
		call FillZBuffer_NT_Sse							;; )
		sfence										;; s'assurer que les donnes qui prcdent soit traites avant celles qui suivent


; code temporaire, qui devra tre supprim plus tard... c'est pour voir ce que l'on fait exactement...
mov eax,Work_Screen.Block_Size					;; ) remplir l'cran avec du gris fonc
mov edx,03F3F3F3Fh								;; )
mov edi,Work_Screen.Pointer						;; )
call FillMem_NT_Sse								;; )
sfence										;; s'assurer que les donnes qui prcdent soit traites avant celles qui suivent
; rep stosd/stosb est presque aussi rapide, et le job est fait !


;
; here, we define the movments/rotation values for the 3d render
;
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
;
; set the POV speed movment for forward depending of the right mouse button (movment made on the Z axis)
;
		bt Mouse_Button_Flags,0							;; bouton droit de la souris est presse ?
		jc IncPOVForwardSpeedMovment						;; si c'est le cas, aller IncPOVForwardSpeedMovment
; dcrmenter la vitesse (diminuer le dplacement  enlever)
DecPOVForwardSpeedMovment:
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Movment_Z	;; mettre la vitesse dans XMM0
		subss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Movment_SlowDown	;; sinon, diminuer la vitesse de dplacement
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Mini	;; comparer la vitesse de translation  celle minimale
		jnc SavePOVForwardMovment						;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller SavePOVForwardMovment
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Mini	;; sinon mettre la vitesse minimale dans XMM0
		jmp SavePOVForwardMovment						;; aller SavePOVForwardMovment
; incrmenter la vitesse (augmenter le dplacement  enlever)
IncPOVForwardSpeedMovment:
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Movment_Z	;; mettre la vitesse dans XMM0
		addss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Movment_SpeedUp	;; sinon, augmenter la vitesse de dplacement
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Maxi	;; comparer la vitesse de translation  celle maximale
		jc SavePOVForwardMovment							;; si c'est infrieur (c=lt et nc=ge pour comiss), aller SavePOVForwardMovment
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Speed_Movment_Maxi	;; sinon, mettre la vitesse maximale dans XMM0
; sortie
SavePOVForwardMovment:
		movss DWORD PTR (A_3D_World PTR [esi]).View_Movment_Z,XMM0	;; enfin, sauvegarder la vitesse de la translation


;
; read the rotations directions for the POV depending of the mouse movments
;
		mov ebx,Rotation_Direction_Flags					;; mettre les tmoins de rotation (11  6, et 5  0) dans ebx
		and ebx,0000000000111111b						;; tester les bits d'augmentation de rotation (5  0)
		jz AvoidModifyRotation							;; s'l n'y a aucun mouvement, aller AvoidModifyRotation


;
; rotation depending of the mouse movment on the x axis of the screen (rotation around the 3D Y axis)
;
		cvtpi2ps XMM0,QWORD PTR Mouse_Movment_X				;; convertir Mouse_Movment_Y,Mouse_Movment_X en valeur real4 dans XMM0
		mulss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed ;; multiplier Mouse_Movment_X par la vitesse de changement d'orientation (ici 0.5)
		addss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y	;; ajouter l'ancien Angle_Vue_Y  Mouse_Movment_X
; rotation y ngative ?
		bt ebx,3										;; tester le bit de rotation Y ngative (3)
		jnc PositiveYRotation							;; s'il n'est pas positionn, aller PositiveYRotation
NegativeYRotation:
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Mini	;; comparer le rsultat  0
		jnc SaveYRotation								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller SaveYRotation
		addss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, ajouter 360  la valeur
		jmp SaveYRotation								;; aller SaveYRotation
; rotation y positive ?
PositiveYRotation:
		bt ebx,2										;; tester le bit de rotation Y positive (2)
		jnc SaveYRotation								;; s'il n'est pas positionn, aller SaveYRotation
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; comparer le rsultat  360
		jc SaveYRotation								;; si c'est infrieur (c=lt et nc=ge pour comiss), aller SaveYRotation
		subss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y_Maxi	;; sinon, enlever 360  la valeur
SaveYRotation:
		movss DWORD PTR (A_3D_World PTR [esi]).View_Angle_Y,XMM0	;; sauvegarder le rsultat dans Angle_Vue_Y


;
; rotation depending of the mouse movment on the y axis of the screen (rotation around the 3D X and Z axis)
;
		shufps XMM0,XMM0,0E1h							;; XMM0 = _,_,Mouse_Movment_X,Mouse_Movment_Y
		mulss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Rotation_Speed ;; multiplier Mouse_Movment_Y par la vitesse de changement d'orientation (ici 0.5)
		addss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_X	;; ajouter l'ancien Angle_Vue_X  Mouse_Movment_Y
; rotation x et z ngative ?
		bt ebx,5										;; tester le bit de rotation X ngative (5)
		jnc PositiveXZRotation							;; s'il n'est pas positionn, aller PositiveXZRotation
NegativeXZRotation:
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Mini	;; infrieur  View_Angle_X_Mini ?
		jnc SaveXZRotation								;; si c'est suprieur ou gal (c=lt et nc=ge pour comiss), aller SaveXZRotation
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Mini	;; sinon, remplacer Angle_Vue_X par Angle_Vue_X_Minimal
		jmp SaveXZRotation								;; aller SaveXZRotation
; rotation x et z positive ?
PositiveXZRotation:
		bt ebx,4										;; tester le bit de rotation X positive (4)
		jnc SaveXZRotation								;; s'il n'est pas positionn, aller SaveXZRotation
		comiss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Maxi	;; suprieur  View_Angle_X_Maxi ?
		jc SaveXZRotation								;; si c'est infrieur (c=lt et nc=ge pour comiss), aller SaveXZRotation
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Angle_X_Maxi	;; sinon, remplacer Angle_Vue_X par Angle_Vue_X_Maximal
SaveXZRotation:
		movss DWORD PTR (A_3D_World PTR [esi]).View_Angle_X,XMM0	;; sauvegarder le rsultat dans Angle_Vue_X


		cmp Dlg_Box_Flags,0								;; comparer Dlg_Box_Flags  0
		jnz AvoidModifyRotation							;; si c'est diffrent (c'est qu'il y a au moins une boite de dialogue active), aller AvoidModifyRotation
		invoke SetCursorPos,Half_Screen_Position_X,Half_Screen_Position_Y	;; sinon, mettre le curseur au center de l'cran OS (ce qui nous permet de toujours obtenir le mouvement de la souris)
AvoidModifyRotation:
		mov Mouse_Movment_X,0							;; effacer Mouse_Movment_X
		mov Mouse_Movment_Y,0							;; effacer Mouse_Movment_Y
;		and Rotation_Direction_Flags,00111000b				;; effacer Angle_X, Angle_Y, Angle_Z (bits 5  0)


;
; apply breath
;
		cmp Breath_Flags,0								;; comparer Breath_Flags  0
		je AvoidBreath									;; si c'est gal, aller AvoidBreath
		mov ebx,OFFSET Breath							;; sinon, mettre l'adresse de la table de valeurs dans ebx
		mov eax,Breath_Counter							;; mettre le compteur dans eax
		movss XMM0,DWORD PTR (A_3D_World PTR [esi]).View_Position_Y	;; lire la position Y
		sub eax,DWORD									;; enlever 4 (1 DWORD)  eax
		jns NewBreath									;; si eax n'est pas sign, aller NewBreath
		add eax,60*DWORD								;; sinon, ajouter 240 (60 DWORDs, la taille de la table)  eax
NewBreath:
		mov Breath_Counter,eax							;; sauvegarder le compteur
		addss XMM0,DWORD PTR [eax+ebx]					;; ajouter la valeur de respiration  la position Y
		movss DWORD PTR (A_3D_World PTR [esi]).View_Position_Y,XMM0	;; sauvegarder la nouvelle position Y
AvoidBreath:


;
; our movments made, we're going to update our 3D world
;
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
		call Update3DWorld_Sse							;; mise  jour du monde o l'on volue
;
; here, the (transposed) global rotation matrix is defined
;


;
; now, we're going to draw the 3d objects
;
		mov ecx,Number_Of_3D_Objects						;; mettre le nombre d'objets 3D dans le compteur de boucle
		mov edx,OFFSET Work_Screen						;; mettre l'adresse de la structure TamponEcranTravail dans edx
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
		mov edi,OFFSET Object_3D_0001						;; mettre l'adresse de la structure _Objet3D_ de dpart dans edi
LoopDraw3dObjetcs:
		call Draw3DObject_Sse							;; mise  jour de l'objet dans le monde
		add edi,SIZEOF A_3D_Object						;; ajouter la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		dec ecx										;; dcrmenter le compteur de boucle
		jnz LoopDraw3dObjetcs							;; tant que c'est diffrent de zro, aller LoopDraw3dObjetcs
;
; here it's done... i mean... for 3D part
;


;
; optionnal screen blur
;
		cmp Blur_Flags,0								;; comparer Blur_Flags  0
		je AvoidScreenBlur								;; si c'est le cas, aller AvoidScreenBlur
		mov edi,OFFSET Work_Screen						;; sinon, mettre l'adresse de la structure TamponEcranTravail dans edi
		call ScreenBlur_Mmx								;; et fondre les couleurs de l'cran
AvoidScreenBlur:


;;;;;;;;;;;;;;;;;
;; start debug ;;
;;;;;;;;;;;;;;;;;
		cmp Debug_Infos_Flags,0							;; tester le tmoin des informations debug
		je AvoidDebugInfos								;; si c'est le cas, aller AvoidDebugInfos
;;;;;;;;;;;;;;;;
;; init debug ;;
;;;;;;;;;;;;;;;;
		mov eax,SIZEOF A_3D_Object						;; mettre la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		mul DWORD PTR Selected_Object_Flags				;; multiplier la taille de la structure par le tmoin contenant le numro de l'objet (de 0  x)
		mov edi,eax									;; mettre le rsultat obtenu dans edi
		mov ecx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov edx,OFFSET Work_Screen						;; mettre l'adresse de la structure TamponEcranTravail dans edx
		mov esi,OFFSET World_3D_0001						;; mettre l'adresse de notre structure A_3D_World dans esi
		add edi,OFFSET Object_3D_0001						;; ajouter l'adresse de la structure _Objet3D_ de dpart dans edi

;;;;;;;;;;;;;;;;;;;
;; draw polygons ;;
;;;;;;;;;;;;;;;;;;;
		bt Debug_Infos_Flags,1							;; tester le bit correspondant aux polygones
		jnc AvoidPolygons								;; si le flag carry n'est pas positionn (inactif), aller AvoidPolygons
		call Draw3DPolygon_Sse							;; dessiner les polygones
AvoidPolygons:
;;;;;;;;;;;;;;;
;; draw area ;;
;;;;;;;;;;;;;;;
		bt Debug_Infos_Flags,2							;; tester le bit correspondant  la zone
		jnc AvoidArea									;; si le flag carry n'est pas positionn (inactif), aller AvoidArea
		call Draw3DArea_Sse								;; dessiner la zone
AvoidArea:
;;;;;;;;;;;;;;;
;; draw axis ;;
;;;;;;;;;;;;;;;
		bt Debug_Infos_Flags,3							;; tester le bit correspondant aux axes
		jnc AvoidAxis									;; si le flag carry n'est pas positionn (inactif), aller AvoidAxis
		call Draw3DAxis_Sse								;; dessiner les axes
AvoidAxis:
;;;;;;;;;;;;;;;;;
;; debug infos ;;
;;;;;;;;;;;;;;;;;
		bt Debug_Infos_Flags,0							;; tester le bit correspondant aux infos debug
		jnc AvoidDebugInfos								;; si le flag carry n'est pas positionn (inactif), aller AvoidDebugInfos
		call DebugInfo									;; enfin, afficher les infos
AvoidDebugInfos:
;;;;;;;;;;;;;;;
;; end debug ;;
;;;;;;;;;;;;;;;



;
; afficher le sprite qui symbolise le viseur (le point de fuite)
;
		cmp Focus_Flags,0								;; on compare Focus_Flags  0
		je EndDisplayFocus								;; si c'est gal (rien  afficher), aller EndDisplayFocus
; ici on dessine le sprite
		mov esi,OFFSET Sprite_0001						;; ) dessiner le sprite du point de fuite
		mov edi,OFFSET Work_Screen						;; )
;		call AfficherSprite_SansRepositionner				;; )
		call SpritePositionned_Mmx						;; )
EndDisplayFocus:


;
; afficher les chanes de caractres graphique
;
		cmp Stat_Flags,0								;; on compare Stat_Flags  0
		je DisplayStringsEnd							;; si c'est gal (rien  afficher), aller DisplayStringsEnd
; ici on dfini la couleur par dfaut des textes  afficher dans l'cran (fait hors boucle, pour une question de vitesse)
		mov eax,Colour_Yellow							;;	) dfinir les couleurs police + fond
		mov ebx,07F1F1F1Fh								;; (inutile si DisplayGfxStringWithoutBackground)
		call SetGfxStringColours							;;	)
;
; display the number of images per seconds
;
		xor eax,eax									;; position X (en pixels)
		xor ebx,ebx									;; position Y (en pixels)
		mov edx,OFFSET Font_LucidaCalligraphy_20_G			;; adresse de la police utilise
		mov esi,OFFSET sz_FPS							;; adresse de la chane  afficher
		mov edi,OFFSET Work_Screen						;; mettre l'adresse du Work_Screen dans edi
;		call DisplayGfxStringWithoutBackground				;; ) afficher cette chane  la position spcifie
		call DisplayGfxStringWithAlphaBackground_Mmx			;; )
DisplayStringsEnd:


;
; griser l'cran si le processus est suspendu
;
		cmp Suspend_Main_Process_Flags,1					;; le processus est suspendu ?
		jne AvoidToGrayScreen							;; si ce n'est pas le cas, aller AvoidToGrayScreen
; sinon, on va griser l'cran
		cmp Resizing_Flags,0							;; pas de redimensionnement ?
		je GrayWithoutResizing							;; si c'est le cas, aller GrayWithoutResizing
		cmp Resizing_Flags,1							;; est-ce un redimensionnement *2 ?
		jne GrayWithResizing							;; si ce n'est pas le cas, aller GrayWithResizing
; sinon, c'est un redimensionnement *2
		mov esi,OFFSET Work_Screen						;; ) redimensionnement vers l'cran final en *2
		mov edi,OFFSET Final_Screen						;; )
		call ScaleX2WithBlur_Mmx							;; )
;		call Sse3_AgrandirX2_RemplissageFondu				;; )
		mov eax,Final_Screen.Screen_Width					;;	) fondre l'cran (hormis pour les pixels du pourtour)
		mov ebx,Final_Screen.Screen_Height					;;	)
		sub eax,2										;;	)
		sub ebx,2										;;	)
		mov ecx,1										;;	)
		mov edx,1										;;	)
;		mov edi,OFFSET Final_Screen						;;	)
		call PartialBlur_Mmx							;;	)
;		mov edi,OFFSET Final_Screen						;; ) griser l'cran
		call GrayScreen_Mmx								;; )
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
		jmp GrayEnd									;; aller GrayEnd
; ici, c'est un redimensionnement, autre que *2
GrayWithResizing:
		mov eax,OFFSET Resizing_Table						;; ) redimensionnement vers l'cran final
		mov esi,OFFSET Work_Screen						;; )
		mov edi,OFFSET Final_Screen						;; )
;		call Redimensionner								;; )
		call Resizing									;; )
		mov eax,Final_Screen.Screen_Width					;;	) fondre l'cran (hormis pour les pixels du pourtour)
		mov ebx,Final_Screen.Screen_Height					;;	)
		sub eax,2										;;	)
		sub ebx,2										;;	)
		mov ecx,1										;;	)
		mov edx,1										;;	)
;		mov edi,OFFSET Final_Screen						;;	)
		call PartialBlur_Mmx							;;	)
;		mov edi,OFFSET Final_Screen						;; ) griser l'cran
		call GrayScreen_Mmx								;; )
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
		jmp GrayEnd									;; aller GrayEnd
; ici, pour le cas o il n'y a aucun redimensionnement
GrayWithoutResizing:
		mov eax,Work_Screen.Screen_Width					;; ) fondre l'cran (hormis pour les pixels du pourtour)
		mov ebx,Work_Screen.Screen_Height					;; )
		sub eax,2										;; )
		sub ebx,2										;; )
		mov ecx,1										;; )
		mov edx,1										;; )
		mov edi,OFFSET Work_Screen						;; )
		call PartialBlur_Mmx							;; )
;		mov edi,OFFSET Work_Screen						;;	) griser l'cran
		call GrayScreen_Mmx								;;	)
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
GrayEnd:
; maintenant, on va attendre qu'il n'y ai plus besoin de griser l'cran
		mov Gray_Screen_Flags,1							;; mettre le tmoin spcifiant que l'cran est gris
ScreenGrayed:
		cmp Gray_Screen_Flags,0							;; l'cran n'a plus a tre gris ?
		jne ScreenGrayed								;; tant que ce n'est pas le cas, aller ScreenGrayed
AvoidToGrayScreen:


;
; redimenssionner l'cran (uniquement si ca doit tre fait)
;
		cmp Resizing_Flags,0							;; pas de redimensionnement ?
		je NoResizing									;; si c'est le cas, aller NoResizing
		cmp Resizing_Flags,1							;; est-ce un redimensionnement *2 ?
		jne Redimensionnement							;; si ce n'est pas le cas, aller Redimensionnement
; sinon, c'est un redimensionnement *2
		mov esi,OFFSET Work_Screen						;; ) redimensionnement vers l'cran final en *2
		mov edi,OFFSET Final_Screen						;; )
		call ScaleX2WithBlur_Mmx							;; )
;		call Sse3_AgrandirX2_RemplissageFondu				;; )
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
		jmp ResizingEnd								;; aller ResizingEnd
; ici, c'est un redimensionnement, autre que *2
Redimensionnement:
		mov eax,OFFSET Resizing_Table						;; ) redimensionnement vers l'cran final
		mov esi,OFFSET Work_Screen						;; )
		mov edi,OFFSET Final_Screen						;; )
;		call Redimensionner								;; )
		call Resizing									;; )
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
		jmp ResizingEnd								;; aller ResizingEnd
; ici, pour le cas o il n'y a aucun redimensionnement
NoResizing:
		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
		call UpdateDBuffer								;; alterner le dbuffer
		invoke SetDIBitsToDevice,Screen_DC_Pointer,NULL,NULL,(Screen_Block PTR [edi]).Screen_Width,(Screen_Block PTR [edi]).Screen_Height,NULL,NULL,NULL,(Screen_Block PTR [edi]).Screen_Height,(Screen_Block PTR [edi]).Pointer,ADDR Bmp_Infos,DIB_RGB_COLORS
ResizingEnd:


;
; fin de la boucle (qui est, en fait, notre processus)
;
		inc Fps_Counter								;; une image de plus  t faite, on incrmente donc notre compteur
		cmp Continue_Main_Process_Flags,1					;; comparer Continue_Main_Process_Flags  1
		jne LoopMainProcess								;; tant que Continue_Main_Process_Flags est diffrent de 1, aller LoopMainProcess


;
; ici, la sortie du programme  t demande, alors effacer l'cran
;
		cmp Resizing_Flags,0							;; pas de redimensionnement actif ?
		je CleanEndScreen								;; si c'est le cas, aller CleanEndScreen
		mov edi,OFFSET Final_Screen						;; sinon, mettre l'adresse de la structure Screen_Block dans edi
		jmp CleanEndScreenEnd							;; aller CleanEndScreenEnd
CleanEndScreen:
		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
CleanEndScreenEnd:
		call CleanScreen_Sse							;; effacer l'cran (pour tre sr que rien d'autre ne soit affich)


;
; here, we read the bitmap for the end screen
; (WARNING : it must be a 16 bytes aligned 32 bits bitmap ! and must be in the current directory)
;
		mov eax,Screen_DC_Pointer						;; lire le pointeur du device context de l'cran
		mov ebx,OFFSET sz_End_Screen_Name					;; mettre l'adresse de la chane qui contient le nom du fichier
		mov ecx,OFFSET Bmp_Infos							;; mettre l'adresse de la structure BITMAPINFOHEADER utilise par nos crans
		mov esi,OFFSET Mem_Instance						;; mettre l'adresse de la structure Mem_Info dans esi
;		cmp Resizing_Flags,0							;; pas de redimensionnement actif ?
;		je EndScreen									;; si c'est le cas, aller EndScreen
;		mov edi,OFFSET Final_Screen						;; sinon, mettre l'adresse de la structure Screen_Block dans edi
;		jmp EndScreenDone								;; aller EndScreenDone
;EndScreen:
;		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
;EndScreenDone:
		call LoadAndDisplayScreen						;; et on affiche


;
; une fois l'cran de fin affich, on commence par supprimer
; tous les objets 3D initialiss (car de la mmoire a t alloue pour chacun d'eux)
;
		mov ecx,Number_Of_3D_Objects						;; mettre le nombre d'objets 3D dans le compteur de boucle
		mov esi,OFFSET Mem_Instance						;; lire l'instance mmoire
		mov edi,OFFSET Object_3D_0001						;; mettre l'adresse de la structure A_3D_Object de dpart dans edi
LoopFree3dObjetcs:
		call Free3DObject								;; supprimer l'objet 3D (la mmoire alloue)
		add edi,SIZEOF A_3D_Object						;; ajouter la taille d'une structure A_3D_Object  edi (pour passer  l'objet suivant)
		dec ecx										;; dcrmenter le compteur de boucle
		jnz LoopFree3dObjetcs							;; tant que c'est diffrent de zro, aller LoopFree3dObjetcs


;
; wait 2 seconds
;
	invoke Sleep,1999


;
; terminate the process
;
		mov Continue_Main_Process_Flags,0					;; processus dfinitivement clos
		invoke SendMessage,Main_Win_Messages_Pointer,WM_CLOSE,NULL,NULL

;	ret												;; ATTENTION !!!  ne pas activer pour un processus
MainProcess ENDP


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * entry point of the program
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
ALIGN 16
Program:
;		invoke GetCurrentProcess							;; ) fixer la priorit de notre application  haute
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS		;; )
		invoke GetCommandLine							;;	) obtenir un pointeur sur la ligne de commande
		mov Command_Line_Pointer,eax						;;	) et sauvegarder ce pointeur dans Command_Line_Pointer
		invoke GetModuleHandle,NULL						;; ) obtenir l'instance de la fentre
		mov App_Instance,eax							;; ) et sauvegarder le pointeur obtenu dans App_Instance
		mov Win_Infos.hInstance,eax						;; ) ainsi que dans notre structure WNDCLASSEX
		invoke GetModuleHandle,NULL						;;	) obtenir l'instance des boites de dialogue
		mov Dlg_Box_Instance,eax							;;	) et sauvegarder le pointeur obtenu dans Dlg_Box_Instance
		invoke SetCapture,eax							;; limiter les messages de la souris  notre application
		invoke ShowCursor,FALSE							;; faire disparaitre le pointeur cran
;		call InitRndNumbers								;; Initialiser les nombres aleatoires avec le nombre de millisecondes coules depuis le dmarrage de l'ordinateur.
		mov esi,OFFSET Mem_Instance						;; ) obtenir une instance mmoire
		call GetMemInstance								;; )


;
; init some datas
;
		mov eax,Work_Screen_Width						;; lire la width
		shr eax,1										;; diviser la valeur par 2
		mov Work_Screen_Half_Width,eax					;; sauvegarder la demi-width dans Work_Screen_Half_Width
		mov eax,Work_Screen_Height						;; lire la width
		shr eax,1										;; diviser la valeur par 2
		mov Work_Screen_Half_Height,eax					;; sauvegarder la demi-width dans Work_Screen_Half_Height
		mov eax,Final_Screen_Width						;; lire la width
		shr eax,1										;; diviser la valeur par 2
		mov Final_Screen_Half_Width,eax					;; sauvegarder la demi-width dans Final_Screen_Half_Width
		mov eax,Final_Screen_Height						;; lire la width
		shr eax,1										;; diviser la valeur par 2
		mov Final_Screen_Half_Height,eax					;; sauvegarder la demi-width dans Final_Screen_Half_Height


;
; center the position of our screen (and obtain some infos..)
;
		invoke GetSystemMetrics,SM_CXSCREEN				;; obtenir la taille x de l'ecran os (en pixels)
		mov OS_Screen_Width,eax							;; sauvegarder le rsultat dans OS_Screen_Width
		sub eax,Final_Screen_Width						;; soustraire la width de notre ecran final
		sar eax,1										;; diviser ensuite ce resultat par 2
		mov Screen_Position_X,eax						;; et mettre le rsultat dans Screen_Position_X (la position x de notre cran)
		mov eax,OS_Screen_Width							;; ) rcuprer la moitie de la width de l'cran OS
		shr eax,1										;; )
		mov OS_Screen_Half_Width,eax						;; )

		invoke GetSystemMetrics,SM_CYSCREEN				;; obtenir la taille y de l'ecran os (toujours en pixels)
		mov OS_Screen_Height,eax							;; sauvegarder le rsultat dans OS_Screen_Height
		sub eax,Final_Screen_Height						;; soustraire la height de notre cran final
		sar eax,1										;; diviser ensuite ce resultat par 2
		mov Screen_Position_Y,eax						;; et mettre le rsultat dans Screen_Position_Y (la position y de notre cran)
		mov eax,OS_Screen_Height							;; ) rcuprer la moitie de la height de l'cran OS
		shr eax,1										;; )
		mov OS_Screen_Half_Height,eax						;; )


;
; here, we define the Half_Screen_Position_X and Half_Screen_Position_Y variables
; (to center correctly our pointer, whatever the screen sizes)
;

; for the width (x)
		mov eax,Final_Screen_Half_Width					;; mettre Final_Screen_Half_Width dans eax
		cmp eax,OS_Screen_Width							;; comparer cette width  celle de l'cran OS
		jae SetHalfScreenXPosition						;; si c'est suprieur ou gal, aller SetHalfScreenXPosition
		add eax,Screen_Position_X						;; ajouter la position x de la fentre  la width de l'cran final
SetHalfScreenXPosition:
		mov Half_Screen_Position_X,eax					;; sauvegarder la position x

; for the height (y)
		mov eax,Final_Screen_Half_Height					;; mettre Final_Screen_Half_Height dans eax
		cmp eax,OS_Screen_Height							;; comparer cette height  celle de l'cran OS
		jae SetHalfScreenYPosition						;; si c'est suprieur ou gal, aller SetHalfScreenYPosition
		add eax,Screen_Position_Y						;; ajouter la position y de la fentre  la height de l'cran final
SetHalfScreenYPosition:
		mov Half_Screen_Position_Y,eax					;; sauvegarder la position Y


;
; fill the BITMAPINFO structure
;
		mov Bmp_Infos.biSize,SIZEOF BITMAPINFOHEADER			;; taille de la structure BITMAPINFOHEADER
		mov eax,Final_Screen_Width						;; ) la width
		mov Bmp_Infos.biWidth,eax						;; )
		mov eax,Final_Screen_Height						;;	) la height (ngative, pour que la premire ligne soit celle du haut, et pas celle du bas)
		neg eax										;;	)
		mov Bmp_Infos.biHeight,eax						;;	)
		mov Bmp_Infos.biPlanes,1							;;
		mov Bmp_Infos.biBitCount,32						;; pour des couleurs 32 bits
		mov Bmp_Infos.biCompression,BI_RGB					;; (BI_RGB=pas de compression)


;
; fill the WNDCLASSEX structure, and create screen
;
		invoke LoadIcon,App_Instance,Rsrc_IDI_Icon_32		;; pointeur sur l'icone
		mov Win_Infos.hIcon,eax							;; sauver le pointeur
		invoke LoadCursor,NULL,IDC_ARROW
		mov Win_Infos.hCursor,eax
; remplir le reste de la structure WNDCLASSEX avec les variables requises
		mov Win_Infos.cbSize,SIZEOF WNDCLASSEX
		mov Win_Infos.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE	; or CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
		mov Win_Infos.lpfnWndProc,OFFSET MainWinMessages
		mov Win_Infos.cbClsExtra,NULL
		mov Win_Infos.cbWndExtra,NULL
		mov Win_Infos.hbrBackground,COLOR_WINDOWTEXT			;; la couleur d'criture, pour avoir un cran noir ds le dpart
		mov Win_Infos.lpszMenuName,NULL
		mov Win_Infos.lpszClassName,OFFSET sz_Win_Class
		mov Win_Infos.hIconSm,0
		invoke RegisterClassEx,ADDR Win_Infos
; maintenant que tous les parametres sont dfinis, on cr l'cran
		invoke CreateWindowEx,WS_EX_LEFT,ADDR sz_Win_Class,ADDR sz_Win_Title,WS_POPUP,Screen_Position_X,Screen_Position_Y,Final_Screen_Width,Final_Screen_Height,NULL,NULL,App_Instance,NULL
		mov Win_Pointer,eax

;
; here, test of the processor to see if the minimum required is here
;
		call GetProcessorInfos
; bit 0 = Cpuid support ? 1=oui, 0=non
; bit 1 = Fpu support ? 1=oui, 0=non
; bit 2 = Tsc support ? 1=oui, 0=non
; bit 3 = Cx8 support ? 1=oui, 0=non
; bit 4 = cMov support ? 1=oui, 0=non
; bit 5 = Clfsh support ? 1=oui, 0=non
; bit 6 = Mmx support ? 1=oui, 0=non
; bit 7 = Fxsr support ? 1=oui, 0=non
; bit 8 = Sse support ? 1=oui, 0=non
; bit 9 = Sse2 support ? 1=oui, 0=non
; bit 10 = Htt support ? 1=oui, 0=non
; bit 11 = Sse3 support ? 1=oui, 0=non
;		mov eax,Processor_Flags							;; copier les tmoins obtenus dans eax
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000010011b							;; cpuid + fpu + cmov
;		mov edx,000001010011b							;; cpuid + fpu + cmov + mmx
		mov edx,000101010011b							;; cpuid + fpu + cmov + mmx + sse
;		mov edx,001101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2
;		mov edx,101101010011b							;; cpuid + fpu + cmov + mmx + sse + sse2 + sse3
		and eax,edx									;; ici on ne conserve que les bits  tester dans eax
		cmp eax,edx									;; et on s'asure qu'ils sont tous l
		je ProcessorOk									;; si c'est gal (le microprocesseur a le minimum requis), aller ProcessorOk
; sinon on va afficher la boite de dialogue en consquence
		invoke ReleaseCapture							;; librer les messages de la souris
		invoke ShowCursor,TRUE							;; faire rapparaitre le pointeur cran
		invoke DialogBoxParam,Dlg_Box_Instance,Rsrc_IDD_Obsolet,0,ADDR DlgBoxWinMessage,0
; boucle a effectuer tant que le message envoy par PostQuitMessage n'a pas t reu
ProcessorMessageLoop:
;		invoke GetMessage,ADDR OS_Messages,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR OS_Messages,Win_Pointer,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je ProcessorTooOld								;; si c'est gal  0 (pas de message), aller ProcessorTooOld
;		invoke TranslateMessage,ADDR OS_Messages			;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR OS_Messages				;; et dispatcher (mettre  la queue pour que ce soit lu par MainWinMessages au moment voulu)
		jmp ProcessorMessageLoop							;; aller ProcessorMessageLoop (pour aller lire le message suivant)
ProcessorOk:


;
; here, the minimum required is ok, we're going to define the directory for the screen captures
;
		call SetCaptureDirectory


;
; we alloc needed memory areas
;
; testing if there is a resizing to do
		mov eax,Work_Screen_Width						;; ) lire la height et la width de l'cran travail
		mov ebx,Work_Screen_Height						;; )
		cmp eax,Final_Screen_Width						;; comparer la width  celle de l'cran final
		jne DefineResizingFlags							;; si il y a une diffrence, aller DefineResizingFlags
		cmp ebx,Final_Screen_Height						;; comparer la height  celle de l'cran final
		jne DefineResizingFlags							;; si il y a une diffrence, aller DefineResizingFlags
; here, no resizing, we only create a work screen
;		mov eax,Work_Screen_Width						;; ) allouer un espace mmoire pour notre tampon ecran travail
;		mov ebx,Work_Screen_Height						;; ) (ici, avec dbuffer, zbuffer et zone limites face 3D)
		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Work_Screen						;; )
		call CreateScreenWithDBufferAndZBuffer				;; )
		mov Resizing_Flags,0							;; sinon, c'est qu'il n'y a pas de redimensionnement  faire
		jmp DefineResizingFlagsEnd						;; aller DefineResizingFlagsEnd
; here, resizing (*2 or other), we create a work screen
DefineResizingFlags:
;		mov eax,Work_Screen_Width						;;	) allouer un espace mmoire pour notre tampon ecran travail
;		mov ebx,Work_Screen_Height						;;	) (ici, avec zbuffer et zone limites face 3D, pas besoin de dbuffer)
;		mov esi,OFFSET Mem_Instance						;;	)
		mov edi,OFFSET Work_Screen						;;	)
		call CreateScreenWithZBuffer						;;	)
; and a final screen
		mov eax,Final_Screen_Width						;; ) allouer un espace mmoire pour notre tampon ecran final
		mov ebx,Final_Screen_Height						;; )
;		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Final_Screen						;; )
		call CreateScreen								;; )
		mov eax,Work_Screen.Screen_Width					;; mettre la width de l'ecran travail dans eax
		add eax,eax									;; multiplier cette height par 2
		cmp eax,Final_Screen.Screen_Width					;; on compare le rsultat  la width de l'cran final
		jne DefineResizingFlags2							;; si c'est diffrent, aller DefineResizingFlags2
		mov eax,Work_Screen.Screen_Height					;; mettre la height de l'ecran travail dans eax
		add eax,eax									;; multiplier cette height par 2
		cmp eax,Final_Screen.Screen_Height					;; on compare le rsultat  la height de l'cran final
		jne DefineResizingFlags2							;; si c'est diffrent, aller DefineResizingFlags2
		mov Resizing_Flags,1							;; sinon, il y aura un redimensionnement *2
		jmp DefineResizingFlagsEnd						;; aller DefineResizingFlagsEnd
; ici, c'est un dans le cas d'un redimensionnement autre que *2, alors on cr la table de redimensionnement
DefineResizingFlags2:
		mov eax,Work_Screen.Screen_Width					;; ) dfinir la table de redimensionnement (la mmoire est alloue avec)
		mov ebx,Work_Screen.Screen_Height					;; )
		mov ecx,Final_Screen.Screen_Width					;; )
		mov edx,Final_Screen.Screen_Height					;; )
;		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Resizing_Table						;; )
		call SetResizingTable							;; )
		mov Resizing_Flags,2							;; il y aura un redimensionnement autre que *2
DefineResizingFlagsEnd:


;
; init used sprites
;

; pour le sprite 1
		mov edx,OFFSET Sprite_Focus_01					;; mettre l'adresse des donnes du sprite dans edx
		mov esi,OFFSET Sprite_0001						;; mettre l'adresse de la structure Sprite_Info dans esi
		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
		call InitSprite								;; et initialiser le sprite
; positionner le sprite  l'cran
		mov eax,Work_Screen_Width						;; mettre Work_Screen_Width dans eax
		sub eax,Sprite_0001.Sprite_Width					;; soustraie la width du sprite  eax
		sar eax,1										;; diviser la width obtenue par 2
		mov ebx,Work_Screen_Height						;; mettre Work_Screen_Height dans ebx
		sub ebx,Sprite_0001.Sprite_Height					;; soustraire la height du sprite  ebx
		sar ebx,1										;; diviser la height obtenue par 2
;		mov esi,OFFSET Sprite_0001						;; mettre l'adresse de la structure Sprite_Info dans esi
;		mov edi,OFFSET Work_Screen						;; mettre l'adresse de la structure Screen_Block dans edi
		call SetSpritePosition							;; et positionner le sprite


;
; create a DC pointer for the screen
;

;		invoke GetDC,Win_Pointer
		invoke GetDCEx,Win_Pointer,NULL,DCX_CACHE or DCX_NORESETATTRS ; or DCX_EXCLUDERGN or DCX_INTERSECTUPDATE or DCX_VALIDATE or DCX_WINDOW
		mov Screen_DC_Pointer,eax						;; sauvegarder le pointeur obtenu
;		invoke SetMapMode,PointeurDeviceContext,MM_TEXT		;; dfinir le mode de mapping par pixel (uniquement si on utilise une police)


;
; here we go... set and launch the main process
;
		invoke CreateThread,NULL,Main_Process_Stack_Size*1024,ADDR MainProcess,Win_Pointer,NULL,ADDR Main_Process_Pointer
		mov Main_Process_Pointer,eax						;; sauvegarder le pointeur obtenu
		invoke SetThreadPriority,Main_Process_Pointer,THREAD_PRIORITY_NORMAL	;; laisser la priorit du processus  la normale THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		mov Continue_Main_Process_Flags,2					;; le processus est maintenant actif
		invoke ShowWindow,Win_Pointer,SW_SHOWNORMAL
		invoke UpdateWindow,Win_Pointer
		invoke SetTimer,Win_Pointer,1,1000,OFFSET ReadTimer


;
; loop to do, until PostQuitMessage not received
;
WinMessageLoop:
;		invoke GetMessage,ADDR OS_Messages,NULL,NULL,NULL	;; pour obtenir les messages provenants de toutes les applications
		invoke GetMessage,ADDR OS_Messages,Win_Pointer,NULL,NULL	;; pour obtenir uniquement les messages concernant notre application
		cmp eax,NULL									;; comparer eax  zro
		je WinMessageLoopEnd							;; si c'est gal  0 (pas de message), aller WinMessageLoopEnd
;		invoke TranslateMessage,ADDR OS_Messages			;; (optionnel) pour traduire les messages des touches du clavier
		invoke DispatchMessage,ADDR OS_Messages				;; et dispatcher (mettre  la queue pour que ce soit lu par MainWinMessages au moment voulu)
		jmp WinMessageLoop								;; aller WinMessageLoop (pour aller lire le message suivant)
WinMessageLoopEnd:


;
; and here we quit...
;
		invoke KillTimer,Win_Pointer,1					;; terminer la procdure priodique
;		invoke SetThreadPriority,Main_Process_Pointer,THREAD_PRIORITY_NORMAL	;; (ici, inutile) baisser la priorit du processus... THREAD_PRIORITY_LOWEST, THREAD_PRIORITY_BELOW_NORMAL, THREAD_PRIORITY_NORMAL, THREAD_PRIORITY_ABOVE_NORMAL, THREAD_PRIORITY_HIGHEST
		invoke TerminateThread,Main_Process_Pointer,0		;; terminer le processus
		invoke DeleteDC,Screen_DC_Pointer					;; supprimer le device context


;
; free allocated memory areas
;
		mov esi,OFFSET Mem_Instance						;; lire l'instance mmoire
		cmp Resizing_Flags,0							;; on teste s'il y a eu un redimensionnement
		je FreeScreenMem2								;; s'il n'y a pas de redimensionnement, aller FreeScreenMem2
		cmp Resizing_Flags,1							;; on teste s'il y a eu un redimensionnement *2
		je FreeScreenMem								;; s'il n'y a pas de redimensionnement, aller FreeScreenMem
		mov edi,OFFSET Resizing_Table						;; ) supprimer l'espace mmoire pour la table de redimensionnement
		call FreeResizingTable							;; )
FreeScreenMem:
		mov edi,OFFSET Final_Screen						;; ) supprimer l'espace mmoire pour l'ecran final
		call FreeScreenBlock							;; )
FreeScreenMem2:
		mov edi,OFFSET Work_Screen						;; ) supprimer l'espace mmoire pour l'ecran travail
		call FreeScreenBlock							;; )
;		mov esi,OFFSET Mem_Instance						;; lire l'instance mmoire
		call FreeMemInstance							;; supprimer l'intance mmoire

		invoke SetCursorPos,OS_Screen_Half_Width,OS_Screen_Half_Height	;; on place le pointeur au center de l'cran OS
		invoke ShowCursor,TRUE							;; on le fait rapparaitre (ben ouaip, autant sortir proprement...)
		invoke ReleaseCapture							;; librer les messages de la souris
ProcessorTooOld:
;		invoke GetCurrentProcess							;;	) remettre la priorit du programme  la normale
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS		;;	)
		invoke ExitProcess,OS_Messages.wParam				;; sortie de l'application
;
; end of program
;
END Program

